<?php
/**
 * Connection a la base de donnee
 *@param $hote  le hote ou la base est stocke
 *@param $port  port de connexion
 *@param $user  l'utilisateur de la base
 *@param $passwd  mot de passe 
 *@param $name_db  nom de la base de donnee
 *@return 
 *			message d'erreur en cas de non connexion a la base
 *			Sinon l'identifiant de la connexion ouvert
 **/

function connection_db($user,$passwd,$name_db){
  //connection a la base
  $id_connection = pg_connect(" dbname=$name_db"); 
//user=$user password=$passwd" );
  if(!$id_connection)
    gestion_error($id_connection,1);
  else 
    return $id_connection;
}

/**
 * Gestion des erreur selon l'identifiant
 *@param $id  identifiant
 *@return message d'erreur et une trace de l'erreur
 **/

function gestion_error($id,$id_function){
  //selon l'id de la fonction on affiche le message d'erreur
  if($id_function == 1) $message= "erreur de connection ";
  else if($id_function == 2) $message = "erreur d'execution de requete ";
  else $message=" erreur inconue ";
  echo $message;
  echo  pg_ErrorMessage($id);
  return -1;
}

/**
 *Recuperation des donnees de la bd
 *@param $id  identifiant
 *@param $request_sql  requete sql (Type : select)
 *@retrun message d'erreur sinon l'identifiant du resultat
 **/

function recup_data($id_connection,$request_sql){
  //execution de la requete 
  $id_selection = pg_exec($id_connection,$request_sql);
  //s'il y'a une erreur
 if(!$id_selection)
  //  return -1;
	gestion_error($id_selection,2);
  else
    return $id_selection;
}
/**
 * Fermeture de la connexion a la bd
 *@param $id identifiant de la connexion
 *@return message d'erreur sinon l'identifiant du resultat
 **/
function close_connexion($id){
	if(!pg_close($id))
		gestion_error($id,3);
}

/**
 *Transferer les donnees de la table SITE  celle de SERVEUR
 *@param
 *@return
 **/
 function transfert_site_to_serveur($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	
	$id_site = connection_db($user,$passwd,$name_db);
	$id_serveur = connection_db($user,$passwd,$name_nv_db);
	$request_site  = "SELECT  url FROM site;";
	
	$id_select_site = recup_data($id_site,$request_site);
	$row_max =  pg_numrows($id_select_site);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_site, $row);
		$url = $object->url;
		
		$url_modif = str_replace("http://",'',$url);
		$request_serveur = "INSERT INTO serveur(url_serveur) VALUES('$url_modif');";
		
		recup_data($id_serveur,$request_serveur);
		$row++;
	}
 close_connexion($id_serveur);
 close_connexion($id_site);
 }


function transfert_mot_to_mot_desc($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	
	$id_mot = connection_db($user,$passwd,$name_db);
	$id_mot_desc = connection_db($user,$passwd,$name_nv_db);
	$request_mot  = "SELECT  mot FROM mothttp UNION  SELECT  mot FROM motmail  UNION SELECT  mot FROM motpict ;";
	
	$id_select_mot = recup_data($id_mot,$request_mot);
	$row_max =  pg_numrows($id_select_mot);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_mot, $row);
		$mot = $object->mot;
		
		
		$request_mot_desc = "INSERT INTO mot_desc(mot) VALUES('$mot');";
		
		recup_data($id_mot_desc,$request_mot_desc);
		$row++;
	}
 close_connexion($id_mot);
 close_connexion($id_mot_desc);
 }

 /**
 *Transferer les donnees de la table MAIL  celle de MAIL (nouvelle BD)
 *@param
 *@return
 **/
 function transfert_mail_to_nvmail($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	
	
	$id_mail = connection_db($user,$passwd,$name_db);
	$id_nv_mail = connection_db($user,$passwd,$name_nv_db);
	$request_mail  = "SELECT  mail FROM mail;";
	$id_select_mail = recup_data($id_mail,$request_mail);
	
	$row_max =  pg_numrows($id_select_mail);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_mail, $row);
		$mail = $object->mail;
		
		$request_nv_mail = "INSERT INTO mail(mail) VALUES('$mail');";
		$id_test = recup_data($id_nv_mail,$request_nv_mail);
		$row++;
	}
	close_connexion($id_mail);
	close_connexion($id_nv_mail);
 }





 /**
  *Transferer les donnees de la table Pict  celle de Img (nouvelle BD)
  *@param
  *@return
  **/
 function transfert_pict_to_img($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	
	//connections au bd
	$id_pict = connection_db($user,$passwd,$name_db);
	$id_nv_pict = connection_db($user,$passwd,$name_nv_db);


	$request_pict  = "SELECT  * FROM pict;";
	
	$id_select_pict = recup_data($id_pict,$request_pict);
	$row_max =  pg_numrows($id_select_pict);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_pict, $row);
		$nom = $object->nom;
		$path = $object->chemin;
		$id_site = $object->id_site;

		$request_url = "SELECT url FROM site WHERE id_site = '$id_site';";

		$result = recup_data($id_pict,$request_url);
		$object_url = pg_fetch_object($result, 0);
		$url = $object_url->url;
		$url_modif = str_replace("http://", '',$url);

		
		$request_id_server = "SELECT id_serveur FROM serveur WHERE url_serveur = '$url_modif';";

		$result_id_server = recup_data($id_nv_pict,$request_id_server);
		$object_id_server = pg_fetch_object($result_id_server, 0);
		$id_server = $object_id_server->id_serveur;


		$request_insert = "INSERT INTO img(id_serveur,path,nom) VALUES ('$id_server','$path','$nom');";

		$result_insert = recup_data($id_nv_pict,$request_insert);
		$row++;
	}
	close_connexion($id_pict);
	close_connexion($id_nv_pict);
 }

 /**
 *Transferer les donnees de la table page a la table PAGE
 *@param
 *@return
 **/
 function transfert_page_to_page($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	
	$id_page = connection_db($user,$passwd,$name_db);
	$id_nv_page = connection_db($user,$passwd,$name_nv_db);
	$request_all_page  = "SELECT  * FROM page;";
	
	$id_select_all = recup_data($id_page,$request_all_page);
	$row_max =  pg_numrows($id_select_all);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_all, $row);
		//recherche du id du site
		$id_site = $object->id_site;
		//recherche de l'url correspondante a l'id_site  trouver
		$request_url = "SELECT url FROM site WHERE id_site =$id_site;";
		$id_select_url = recup_data($id_page,$request_url);
		$object_url = pg_fetch_object($id_select_url, 0);
		$url = $object_url->url;
		//modification de l'url
		$url_modif = str_replace("http://",'',$url);
		//recherche de l'id_serveur correspondant a l'url transformer
		$request_id_serveur = "SELECT id_serveur FROM serveur WHERE url_serveur = '$url_modif';";
		$id_select_id_serveur = recup_data($id_nv_page,$request_id_serveur);
		$object_id_serveur = pg_fetch_object($id_select_id_serveur, 0);
		$id_serveur = $object_id_serveur->id_serveur;
		//inserer dans la table Page de la nouvelle BD
		$url_page = $object->fin_url;
		$date = $object->date;
		$request_nv_page = "INSERT INTO page(id_serveur,url_page,date) VALUES('$id_serveur','$url_page','$date');";
		recup_data($id_nv_page,$request_nv_page);
		$row++;
	}
 close_connexion($id_page);
 close_connexion($id_nv_page);
 }




/**
 *Transferer les donnees de la table AppMail a la table App_Mail
 *@param
 *@return
 **/
 function transfert_appmail_to_nvappmail($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	///connection au deux base de donnees
	$id_AppMail = connection_db($user,$passwd,$name_db);
	$id_nv_App_mail = connection_db($user,$passwd,$name_nv_db);
	///recuperation de toutes les donnees de la table Appmail
	$request_all_AppMail  = "SELECT  * FROM appmail;";
	$id_select_all = recup_data($id_AppMail,$request_all_AppMail);
	$row_max =  pg_numrows($id_select_all);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_all, $row);
		//recherche des ids
		$id_page = $object->id_page;
		$id_mail = $object->id_mail;
		$id_mot =  $object->id_mot;
                $occurence = $object->occurence;

		//Transformation en texte
		$request_mot = "SELECT mot FROM motmail WHERE id_mot = $id_mot;";

		$request_mail = "SELECT mail FROM mail WHERE id_mail = $id_mail;";

		$request_page = "SELECT fin_url FROM page WHERE id_page = $id_page;";


		$select_mot = recup_data($id_AppMail,$request_mot);
		$select_mail = recup_data($id_AppMail,$request_mail);
		$select_page = recup_data($id_AppMail,$request_page);
	
		$object_mot = pg_fetch_object($select_mot, 0);
		$object_mail = pg_fetch_object($select_mail, 0);
		$object_page = pg_fetch_object($select_page, 0);

		$mot = $object_mot->mot;
		$mail = $object_mail->mail;
		$page = $object_page->fin_url;

		///recherche des ids correspondant au mot, mail et fin_url dans les tables 
		///Mot_desc Mail et Page
		$request_id_desc = "SELECT id_desc FROM mot_desc WHERE mot = '$mot';";

		$request_id_mail = "SELECT id_mail FROM mail WHERE mail = '$mail';";

		$request_id_page = "SELECT id_page FROM page WHERE url_page = '$page';";

			
                $id_select_mot = recup_data($id_nv_App_mail,$request_id_desc);
		$id_select_mail = recup_data($id_nv_App_mail,$request_id_mail);
		$id_select_page = recup_data($id_nv_App_mail,$request_id_page);
		
		$object_id_mot = pg_fetch_object($id_select_mot, 0);
		$object_id_mail = pg_fetch_object($id_select_mail, 0);
		$object_id_page = pg_fetch_object($id_select_page, 0);

		$id_desc = $object_id_mot->id_desc;

		$id_mail = $object_id_mail->id_mail;
		$id_page = $object_id_page->id_page;
		///Insertions des ids dans la table App_Mail
		
		$request_app_mail = "INSERT INTO app_mail(id_page,id_mail,id_desc,occurrence) VALUES($id_page,$id_mail,$id_desc,$occurence);";




		$result = recup_data($id_nv_App_mail,$request_app_mail);
		$row++;
	}
		close_connexion($id_AppMail);
		close_connexion($id_nv_App_mail );
 

 }

/**
 *Transferer les donnees de la table AppPict a la table App_Img
 *@param
 *@return
 **/
 function transfert_apppict_to_appimg($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	///connection au deux base de donnees
	$id_AppPict = connection_db($user,$passwd,$name_db);
	$id_App_img = connection_db($user,$passwd,$name_nv_db);
	///recuperation de toutes les donnees de la table Appmail
	$request_all_AppPict  = "SELECT  * FROM apppict;";
	$id_select_all = recup_data($id_AppPict,$request_all_AppPict);
	$row_max =  pg_numrows($id_select_all);
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_all, $row);
		//recherche des ids
		$id_page = $object->id_page;

		$id_pict = $object->id_pict;

		$id_mot =  $object->id_mot;

        	$occurence = $object->occurence;


		//Transformation en texte
		$request_mot = "SELECT mot FROM motpict WHERE id_mot = '$id_mot';";

		$request_pict = "SELECT *  FROM pict WHERE id_pict = '$id_pict';";

		$request_page = "SELECT fin_url FROM page WHERE id_page = '$id_page';";


	
		$select_mot = recup_data($id_AppPict,$request_mot);
		$select_pict = recup_data($id_AppPict,$request_pict);
		$select_page = recup_data($id_AppPict,$request_page);
		
		$object_mot = pg_fetch_object($select_mot, 0);
		$object_pict = pg_fetch_object($select_pict, 0);
		$object_page = pg_fetch_object($select_page, 0);

		$mot = $object_mot->mot;

		$pict = $object_pict->nom;

		$id_site = $object_pict->id_site;

		$chemin = $object_pict->chemin;
		$page = $object_page->fin_url;

		//recuperation de l'url 
		$request_url = "SELECT url from site where id_site='$id_site';";
		$select_url = recup_data($id_AppPict,$request_url);
		$object_url = pg_fetch_object($select_url, 0);
		$url = $object_url->url;
		
		$url = str_replace("http://",'',$url); 
		
		//recuperation de l'id_serveur
		$request_id_serveur = "SELECT id_serveur from serveur where url_serveur='$url';";
		$select_id_serveur = recup_data($id_App_img,$request_id_serveur);
		$object_id_serveur = pg_fetch_object($select_id_serveur,0);

		$id_serveur = $object_id_serveur->id_serveur;
			


		///recherche des ids correspondant au mot, mail et fin_url dans les tables 
		///Mot_desc nom et Page
		$request_id_desc = "SELECT id_desc FROM mot_desc WHERE mot = '$mot';";

		$request_id_pict = "SELECT id_img FROM img WHERE nom = '$pict' and id_serveur='$id_serveur' and path='$chemin';";

		$request_id_page = "SELECT id_page FROM page WHERE url_page = '$page' and id_serveur='$id_serveur';";


		$id_select_mot = recup_data($id_App_img,$request_id_desc);
		$id_select_pict = recup_data($id_App_img,$request_id_pict);
		$id_select_page = recup_data($id_App_img,$request_id_page);
		
		$object_id_mot = pg_fetch_object($id_select_mot, 0);
		$object_id_pict = pg_fetch_object($id_select_pict, 0);
		$object_id_page = pg_fetch_object($id_select_page, 0);

		$id_motn = $object_id_mot->id_desc;

		$id_img = $object_id_pict->id_img;

		$id_pagen = $object_id_page->id_page;

		///Insertions des ids dans la table app_img
		//(id_page,id_img,id_desc,occurrence)
		$request_App_img = "INSERT INTO app_img VALUES($id_pagen,$id_img,$id_motn,$occurence);";


		$result = recup_data($id_App_img,$request_App_img);
		$row++;
	}
		close_connexion($id_AppPict);
		close_connexion($id_nv_App_pict );
 }


///Pour les liens Http vers les (.htm html shtml xml) et les types d'images (jpg,bimp)
 function transfert_liens($name_db,$name_nv_db){
	

	$user = "kartoush";
	$passwd = "freeman23";
	$proto_http = 0;
	$proto_ftp = 0;
	///connection au deux base de donnees
	$id_http = connection_db($user,$passwd,$name_db);
	$id_href = connection_db($user,$passwd,$name_nv_db);
	//On recupere tout de la table Http(lien,id_http) 
	$request_http = "SELECT * FROM Http;";
	$id_select_http = recup_data($id_http,$request_http);
	$row_max =  pg_numrows($id_select_http);
	print("\n row max = $row_max \n");
	$row = 0;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_http, $row);
		$lien = $object->lien;
		echo "$lien";
		
		//parse_url permet de decouper l'url en plusieurs morceau
		//host = le lien, scheme = protocole , path = chemin absolue de la page
		$url = parse_url($lien);
		//le protocole ftp ou http en ajoute le "://"
		$protocole = "$url[scheme]://";
		print("\n protocole ==> $protocole \n");
		// le chemin absolue (rep et nom du fichier)
		$path = $url[path];
		print("\n path ==> $path \n");
		
		//on decoupe le chemin absolue
		$tab_path = explode("/",$path);
		print(" \n ___ $tab_path[1] \n");
		$taille_tab = count($tab_path);
		print("\n taille du tableau ==> $taille_tab \n");
		//on recupere le nom du fichier
		$nom_fic = $tab_path[$taille_tab - 1];
		print("\n nom du fichier ==> $nom_fic \n");
		//on recupere le chemin 
		$path_rep = str_replace($nom_fic,'',$path);
		print("\n path du repertoire ==> $path_rep \n");
		//rajouter les ? pour les pages
		if(count($url[query]) != 0) {
		   $path_complet = "$path?$url[query]";
		   print("\n path complet ==> $path_complet \n");
		}
		else{
		   $path_complet = $path;
		   print("\n path complet ==> $path_complet \n");
		}
		echo"<br>";

		print("\n pas inserer \n");
		$request_insert = "INSERT INTO serveur(url_serveur) VALUES ('$url[host]');";
		echo"<br>";
		print("\n request_insert ==> $request_insert \n"); 
		$id_insert_server = recup_data($id_href,$request_insert);
		
		$request_id_serveur = "SELECT id_serveur FROM serveur WHERE url_serveur = '$url[host]';";
		$result_id_serveur = recup_data($id_href,$request_id_serveur);
		$object_id_server = pg_fetch_object($result_id_serveur, 0);
		$id_serveur = $object_id_server->id_serveur;


		if(ereg('\.pdf$',$nom_fic) || eregi('\.tar$',$nom_fic) || eregi('\.zip$',$nom_fic)  || ereg('\.gz$',$nom_fic) || ereg('\.ps$',$nom_fic) || ereg('\.Z$',$nom_fic) || ereg('\.txt',$nom_fic)){
			print(" \n Autre type de fichier \n");
			//trouver l'id du serveur
			$request_id_serve = "SELECT id_serveur FROM serveur WHERE url_serveur = '$url[host]';";
			print("\n request_id_server ==> $request_id_serve \n"); 
			$result_id_serve = recup_data($id_href,$request_id_serve);
			$object_serve = pg_fetch_object($result_id_serve, 0);
			$id_serve = $object_serve->id_serveur;
			print("\n id_server ==> $id_serve \n");
			$request_insert_fic = "INSERT INTO Fichier(path,nom) VALUES('$path_rep','$nom_fic');";
			print("\n request_insert_fic ==> $request_insert_fic \n");
			$id_insert_fic = recup_data($id_href,$request_insert_fic);
			$request_id_fic = "SELECT id_fichier FROM Fichier WHERE path = '$path_rep' and nom = '$nom_fic';";
			print("\n request_id_fic ==> $request_id_fic \n");
			$id_select_fic = recup_data($id_href,$request_id_fic);
			$object_id_fic = pg_fetch_object($id_select_fic, 0);
			$id_fic = $object_id_fic->id_fichier;
			print("\n id_fic ==> $id_fic \n");
			if($protocole == "http://"){
			if($proto_http == 0 ) {
			$request_insert_proto = "INSERT INTO Protocole(prefixe,id_proto) VALUES('$protocole');";	
			$id_insert_proto = recup_data($id_href,$request_insert_proto);
			$proto_http = 1;
				}
			}
			else {
			if($proto_ftp == 0 ) {
			$request_insert_proto = "INSERT INTO Protocole(prefixe,id_proto) VALUES('$protocole');";
			$id_insert_proto = recup_data($id_href,$request_insert_proto);
			$proto_ftp = 1;
				}
			}
			$request_select_proto = "SELECT id_proto FROM protocole WHERE prefixe = '$protocole';";
			print("\n request_select_proto ==> $request_select_proto \n");
			$id_select_proto = recup_data($id_href,$request_select_proto);
			$object_id_proto = pg_fetch_object($id_select_proto, 0);
			$id_proto = $object_id_proto->id_proto;
			print("\n id_proto ==> $id_proto \n");
			$request_insert_heb = "INSERT INTO Heberge(id_fichier,id_proto,id_serveur) VALUES('$id_fic','$id_proto','$id_serve');";
			print("\n request_insert_heb ==> $request_insert_heb \n");
			$request_insert_h = "INSERT INTO Href(type_fic,id_fic) VALUES('1','$id_fic');";
			print("\n request_insert_h ==> $request_insert_h \n");
			$id_insert_heb = recup_data($id_href,$request_insert_heb);
			$id_insert_h = recup_data($id_href,$request_insert_h);
		}



		///traitement des lien http ainsi que des liens images
				
		else {
			print("\n Type : Http \n");
			$type_href = 2;
			$request_insert_page = "INSERT INTO page(id_serveur,url_page,date) VALUES ('$id_serveur','$path_complet',0);";
			echo"<br>";
			print("\n inserer dans la page ==> $request_insert_page \n");
			$result_insert_page = recup_data($id_href,$request_insert_page);
			$request_id_href = "SELECT id_page FROM page WHERE url_page = '$path_complet' and id_serveur='$id_serveur';";
			print("\n request_id_href ==> $request_id_href \n");
			$id_select_href = recup_data($id_href,$request_id_href);
			$object_href = pg_fetch_object($id_select_href, 0);
			$id_fic = $object_href->id_page;
			print("\n id_fic ==> $id_fic \n");
			$request_insert_href = "INSERT INTO Href(type_fic,id_fic) VALUES ($type_href,$id_fic);";
			print("\n request_insert_href ==> $request_insert_href \n");
			$result_insert = recup_data($id_href,$request_insert_href);
		}

/*		else if(ereg('jpg',$lien) || ereg('png',$lien) || ereg('bimp',$lien) || ereg('gif',$lien) || ereg('jpeg',$lien)){
			print("\n Type : Image \n");
			$type_href_img = 3;
			$request_id_href_img = "SELECT id_img FROM page WHERE url_page = '$path_complet';";
			print("\n request_id_href_img ==> $request_id_hre_imgf \n");
			$id_select_href_img = recup_data($id_href,$request_id_href_img);
			$object_href_img = pg_fetch_object($id_select_href_img, 0);
			$id_fic_img = $object_href_img->id_img;
			print("\n id_fic_img ==> $id_fic_img \n");
			$request_insert_href_img = "INSERT INTO Href(type_fic,id_fic) VALUES ('$type_href_img','$id_fic_img');";
			print("\n request_insert_href_img ==> $request_insert_href_img \n");
			$result_insert_img = recup_data($id_href,$request_insert_href_img);
		}*/
		
		$row++;
	}
	close_connexion($id_http);
	close_connexion($id_href );
}





     

 function transfert_app_http_to_apphref($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	///connection au deux base de donnees
	$id_apphttp = connection_db($user,$passwd,$name_db);
	$id_apphref = connection_db($user,$passwd,$name_nv_db);
	///recuperation de toutes les donnees de la table Appmail
	$request_allapphttp  = "SELECT  * FROM apphttp;";
	$id_select_all = recup_data($id_apphttp,$request_allapphttp);
	$row_max =  pg_numrows($id_select_all);
	$row = 4363;
	//tanqu'il y'a des lignes
	while($row < $row_max ){
		$object = pg_fetch_object($id_select_all, $row);
		//recherche des ids
		$id_page = $object->id_page;
		$id_http = $object->id_http;
		$id_mot =  $object->id_mot;
        	$occurence = $object->occurence;

		//Transformation en texte
		$request_mot = "SELECT mot FROM mothttp WHERE id_mot = $id_mot;";

		$request_lien = "SELECT lien FROM http WHERE id_http = $id_http;";

		$request_page = "SELECT * FROM page WHERE id_page = $id_page;";


		$select_mot = recup_data($id_apphttp,$request_mot);
		$select_lien = recup_data($id_apphttp,$request_lien);
		$select_page = recup_data($id_apphttp,$request_page);
	
		$object_mot = pg_fetch_object($select_mot, 0);
		$object_lien = pg_fetch_object($select_lien, 0);
		$object_page = pg_fetch_object($select_page, 0);
 
		$mot = $object_mot->mot;
		$lien = $object_lien->lien;
		$page = $object_page->fin_url;
		$id_site = $object_page->id_site;

		//id_serveur pour retrouver l'id_page
		$request_lien_site = "SELECT url from site where id_site='$id_site';";
		$select_lien_site = recup_data($id_apphttp,$request_lien_site);
		$object_lien_site =   pg_fetch_object($select_lien_site,0);
		$lien_site = $object_lien_site->url;
		
		$url_serv = str_replace("http://",'',$lien_site);
		$request_id_serv = "SELECT id_serveur FROM serveur WHERE url_serveur = '$url_serv';";
		$result_id_serv = recup_data($id_apphref,$request_id_serv);
		$object_id_serv = pg_fetch_object($result_id_serv,0);
		$id_serv = $object_id_serv->id_serveur;


		$url = parse_url($lien);
		//le protocole ftp ou http en ajoute le "://"
		//$protocole = "$url[scheme]://";
		//print("\n protocole ==> $protocole \n");
		// le chemin absolue (rep et nom du fichier)
		$path = $url[path];
		print("\n path ==> $path \n");
		
		//on decoupe le chemin absolue
		$tab_path = explode("/",$path);
		print(" \n ___ $tab_path[1] \n");
		$taille_tab = count($tab_path);
		print("\n taille du tableau ==> $taille_tab \n");
		//on recupere le nom du fichier
		$nom_fic = $tab_path[$taille_tab - 1];
		print("\n nom du fichier ==> $nom_fic \n");
		//on recupere le chemin
		if($nom_fic != null) 
			$path_rep = str_replace($nom_fic,'',$path);
		else
			$path_rep = $path;

		print("\n path du repertoire ==> $path_rep \n");
		//rajouter les ? pour les pages
		if(count($url[query]) != 0) {
			$path_complet = "$path?$url[query]";
			print("\n path complet ==> $path_complet \n");
		}
		else {
			$path_complet = $path;
			print("\n path complet ==> $path_complet \n");
		}
		$request_id_server = "SELECT id_serveur from serveur where url_serveur = '$url[host]';";
		$result_id_server = recup_data($id_apphref,$request_id_server);
		$object_id_server = pg_fetch_object($result_id_server,0);
		$id_server = $object_id_server->id_serveur;
		

/*		if(ereg(".htm",$nom_fic) || ereg(".html",$nom_fic) || ereg(".shtml",$nom_fic) || ereg(".php",$nom_fic) || ereg(".php3",$nom_fic) || ereg(".cgi",$nom_fic) || ereg(".css",$nom_fic) || ereg(".asp",$nom_fic) || ereg(".js",$nom_fic) || ereg(".shtm",$nom_fic) || ereg(".jsp",$nom_fic) || ($nom_fic == null))*/

if(ereg('\.pdf$',$nom_fic) || eregi('\.tar$',$nom_fic) || eregi('\.zip$',$nom_fic)  || ereg('\.gz$',$nom_fic) || ereg('\.ps$',$nom_fic) || ereg('\.Z$',$nom_fic) || ereg('\.txt',$nom_fic))
			$type_fic = 1;
		else 
			$type_fic = 2;


		if($type_fic == 1){
		$request_id_fic_f = "SELECT id_fichier from fichier where path='$path_rep' and nom = '$nom_fic';";
		$select_id_fic_f = recup_data($id_apphref,$request_id_fic_f);
		$object_id_fic_f = pg_fetch_object($select_id_fic_f,0);
		$id_fic = $object_id_fic_f->id_fichier;
		}
		else{
		
		$request_id_fic = "SELECT id_page FROM page WHERE url_page = '$path_complet' and id_serveur='$id_server';"; 
		$select_id_fic = recup_data($id_apphref,$request_id_fic);
		$object_id_fic = pg_fetch_object($select_id_fic,0);
		$id_fic = $object_id_fic->id_page;
		}



		
		
		$request_id_desc = "SELECT id_desc FROM mot_desc WHERE mot = '$mot';";
		
		$request_id_lien = "SELECT id_href FROM href WHERE  type_fic='$type_fic' and id_fic='$id_fic';";
		echo"<br>";
		print("\n request==>$request_id_lien \n");
		$request_id_page = "SELECT id_page FROM page WHERE url_page = '$page' and id_serveur='$id_serv';";

			
        	$id_select_mot = recup_data($id_apphref,$request_id_desc);
		$id_select_lien = recup_data($id_apphref,$request_id_lien);
		$id_select_page = recup_data($id_apphref,$request_id_page);
		
		$object_id_mot = pg_fetch_object($id_select_mot, 0);
		$object_id_lien = pg_fetch_object($id_select_lien, 0);
		$object_id_page = pg_fetch_object($id_select_page, 0);

		$id_desc = $object_id_mot->id_desc;
		$id_href = $object_id_lien->id_href;
		$id_pagen = $object_id_page->id_page;
		///Insertions des ids dans la table apphref
		
		$request_apphref = "INSERT INTO app_href(id_page,id_href,id_desc,occurrence) VALUES('$id_pagen','$id_href','$id_desc','$occurence');";

		echo"<br>";
		print("request apphref ==> $request_apphref\n");

		$result = recup_data($id_apphref,$request_apphref);
		$row++;
	}
		close_connexion($id_apphttp);
		close_connexion($id_apphref );
 

 }



function fill_mot($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	///connection au deux base de donnees
	$id_mot_txt = connection_db($user,$passwd,$name_nv_db);
	$fichier='src'; 
	$contenu = fread(fopen($fichier, "r"), filesize($fichier)); 
	$contenu_array = explode(" ",$contenu);
	$taille = sizeof($contenu_array);
	for($i=0; $i<$taille;$i++){
		$mot = strtolower($contenu_array[$i]);
		echo"<br> $mot</br>";
		$request_verif = "select id_txt from mot_txt where mot='$mot'";
		$result_verif = recup_data($id_mot_txt,$request_verif);
		$row = pg_numrows($result_verif);
		if($row == 0){
		$request_insert = "INSERT INTO mot_txt (mot) VALUES ('$mot');";
		$result = recup_data($id_mot_txt,$request_insert);
		}
	}
	close_connexion($id_mot_txt);
}

function fill_txt_doc($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	$id_txt_doc = connection_db($user,$passwd,$name_nv_db);
    	$request_select_fic = "select id_fichier from fichier where nom like '%.txt' or nom like '%.pdf' or nom like '%.ps';";
	$result =recup_data($id_txt_doc,$request_select_fic);
	$row_max =  pg_numrows($result);
	$row = 0;
	while($row < $row_max){
		$object_id_fic = pg_fetch_object($result, $row);
		$tab_id_fic[$row] = $object_id_fic->id_fichier;
		$request_insert_doc_txt = "INSERT INTO doc_txt(id_fichier) VALUES ('$tab_id_fic[$row]');";
		$insert =  recup_data($id_txt_doc,$request_insert_doc_txt);
		$row++;
	}
	
	
	$request_id_fic = "select * from fichier;";
	$result_id_fic = recup_data($id_txt_doc,$request_id_fic);
	$row_max_fic =  pg_numrows($result_id_fic);
	$row_fic = 0;
	$taille_tab = sizeof($tab_id_fic);
	echo"<br> taille du tableau =>$taille_tab </br>";
	while($row_fic < $row_max_fic){
		$object =   pg_fetch_object($result_id_fic, $row_fic);
		$id_fic = $object->id_fichier;
		echo"<br> l'id du fichier : $id_fic ";
		for($i=0;$i<200;$i++){
			$indice_fic_r = rand(1,($taille_tab-1));
			echo"<br>indice du tableau ==> $indice_fic_r </br>";
			$id_fic_r = $tab_id_fic[$indice_fic_r];
			echo"<br> l'id_txt : $id_fic_r </br>";
			///verifier si l'id est valide en cherchant le nbre d'occurence 
			$valid_id = "select occurrence from txt_doc where (id_txt=$id_fic_r AND id_fichier=$id_fic );";
			echo"<br> request => $valid_id </br>";
			$result_valid = recup_data($id_txt_doc,$valid_id); 
			$row_existe =  pg_numrows($result_valid);
			///modifier le nombre d'occurence avec un update
			if($row_existe > 0){
				$object_valide =   pg_fetch_object($result_valid, 0);
				$occ = $object_valide->occurrence;
				$occ++;
				$request_update = "UPDATE txt_doc SET occurrence = $occ WHERE (id_txt = $id_fic_r AND id_fichier=$id_fic);";
				$result_update = recup_data($id_txt_doc,$request_update);
			}
			///inserer dans la Table 
			else{
				$request_insert = "insert into  txt_doc (id_txt,id_fichier,occurrence) values('$id_fic_r','$id_fic','1');";	
				$result_update = recup_data($id_txt_doc,$request_insert);
			}
		}//fin du for
	$row_fic++;
	}//fin du while
	close_connexion($id_txt_doc);
}


///remplir la table txt_page

function fill_txt_page($name_db,$name_nv_db){
	$user = "kartoush";
	$passwd = "freeman23";
	$id_txt_page = connection_db($user,$passwd,$name_nv_db);
	$request_id_page = "select * from page;";
	$result_id_page = recup_data($id_txt_page,$request_id_page);
	$row_max =  pg_numrows($result_id_page);
	$row = 0;
	$request_max = "SELECT MAX(id_txt) FROM mot_txt AS A;";
	$result_max = recup_data($id_txt_page,$request_max);
	$object_max =  pg_fetch_object($result_max, 0);
	$max = $object_max->max;
	echo"<br> le max des id_page : $max <br>";
	while($row < $row_max){
		
		$object =   pg_fetch_object($result_id_page, $row);
		$id_page = $object->id_page;	
		for($i=0;$i<20;$i++){
			$id_txt = rand(1,$max);
			echo "<br> $id_txt </br>";
			
			///verifier si l'id est valide en cherchant le nbre d'occurence 
			$valid_id = "select occurrence from txt_page where id_txt=$id_txt and id_page = $id_page;";
			$result_valid = recup_data($id_txt_page,$valid_id); 
			$row_existe =  pg_numrows($result_valid);
			///modifier le nombre d'occurence avec un update
			if($row_existe > 0){
				$object_valide =   pg_fetch_object($result_valid, 0);
				$occ = $object_valide->occurrence;
				$occ++;
				$request_update = "UPDATE  txt_page SET occurrence = $occ WHERE (id_txt = $id_txt AND id_page = $id_page);";

				echo"<br> $request_update </br>";
				$result_update = recup_data($id_txt_page,$request_update);
			}
			///inserer dans la Table 
			else{
				$request_insert = "insert into  txt_page (id_txt,id_page,occurrence) values($id_txt,$id_page,1);";

				echo "<br>la requete d'insertion ==> $request_insert</br>";	
				$result_insert = recup_data($id_txt_page,$request_insert);
			}
		}//fin du for
	$row++;
	}//fin du while
	close_connexion($id_txt_page);
}

?>
