<?php
/**
 * Connection a la base de donnee
 *@param $hote  le hote ou la base est stocke
 *@param $port  port de connexion
 *@param $user  l'utilisateur de la base
 *@param $passwd  mot de passe 
 *@param $name_db  nom de la base de donnee
 *@return 
 *			message d'erreur en cas de non connexion a la base
 *			Sinon l'identifiant de la connexion ouvert
 **/

function connection_db($user,$passwd,$name_db){
  //connection a la base
  $id_connection = pg_connect(" dbname=$name_db user=$user password=$passwd" );
  if(!$id_connection)
    gestion_error($id_connection,1);
  else 
    return $id_connection;
}

/**
 * Gestion des erreur selon l'identifiant
 *@param $id  identifiant
 *@return message d'erreur et une trace de l'erreur
 **/

function gestion_error($id,$id_function){
  //selon l'id de la fonction on affiche le message d'erreur
  if($id_function == 1) $message= "erreur de connection ";
  else if($id_function == 2) $message = "erreur d'execution de requete ";
  else $message=" erreur inconue ";
  echo $message;
  echo  pg_ErrorMessage($id);
  exit;
}

/**
 *Recuperation des donnees de la bd
 *@param $id  identifiant
 *@param $request_sql  requete sql (Type : select)
 *@retrun message d'erreur sinon l'identifiant du resultat
 **/

function recup_data($id_connection,$request_sql){
  //execution de la requete 
  $id_selection = pg_exec($id_connection,$request_sql);
  //s'il y'a une erreur
  if(!$id_selection)
    gestion_error($id_selection,2);
  else
    return $id_selection;
}






/***************************************************************** HTTP ****************************************************************
*****************************************************************************************************************************************/

/**
 * Transforme la chaine de caracteres sous forme d'une requete SQL
 *@param chaine de caractere
 *@return requete SQL
 **/

function parsing_token_mot($tok,$id){
  $string = null;
  $id_mot = null;
  $tok = trim($tok);
  $tok = str_replace('+',',',$tok);
  $tok = str_replace('&',',',$tok);
  $tok = str_replace(' ',',',$tok);
  $arry  = explode(",",$tok);
  $length  = count($arry);
  
  for($i=0; $i<$length;$i++){
   if($string == null) 
   $string = $string . "'" . $arry[$i] . "'";
   else
   $string = $string . ","  . "'" . $arry[$i] ."'";
 }
  $request= "SELECT id_mot FROM mothttp WHERE mot IN ($string)";
  $id_request = recup_data($id,$request);
  $row_max =  pg_numrows($id_request);
  $i = 0;
  while($i < $row_max){
    $mot = pg_fetch_object($id_request, $i);
    if($id_mot == null) 
      $id_mot = $id_mot  . $mot->id_mot ;
    else
      $id_mot = $id_mot . ","  . $mot->id_mot ;
    $i++;
  }
  $id_mots = "($id_mot)";
 return $id_mots;
}

/**
 *Parser une chaine de caracteres
 *@param $token  chaine de caracteres
 *@return requete SQL
 */
function parsing_token($tokens){  
  $tokens = trim($tokens);
  //traitement de l'operateur AND
  $arry = explode("&",$tokens);
  $length = count($arry);
  //traitement de l'operateur OR
  for($i=0;$i<$length;++$i){	
    $arry[$i] = str_replace('+',' ',$arry[$i]);
    $arry[$i] = trim($arry[$i]);
    $arry1 = explode(' ',$arry[$i]);
    for($j=0; $j<count($arry1);++$j){
      $arry1[$j] = trim($arry1[$j]);
      $arry1[$j] = strtolower($arry1[$j]);
    }
    $arry[$i] = $arry1;
  }
  $lentgh = count($arry);
  $request = NULL;
  $request_inter = NULL;
  //mise de la recherche sous forme de requete SQL
  for($i=0; $i < $lentgh; ++$i)
    {
      $length_to = count($arry[$i]);
      $arry_to = $arry[$i];
      for($j=0; $j<$length_to;++$j)
	{   
	  if(($request_inter == NULL) && ($arry[$j] != " ") && ($arry_to[$j] != null))
	    $request_inter =  " SELECT DISTINCT id_http FROM AppHttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot = '$arry_to[$j]') " ;
	  else if (($arry[$j] !=  " ") && ($arry_to[$j] != null))
	    $request_inter = $request_inter . "   UNION ALL  " .  "  SELECT DISTINCT id_http from AppHttp where id_mot IN (SELECT id_mot FROM mothttp WHERE mot = '$arry_to[$j]')" ;
	}
      if($request == NULL)
	$request = $request_inter;
      else
	$request = " ( $request )" . "  INTERSECT ALL  " . "( $request_inter )";   
      $request_inter = NULL;
    }
  
  return $request; 
}


/**
 *Recupration des id_http dans un tableau
 *@param $id_selection l'identifiant de la requete qui selectionn les id_http 
 *                     ordonner dans l'ordre croissant 
 *@param $tokens  les mots rechercher
 *@param $id l'identifiant de la connexion a la bd 
 *@return tableau contenant les id_http classes par ordre de pertinance
 */

function recup($id_selection,$tokens,$id){
  //nombre maximum de ligne dans la table
  $row_max =  pg_numrows($id_selection);
  $row = 0;
  $cur = 0; 
  $last = 0;
  //tanqu'il y'a des lignes
  while($cur < $row_max ){
     //recuperation de la ligne (sous forme d'objet)
     $data = pg_fetch_object($id_selection, $cur);
     $occ = $data->occ;
     $last = $cur;
     while($data->occ == $occ){
        $cur++;
        if($cur == $row_max) 
	    break;
        $data = pg_fetch_object($id_selection, $cur); 
     }
     $data_tmp = pg_fetch_object($id_selection, $last);
     $query = "SELECT id_http, SUM(occurence) AS nb FROM apphttp WHERE  (id_http IN (" . $data_tmp->id_http;
     for($i=$last+1 ; $i<$cur ; $i++){
       $data_tmp = pg_fetch_object($id_selection, $i);
	$query = $query . ',' . $data_tmp->id_http;
     }
     $liste_id_mots = parsing_token_mot($tokens,$id);
echo "liste_id_mots=$liste_id_mots<br>";
     $query =  $query . " )) AND (id_mot IN  " . $liste_id_mots  . " ) GROUP BY id_http ORDER BY nb ;";
echo "$query<br>";
     $result_c = recup_data($id,$query);
     for($i=$last;$i<$cur;$i++){
       $data_tmp = pg_fetch_object($result_c, $i-$last);
       $tab_id_lien[$i] =  $data_tmp->id_http; 
     }
     $query=null;
     $query_ter=null;
  }
  return ($tab_id_lien);
}
/**
 *Affichage des liens trouver
 *@param $tab tableau des id_http trouver  
 *@param $id l'identifiant de la connexion a la bd 
 *@param $tokens les mots rechercher
 *@return rien
 */

function print_link($tab,$id,$tokens){
  $i = 0;
  $taille = count($tab);
  if(!$taille){
    echo "<H3> Aucun document ne correspond aux termes de recherche spcifier($tokens).<BR>\n
               Aucune page ne contient \"$tokens\".<BR>\n

              Suggestions :<BR>\n

              -Vrifiez l'orthographe des termes de recherche.<BR>\n
              - Essayez d'autres mots.<BR>\n
              - Utilisez des mots plus gnraux.<BR>\n
          <H3>";
  }
  else{ 
    $page = 0;
    while($page < $taille){
      if($taille < 10) $page = $taille;
      else $page = $page + 10;
	while($i < $page ){
	  $query = "SELECT lien FROM http WHERE id_http=$tab[$i];";
	  $id_execute = recup_data($id,$query);
	  $data = pg_fetch_object($id_execute, 0);
	  $http = $tab[$i];
	  //recuperation du lien
	  $link = $data->lien;
	  
	  echo"<br>";
	  echo "<H3><a href=$link> $link  </a></H3> ";
	  echo "<H3><a href=\"app.php?idhttp=$http\"> appartient  </a> </H3>";
	  echo"<br>";
	  $i++;
    }
	$i = $i + $page;
  }
}
}
/******************************************************************Fin HTTP******************************************************************
**********************************************************************************************************************************************/

/****************************************************************** EMAIL *********************************************************************
**********************************************************************************************************************************************/

/**
 * Transforme la chaine de caracteres sous forme d'une requete SQL
 *@param chaine de caractere
 *@return requete SQL
 **/

function parsing_token_email($tok,$id){
  $string = null;
  $id_mot = null;
  $tok = trim($tok);
  $tok = str_replace('+',',',$tok);
  $tok = str_replace('&',',',$tok);
  $tok = str_replace(' ',',',$tok);
  $arry  = explode(",",$tok);
  $length  = count($arry);
  
  for($i=0; $i<$length;$i++){
   if($string == null) 
   $string = $string . "'" . $arry[$i] . "'";
   else
   $string = $string . ","  . "'" . $arry[$i] ."'";
 }
  $request= "SELECT id_mot FROM MotMail WHERE mot IN ($string)";
  $id_request = recup_data($id,$request);
  $row_max =  pg_numrows($id_request);
  $i = 0;
  while($i < $row_max){
    $mot = pg_fetch_object($id_request, $i);
    if($id_mot == null) 
      $id_mot = $id_mot  . $mot->id_mot ;
    else
      $id_mot = $id_mot . ","  . $mot->id_mot ;
    $i++;
  }
  $id_mots = "($id_mot)";
 return $id_mots;
}

/**
 *Parser une chaine de caracteres
 *@param $token  chaine de caracteres
 *@return requete SQL
 */
function parsing_email($tokens){  
  $tokens = trim($tokens);
  //traitement de l'operateur AND
  $arry = explode("&",$tokens);
  $length = count($arry);
  //traitement de l'operateur OR
  for($i=0;$i<$length;++$i){	
    $arry[$i] = str_replace('+',' ',$arry[$i]);
    $arry[$i] = trim($arry[$i]);
    $arry1 = explode(' ',$arry[$i]);
    for($j=0; $j<count($arry1);++$j){
      $arry1[$j] = trim($arry1[$j]);
      $arry1[$j] = strtolower($arry1[$j]);
    }
    $arry[$i] = $arry1;
  }
  $lentgh = count($arry);
  $request = NULL;
  $request_inter = NULL;
  //mise de la recherche sous forme de requete SQL
  for($i=0; $i < $lentgh; ++$i)
    {
      $length_to = count($arry[$i]);
      $arry_to = $arry[$i];
      for($j=0; $j<$length_to;++$j)
	{   
	  if(($request_inter == NULL) && ($arry[$j] != " ")  && ($arry_to[$j] != null))
	    $request_inter =  " SELECT DISTINCT id_mail FROM AppMail WHERE id_mot IN (SELECT id_mot FROM MotMail WHERE mot = '$arry_to[$j]') " ;
	  else if (  ($arry[$j] != " ") && ($arry_to[$j] != null) )
	    $request_inter = $request_inter . "   UNION ALL  " .  "  SELECT DISTINCT id_mail from AppMail where id_mot IN (SELECT id_mot FROM MotMail WHERE mot = '$arry_to[$j]')" ;
	}
      if($request == NULL)
	$request = $request_inter;
      else
	$request = " ( $request )" . "  INTERSECT ALL  " . "( $request_inter )";   
      $request_inter = NULL;
    }

  return $request; 
}

/**
 *Recupration des id_mail dans un tableau
 *@param $id_selection l'identifiant de la requete qui selectionn les id_http 
 *                     ordonner dans l'ordre croissant 
 *@param $tokens  les mots rechercher
 *@param $id l'identifiant de la connexion a la bd 
 *@return tableau contenant les id_mail
 */

function recup_email($id_selection,$tokens,$id){
  //nombre maximum de ligne dans la table
  $row_max =  pg_numrows($id_selection);
  $row = 0;
  $cur = 0; 
  $last = 0;
  //tanqu'il y'a des lignes
  while($cur < $row_max ){
     //recuperation de la ligne (sous forme d'objet)
     $data = pg_fetch_object($id_selection, $cur);
     $occ = $data->occ;
     $last = $cur;
     while($data->occ == $occ){
        $cur++;
        if($cur == $row_max) 
	    break;
        $data = pg_fetch_object($id_selection, $cur); 
     }
     $data_tmp = pg_fetch_object($id_selection, $last);
     $query = "SELECT id_mail, SUM(occurence) AS nb FROM appmail WHERE  (id_mail IN (" . $data_tmp->id_mail;
     for($i=$last+1 ; $i<$cur ; $i++){
        $data_tmp = pg_fetch_object($id_selection, $i);
	$query = $query . ',' . $data_tmp->id_mail;
     }
     $liste_id_mots = parsing_token_email($tokens,$id);
echo "liste_id_mots=$liste_id_mots<br>";
     $query =  $query . " )) AND (id_mot IN  " . $liste_id_mots  . " ) GROUP BY id_mail ORDER BY nb ;";
echo "$query<br>";
     $result_c = recup_data($id,$query);
     for($i=$last;$i<$cur;$i++){
       $data_tmp = pg_fetch_object($result_c, $i-$last);
       $tab_id_lien[$i] =  $data_tmp->id_mail; 
     }
  }
  return ($tab_id_lien);
}

/**
 *Affichage des email trouver
 *@param $tab tableau des id_mail trouver  
 *@param $id l'identifiant de la connexion a la bd 
 *@param $tokens les mots rechercher
 *@return rien
 */
function print_email($tab,$id,$tokens){
  $i = 0;
  $taille = count($tab);
  if(!$taille){
    echo "<H3> Aucune adresse email ne correspond aux termes de recherche spcifier($tokens).<BR>\n
               Aucune page ne contient \"$tokens\".<BR>\n

              Suggestions :<BR>\n

              -Vrifiez l'orthographe des termes de recherche.<BR>\n
              - Essayez d'autres mots.<BR>\n
              - Utilisez des mots plus gnraux.<BR>\n
          <H3>";
  }
  else{ 
    $page = 0;
    while($page < $taille){
      if($taille < 10) $page = $taille;
      else $page = $page + 10;
	while($i < $page ){
	  $query = "SELECT mail FROM Mail WHERE id_mail=$tab[$i];";
	  $id_execute = recup_data($id,$query);
	  $data = pg_fetch_object($id_execute, 0);
	  $mailid = $tab[$i];
	  //recuperation du lien
	  $mail = $data->mail;
	  
	  echo"<br>";
	  echo "<H3><a href=$mail> $mail  </a></H3> ";
	  echo "<H3><a href=\"appMail.php?idmail=$mailid\"> appartient  </a> </H3>";
	  echo"<br>";
	  $i++;
    }
	$i = $i + $page;
  }
}
}


/**************************************************************************** Fin EMAIL ****************************************************************
*******************************************************************************************************************************************************/


/**************************************************************************** Image *******************************************************************
*******************************************************************************************************************************************************/




function parsing_token_picture($tok,$id){
  $string = null;
  $id_mot = null;
  $tok = trim($tok);
  $tok = str_replace('+',',',$tok);
  $tok = str_replace('&',',',$tok);
  $tok = str_replace(' ',',',$tok);
  $arry  = explode(",",$tok);
  $length  = count($arry);
  
  for($i=0; $i<$length;$i++){
   if($string == null) 
   $string = $string . "'" . $arry[$i] . "'";
   else
   $string = $string . ","  . "'" . $arry[$i] ."'";
  }
  $request= "SELECT id_mot FROM MotPict WHERE mot IN ($string)";
  $id_request = recup_data($id,$request);
  $row_max =  pg_numrows($id_request);
  $i = 0;
  while($i < $row_max){
    $mot = pg_fetch_object($id_request, $i);
    if($id_mot == null) 
      $id_mot = $id_mot  . $mot->id_mot ;
    else
      $id_mot = $id_mot . ","  . $mot->id_mot ;
    $i++;
  }
  $id_mots = "($id_mot)";
 return $id_mots;
}

/**Fonction : parser une chaine de caracteres
 *@param $token  chaine de caracteres
 *@return requete SQL
 */
function parsing_picture($tokens){  
  $tokens = trim($tokens);
  //traitement de l'operateur AND
  $arry = explode("&",$tokens);
  $length = count($arry);
  //traitement de l'operateur OR
  for($i=0;$i<$length;++$i){	
    $arry[$i] = str_replace('+',' ',$arry[$i]);
    $arry[$i] = trim($arry[$i]);
    $arry1 = explode(' ',$arry[$i]);
    for($j=0; $j<count($arry1);++$j){
      $arry1[$j] = trim($arry1[$j]);
      $arry1[$j] = strtolower($arry1[$j]);
    }
    $arry[$i] = $arry1;
  }
  $lentgh = count($arry);
  $request = NULL;
  $request_inter = NULL;
  //mise de la recherche sous forme de requete SQL
  for($i=0; $i < $lentgh; ++$i)
    {
      $length_to = count($arry[$i]);
      $arry_to = $arry[$i];
      for($j=0; $j<$length_to;++$j)
	{   
	  if( ($request_inter == NULL) && ($arry[$j] != " ") && ($arry_to[$j] != null) )
	    $request_inter =  " SELECT DISTINCT id_pict FROM AppPict WHERE id_mot IN (SELECT id_mot FROM MotPict WHERE mot = '$arry_to[$j]') " ;
	  else if ( ($arry[$j] != " ") && ($arry_to[$j] != null ) )
	    $request_inter = $request_inter . "   UNION ALL  " .  "  SELECT DISTINCT id_pict from AppPict where id_mot IN (SELECT id_mot FROM MotPict WHERE mot = '$arry_to[$j]')" ;
	}
      if($request == NULL)
	$request = $request_inter;
      else
	$request = " ( $request )" . "  INTERSECT ALL  " . "( $request_inter )";   
      $request_inter = NULL;
    }
  
  return $request; 
}



function recup_picture($id_selection,$tokens,$id){
  //nombre maximum de ligne dans la table
  $row_max =  pg_numrows($id_selection);
  $row = 0;
  $cur = 0; 
  $last = 0;
  //tanqu'il y'a des lignes
  while($cur < $row_max ){
     //recuperation de la ligne (sous forme d'objet)
     $data = pg_fetch_object($id_selection, $cur);
     $occ = $data->occ;
     $last = $cur;
     while($data->occ == $occ){
        $cur++;
        if($cur == $row_max) 
	    break;
        $data = pg_fetch_object($id_selection, $cur); 
     }
     $data_tmp = pg_fetch_object($id_selection, $last);
     $query = "SELECT id_pict, SUM(occurence) AS nb FROM apppict WHERE  (id_pict IN (" . $data_tmp->id_pict;
     for($i=$last+1 ; $i<$cur ; $i++){
        $data_tmp = pg_fetch_object($id_selection, $i);
	$query = $query . ',' . $data_tmp->id_pict;
     }
     $liste_id_mots = parsing_token_picture($tokens,$id);
echo "liste_id_mots=$liste_id_mots<br>";
     $query =  $query . " )) AND (id_mot IN  " . $liste_id_mots  . " ) GROUP BY id_pict ORDER BY nb ;";
echo "$query<br>";
     $result_c = recup_data($id,$query);
     for($i=$last;$i<$cur;$i++){
       $data_tmp = pg_fetch_object($result_c, $i-$last);
       $tab_id_lien[$i] =  $data_tmp->id_pict; 
     }
  }
  return ($tab_id_lien);
}


function print_picture($tab,$id,$tokens){
  $i = 0;
  $taille = count($tab);
  if(!$taille){
    echo "<H3> Aucune image ne correspond aux termes de recherche spcifier($tokens).<BR>\n
               Aucune image  ne contient \"$tokens\".<BR>\n

              Suggestions :<BR>\n

              -Vrifiez l'orthographe des termes de recherche.<BR>\n
              - Essayez d'autres mots.<BR>\n
              - Utilisez des mots plus gnraux.<BR>\n
          <H3>";
  }
  else{ 
    $page = 0;
 	echo"<TABLE BORDER=2 CELLPADDING=0 CELLSPACING=1>";
    while($page < $taille){
      if($taille < 10) $page = $taille;
      else $page = $page + 10;
	while($i < $page ){
	  $query = "SELECT * FROM Pict WHERE id_pict=$tab[$i];";
	  $id_execute = recup_data($id,$query);
	  $data = pg_fetch_object($id_execute, 0);
	  //$mailid = $tab[$i];
	  //recuperation du lien
	  $nomimage = $data->fichier;
          $query = "SELECT url FROM Site WHERE id_site=" . $data->id_site . ";";
	  $id_execute = recup_data($id,$query);
	  $data2 = pg_fetch_object($id_execute, 0);
          $url_pict = $data2->url . $data->chemin . $data->nom;
	  echo "<TR>";
	  echo "<TD> <IMG SRC=../data/pict/$nomimage></TD>";
          echo "<TD> <A HREF=$url_pict>$url_pict</A> </TD>"; 
	  echo "</TR>";
	  $i++;
    }
	$i = $i + $page;
  }
}
echo"</TABLE>";
}

/***************************************************************************Fin Image *******************************************************************
*********************************************************************************************************************************************************/

/**
 * Fermeture de la connexion a la bd
 *@param $id identifiant de la connexion
 *@return message d'erreur sinon l'identifiant du resultat
 **/
function close_connexion($id){
	if(!pg_close($id))
		gestion_error($id,3);
}
?>
