----------------------------------------------------------------------------------------------
-- INSERTIONS
----------------------------------------------------------------------------------------------

----
-- Insertion ds Site
--

insert into site values ('www.google.fr');
insert into site values ('www.altavista.com');

--
-- Insertion ds Page
--

insert into page values ('',1,0);
insert into page values ('',2,0);

----
-- Insertion ds Http
--

insert into http values ('www.free.fr');
insert into http values ('www.oreka.com');

--
-- Insertion ds MotHttp
--

insert into mothttp values ('fournisseur_inet');
insert into mothttp values ('bien');
insert into mothttp values ('nul');
insert into mothttp values ('provider');
insert into mothttp values ('good');

--
-- Insertion ds AppHttp
--

insert into apphttp values (1,1,1,3); -- www.google.fr     | www.free.fr  | fournisseur_inet | 3
insert into apphttp values (1,1,2,3); -- www.google.fr     | www.free.fr  | bien             | 3
insert into apphttp values (2,1,4,1); -- www.altavista.com | www.free.fr  | provider         | 1
insert into apphttp values (2,1,5,1); -- www.altavista.com | www.free.fr  | good             | 1
insert into apphttp values (1,2,1,2); -- www.google.fr     | www.oreka.fr | fournisseur_inet | 2
insert into apphttp values (1,2,3,2); -- www.google.fr     | www.oreka.fr | nul              | 2

----
-- Insertion ds Mail
--

insert into mail values ('sav@free.fr');
insert into mail values ('client@oreka.fr');

--
-- Insertion ds MotMail
--

insert into motmail values ('service');
insert into motmail values ('apres');
insert into motmail values ('vente');
insert into motmail values ('clientelle');

--
-- Insertion ds AppMail
--

insert into appmail values (1,1,1,1); -- www.google.fr     | sav@free.fr     | service    | 1
insert into appmail values (1,1,2,1); -- www.google.fr     | sav@free.fr     | apres      | 1
insert into appmail values (1,1,3,1); -- www.google.fr     | sav@free.fr     | vente      | 1
insert into appmail values (1,2,1,1); -- www.google.fr     | client@oreka.fr | service    | 1
insert into appmail values (1,2,4,1); -- www.google.fr     | client@oreka.fr | clientelle | 1

----
-- Insertion ds Pict
--

select ins_pict_nom(1,1,'logo_free.gif','/img/','logo_free.gif','logo',1);
select ins_pict_nom(1,1,'logo_free.gif','/img/','logo_free.gif','free',1);
select ins_pict_nom(1,1,'logo_google.gif','/data/pict/','logo_google.gif','logo',1);
select ins_pict_nom(1,1,'logo_google.gif','/data/pict/','logo_google.gif','google',1);
select ins_pict_nom(2,2,'logo_alta.gif','/pict/','logo_altavista.gif','title',1);

----------------------------------------------------------------------------------------------
-- REQUETES
----------------------------------------------------------------------------------------------

--
-- provider
--

\echo requete : provider
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider');

--
-- provider OU fournisseur_inet
--

\echo requete : provider OU fournisseur_inet
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider')
UNION ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='fournisseur_inet');

--
-- provider ET good
--

\echo requete : provider ET good
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider')
INTERSECT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='good');

--
-- provider ET good ET fournisseur_inet ET bien
--

\echo requete : provider ET good ET fournisseur_inet ET bien
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider')
INTERSECT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='good')
INTERSECT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='fournisseur_inet')
INTERSECT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='bien');

--
-- provider ET nul
--

\echo requete : provider ET nul
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider')
INTERSECT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='nul');

--
-- (provider OU fournisseur_inet) ET (bien OU good)
--

\echo requete : (provider OU fournisseur_inet) ET (bien OU good)
(SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider')
UNION ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='fournisseur_inet'))
INTERSECT ALL
(SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='bien')
UNION ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='good'));

--
-- provider ET (good OU average)
--

\echo requete : provider ET (good OU average)
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider')
INTERSECT ALL
(SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='good')
UNION ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='average'));

--
-- fournisseur_inet NOT nul
--

\echo requete : fournisseur_inet NOT nul
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='fournisseur_inet')
EXCEPT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='nul');

--
-- (fournisseur_inet OU provider) NOT nul
--

\echo requete : (fournisseur_inet OU provider) NOT nul
(SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='fournisseur_inet')
UNION ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='provider'))
EXCEPT ALL
SELECT DISTINCT id_http FROM apphttp WHERE id_mot IN (SELECT id_mot FROM mothttp WHERE mot='nul');
