import java.io.*;

/**
 * Classe amliorant la classe <code>PrintStream</code> en facilitant le contrle des accs
 * concurants au flux.<p>
 * En fait cette classe n'est plus utilise (voir la section 'deprecation').
 * @author Martin Ludovic
 * @deprecated Cette classe est en faite inutile car la classe <code>PrintStream</code> est
 * dj protge contre les accs concurents bien que cela ne soit pas explicitement dit
 * dans la documentation java (il faut regarder le code source de la classe pour le savoir).
 * Cette classe engendre donc des appels de fonction inutils (mais couteux en temps et en mmoire).
 * De plus elle est risque dan sle sens o toutes les mthodes de la classe mre n'ont pas t 
 * surcharges ce qui la rend non homogne.
 */
public class LockedPrintStream extends PrintStream {
    /** Limite l'accs au flux pour conserver la cohrence des donnes qui y sont crites. */
    protected Semaphore sem;

    /**
     * Construit un nouvel objet <code>LockedPrintStream</code>.<p>
     * Le smaphore est initialis de sorte qu'il ne permette qu' un seul processus  la fois 
     * d'crire dans le flux.<p>
     * Le constructeur fait appel au constructeur de PrintStream en prcisant explicitement
     * qu'aprs chaque appel  <code>println</code> le buffer doit tre vid et le flux inscrit
     * sur le disque dur.
     * @param os paramtre ncessaire au constructeur de <code>PrintStream</code>
     * @see java.io.PrintStream#PrintStream(java.io.OutputStream,boolean)
     */
    public LockedPrintStream (OutputStream os) {
	super(os,true);
	sem = new Semaphore();
    }

    public void println (String s) {
	sem.P();
	print(s);
	println();
	sem.V();
    }

    public void println (Object o) {
	sem.P();
	print(o);
	println();
	sem.V();
    }

    public void println (char c) {
	sem.P();
	print(c);
	println();
	sem.V();
    }

    public void println (char[] s) {
	sem.P();
	print(s);
	println();
	sem.V();
    }

    public void println (double x) {
	sem.P();
	print(x);
	println();
	sem.V();
    }

    public void println (int x) {
	sem.P();
	print(x);
	println();
	sem.V();
    }

    public void println (long x) {
	sem.P();
	print(x);
	println();
	sem.V();
    }

    public void println (float x) {
	sem.P();
	print(x);
	println();
	sem.V();
    }

    public void println (boolean x) {
	sem.P();
	print(x);
	println();
	sem.V();
    }
}
