/**
 * Classe permettant de runir dans un mme objet toutes les caractristiques d'une page web
 * stocke dans la base de donnes du crawler.
 * @author Martin Ludoovic
 */
public class Page {
    /** L'url de la page web */
    public String fin_url;
    /** La date de dernire modificationde la page */
    public int date;
    /** L'identificateur de la page dans la base de donnes du crawler */
    public int id_page;
    /** L'identificateur du site o se trouve la page. */
    public int id_site;

    /**
     * Construit un nouvel objet <code>Page</code> sans initialiser ses caractristiques.
     */
    public Page () {}

    /**
     * Construit un nouvel objet <code>Page</code> en initialisant ses caractristiques.
     * @param fin_url l'url de la page web
     * @param date la date de dernire modificationde la page
     * @param id_page l'identificateur de la page dans la base de donnes du crawler
     * @see #fin_url
     * @see #date
     * @see #id_page
     * @see #id_site
     */
    public Page (String fin_url, int date, int id_page, int id_site) {
	this.fin_url = fin_url;
	this.date = date;
	this.id_page = id_page;
	this.id_site = id_site;
    }
}
