import java.lang.*;

/**
 * Classe permettant de stocker dans la pile fifo du crawler  la fois une url de page  visiter
 * et la profondeur de celle-ci par rapport  une des pages de dmarrage de l'application.<p>
 */
public class PageWeb {
    /** URL d'une page web  vister. */
    public String url;
    /** Profondeur de la page  visiter par rapport  une des pages de dmarrage de l'application. */
    public int depth;

    /**
     * Construit un nouvel objet <code>PageWeb</code> sans initialiser ses champs.
     */
    public PageWeb () {
    }

    /**
     * Construit un nouvel objet <code>PageWeb</code> en initialisant tous ses champs.
     */
    public PageWeb (String url, int depth) {
	this.url = url;
	this.depth = depth;
    }

    /**
     * Compare deux objets et dtermine s'il dsigne la mme page web.<p>
     * L'objet pass en argument doit tre de type <code>PageWeb</code>.<p>
     * Deux objet <code>PageWeb</code> sont identiques si leurs champs le sont.
     * @param o l'objet auquel il faut comparer <code<this</code>
     * @return <ul>
     *           <li><code>true</code> si les deux objets dsignent la mme page web.
     *           <li><code>false</code> sinon
     *         </ul>
     */
    public boolean equals(Object o) {
	if (this == o) {
	    return true;
	}
	if (o instanceof String) {
	    PageWeb pw = (PageWeb) o;
	    return (this.url==pw.url && this.depth==pw.depth);
	}
	return false;
    }
}
