/**
 * Classe implmentant un smaphore.<p>
 * Un smaphore permet de contrler le nombre de processus accdant  une ressource partage.<p>
 * Remarque: Cette classe est totalement gnrale, c'est  dire qu'elle peut tre rutilise.<p>
 * Remarque: Cette classe n'est plus utilise car elle devait servir dans l'implmentation de la
 * classe <code>LockedPrintStream</code>, mais celle-ci a t dprcie.
 * telle quelle dans une autre application.
 * @see LockedPrintStream
 * @author Martin Ludovic
 */
public class Semaphore {
    /** Indique le nombre maximal d'accs simultans  la ressource partage */
    protected int val;
	
    /**
     * Construit un nouvel objet <code>Semaphore</code> n'autorisant qu'un seul accs  la fois
     *  la ressource partage.<p>
     * Identique au constructeur <code>Semaphore(int)</code> auquel on aurait pass 1 en argument.
     * @see #Semaphore(int)
     */
    public Semaphore () {
	val = 1;
    }

    /**
     * Construit un nouvel objet <code>Semaphore</code> autorisant <code>nb</code> accs simultans
     *  la ressource partage.
     * @param nb le nombre maximum d'accs simultans  la ressource partage.
     */
    public Semaphore (int nb) throws IllegalArgumentException {
	if (nb < 1)
	    throw new IllegalArgumentException(nb + " < 1");
	val = nb;
    }

    /**
     * Demande l'autorisation d'accder  la resource partage.<p>
     * Lorsque le nombre maximum d'accs  la ressource est atteint, tous les processus appelant
     * cette mthode sont mis en attente.
     */
    public synchronized void P () {
	try	{
	    while (val == 0) { // La ressource est dj utilise
		wait();
	    }
	    // Rserve la ressource la resource
	    val --;
	} catch (InterruptedException e) {}
    }

    /**
     * Relache la ressource partage pour permettre ventuellement  un autre processus d'y accder.
     */
    public synchronized void V () {
	val++;
	if (val == 1)
	    notify();
    }
}
