/**
 * Classe implmentant un entier et permettant plus d'oprations que la classe java.lang.Integer.
 */
public class Entier {
    /** La valeur entire de cet objet */
    protected int i;

    /**
     * Construit un nouvel objet Entier avec 0 comme valeur par dfaut.
     * Identique au constructeur Entier(int) auquel on aurait pass en argument 0.
     */
    public Entier () {
	i = 0;
    }

    /**
     * Construit un nouvel objet Entier valant nb.
     */
    public Entier (int nb) {
	i = nb;
    }

    /**
     * Incrmente de 1 la valeur de cet objet.<p>
     * Identique  la mthode void#increase(int)  laquelle on aurait pass comme argument 1.
     * @see #increase(int)
     */
    public void increase () {
	i++;
    }

    /**
     * Incrmente de pas la valeur de cet objet.
     * @param pas le pas d'incrmentation de la valeur de l'objet
     */
    public void increase (int pas) {
	i += pas;
    }

    /**
     * Retourne la valeur de cet objet sous forme de int.
     * @return La valeur de l'objet sous forme de int
     */
    public int intValue () {
	return i;
    }

    /**
     * Retourne la valeur de cet objet sous forme de int.<p>
     * Identique  int#intValue(). D'ailleurs cette mthode se contente de faire appel  int#intValue().
     * @return La valeur de l'objet sous forme de int
     * @see #intValue()
     */
    public int value () {
	return intValue();
    }
}
