--
-- Selected TOC Entries:
--
\connect - postgres

--
-- TOC Entry ID 41 (OID 16556)
--
-- Name: "plpgsql_call_handler" () Type: FUNCTION Owner: postgres
--

CREATE FUNCTION "plpgsql_call_handler" () RETURNS opaque AS '$libdir/plpgsql', 'plpgsql_call_handler' LANGUAGE 'C';

--
-- TOC Entry ID 42 (OID 16557)
--
-- Name: plpgsql Type: PROCEDURAL LANGUAGE Owner: 
--

CREATE TRUSTED PROCEDURAL LANGUAGE 'plpgsql' HANDLER "plpgsql_call_handler" LANCOMPILER '';

\connect - tistou

--
-- TOC Entry ID 43 (OID 25125)
--
-- Name: "ins_http_url" (integer,text,text,integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "ins_http_url" (integer,text,text,integer) RETURNS integer AS '
  DECLARE
    n_http INTEGER := -1;
    n_mot INTEGER;
    rec RECORD;
  BEGIN
    -- Recuperation de l id du lien et creation de celui-ci si necesssaire
    SELECT INTO n_http id_http FROM Http WHERE lien=$2;
    IF NOT FOUND THEN
      n_http := nextval(''http_id_http_seq'');
      INSERT INTO Http VALUES ($2,n_http);
    END IF;
    -- Recuperation de l id du mot et creation de celui-ci si necesssaire
    SELECT INTO n_mot id_mot FROM MotHttp WHERE mot=$3;
    IF NOT FOUND THEN
      n_mot := nextval(''mothttp_id_mot_seq'');
      INSERT INTO MotHttp VALUES ($3,n_mot);
    END IF;
    -- Regarde si ce lien est deja designe par ce mot ds cette page
    SELECT INTO rec * FROM AppHttp WHERE (id_mot=n_mot AND id_http=n_http AND id_page=$1);
    IF NOT FOUND THEN
      INSERT INTO AppHttp VALUES ($1,n_http,n_mot,$4);
    ELSIF rec.occurence <> $4 THEN
      UPDATE AppHttp SET occurence=$4 WHERE (id_mot=n_mot AND id_http=n_http AND id_page=$1);
    END IF;
    RETURN n_http;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 44 (OID 25126)
--
-- Name: "ins_http_id" (integer,integer,text,integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "ins_http_id" (integer,integer,text,integer) RETURNS integer AS '
  DECLARE
    n_mot INTEGER;
    rec RECORD;
  BEGIN
    -- Recuperation de l id du mot et creation de celui-ci si necesssaire
    SELECT INTO n_mot id_mot FROM MotHttp WHERE mot=$3;
    IF NOT FOUND THEN
      n_mot := nextval(''mothttp_id_mot_seq'');
      INSERT INTO MotHttp VALUES ($3,n_mot);
    END IF;
    -- Regarde si ce lien est deja designe par ce mot ds cette page
    SELECT INTO rec * FROM AppHttp WHERE (id_mot=n_mot AND id_http=$2 AND id_page=$1);
    IF NOT FOUND THEN
      INSERT INTO AppHttp VALUES ($1,$2,n_mot,$4);
    ELSIF rec.occurence <> $4 THEN
      UPDATE AppHttp SET occurence=$4 WHERE (id_mot=n_mot AND id_http=$2 AND id_page=$1);
    END IF;
    RETURN $2;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 45 (OID 25166)
--
-- Name: "ins_mail_adr" (integer,text,text,integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "ins_mail_adr" (integer,text,text,integer) RETURNS integer AS '
  DECLARE
    n_mail INTEGER := -1;
    n_mot INTEGER;
    rec RECORD;
  BEGIN
    -- Recuperation de l id du lien et creation de celui-ci si necesssaire
    SELECT INTO n_mail id_mail FROM Mail WHERE mail=$2;
    IF NOT FOUND THEN
      n_mail := nextval(''mail_id_mail_seq'');
      INSERT INTO Mail VALUES ($2,n_mail);
    END IF;
    -- Recuperation de l id du mot et creation de celui-ci si necesssaire
    SELECT INTO n_mot id_mot FROM MotMail WHERE mot=$3;
    IF NOT FOUND THEN
      n_mot := nextval(''motmail_id_mot_seq'');
      INSERT INTO MotMail VALUES ($3,n_mot);
    END IF;
    -- Regarde si ce lien est deja designe par ce mot ds cette page
    SELECT INTO rec * FROM AppMail WHERE (id_mot=n_mot AND id_mail=n_mail AND id_page=$1);
    IF NOT FOUND THEN
      INSERT INTO AppMail VALUES ($1,n_mail,n_mot,$4);
    ELSIF rec.occurence <> $4 THEN
      UPDATE AppMail SET occurence=$4 WHERE (id_mot=n_mot AND id_mail=n_mail AND id_page=$1);
    END IF;
    RETURN n_mail;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 46 (OID 25167)
--
-- Name: "ins_mail_id" (integer,integer,text,integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "ins_mail_id" (integer,integer,text,integer) RETURNS integer AS '
  DECLARE
    n_mot INTEGER;
    rec RECORD;
  BEGIN
    -- Recuperation de l id du mot et creation de celui-ci si necesssaire
    SELECT INTO n_mot id_mot FROM MotMail WHERE mot=$3;
    IF NOT FOUND THEN
      n_mot := nextval(''motmail_id_mot_seq'');
      INSERT INTO MotMail VALUES ($3,n_mot);
    END IF;
    -- Regarde si ce lien est deja designe par ce mot ds cette page
    SELECT INTO rec * FROM AppMail WHERE (id_mot=n_mot AND id_mail=$2 AND id_page=$1);
    IF NOT FOUND THEN
      INSERT INTO AppMail VALUES ($1,$2,n_mot,$4);
    ELSIF rec.occurence <> $4 THEN
      UPDATE AppMail SET occurence=$4 WHERE (id_mot=n_mot AND id_mail=$2 AND id_page=$1);
    END IF;
    RETURN $2;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 48 (OID 25214)
--
-- Name: "ins_pict_id" (integer,integer,text,integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "ins_pict_id" (integer,integer,text,integer) RETURNS integer AS '
  DECLARE
    n_mot INTEGER;
    rec RECORD;
  BEGIN
    -- Recuperation de l id du mot et creation de celui-ci si necesssaire
    SELECT INTO n_mot id_mot FROM MotPict WHERE mot=$3;
    IF NOT FOUND THEN
      n_mot := nextval(''motpict_id_mot_seq'');
      INSERT INTO MotPict VALUES ($3,n_mot);
    END IF;
    -- Regarde si cette image est deja designee par ce mot ds cette page
    SELECT INTO rec * FROM AppPict WHERE (id_mot=n_mot AND id_pict=$2 AND id_page=$1);
    IF NOT FOUND THEN
      INSERT INTO AppPict VALUES ($1,$2,n_mot,$4);
    ELSIF rec.occurence <> $4 THEN
      UPDATE AppPict SET occurence=$4 WHERE (id_mot=n_mot AND id_pict=$2 AND id_page=$1);
    END IF;
    RETURN $2;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 49 (OID 25220)
--
-- Name: "supp_page" (integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "supp_page" (integer) RETURNS integer AS '
  DECLARE
    id INTEGER;
    nb_supp INTEGER := 0;
    rec_lien RECORD;
    rec_mot RECORD;
    n_site INTEGER;
    fic TEXT;
  BEGIN
    -- Reinitialisation de la table SuppFic
    DELETE FROM SuppFic;
    -- Creation de tables temporaires de liens et mots a supprimer eventuellement
    CREATE LOCAL TEMP TABLE liens_http AS 
      (SELECT id_http,id_mot FROM AppHttp WHERE id_page=$1);
    CREATE LOCAL TEMP TABLE liens_mail AS 
      (SELECT id_mail,id_mot FROM AppMail WHERE id_page=$1);
    CREATE LOCAL TEMP TABLE liens_pict AS 
      (SELECT id_pict,id_mot FROM AppPict WHERE id_page=$1);
    -- Suppression des liens et des mots http inutils
    FOR rec_lien IN SELECT DISTINCT id_http FROM liens_http LOOP
        SELECT INTO id id_page FROM AppHttp
          WHERE (id_http=rec_lien.id_http AND id_page<>$1);
        IF NOT FOUND THEN
          RAISE NOTICE ''supp_http %'',rec_lien.id_http;
          DELETE FROM Http WHERE id_http=rec_lien.id_http;
          nb_supp := nb_supp + 1;
        ELSE
          RAISE NOTICE ''la page % contient le lien %'',id,rec_lien.id_http;
        END IF;
    END LOOP;
    FOR rec_lien IN SELECT DISTINCT id_mot FROM liens_http LOOP
        SELECT INTO id id_page FROM AppHttp
          WHERE (id_mot=rec_lien.id_mot AND id_page<>$1);
        IF NOT FOUND THEN
          RAISE NOTICE ''supp_mot_http %'',rec_lien.id_mot;
          DELETE FROM MotHttp WHERE id_mot=rec_lien.id_mot;
          nb_supp := nb_supp + 1;
        ELSE
          RAISE NOTICE ''la page % contient le mot %'',id,rec_lien.id_mot;
        END IF;
    END LOOP;
    -- Suppression des liens et des mots mail inutils
    FOR rec_lien IN SELECT DISTINCT id_mail FROM liens_mail LOOP
        SELECT INTO id id_page FROM AppMail
          WHERE (id_mail=rec_lien.id_mail AND id_page<>$1);
        IF NOT FOUND THEN
          RAISE NOTICE ''supp_mail %'',rec_lien.id_mail;
          DELETE FROM Mail WHERE id_mail=rec_lien.id_mail;
          nb_supp := nb_supp + 1;
        ELSE
          RAISE NOTICE ''la page % contient le lien %'',id,rec_lien.id_mail;
        END IF;
    END LOOP;
    FOR rec_lien IN SELECT DISTINCT id_mot FROM liens_mail LOOP
        SELECT INTO id id_page FROM AppMail
          WHERE (id_mot=rec_lien.id_mot AND id_page<>$1);
        IF NOT FOUND THEN
          RAISE NOTICE ''supp_mot_mail %'',rec_lien.id_mot;
          DELETE FROM MotMail WHERE id_mot=rec_lien.id_mot;
          nb_supp := nb_supp + 1;
        ELSE
          RAISE NOTICE ''la page % contient le mot %'',id,rec_lien.id_mot;
        END IF;
    END LOOP;
    -- Suppression des images, des mots et des noms d images inutils
    FOR rec_lien IN SELECT DISTINCT id_pict FROM liens_pict LOOP
        SELECT INTO id id_page FROM AppPict
          WHERE (id_pict=rec_lien.id_pict AND id_page<>$1);
        IF NOT FOUND THEN
          -- Insert le fichier de l image ds SuppFic
          SELECT INTO fic fichier FROM Pict WHERE id_pict=rec_lien.id_pict;
          INSERT INTO SuppFic VALUES (fic);
          -- Supprime l image de Pict
          DELETE FROM Pict WHERE id_pict=rec_lien.id_pict;
          RAISE NOTICE ''supp_pict %'',rec_lien.id_pict;
          nb_supp := nb_supp + 1;
        ELSE
          RAISE NOTICE ''la page % contient le lien %'',id,rec_lien.id_pict;
        END IF;
    END LOOP;
    FOR rec_lien IN SELECT DISTINCT id_mot FROM liens_pict LOOP
        SELECT INTO id id_page FROM AppPict
          WHERE (id_mot=rec_lien.id_mot AND id_page<>$1);
        IF NOT FOUND THEN
          RAISE NOTICE ''supp_mot_pict %'',rec_lien.id_mot;
          DELETE FROM MotPict WHERE id_mot=rec_lien.id_mot;
          nb_supp := nb_supp + 1;
        ELSE
          RAISE NOTICE ''la page % contient le mot %'',id,rec_lien.id_mot;
        END IF;
    END LOOP;
    -- Suppression du site si celui-ci ne contient plus de page
    SELECT INTO n_site id_site FROM Page WHERE id_page=$1;
    SELECT INTO id id_page FROM Page WHERE (id_site=n_site AND id_page<>$1);
    IF NOT FOUND THEN
      RAISE NOTICE ''supp_site %'',n_site;
      DELETE FROM Site WHERE id_site=n_site;
      nb_supp := nb_supp + 1;
    ELSE
      RAISE NOTICE ''le site % contient la page %'',n_site,id;
    END IF;
    -- Suppression de la page et de toutes les entrees comprenant cette page
    DELETE FROM Page WHERE id_page=$1;
    -- Suppression des tables temporaires
    DROP TABLE liens_http;
    DROP TABLE liens_mail;
    DROP TABLE liens_pict;
    RETURN nb_supp;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 50 (OID 129981)
--
-- Name: "supp_lien" (integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "supp_lien" (integer) RETURNS integer AS '
  BEGIN
    -- Supprime le lien de la table Http et simultanement les entrees correspondante
    -- dans la table AppHttp
    DELETE FROM Http WHERE id_http=$1;
    RETURN 0;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 2 (OID 230299)
--
-- Name: site_id_site_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "site_id_site_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 18 (OID 230301)
--
-- Name: site Type: TABLE Owner: tistou
--

CREATE TABLE "site" (
	"url" text NOT NULL,
	"id_site" integer DEFAULT nextval('"site_id_site_seq"'::text) NOT NULL,
	Constraint "site_pkey" Primary Key ("id_site")
);

--
-- TOC Entry ID 4 (OID 230308)
--
-- Name: page_id_page_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "page_id_page_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 19 (OID 230310)
--
-- Name: page Type: TABLE Owner: tistou
--

CREATE TABLE "page" (
	"fin_url" text,
	"id_site" integer,
	"date" integer,
	"id_page" integer DEFAULT nextval('"page_id_page_seq"'::text) NOT NULL,
	Constraint "page_pkey" Primary Key ("id_page")
);

--
-- TOC Entry ID 6 (OID 230323)
--
-- Name: http_id_http_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "http_id_http_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 20 (OID 230325)
--
-- Name: http Type: TABLE Owner: tistou
--

CREATE TABLE "http" (
	"lien" text NOT NULL,
	"id_http" integer DEFAULT nextval('"http_id_http_seq"'::text) NOT NULL,
	Constraint "http_pkey" Primary Key ("id_http")
);

--
-- TOC Entry ID 8 (OID 230332)
--
-- Name: mothttp_id_mot_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "mothttp_id_mot_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 21 (OID 230334)
--
-- Name: mothttp Type: TABLE Owner: tistou
--

CREATE TABLE "mothttp" (
	"mot" text NOT NULL,
	"id_mot" integer DEFAULT nextval('"mothttp_id_mot_seq"'::text) NOT NULL,
	Constraint "mothttp_pkey" Primary Key ("id_mot")
);

--
-- TOC Entry ID 22 (OID 230341)
--
-- Name: apphttp Type: TABLE Owner: tistou
--

CREATE TABLE "apphttp" (
	"id_page" integer NOT NULL,
	"id_http" integer NOT NULL,
	"id_mot" integer NOT NULL,
	"occurence" integer DEFAULT 1
);

--
-- TOC Entry ID 10 (OID 230362)
--
-- Name: mail_id_mail_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "mail_id_mail_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 23 (OID 230364)
--
-- Name: mail Type: TABLE Owner: tistou
--

CREATE TABLE "mail" (
	"mail" text NOT NULL,
	"id_mail" integer DEFAULT nextval('"mail_id_mail_seq"'::text) NOT NULL,
	Constraint "mail_pkey" Primary Key ("id_mail")
);

--
-- TOC Entry ID 12 (OID 230371)
--
-- Name: motmail_id_mot_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "motmail_id_mot_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 24 (OID 230373)
--
-- Name: motmail Type: TABLE Owner: tistou
--

CREATE TABLE "motmail" (
	"mot" text NOT NULL,
	"id_mot" integer DEFAULT nextval('"motmail_id_mot_seq"'::text) NOT NULL,
	Constraint "motmail_pkey" Primary Key ("id_mot")
);

--
-- TOC Entry ID 25 (OID 230380)
--
-- Name: appmail Type: TABLE Owner: tistou
--

CREATE TABLE "appmail" (
	"id_page" integer NOT NULL,
	"id_mail" integer NOT NULL,
	"id_mot" integer NOT NULL,
	"occurence" integer DEFAULT 1
);

--
-- TOC Entry ID 14 (OID 230401)
--
-- Name: pict_id_pict_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "pict_id_pict_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 26 (OID 230403)
--
-- Name: pict Type: TABLE Owner: tistou
--

CREATE TABLE "pict" (
	"nom" text NOT NULL,
	"chemin" text NOT NULL,
	"id_site" integer,
	"fichier" text,
	"id_pict" integer DEFAULT nextval('"pict_id_pict_seq"'::text) NOT NULL,
	Constraint "pict_pkey" Primary Key ("id_pict")
);

--
-- TOC Entry ID 16 (OID 230416)
--
-- Name: motpict_id_mot_seq Type: SEQUENCE Owner: tistou
--

CREATE SEQUENCE "motpict_id_mot_seq" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--
-- TOC Entry ID 27 (OID 230418)
--
-- Name: motpict Type: TABLE Owner: tistou
--

CREATE TABLE "motpict" (
	"mot" text NOT NULL,
	"id_mot" integer DEFAULT nextval('"motpict_id_mot_seq"'::text) NOT NULL,
	Constraint "motpict_pkey" Primary Key ("id_mot")
);

--
-- TOC Entry ID 28 (OID 230425)
--
-- Name: apppict Type: TABLE Owner: tistou
--

CREATE TABLE "apppict" (
	"id_page" integer NOT NULL,
	"id_pict" integer NOT NULL,
	"id_mot" integer NOT NULL,
	"occurence" integer DEFAULT 1
);

--
-- TOC Entry ID 47 (OID 230446)
--
-- Name: "ins_pict_nom" (integer,integer,text,text,text,text,integer) Type: FUNCTION Owner: tistou
--

CREATE FUNCTION "ins_pict_nom" (integer,integer,text,text,text,text,integer) RETURNS integer AS '
  DECLARE
    new INTEGER;
    n_pict INTEGER;
    n_mot INTEGER;
    rec RECORD;
  BEGIN
    -- Recuperation de l id de l image et creation de celui-ci si necesssaire
    new := -1;
    SELECT INTO n_pict id_pict FROM Pict WHERE (id_site=$1 AND nom=$3 AND chemin=$4);
    IF NOT FOUND THEN
      new := 1;
      n_pict := nextval(''pict_id_pict_seq'');
      INSERT INTO Pict VALUES ($3,$4,$1,$5,n_pict);
    END IF;
    -- Recuperation de l id du mot et creation de celui-ci si necesssaire
    SELECT INTO n_mot id_mot FROM MotPict WHERE mot=$6;
    IF NOT FOUND THEN
      n_mot := nextval(''motpict_id_mot_seq'');
      INSERT INTO MotPict VALUES ($6,n_mot);
    END IF;
    -- Regarde si ce lien est deja designe par ce mot ds cette page
    SELECT INTO rec * FROM AppPict WHERE (id_mot=n_mot AND id_pict=n_pict AND id_page=$2);
    IF NOT FOUND THEN
      INSERT INTO AppPict VALUES ($2,n_pict,n_mot,$7);
    ELSIF rec.occurence <> $7 THEN
      UPDATE AppPict SET occurence=$7 WHERE (id_mot=n_mot AND id_pict=n_pict AND id_page=$2);
    END IF;
    RETURN new * n_pict;
  END;
' LANGUAGE 'plpgsql';

--
-- TOC Entry ID 29 (OID 230447)
--
-- Name: suppfic Type: TABLE Owner: tistou
--

CREATE TABLE "suppfic" (
	"fichier" text
);

--
-- Data for TOC Entry ID 51 (OID 230301)
--
-- Name: site Type: TABLE DATA Owner: tistou
--


COPY "site" FROM stdin;
http://java.sun.com	1
http://www.sun.com	2
http://developer.java.sun.com	3
http://search.java.sun.com	4
http://wwws.sun.com	5
http://www201.ikiosk.com	6
http://www.jcp.org	7
http://suned.sun.com	8
http://www.corba.org	9
\.
--
-- Data for TOC Entry ID 52 (OID 230310)
--
-- Name: page Type: TABLE DATA Owner: tistou
--


COPY "page" FROM stdin;
/j2se/1.4.1/docs/index.html	1	0	1
/j2se/1.4.1/docs/guide/awt/index.html	1	0	3
/j2se/1.4.1/docs/guide/serialization/index.html	1	0	4
/j2se/1.4.1/compatibility.html	1	0	5
/j2se/1.4.1/docs	1	0	6
/j2se/1.4.1/docs/guide/util/logging/index.html	1	0	7
/j2se/1.4.1/docs/guide/beans/index.html	1	0	8
/j2se/1.4.1/docs/relnotes/features.html	1	0	9
/j2se/1.4.1/docs/tooldocs/tools.html	1	0	10
/j2se/1.4.1/docs/guide/xml/index.html	1	0	11
/j2se/1.4.1/docs/guide/jdbc/index.html	1	0	12
/docs/books/jls/second_edition/html/j.title.doc.html	1	0	13
/j2se/1.4.1/docs/guide/2d/index.html	1	0	14
/j2se/1.4.1/docs/guide/security/index.html	1	0	15
/j2se/1.4.1/docs/relnotes/demos.html	1	0	16
/	2	1051131651	17
/j2se/1.4.1/docs/guide/jni/index.html	1	0	18
/j2se/1.4.1/docs/guide/swing/index.html	1	0	19
/docs/windows_format.html	1	0	20
/j2se/1.4.1/fixedbugs/index.html	1	0	21
/j2se/1.4.1/docs/guide/imf/index.html	1	0	22
/j2se/1.4.1/docs/guide/collections/index.html	1	0	23
/j2se/1.4.1/changes.html	1	0	24
/	1	0	25
/docs/codeconv/index.html	1	0	26
/j2se/1.4.1/download.html	1	0	27
/j2se/1.4.1/docs/guide/jws/index.html	1	0	28
/j2se/1.4.1/docs/guide/standards/index.html	1	0	29
/j2se/1.4.1/docs/guide/sound/index.html	1	0	30
/products/jdk/faq.html	1	0	31
/j2se/1.4.1/docs/guide/jpda/index.html	1	0	32
/j2se/1.4.1/docs/api/index.html	1	0	33
/j2se/1.4.1/docs/relnotes/contacts.html	1	0	34
/j2se/1.4.1/docs/guide/net/index.html	1	0	35
/j2se/1.4.1/docs/guide/rmi/index.html	1	0	36
/j2se/1.4.1/docs/relnotes/SMICopyright.html	1	0	37
/developer/onlineTraining/new2java/index.html	3	1050704015	38
/j2se/1.4.1/docs/api/overview-summary.html	1	0	39
/docs/books/jls/index.html	1	0	40
/j2se/1.4.1/docs/guide/jps/index.html	1	0	41
/docs/books/vmspec/index.html	1	0	42
/j2se/1.4.1/docs/guide/vm/index.html	1	0	43
/j2se/1.4.1/docs/guide/versioning/index.html	1	0	44
/j2se/1.4.1/docs/guide/intl/index.html	1	0	45
/docs/books/vmspec/2nd-edition/html/VMSpecTOC.doc.html	1	0	46
/docs/books/chanlee/second_edition/vol1/examples.html	1	0	47
/docs/books/tutorial/index.html	1	0	48
/docs/books/effective/index.html	1	0	49
/j2se/1.4.1/docs/guide/io/index.html	1	0	50
/developer/onlineTraining	3	1050704009	51
/j2se/1.4.1/docs/guide/extensions/index.html	1	0	52
/j2se/1.4.1/docchanges.html	1	0	53
/j2se/1.4.1/docs/guide/jndi/index.html	1	0	54
/docs/books/chanlee	1	0	55
/j2se/1.4.1/docs/guide/lang/index.html	1	0	56
/j2se/1.4.1/docs/guide/resources/index.html	1	0	57
/j2se/1.4.1/docs/guide/plugin/index.html	1	0	58
/docs/books/chanlee/supplement/examples.html	1	0	59
/products/jdk/faq/faq-sun-packages.html	1	0	60
/j2se/1.4.1/relnotes.html	1	0	61
/j2se/1.4.1/docs/guide/reflection/index.html	1	0	62
/j2se/1.4.1/docs/guide/performance/index.html	1	0	63
/j2se/1.4.1/docs/guide/refobs/index.html	1	0	64
/j2se/1.4.1/docs/guide/misc/index.html	1	0	65
/j2se/1.4.1/docs/guide/imageio/index.html	1	0	66
/j2se/1.4.1/docs/guide/dragndrop/index.html	1	0	67
/j2se/1.4.1/install-solaris.html	1	0	68
/j2se/1.4.1/docs/guide/math/index.html	1	0	69
/features/2001/09/goslingrev.html	1	0	70
/j2se/1.4.1/docs/guide/rmi-iiop/index.html	1	0	71
/j2se/1.4.1/docs/guide/jvmpi/index.html	1	0	72
/j2se/1.4.1/download-pdf-ps.html	1	0	73
/docs/redist.html	1	0	74
/j2se/1.4.1/install-linux.html	1	0	75
/j2se/1.4.1/docs/guide/corba/index.html	1	0	76
/j2se/1.4.1/search.html	1	0	77
/j2se/1.4.1/docs/guide/nio/index.html	1	0	78
/docs/books/chanlee/second_edition/examples.html	1	0	79
/j2se/1.4.1/docs/guide/idl/index.html	1	0	80
/j2se/1.4.1/README.html	1	0	81
/j2se/1.4.1/install-windows.html	1	0	82
/aboutJava/training	1	0	83
/j2se/1.4.1/docs/guide/access/index.html	1	0	84
/j2se/1.4.1/docs/guide/serialization/relnotes.html	1	0	85
/j2se/1.4.1/docs/api/java/io/package-summary.html	1	0	86
/j2se/1.4.1/docs/guide/serialization/spec/serialTOC.doc.html	1	0	87
/products/jdk/serialization/faq	1	0	88
/j2se/1.4.1/docs/guide/serialization/examples/index.html	1	0	89
/j2se/1.4.1/docs/tooldocs/solaris/serialver.html	1	0	90
/j2se/1.4.1/docs/api/java/util/logging/package-summary.html	1	0	104
/j2se/1.4.1/docs/guide/util/logging/overview.html	1	0	105
/j2se/1.4.1/docs/api/java/beans/beancontext/package-summary.html	1	0	106
/beans/index.html	1	0	115
/j2se/1.4.1/docs/tooldocs/solaris/jar.html	1	0	123
/j2se/1.4.1/docs/tooldocs/solaris/rmiregistry.html	1	0	124
/j2se/1.4.1/docs/tooldocs/solaris/native2ascii.html	1	0	125
/j2se/1.4.1/docs/tooldocs/solaris/javap.html	1	0	145
/j2se/1.4.1/docs/tooldocs/solaris/javac.html	1	0	148
/j2se/1.4.1/docs/tooldocs/windows/java.html	1	0	151
/j2se/1.4.1/docs/tooldocs/windows/javap.html	1	0	154
/j2se/1.4.1/docs/tooldocs/solaris/rmic.html	1	0	156
/j2se/1.4.1/docs/tooldocs/solaris/extcheck.html	1	0	157
/products/plugin/1.3/docs/script.html	1	0	160
/j2se/1.4.1/docs/tooldocs/windows/javac.html	1	0	164
/j2se/1.4.1/docs/guide/idl/jidlNaming.html	1	0	168
/j2se/1.4.1/docs/guide/jdbc/bridge.html	1	0	171
/j2se/1.4.1/docs/api/javax/sql/package-summary.html	1	0	177
/developer/Books/JDBCTutorial/chapter5.html	3	1050617884	178
/j2se/1.4.1/docs/guide/jdbc/getstart/GettingStartedTOC.fm.html	1	0	179
/products/jdbc/jdbc-frequent.html	1	0	184
/software/java2	5	1047618019	195
/j2se/downloads.html	1	0	208
/j2se/1.4.1/docs/api/deprecated-list.html	1	0	210
/	7	0	214
/docs/books/tutorial/together/index.html	1	0	215
/docs/books/tutorial/getStarted/index.html	1	0	216
/products/jdk/faq/jnifaq.html	1	0	217
/j2se/1.4.1/docs/guide/jni/spec/jniTOC.doc.html	1	0	219
/j2se/1.4.1/docs/api/java/rmi/server/RMIClassLoader.html	1	0	220
/j2se/1.4.1/docs/guide/security/jgss/tutorials/index.html	1	0	225
/j2se/1.4.1/docs/relnotes/license.html	1	0	230
/developer/bugParade/bugs/4532517.html	3	0	233
/j2se/1.4.1/docs/guide/intl/font.html	1	0	236
/docs/books/vmspec/2nd-edition/html/Threads.doc.html	1	0	237
/docs/books/effective/chapters.html	1	0	238
/j2se/1.4.1/docs/guide/extensions/spec.html	1	0	239
/docs/books/tutorial/security1.2/index.html	1	0	240
/share/text/SMICopyright.html	2	1037812332	241
/j2se/1.4.1/docs/api/java/lang/reflect/package-summary.html	1	0	242
/j2se/1.4.1/docs/api/java/lang/ref/Reference.html	1	0	248
/nav/whatis/index.html	1	0	250
/j2se/1.4.1/docs/api/java/net/InetSocketAddress.html	1	0	251
/j2se/1.4.1/docs/api/org/omg/PortableServer/Servant.html	1	0	252
/USA/catalog/options/index.html	8	0	253
/j2se/1.4.1/docs/guide/idl/limitations.html	1	0	255
/j2se/1.4.1/docs/guide/access/properties.html	1	0	256
/j2se/1.4.1/docs/api/java/util/jar/JarFile.html	1	0	259
/j2se/1.4.1/docs/api/java/util/zip/ZipFile.html	1	0	263
/products/ejb/index.html	1	0	264
/j2se/1.4.1/docs/guide/rmi-iiop	1	0	265
/j2se/1.4.1/docs/api/org/omg/CORBA/doc-files/compliance.html	1	0	267
/j2se/1.4.1/docs/guide/idl/GShome.html	1	0	269
/j2se/1.4.1/docs/api/org/omg/CORBA/ORB.html	1	0	274
/j2se/1.4.1/docs/guide/serialization/relnotes14.html	1	0	91
/j2se/1.4.1/docs/tooldocs/windows/rmiregistry.html	1	0	136
/j2se/1.4.1/docs/tooldocs/windows/jar.html	1	0	137
/j2se/1.4.1/docs/tooldocs/solaris/javadoc.html	1	0	147
/j2se/1.4.1/docs/tooldocs/linux/jdkfiles.html	1	0	150
/j2se/1.4.1/docs/tooldocs/windows/klist.html	1	0	153
/j2se/1.4.1/docs/tooldocs/solaris/policytool.html	1	0	155
/j2se/1.4.1/docs/tooldocs/windows/native2ascii.html	1	0	158
/j2se/1.4.1/docs/tooldocs/windows/kinit.html	1	0	159
/j2se/1.4.1/docs/guide/rmi-iiop/toJavaPortableUG.html	1	0	186
/blueprints	1	0	192
/products	1	0	199
/share/text/termsofuse.html	2	1037812332	200
/berkeley_license.html	3	1050618051	201
/products/jdk/1.1/compatibility.html	1	0	203
/j2se/1.4.1/docs/guide/jar/index.html	1	0	92
/products/jdk/awt	1	0	102
/j2se/1.4.1/docs/guide/awt/1.3/enhancements.html	1	0	103
/j2se/1.4.1/docs/guide/beans/changes14.html	1	0	107
/j2se/1.4.1/docs/api/java/beans/package-summary.html	1	0	110
/xml/tutorial_intro.html	1	0	112
/j2se/1.4.1/docs/tooldocs/linux/java.html	1	0	130
/j2se/1.4.1/docs/tooldocs/solaris/classpath.html	1	0	131
/j2se/1.4.1/docs/tooldocs/windows/appletviewer.html	1	0	138
/j2se/1.4.1/docs/tooldocs/linux/ktab.html	1	0	139
/j2se/1.4.1/docs/tooldocs/windows/policytool.html	1	0	140
/j2se/1.4.1/docs/tooldocs/windows/javadoc.html	1	0	141
/j2se/1.4.1/docs/tooldocs/linux/klist.html	1	0	143
/j2se/1.4.1/docs/tooldocs/windows/classpath.html	1	0	144
/j2se/1.4.1/docs/tooldocs/windows/javah.html	1	0	146
/j2se/1.4.1/docs/guide/idl/orbd.html	1	0	149
/j2se/1.4.1/docs/tooldocs/linux/kinit.html	1	0	152
/j2se/1.4.1/docs/tooldocs/windows/jdkfiles.html	1	0	183
/j2se/1.4.1/docs/api/java/awt/event/package-summary.html	1	0	93
/j2se/1.4.1/docs/guide/awt/1.3/designspec/index.html	1	0	94
/j2se/1.4.1/docs/api/java/awt/doc-files/FocusSpec.html	1	0	95
/j2se/1.4.1/docs/guide/awt/AWTChanges.html	1	0	96
/j2se/1.4.1/docs/api/java/awt/datatransfer/package-summary.html	1	0	97
/products/jfc	1	0	98
/docs/books/tutorial/ui	1	0	99
/j2se/1.4.1/docs/guide/awt/demos/index.html	1	0	100
/j2se/1.4.1/docs/api/java/awt/package-summary.html	1	0	101
/products/jfc/tsc	1	0	109
/j2se/1.4.1/docs/guide/beans/spec/beancontextTOC.fm.html	1	0	111
/j2se/1.4.1/docs/guide/xml/jaxp/index.html	1	0	113
/xml	1	0	114
/xml	2	1047629867	118
/j2se/1.4.1/docs/tooldocs/findingclasses.html	1	0	120
/j2se/1.4.1/docs/tooldocs/solaris/rmid.html	1	0	122
/j2se/1.4.1/docs/tooldocs/solaris/jdkfiles.html	1	0	127
/j2se/1.4.1/docs/tooldocs/solaris/java.html	1	0	128
/j2se/1.4.1/docs/tooldocs/tools-changes.html	1	0	129
/j2se/1.4.1/docs/tooldocs/javadoc/index.html	1	0	135
/products/jdbc/jdbc.drivers.html	1	0	176
/docs/books/jdbc	1	0	180
/j2se/1.4.1/docs/guide/jdbc/clob.html	1	0	181
/developer/onlineTraining/new2java	3	1050704015	182
/tools/index.html	1	0	188
/j2se	1	0	198
/j2se/1.4/compatibility.html	1	0	202
/j2se/1.3/compatibility.html	1	0	207
/docs	1	0	211
/docs/books/jls/second_edition/html/jcopyright.doc.html	1	0	213
/products/plugin/1.4.1/demos/applets/CardTest/example1.html	1	0	218
/j2se/1.4.1/docs/api/javax/swing/tree/package-summary.html	1	0	222
/products/javawebstart/faq.html	1	0	226
/products/java-media/sound/index.html	1	0	227
/j2se/1.4.1/docs/guide/jpda/jpda.html	1	0	228
/docs/forms/sendusmail.html	1	0	231
/solaris/java/faq.html	2	1049499278	232
/j2se/1.4.1/docs/api/java/lang/SecurityManager.html	1	0	243
/developer/bugParade/bugs/4693219.html	3	0	245
/j2se/1.4.1/docs/api/java/awt/datatransfer/DataFlavor.html	1	0	246
/access/index.html	2	1049501829	254
/j2se/1.4.1/docs/guide/access/new-features.html	1	0	258
/j2se/1.4.1/docs/api/java/util/jar/package-summary.html	1	0	266
/j2se/1.4.1/docs/api	1	0	268
/j2se/1.4.1/docs/guide/rmi-iiop/rmi_iiop_pg.html	1	0	271
/docs/books/tutorial/javabeans/index.html	1	0	108
/beans/spec.html	1	0	116
/j2se/1.4.1/docs/tooldocs/solaris/jarsigner.html	1	0	117
/j2se/1.4.1/docs/tooldocs/windows/extcheck.html	1	0	119
/j2se/1.4.1/docs/tooldocs/solaris/javah.html	1	0	121
/j2se/1.4.1/docs/tooldocs/windows/jdb.html	1	0	126
/j2se/1.4.1/docs/tooldocs/windows/jarsigner.html	1	0	132
/j2se/1.4.1/docs/tooldocs/windows/serialver.html	1	0	133
/j2se/1.4.1/docs/guide/idl/servertool.html	1	0	134
/j2se/1.4.1/docs/tooldocs/windows/rmid.html	1	0	142
/j2se/1.4.1/docs/tooldocs/solaris/appletviewer.html	1	0	161
/j2se/1.4.1/docs/tooldocs/windows/rmic.html	1	0	162
/j2se/1.4.1/docs/tooldocs/windows/ktab.html	1	0	163
/j2se/1.4.1/docs/tooldocs/solaris/jdb.html	1	0	165
/j2se/1.4.1/docs/tooldocs/solaris/keytool.html	1	0	166
/j2se/1.4.1/docs/tooldocs/windows/keytool.html	1	0	167
/products/jdbc/index.html	1	0	169
/products/jdbc/download.html	1	0	170
/j2se/1.4.1/docs/guide/jdbc/blob.html	1	0	172
/j2se/1.4.1/docs/api/java/sql/package-summary.html	1	0	173
/docs/books/tutorial/jdbc/basics/index.html	1	0	174
/j2ee/docs.html	1	0	175
/developer/Books/JDBCTutorial/index.html	3	1050617884	185
/j2se/1.4.1/ja	1	0	187
/downloads	1	0	189
/j2se/vb.development.center.html	1	0	190
/smi/Press/sunflash/web_sunflash.html	2	1051204440	191
/j2se/1.4.1	1	0	193
/search/java/advanced.jsp	4	0	194
/industry	1	0	196
/products/jdk/1.2/compatibility.html	1	0	197
/apis.html	1	0	204
/	3	0	205
/developer/infodocs	3	0	206
/cgi-shl/index.cgi?shop=33293&date=2002%3A04%3A26%3A10%3A29%3A26	6	0	209
/docs/books/jls/clarify.html	1	0	212
/docs/books/jls/second_edition/html/jTOC.doc.html	1	0	221
/j2se/1.4.1/docs/guide/collections/overview.html	1	0	223
/developer/bugParade	3	0	224
/j2se/1.4.1/docs/guide/net/enhancements14.html	1	0	229
/j2se/1.4.1/docs/api/javax/security/auth/login/package-summary.html	1	0	234
/j2se/docs/PerformanceFAQ.html	1	0	235
/docs/books/chanlee/first_edition/examples.html	1	0	244
/j2se/1.4.1/docs/guide/imageio/spec/title.fm.html	1	0	247
/docs/books/chanlee/first_edition	1	0	249
/j2se/1.4.1/docs/api/javax/swing/doc-files/Key-Index.html	1	0	257
/j2se/1.4.1/docs/guide/jar/jarGuide.html	1	0	260
/j2se/1.4.1/docs/guide/jar/jar.html	1	0	261
/j2se/1.4.1/docs/api/java/net/JarURLConnection.html	1	0	262
/docs/books/tutorial/jar	1	0	270
/j2se/1.4.1/docs/guide/idl/jidlChanges.html	1	0	272
/j2se/1.4.1/docs/guide/rmi-iiop/tutorial.html	1	0	273
/j2se/1.4.1/docs/guide/rmi	1	0	275
/	9	0	276
/j2se/1.4.1/docs/guide/corba	1	0	277
\.
--
-- Data for TOC Entry ID 53 (OID 230325)
--
-- Name: http Type: TABLE DATA Owner: tistou
--


COPY "http" FROM stdin;
http://java.sun.com/j2se/1.4.1/docs/guide/xml/index.html	1
http://java.sun.com/j2se/1.4.1/docs/guide/serialization/index.html	2
http://java.sun.com/j2se/1.4.1/docs/guide/awt/index.html	3
http://java.sun.com/j2se/1.4.1/compatibility.html	4
http://java.sun.com/j2se/1.4.1/docs	5
http://java.sun.com/j2se/1.4.1/docs/guide/util/logging/index.html	6
http://java.sun.com/j2se/1.4.1/docs/guide/beans/index.html	7
http://java.sun.com/j2se/1.4.1/docs/relnotes/features.html	8
http://java.sun.com/j2se/1.4.1/docs/tooldocs/tools.html	9
http://java.sun.com/j2se/1.4.1/docs/guide/jdbc/index.html	10
http://java.sun.com/docs/books/jls/second_edition/html/j.title.doc.html	11
http://java.sun.com/j2se/1.4.1/docs/guide/2d/index.html	12
http://java.sun.com/j2se/1.4.1/docs/guide/security/index.html	13
http://java.sun.com/j2se/1.4.1/docs/relnotes/demos.html	14
http://www.sun.com/	15
http://java.sun.com/j2se/1.4.1/docs/guide/jni/index.html	16
http://java.sun.com/j2se/1.4.1/docs/guide/swing/index.html	17
http://java.sun.com/docs/windows_format.html	18
http://java.sun.com/j2se/1.4.1/fixedbugs/index.html	19
http://java.sun.com/j2se/1.4.1/docs/guide/jws/index.html	20
http://java.sun.com/j2se/1.4.1/changes.html	21
http://java.sun.com/j2se/1.4.1/docs/guide/imf/index.html	22
http://java.sun.com/j2se/1.4.1/docs/guide/collections/index.html	23
http://java.sun.com/	24
http://java.sun.com/docs/codeconv/index.html	25
http://java.sun.com/j2se/1.4.1/download.html	26
http://java.sun.com/j2se/1.4.1/docs/guide/standards/index.html	27
http://java.sun.com/j2se/1.4.1/docs/guide/sound/index.html	28
http://java.sun.com/products/jdk/faq.html	29
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/index.html	30
http://java.sun.com/j2se/1.4.1/docs/api/index.html	31
http://java.sun.com/j2se/1.4.1/docs/relnotes/contacts.html	32
http://java.sun.com/j2se/1.4.1/docs/guide/net/index.html	33
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/index.html	34
http://java.sun.com/j2se/1.4.1/docs/relnotes/SMICopyright.html	35
http://java.sun.com/cgi-bin/bugreport.cgi	36
http://java.sun.com/j2se/1.4.1/docs/api/overview-summary.html	37
http://java.sun.com/docs/books/effective/index.html	38
http://developer.java.sun.com/developer/onlineTraining/new2java/index.html	39
http://java.sun.com/docs/books/jls/index.html	40
http://java.sun.com/j2se/1.4.1/docs/guide/jps/index.html	41
http://java.sun.com/docs/books/vmspec/index.html	42
http://java.sun.com/j2se/1.4.1/docs/guide/versioning/index.html	43
http://java.sun.com/j2se/1.4.1/docs/guide/intl/index.html	44
http://java.sun.com/j2se/1.4.1/docs/guide/vm/index.html	45
http://java.sun.com/j2se/1.4.1/docs/guide/extensions/index.html	46
http://java.sun.com/j2se/1.4.1/docs/guide/reflection/index.html	47
http://java.sun.com/docs/books/vmspec/2nd-edition/html/VMSpecTOC.doc.html	48
http://java.sun.com/docs/books/chanlee/second_edition/vol1/examples.html	49
http://java.sun.com/docs/books/tutorial/index.html	50
http://java.sun.com/j2se/1.4.1/docchanges.html	51
http://developer.java.sun.com/developer/onlineTraining	52
http://java.sun.com/j2se/1.4.1/docs/guide/lang/index.html	53
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/index.html	54
http://java.sun.com/docs/books/chanlee	55
http://java.sun.com/features/2001/09/goslingrev.html	56
http://java.sun.com/j2se/1.4.1/docs/guide/resources/index.html	57
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/index.html	58
http://java.sun.com/j2se/1.4.1/docs/guide/performance/index.html	59
http://java.sun.com/docs/books/chanlee/supplement/examples.html	60
http://java.sun.com/products/jdk/faq/faq-sun-packages.html	61
http://java.sun.com/j2se/1.4.1/relnotes.html	62
http://java.sun.com/j2se/1.4.1/docs/guide/refobs/index.html	63
http://java.sun.com/j2se/1.4.1/docs/guide/misc/index.html	64
http://java.sun.com/j2se/1.4.1/docs/guide/imageio/index.html	65
http://java.sun.com/j2se/1.4.1/docs/guide/dragndrop/index.html	66
http://java.sun.com/j2se/1.4.1/install-solaris.html	67
http://java.sun.com/j2se/1.4.1/docs/guide/math/index.html	68
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/index.html	69
http://java.sun.com/j2se/1.4.1/docs/guide/corba/index.html	70
http://java.sun.com/j2se/1.4.1/docs/guide/jvmpi/index.html	71
http://java.sun.com/j2se/1.4.1/download-pdf-ps.html	72
http://java.sun.com/j2se/1.4.1/docs/guide/nio/index.html	73
http://java.sun.com/docs/redist.html	74
http://java.sun.com/j2se/1.4.1/install-linux.html	75
http://java.sun.com/j2se/1.4.1/search.html	76
http://java.sun.com/docs/books/chanlee/second_edition/examples.html	77
http://java.sun.com/j2se/1.4.1/docs/guide/idl/index.html	78
http://java.sun.com/j2se/1.4.1/README.html	79
http://java.sun.com/j2se/1.4.1/install-windows.html	80
http://java.sun.com/aboutJava/training	81
http://java.sun.com/j2se/1.4.1/docs/guide/access/index.html	82
http://java.sun.com/j2se/1.4.1/docs/guide/jar/index.html	83
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/event/package-summary.html	84
http://java.sun.com/j2se/1.4.1/docs/guide/awt/1.3/designspec/index.html	85
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/doc-files/FocusSpec.html	86
http://java.sun.com/j2se/1.4.1/docs/index.html	87
http://java.sun.com/j2se/1.4.1/docs/guide/awt/AWTChanges.html	88
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/datatransfer/package-summary.html	89
http://java.sun.com/j2se/1.4.1/docs/guide/serialization/relnotes.html	90
http://java.sun.com/j2se/1.4.1/docs/api/java/io/package-summary.html	91
http://java.sun.com/products/jdk/serialization/faq	92
http://java.sun.com/j2se/1.4.1/docs/guide/serialization/spec/serialTOC.doc.html	93
http://java.sun.com/j2se/1.4.1/docs/guide/serialization/examples/index.html	94
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/serialver.html	95
http://java.sun.com/j2se/1.4.1/docs/guide/serialization/relnotes14.html	96
ftp://ftp.java.sun.com/docs/j2se1.4/serial-spec.pdf	97
ftp://ftp.java.sun.com/docs/j2se1.4/serial-spec.ps	98
http://java.sun.com/products/jfc	99
http://java.sun.com/products/jdk/awt	100
http://java.sun.com/docs/books/tutorial/ui	101
http://java.sun.com/j2se/1.4.1/docs/guide/awt/demos/index.html	102
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/package-summary.html	103
http://java.sun.com/j2se/1.4.1/docs/guide/awt/1.3/enhancements.html	104
http://java.sun.com/j2se/1.4.1/docs/guide/util/logging/MAILTO:j2se-comments@java.sun.com	105
http://java.sun.com/j2se/1.4.1/docs/api/java/util/logging/package-summary.html	106
http://java.sun.com/j2se/1.4.1/docs/guide/util/logging/overview.html	107
http://java.sun.com/j2se/1.4.1/docs/api/java/beans/beancontext/package-summary.html	108
http://java.sun.com/products/javabeans/glasgow/beancontext.ps	109
http://java.sun.com/beans/index.html	110
http://java.sun.com/j2se/1.4.1/docs/guide/beans/changes14.html	111
http://java.sun.com/docs/books/tutorial/javabeans/index.html	112
http://java.sun.com/products/jfc/tsc	113
http://java.sun.com/products/javabeans/glasgow/beancontext.pdf	114
http://java.sun.com/beans/spec.html	115
http://java.sun.com/j2se/1.4.1/docs/api/java/beans/package-summary.html	116
http://java.sun.com/j2se/1.4.1/docs/guide/beans/spec/beancontextTOC.fm.html	117
http://docs.sun.com/?q=kinit&p=/doc/806-0624/6j9vek58e&a=view	118
http://java.sun.com/j2se/1.4.1/docs/tooldocs/linux/java.html	119
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/jarsigner.html	120
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/extcheck.html	121
http://java.sun.com/j2se/1.4.1/docs/tooldocs/findingclasses.html	122
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/javah.html	123
http://java.sun.com/xml/tutorial_intro.html	124
http://java.sun.com/j2se/1.4.1/docs/guide/xml/jaxp/index.html	125
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/rmid.html	126
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/jdb.html	127
http://www.w3.org/XML	128
http://java.sun.com/xml	129
http://www.sun.com/xml	130
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/jdkfiles.html	131
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/jar.html	132
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/rmiregistry.html	133
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/native2ascii.html	134
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/javap.html	135
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/jarsigner.html	136
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/java.html	137
http://java.sun.com/j2se/1.4.1/docs/tooldocs/tools-changes.html	138
http://java.sun.com/j2se/1.4.1/docs/tooldocs/javadoc/index.html	139
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/rmiregistry.html	140
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/classpath.html	141
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/appletviewer.html	142
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/serialver.html	143
http://java.sun.com/j2se/1.4.1/docs/guide/idl/servertool.html	144
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/rmid.html	145
http://java.sun.com/j2se/1.4.1/docs/tooldocs	146
http://developer.java.sun.com/developer/onlineTraining/new2java	147
http://java.sun.com/PrintPage.jsp	148
http://servlet.java.sun.com/help/legal_and_licensing	149
http://wwws.sun.com/software/java2	150
http://java.sun.com/j2se/1.4.1/guide/collections/index.html	151
http://www.sun.com/suntrademarks	152
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/jar.html	153
http://java.sun.com/j2se/1.4.1/ja	154
http://java.sun.com/products/jdbc/index.html	155
http://java.sun.com/j2se/1.4.1/guide/serialization/index.html	156
http://java.sun.com/j2se/1.4.1/guide/rmi-iiop/index.html	157
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/javadoc.html	158
http://java.sun.com/j2se/1.4.1/guide/jni/index.html	159
http://java.sun.com/j2se/1.4.1/guide/misc/index.html	160
http://java.sun.com/javaone	161
http://java.sun.com/tools/index.html	169
http://www.sun.com/corp_emp	171
http://java.sun.com/downloads	172
http://java.sun.com/j2se	173
http://java.sun.com/blueprints	175
http://java.sun.com/j2se/vb.development.center.html	183
http://www.sun.com/smi/Press/sunflash/web_sunflash.html	189
http://java.sun.com/j2se/1.4.1	190
http://search.java.sun.com/search/java/advanced.jsp	195
http://java.sun.com/industry	196
http://www.sun.com/privacy	199
http://java.sun.com/products	209
http://java.sun.com/products/jdk/1.2/compatibility.html	210
http://java.sun.com/apis.html	211
http://java.sun.com/j2se/1.4/compatibility.html	212
http://www.sun.com/share/text/termsofuse.html	213
http://developer.java.sun.com/berkeley_license.html	216
http://java.sun.com/products/jdk/1.1/compatibility.html	220
http://java.sun.com/j2se/1.3/compatibility.html	221
http://servlet.java.sun.com/help	222
http://developer.java.sun.com/	223
http://developer.java.sun.com/developer/infodocs	232
http://www.sun.com/company	234
http://www201.ikiosk.com/cgi-shl/index.cgi?shop=33293&date=2002%3A04%3A26%3A10%3A29%3A26	238
http://java.sun.com/j2se/downloads.html	247
http://java.sun.com/docs	248
http://java.sun.com/j2se/1.4.1/docs/api/deprecated-list.html	249
http://java.sun.com/docs/books/jls/clarify.html	250
http://www.jcp.org/	251
http://java.sun.com/products/plugin/1.4.1/demos/applets/CardTest/example1.html	284
http://java.sun.com/docs/books/tutorial/together/index.html	285
http://java.sun.com/docs/books/tutorial/getStarted/index.html	287
http://java.sun.com/products/plugin/1.4.1/demos/applets/GraphLayout/example2.html	290
http://java.sun.com/products/plugin/1.4.1/demos/applets/GraphLayout/example4.html	292
http://java.sun.com/products/plugin/1.4.1/demos/applets/WireFrame/example1.html	293
http://java.sun.com/products/plugin/1.4.1/demos/applets/SortDemo/example1.html	294
http://java.sun.com/products/plugin/1.4.1/demos/applets/WireFrame/example3.html	295
http://java.sun.com/docs/books/tutorial/getStarted/cupojava/index.html	296
http://java.sun.com/products/plugin/1.4.1/demos/applets/Animator/example2.html	300
http://java.sun.com/products/plugin/1.4.1/demos/applets/Animator/example4.html	301
http://java.sun.com/products/plugin/1.4.1/demos/applets/MoleculeViewer/example2.html	302
http://java.sun.com/products/plugin/1.4.1/demos/applets/DrawTest/example1.html	306
http://java.sun.com/products/plugin/1.4.1/demos/applets/Fractal/example1.html	307
http://java.sun.com/products/plugin/1.4.1/demos/applets/SimpleGraph/example1.html	308
http://java.sun.com/products/plugin/1.4.1/demos/applets/ImageMap/example1.html	309
http://java.sun.com/products/plugin/1.4.1/demos/applets/Clock/example1.html	313
http://java.sun.com/products/plugin/1.4.1/demos/applets/TicTacToe/example1.html	314
http://java.sun.com/products/plugin/1.4.1/demos/applets/GraphicsTest/example1.html	317
http://java.sun.com/products/plugin/1.4.1/demos/applets/GraphLayout/example1.html	320
http://java.sun.com/products/plugin/1.4.1/demos/applets/ArcTest/example1.html	321
http://java.sun.com/products/plugin/1.4.1/demos/applets/BarChart/example1.html	322
http://java.sun.com/applets/index.html	323
http://java.sun.com/products/plugin/1.4.1/demos/applets/GraphLayout/example3.html	324
http://java.sun.com/products/plugin/1.4.1/demos/applets/WireFrame/example2.html	325
http://java.sun.com/products/plugin/1.4.1/demos/applets/Animator/example1.html	326
http://java.sun.com/products/plugin/1.4.1/demos/applets/WireFrame/example4.html	327
http://java.sun.com/products/plugin/1.4.1/demos/applets/Blink/example1.html	328
http://java.sun.com/products/plugin/1.4.1/demos/applets/Animator/example3.html	329
http://java.sun.com/products/plugin/1.4.1/demos/applets/NervousText/example1.html	330
http://java.sun.com/products/plugin/1.4.1/demos/applets/MoleculeViewer/example1.html	331
http://java.sun.com/products/plugin/1.4.1/demos/applets/DitherTest/example1.html	334
http://java.sun.com/products/plugin/1.4.1/demos/applets/MoleculeViewer/example3.html	335
http://java.sun.com/products/plugin/1.4.1/demos/applets/JumpingBox/example1.html	336
http://java.sun.com/products/plugin/1.4.1/demos/applets/SpreadSheet/example1.html	337
http://www.sun.com/products	360
http://developer.java.sun.com/developer/community/chat	365
http://www.sun.com/developers	366
http://www.sun.com/bigadmin	367
http://www.sun.com/learnabout/n1	368
http://www.sun.com/aboutsun/investor	369
http://www.sun.com/www.sun.com/featurepromo/sunfireblade?AssociateId=bladepromo	370
http://www.sun.com/MySun	371
http://www.sun.com/worldwide	374
http://www.sun.com/howtobuy	375
http://www.sun.com/datacenter/superg/feature/index.html	376
http://www.sun.com/learnabout/java	379
http://www.sun.com/learnabout/webservices	380
http://www.sun.com/company/newsevents	381
http://www.sun.com/bignews/nc03q2	384
http://www.sun.com/supportraining	385
http://java.sun.com/j2se/1.4.1/guide/awt/index.html	162
http://java.sun.com/j2se/1.4.1/guide/util/logging/index.html	168
http://java.sun.com/j2se/1.4.1/guide/jvmpi/index.html	170
http://java.sun.com/j2se/1.4.1/guide/math/index.html	184
http://java.sun.com/j2se/1.4.1/guide/corba/index.html	187
http://java.sun.com/j2se/1.4.1/guide/imf/index.html	188
http://java.sun.com/j2se/1.4.1/guide/access/index.html	192
http://java.sun.com/j2se/1.4.1/guide/extensions/index.html	201
http://java.sun.com/j2se/1.4.1/guide/reflection/index.html	215
http://java.sun.com/j2se/1.4.1/guide/jws/index.html	219
http://java.sun.com/j2se/1.4.1/guide/rmi/index.html	233
http://java.sun.com/j2se/1.4.1/guide/imageio/index.html	236
http://java.sun.com/j2se/1.4.1/guide/versioning/index.html	237
http://java.sun.com/j2se/1.4.1/guide/jdbc/index.html	243
http://java.sun.com/j2se/1.4.1/guide/jps/index.html	244
http://java.sun.com/j2se/1.4.1/guide/net/index.html	245
http://java.sun.com/j2se/1.4.1/guide/beans/index.html	252
http://java.sun.com/j2se/1.4.1/guide/security/index.html	253
http://java.sun.com/j2se/1.4.1/relnotes/features.html	254
http://java.sun.com/j2se/1.4.1/guide/standards/index.html	260
http://java.sun.com/j2se/1.4.1/tooldocs/tools.html	263
http://java.sun.com/j2se/1.4.1/guide/swing/index.html	266
http://java.sun.com/j2se/1.4.1/relnotes/SMICopyright.html	268
http://java.sun.com/j2se/1.4.1/guide/performance/index.html	274
http://java.sun.com/j2se/1.4.1/guide/sound/index.html	288
http://java.sun.com/j2se/1.4.1/guide/2d/index.html	289
http://java.sun.com/j2se/1.4.1/relnotes/demos.html	318
http://java.sun.com/j2se/1.4.1/relnotes/contacts.html	319
http://java.sun.com/j2se/1.4.1/guide/jpda/index.html	343
http://java.sun.com/j2se/1.4.1/guide/intl/index.html	348
http://java.sun.com/j2se/1.4.1/api/overview-summary.html	349
http://java.sun.com/j2se/1.4.1/api/index.html	350
http://java.sun.com/j2se/1.4.1/guide/nio/index.html	354
http://java.sun.com/j2se/1.4.1/guide/plugin/index.html	358
http://java.sun.com/j2se/1.4.1/guide/lang/index.html	383
http://java.sun.com/j2se/1.4.1/guide/jar/index.html	390
http://java.sun.com/j2se/1.4.1/guide/resources/index.html	405
http://java.sun.com/j2se/1.4.1/guide/xml/index.html	406
http://java.sun.com/j2se/1.4.1/guide/jndi/index.html	407
http://java.sun.com/j2se/1.4.1/guide/dragndrop/index.html	408
http://java.sun.com/j2se/1.4.1/guide/vm/index.html	414
http://java.sun.com/j2se/1.4.1/guide/refobs/index.html	416
http://java.sun.com/j2se/1.4.1/guide/idl/index.html	417
http://java.sun.com/products/javawebstart/faq.html	486
http://java.sun.com/products/javawebstart/architecture.html	487
http://java.sun.com/features/2001/09/webstart.html	488
http://java.sun.com/j2se/1.4.1/docs/guide/jws/Readme.html	489
http://java.sun.com/products/javawebstart/developers.html	490
http://java.sun.com/j2se/1.4.1/docs/guide/jws/downloadservletguide.html	491
http://java.sun.com/j2se/1.4.1/docs/guide/jws/relnotes.html	492
http://java.sun.com/products/javawebstart/1.2/docs/l10n/index.html	493
http://java.sun.com/j2se/1.4.1/docs/guide/jws/developersguide.html	494
http://java.sun.com/docs/forma/javaws-sendusmail.html	495
http://java.sun.com/j2se/1.4.1/docs/guide/jws/jnlp/index.html	496
http://java.sun.com/products/java-media/sound/index.html	498
http://java.sun.com/j2se/1.4.1/docs/api/javax/sound/midi/package-summary.html	499
http://java.sun.com/j2se/1.4.1/docs/guide/sound/programmer_guide/contents.html	500
http://java.sun.com/products/java-media/sound	501
http://java.sun.com/j2se/1.4.1/docs/api/javax/sound/midi/spi/package-summary.html	502
http://java.sun.com/j2se/1.4.1/docs/api/javax/sound/sampled/spi/package-summary.html	503
ftp://ftp.java.sun.com/docs/j2se1.4/programmer_guide.pdf	504
http://java.sun.com/j2se/1.4.1/docs/api/javax/sound/sampled/package-summary.html	505
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/jpda.html	506
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/jvmdi-spec.html	507
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/architecture.html	508
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/jdi/index.html	509
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/enhancements.html	510
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/conninv.html	511
http://java.sun.com/j2se/1.4.1/docs/guide/jpda/jdwp-spec.html	512
http://java.sun.com/products/jpda	513
http://java.sun.com/docs/forms/sendusmail.html	514
http://java.sun.com/mail	515
http://java.sun.com/feedback/faq/assistance.html	516
http://java.sun.com/feedback/sitecomments.html	517
http://java.sun.com/j2se/1.4.1/docs/guide/net/overview/overview.html	518
http://java.sun.com/j2se/1.4.1/docs/guide/net/properties.html	519
http://java.sun.com/j2se/1.4.1/docs/guide/net/socketOpt.html	520
http://java.sun.com/j2se/1.4.1/networking-relnotes.html	521
http://java.sun.com/j2se/1.4.1/docs/api/java/net/package-summary.html	522
http://java.sun.com/j2se/1.4.1/docs/guide/net/ipv6_guide/index.html	523
http://java.sun.com/products/jdbc/download.html	163
http://java.sun.com/j2se/1.4.1/docs/guide/jdbc/bridge.html	165
http://java.sun.com/j2se/1.4.1/docs/api/javax/sql/package-summary.html	174
http://java.sun.com/j2se/1.4.1/docs/guide/jdbc/blob.html	177
http://java.sun.com/products/jdbc/jdbc.drivers.html	185
http://java.sun.com/j2se/1.4.1/docs/api/java/sql/package-summary.html	193
http://java.sun.com/docs/books/tutorial/jdbc/basics/index.html	200
http://java.sun.com/j2ee/docs.html	203
http://developer.java.sun.com/developer/Books/JDBCTutorial/index.html	205
http://java.sun.com/docs/books/jdbc	207
http://developer.java.sun.com/developer/Books/JDBCTutorial/chapter5.html	229
http://java.sun.com/j2se/1.4.1/docs/guide/jdbc/getstart/GettingStartedTOC.fm.html	231
http://java.sun.com/products/jdbc/jdbc-frequent.html	240
http://java.sun.com/j2se/1.4.1/docs/guide/jdbc/clob.html	241
http://java.sun.com/j2se/1.4.1/docs/guide/security/smPortGuide.html	283
http://java.sun.com/docs/books/tutorial/security1.2/index.html	299
http://java.sun.com/j2se/1.4.1/docs/api/org/ietf/jgss/package-summary.html	315
http://java.sun.com/j2se/1.4.1/docs/guide/security/HowToImplAProvider.html	316
http://java.sun.com/j2se/1.4.1/docs/guide/security/PolicyFiles.html	333
http://java.sun.com/j2se/1.4.1/docs/guide/security/permissions.html	340
http://java.sun.com/j2se/1.4.1/docs/api/javax/crypto/package-summary.html	341
http://java.sun.com/j2se/1.4.1/docs/api/javax/crypto/spec/package-summary.html	345
http://java.sun.com/j2se/1.4.1/docs/api/javax/crypto/interfaces/package-summary.html	346
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/auth/kerberos/package-summary.html	347
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/spec/com/sun/security/auth/login/package-summary.html	352
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/auth/login/package-summary.html	355
http://java.sun.com/j2se/1.4.1/docs/guide/security/jce/JCERefGuide.html	357
http://java.sun.com/j2se/1.4.1/docs/guide/security/jgss/single-signon.html	359
http://java.sun.com/j2se/1.4.1/docs/api/java/security/package-summary.html	362
http://java.sun.com/j2se/1.4.1/docs/guide/security/spec/security-spec.doc.html	363
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/spec/com/sun/security/auth/callback/package-summary.html	364
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/tutorials/index.html	372
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/auth/callback/package-summary.html	373
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/cert/package-summary.html	382
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/spec/com/sun/security/auth/module/package-summary.html	395
http://java.sun.com/j2se/1.4.1/docs/api/java/security/cert/package-summary.html	401
http://java.sun.com/j2se/1.4.1/docs/api/javax/net/ssl/package-summary.html	403
http://java.sun.com/j2se/1.4.1/docs/api/java/security/spec/package-summary.html	404
http://java.sun.com/security/index.html	410
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/auth/x500/package-summary.html	413
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/auth/package-summary.html	418
http://java.sun.com/docs/books/tutorial/trailmap.html	419
http://java.sun.com/j2se/1.4.1/docs/api/javax/net/package-summary.html	421
http://java.sun.com/j2se/1.4.1/docs/guide/security/doprivileged.html	424
http://java.sun.com/j2se/1.4.1/docs/guide/security/jgss/spec/com/sun/security/jgss/package-summary.html	429
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/JAASLMDevGuide.html	431
http://java.sun.com/j2se/1.4.1/docs/guide/security/jce/HowToImplAJCEProvider.html	432
http://java.sun.com/security/jaas/doc/acsac.html	437
http://java.sun.com/j2se/1.4.1/docs/guide/security/SecurityToolsSummary.html	440
http://java.sun.com/j2se/1.4.1/docs/guide/security/cert3.html	442
http://java.sun.com/j2se/1.4.1/docs/api/javax/security/auth/spi/package-summary.html	446
http://java.sun.com/j2se/1.4.1/docs/api/java/security/interfaces/package-summary.html	448
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/spec/com/sun/security/auth/package-summary.html	450
http://java.sun.com/j2se/1.4.1/docs/guide/security/CryptoSpec.html	455
http://developer.java.sun.com/developer/bugParade/bugs/4532517.html	559
http://developer.java.sun.com/developer/bugParade/bugs/4639735.html	560
http://developer.java.sun.com/developer/bugParade/bugs/4513715.html	561
http://jcp.org/aboutJava/communityprocess/maintenance/jsr059/index.html	562
http://developer.java.sun.com/developer/bugParade/bugs/4668963.html	565
http://developer.java.sun.com/developer/bugParade/bugs/4395157.html	566
http://developer.java.sun.com/developer/bugParade/bugs/4659800.html	567
http://developer.java.sun.com/developer/bugParade/bugs/4615396.html	568
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/server/RMISocketFactory.html	569
http://www.ietf.org/internet-drafts/draft-ietf-ldapext-locate-08.txt	570
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/control_panel.html	571
http://developer.java.sun.com/developer/bugParade/bugs/4632782.html	572
http://java.sun.com/j2se/1.4.1/docs/guide/intl/encoding.doc.html	573
http://developer.java.sun.com/developer/bugParade/bugs/4556882.html	574
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/jndi-ldap.html	575
http://java.sun.com/j2se/1.4.1/docs/tooldocs/linux/ktab.html	164
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/policytool.html	166
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/javadoc.html	167
http://java.sun.com/j2se/1.4.1/docs/tooldocs/linux/klist.html	176
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/classpath.html	178
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/javah.html	179
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/javac.html	180
http://java.sun.com/j2se/1.4.1/docs/guide/idl/orbd.html	181
http://java.sun.com/j2se/1.4.1/docs/tooldocs/linux/jdkfiles.html	182
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/java.html	186
http://java.sun.com/j2se/1.4.1/docs/tooldocs/linux/kinit.html	191
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/klist.html	194
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/javap.html	197
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/jdkfiles.html	198
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/policytool.html	202
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/rmic.html	204
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/extcheck.html	206
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/native2ascii.html	208
http://java.sun.com/products/plugin/1.3/docs/script.html	214
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/kinit.html	217
http://docs.sun.com/?q=kadmin&p=/doc/816-0211/6m6nc66th&a=view	218
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/toJavaPortableUG.html	224
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/appletviewer.html	225
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/rmic.html	226
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/ktab.html	227
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/javac.html	228
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/jdb.html	230
http://docs.sun.com/?q=kinit&p=/doc/806-0624/6j9vek58d&a=view	235
http://java.sun.com/j2se/1.4.1/docs/tooldocs/solaris/keytool.html	239
http://java.sun.com/j2se/1.4.1/docs/tooldocs/windows/keytool.html	242
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlNaming.html	246
http://java.sun.com/docs/books/jls/second_edition/html/jcopyright.doc.html	262
http://java.sun.com/docs/books/jls/second_edition/html/jTOC.doc.html	264
http://java.sun.com/docs/books/jls/second_edition/html/jIX.fm.html	265
http://java.sun.com/docs/books/tutorial/2d/index.html	276
http://java.sun.com/j2se/1.4.1/docs/guide/2d/samples/README.html	277
http://java.sun.com/products/java-media/2D/perf_graphics.html	278
ftp://ftp.java.sun.com/docs/j2se/1.4/j2d-book.pdf	279
http://java.sun.com/j2se/1.4.1/docs/guide/2d/new_features.html	280
http://java.sun.com/products/java-media/2D/index.html	282
ftp://ftp.java.sun.com/docs/j2se/1.4/j2d-book.ps	286
http://java.sun.com/j2se/1.4.1/docs/guide/2d/spec.html	291
http://java.sun.com/j2se/1.4.1/docs/guide/2d/spec/j2d-title.fm.html	305
http://java.sun.com/products/jfc/index.html	339
http://java.sun.com/products/jdk/faq/jnifaq.html	353
http://java.sun.com/j2se/1.4.1/docs/guide/jni/spec/jniTOC.doc.html	356
http://java.sun.com/docs/books/tutorial/native1.1/index.html	361
http://java.sun.com/j2se/1.4.1/docs/guide/awt/1.3/AWT_Native_Interface.html	377
http://java.sun.com/j2se/1.4.1/docs/guide/jni/jni-12.html	378
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/tree/package-summary.html	409
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/event/package-summary.html	425
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/plaf/basic/package-summary.html	426
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/table/package-summary.html	427
http://java.sun.com/j2se/1.4.1/docs/guide/swing/SwingChanges.html	428
http://java.sun.com/j2se/1.4.1/docs/guide/swing/1.3/SwingChanges.html	430
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/plaf/package-summary.html	433
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/undo/package-summary.html	434
http://java.sun.com/products/jfc/tsc/index.html	435
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/plaf/metal/package-summary.html	436
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/colorchooser/package-summary.html	438
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/filechooser/package-summary.html	439
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/package-summary.html	441
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/text/rtf/package-summary.html	443
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/border/package-summary.html	444
http://java.sun.com/docs/books/tutorial/uiswing/index.html	445
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/text/html/parser/package-summary.html	447
http://java.sun.com/j2se/1.4.1/docs/guide/swing/1.4/Post1.4.html	454
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/text/package-summary.html	456
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/text/html/package-summary.html	457
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/plaf/multi/package-summary.html	458
http://java.sun.com/j2se/1.4.1/docs/guide/collections/overview.html	461
http://java.sun.com/docs/books/tutorial/collections/index.html	463
http://java.sun.com/j2se/1.4.1/docs/guide/collections/designfaq.html	464
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/server/RMIClassLoader.html	255
http://java.sun.com/j2se/1.4.1/docs/guide/security/jgss/tutorials/index.html	256
http://java.sun.com/j2se/1.4.1/docs/api/java/net/NetworkInterface.html	257
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/Class.html	258
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/reflect/Field.html	259
http://java.sun.com/j2se/1.4.1/docs/api/java/util/regex/package-summary.html	261
http://java.sun.com/j2se/1.4.1/docs/guide/swing/1.4/dnd.html	267
http://java.sun.com/j2se/1.4.1/docs/guide/collections/changes4.html	269
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/server/RMIClassLoaderSpi.html	270
http://java.sun.com/j2se/1.4.1/docs/guide/performance/speed.html	271
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/reflect/Constructor.html	272
ftp://ftp.omg.org/pub/docs/ptc/99-12-03.pdf	273
http://java.sun.com/j2se/1.4.1/docs/guide/intl/locale.doc.html	275
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlChanges.html	281
http://java.sun.com/j2se/1.4.1/docs/api/java/net/InetAddress.html	297
http://java.sun.com/j2se/1.4.1/docs/guide/security/jsse/JSSERefGuide.html	298
http://java.sun.com/j2se/1.4.1/docs/guide/jni/jni-14.html	303
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/reflect/Method.html	304
http://java.sun.com/j2se/1.4.1/docs/guide/security/certpath/CertPathProgGuide.html	310
http://java.sun.com/j2se/1.4.1/docs/api/java/net/URI.html	311
http://java.sun.com/j2se/1.4.1/docs/guide/security/jaas/JAASRefGuide.html	312
http://java.sun.com/j2se/1.4.1/docs/guide/net/enhancements14.html	332
http://java.sun.com/j2se/1.4.1/docs/api/java/text/NumberFormat.html	338
http://java.sun.com/j2se/1.4.1/docs/guide/lang/preferences.html	342
http://java.sun.com/j2se/1.4.1/docs/guide/idl/POA.html	344
http://java.sun.com/j2se/1.4.1/docs/relnotes	351
http://java.sun.com/products/hotspot	411
http://java.sun.com/j2se/1.4.1/docs/guide/lang/chained-exceptions.html	412
http://java.sun.com/j2se/1.4.1/docs/api/java/util/Currency.html	415
http://java.sun.com/j2se/1.4.1/docs/tooldocs/javadoc/whatsnew-1.4.1.html	420
http://java.sun.com/j2se/1.4.1/docs/guide/lang/assert.html	422
http://java.sun.com/j2se/1.4.1/docs/guide/dragndrop	423
http://java.sun.com/jdc/bugParade/index.html	449
http://java.sun.com/j2se/1.4/docs/relnotes/SMICopyright.html	451
http://java.sun.com/j2se/1.4.1/fixedbugs/fixedbugs.html	452
http://developer.java.sun.com/developer/bugParade/index.html	453
http://java.sun.com/j2se/1.4.1/docs/guide/imf/spi-tutorial.html	459
http://java.sun.com/j2se/1.4.1/docs/guide/imf/overview.html	460
http://java.sun.com/j2se/1.4.1/docs/guide/imf/api-reference.html	462
http://java.sun.com/j2se/1.4.1/docs/guide/imf/api-tutorial.html	466
http://java.sun.com/j2se/1.4.1/docs/guide/imf/spi-reference.html	468
http://java.sun.com/j2se/1.4.1/docs/guide/imf/spec.html	469
http://developer.java.sun.com/developer/bugParade	470
http://developer.java.sun.com/developer/earlyAccess	471
http://java.sun.com/j2me	472
http://java.sun.com/webservices	473
ftp://ftp.javasoft.com/docs/codeconv/codeconv.zip	474
http://developer.java.sun.com/developer/codesamples	475
http://java.sun.com/docs/codeconv/html/CodeConvTOC.doc.html	476
http://wireless.java.sun.com/	477
http://forum.java.sun.com/	478
http://java.sun.com/products/OV_otherProduct.html	479
ftp://ftp.javasoft.com/docs/codeconv/CodeConventions.pdf	480
http://developer.java.sun.com/developer/support	481
http://java.sun.com/j2ee	482
ftp://ftp.javasoft.com/docs/codeconv/CodeConventions.ps	483
http://java.sun.com/j2se/1.4.1/relnotes-cobundle.html	539
http://servlet.java.sun.com/help/download	540
http://java.sun.com/j2se/docs/PerformanceFAQ.html	808
http://java.sun.com/j2se/1.4.1/docs/guide/vm/sample-output.html	809
http://java.sun.com/j2se/1.4.1/docs/guide/vm/signal-chaining.html	810
http://java.sun.com/j2se/docs/VMOptions.html	812
http://java.sun.com/products/hotspot/docs/whitepaper/Java_Hotspot_v1.4.1/Java_HSpot_WP_v1.4.1_1002_1.html	813
http://java.sun.com/docs/hotspot/index.html	817
http://java.sun.com/products/hotspot/docs/general/hs2.html	818
http://java.sun.com/j2se/1.4.1/docs/guide/vm/error-handling.html	819
http://java.sun.com/j2se/1.4.1/docs/guide/reflection/proxy.html	1017
http://java.sun.com/j2se/1.4.1/docs/guide/reflection/reflection.html	1018
http://java.sun.com/j2se/1.4.1/docs/guide/reflection/spec/java-reflectionTOC.doc.html	1019
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ref/Reference.html	1049
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ref/SoftReference.html	1050
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ref/WeakReference.html	1051
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ref/ReferenceQueue.html	1052
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ref/PhantomReference.html	1054
http://java.sun.com/j2se/1.4.1/docs/guide/misc/deprecation/index.html	1060
http://java.sun.com/j2se/1.4.1/docs/guide/misc/applet.html	1061
http://java.sun.com/j2se/1.4.1/docs/guide/imageio/spec/title.fm.html	1084
http://www.sun.com/downloads	386
http://java.sun.com/getjava	387
http://www.sun.com/research	388
http://www.sun.com/executives	389
http://www.sun.com/partners	391
http://www.sun.com/emrkt/whynot	392
http://www.sun.com/documentation	393
http://www.sun.com/featured-articles	394
http://www.sun.com/learnabout/solaris	396
http://www.sun.com/contact	397
http://www.sun.com/learnabout/netid	398
http://www.sun.com/aboutsun/media	399
http://research.sun.com/techrep/2003/abstract-122.html	400
http://www.sun.com/solutions	402
http://www.confluent.fr/javadoc/javadoce.html	484
http://www.confluent.fr/javadoc/javadoc.html	485
http://java.sun.com/j2se/1.4.1/docs/api/java/io/File.html	497
http://www.sun.com/solaris/java/faq.html	554
http://www.winzip.com/	555
http://java.sun.com/nav/new/index.html	556
http://java.sun.com/products/hotjava	557
http://java.sun.com/cgi-bin/feedback.pl	558
http://java.sun.com/cgi-bin/java-ports.cgi	563
http://java.sun.com/products/jdk	564
http://java.sun.com/j2se/1.3/docs/tooldocs/tools.html	591
http://home.mcom.com/assist/support/client	592
http://java.sun.com/licensees.html	596
http://java.sun.com/mail/index.html	601
http://java.sun.com/index.html	604
http://java.sun.com/products/jdk/1.2/jre/download-solaris.html	605
http://java.sun.com/products/jdk/1.2/download-solaris.html	606
http://www.sun.com/solaris/java	607
http://java.sun.com/products/jdk/1.1/jre/download-jre-solaris.html	608
http://www.sun.com/sunservice/suned	609
http://www.sun.com/solaris/jre	610
http://java.sun.com/docs/index.html	611
http://java.sun.com/products/jdk/1.1/download-jdk-solaris.html	612
http://developer.netscape.com/tech/javascript/index.html	613
http://home.netscape.com/	614
http://java.sun.com/nav/business/trademark_guidelines.html	615
http://java.sun.com/communitysource/index.html	616
http://java.sun.com/starter.html	617
http://java.sun.com/nav/business/index.html	618
http://java.sun.com/products/jdk/1.1/solaris-product-comparison.html	619
http://developer.java.sun.com/developer/onlineTraining/new2java/overview.html	620
http://developer.java.sun.com/developer/onlineTraining/new2java/supplements/2003/Feb03.html	621
http://developer.java.sun.com/developer/onlineTraining/new2java/javaworkbook	628
http://developer.java.sun.com/developer	631
http://wwws.sun.com/software/sundev/jde/buy	632
http://developer.java.sun.com/developer/onlineTraining/new2java/reference.html	639
http://wwws.sun.com/software/products/appsrvr/appsrvr_download.html	640
http://developer.java.sun.com/developer/onlineTraining/new2java/certification.html	642
http://developer.java.sun.com/developer/onlineTraining/new2java/learningpaths.html	648
http://developer.java.sun.com/developer/onlineTraining/new2java/supplements/quizzes/index.html	649
http://developer.java.sun.com/developer/onlineTraining/new2java/gettingstartedjava.html	652
http://developer.java.sun.com/developer/onlineTraining/new2java/programming/learn/unravelingjava.html	653
http://java.sun.com/webservices/downloads/webservicespack.html	661
http://developer.java.sun.com/developer/onlineTraining/new2java/stepbystep.html	664
http://www.amazon.com/exec/obidos/ASIN/0201310082/qid=959301911/sr=1-2/103-0036873-9502255/javasoftsunmicroA	790
ftp://ftp.javasoft.com/docs/specs/langspec-2.0.html.tar.Z	791
http://java.sun.com/docs/books/jls/first_edition/html/index.html	792
http://cseng.aw.com/book/backcover/0,3828,0201634511,00.html	793
ftp://ftp.javasoft.com/docs/specs/langspec-1.0.html.zip	794
ftp://ftp.javasoft.com/docs/specs/langspec-1.0.html.tar.Z	795
http://www.awl.com/cp/javaseries.html	796
ftp://ftp.javasoft.com/docs/specs/langspec-1.0.ps.zip	797
ftp://ftp.javasoft.com/docs/specs/langspec-2.0.pdf	798
ftp://ftp.javasoft.com/docs/specs/langspec-1.0.pdf	799
http://java.sun.com/docs/books/jls/second_edition/download/langspec-2.0.html.tar.Z	800
http://java.sun.com/docs/forms/jls-sendusmail.html	801
http://java.sun.com/docs/books/jls/first_edition/html/1.1Update.html	802
http://java.sun.com/docs/books/jls/html/jcopyright.doc.html	803
http://java.sun.com/docs/books/jls/second_edition/download/langspec-2.0.html.zip	804
http://java.sun.com/docs/books/jls/jls-maintenance.html	805
http://12.31.179.2/DigitalGuru/product_detail.asp?catalog_name=Books&category_name=&product_id=0201310082&partner_id=87	806
ftp://ftp.javasoft.com/docs/specs/langspec-2.0.html.zip	807
http://12.31.179.2/DigitalGuru/product_detail.asp?catalog_name=Books&category_name=&product_id=0201634511&partner_id=87	811
http://www.amazon.com/exec/obidos/ISBN=0201634511/javasoftsunmicroA	814
http://cseng.aw.com/book/toc/0,3828,0201634511,00.html	815
ftp://ftp.javasoft.com/docs/specs/langspec-1.0.ps.Z	816
http://java.sun.com/j2se/1.4.1/docs/guide/extensions/spec.html	901
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/Thread.html	902
http://java.sun.com/j2se/1.4.1/docs/guide/collections/changes3.html	465
http://java.sun.com/j2se/1.4.1/docs/guide/collections/reference.html	467
http://servlet.java.sun.com/java.sun.com/apis.html	622
http://servlet.java.sun.com/java.sun.com/docs/books/tutorial	623
http://servlet.java.sun.com/java.sun.com/webservices/downloads/webservicespack.html	624
http://servlet.java.sun.com/java.sun.com/j2ee	625
http://servlet.java.sun.com/developer.java.sun.com/developer/codesamples	626
http://servlet.java.sun.com/java.sun.com/j2se/1.4.2/download.html	627
http://servlet.java.sun.com/java.sun.com/getjava/download.html	629
http://servlet.java.sun.com/developer.java.sun.com/developer/community	630
http://developer.java.sun.com/developer/technicalArticles/Networking/jxta2.0/index.html	633
http://servlet.java.sun.com/java.sun.com/tools	634
http://java.sun.com/j2ee/download.html	635
http://servlet.java.sun.com/java.sun.com/webservices	636
http://servlet.java.sun.com/developer.java.sun.com/developer/support	637
http://java.sun.com/features/index.html	638
http://servlet.java.sun.com/wwws.sun.com/software/products/appsrvr/appsrvr_download.html	641
http://servlet.java.sun.com/developer.java.sun.com/developer/onlineTraining/new2java	643
http://servlet.java.sun.com/developer.java.sun.com/servlet/SessionServlet?url=/developer/	644
http://servlet.java.sun.com/javaone/sf2003/conf/sessions/index.en.jsp	645
http://servlet.java.sun.com/java.sun.com/whyregister.html	646
http://servlet.java.sun.com/forum.java.sun.com	647
http://servlet.java.sun.com/developer.java.sun.com/developer/infodocs	650
http://servlet.java.sun.com/developer.java.sun.com/developer/onlineTraining	651
http://servlet.java.sun.com/java.sun.com/j2me	654
http://servlet.java.sun.com/developer.java.sun.com/servlet/RegistrationServlet	655
http://servlet.java.sun.com/java.sun.com/products/OV_otherProduct.html	656
http://servlet.java.sun.com/java.sun.com/industry	657
http://servlet.java.sun.com/java.sun.com/j2se/1.4.1/download.html	658
http://servlet.java.sun.com/java.sun.com/j2se	659
http://servlet.java.sun.com/java.sun.com/jugs	660
http://servlet.java.sun.com/wwws.sun.com/software/sundev/jde/buy/index.html	662
http://servlet.java.sun.com/developer.java.sun.com/developer/community/chat	666
http://servlet.java.sun.com/java.sun.com/products	667
http://developer.java.sun.com/developer/technicalArticles/Programming/TopCoder	668
http://servlet.java.sun.com/developer.java.sun.com/subscription	672
http://servlet.java.sun.com/java.sun.com/downloads	674
http://servlet.java.sun.com/java.sun.com/xml	675
http://servlet.java.sun.com/developer.java.sun.com/developer/earlyAccess	678
http://servlet.java.sun.com/developer.java.sun.com/developer/bugParade	681
http://servlet.java.sun.com/wireless.java.sun.com	682
http://developer.apple.com/wwdc/index_j.html	683
http://servlet.java.sun.com/developer.java.sun.com	684
http://servlet.java.sun.com/java.sun.com/blueprints	688
http://java.sun.com/aboutJava/communityprocess/review/jsr006/index.html	709
ftp://ftp.java.sun.com/docs/j2se1.4/JPS_PDF.pdf	710
http://java.sun.com/j2se/1.4.1/docs/api/javax/print/attribute/package-summary.html	711
http://java.sun.com/printing	712
http://java.sun.com/j2se/1.4.1/docs/guide/jps/spec/jpsTitle.fm.html	715
ftp://ftp.javasoft.com/docs/specs/vmspec.html.tar.Z	734
http://java.sun.com/docs/books/vmspec/html/VMSpecTOC.doc.html	735
ftp://ftp.javasoft.com/docs/specs/vmspec.2nded.html.zip	737
ftp://ftp.javasoft.com/docs/specs/vmspec.2nded.html.tar.Z	738
http://www.amazon.com/exec/obidos/ISBN=020163452X/javasoftsunmicroA	739
http://www.amazon.com/exec/obidos/ISBN=0201432943/javasoftsunmicroA	740
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Copyright.doc.html	741
http://cseng.awl.com/book/preface/0,3829,0201432943,00.html	742
http://java.sun.com/docs/books/vmspec/2nd-edition/jvms-maintenance.html	744
http://java.sun.com/docs/books/vmspec/2nd-edition/errata.html	745
http://12.31.179.2/DigitalGuru/product_detail.asp?catalog_name=Books&category_name=&product_id=0201432943&partner_id=87	748
http://java.sun.com/docs/books/vmspec/jvmcopyr.html	750
http://java.sun.com/docs/books/vmspec/errata.html	752
http://cseng.aw.com/bookdetail.qry?ISBN=0-201-63452-X&ptype=1160	754
http://12.31.179.2/DigitalGuru/product_detail.asp?catalog_name=Books&category_name=&product_id=020163452X&partner_id=87	756
ftp://ftp.javasoft.com/docs/specs/vmspec.html.zip	757
ftp://ftp.javasoft.com/docs/specs/vmspec.2nded.html.tar.gz	759
ftp://ftp.javasoft.com/docs/specs/vmspec.html.tar.gz	764
http://cseng.aw.com/book/backcover/0,3828,0201432943,00.html	766
http://cseng.aw.com/bookdetail.qry?ISBN=0-201-63452-X&ptype=0	769
ftp://ftp.java.sun.com/docs/j2se1.4/versioning.pdf	820
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/System.html	821
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/Package.html	822
ftp://ftp.java.sun.com/docs/j2se1.4/versioning.ps	823
http://java.sun.com/j2se/1.4.1/docs/guide/versioning/spec/VersioningTOC.html	824
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ClassLoader.html	825
ftp://ftp.java.sun.com/docs/j2se1.4/networking.pdf	524
http://java.sun.com/j2se/1.4.1/docs/guide/net/enhancements.html	525
ftp://ftp.java.sun.com/docs/j2se1.4/ipv6_guide.pdf	526
http://java.sun.com/j2se/1.4.1/docs/guide/net/socketException.html	527
http://java.sun.com/j2se/1.4.1/docs/guide/net/extendingSocks.html	528
http://java.sun.com/j2se/1.4.1/docs/guide/net/miscNet.html	529
ftp://ftp.java.sun.com/docs/j2se1.4/rmi-spec-1.4.pdf	530
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/javarmiproperties.html	531
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/codebase.html	532
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/registry/package-summary.html	533
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/relnotes.html	534
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/socketfactory/SSLInfo.html	535
http://java.sun.com/docs/books/tutorial/rmi/index.html	536
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/sunrmiproperties.html	537
http://archives.java.sun.com/archives/rmi-users.html	538
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/faq.html	541
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/subscribe.html	542
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/Factory.html	543
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/activation/package-summary.html	544
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/package-summary.html	545
http://java.sun.com/products/jdk/rmi	546
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/server/package-summary.html	547
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/getstart.doc.html	548
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/spec/rmiTOC.html	549
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/activation.html	550
http://java.sun.com/j2se/1.4.1/docs/guide/rmi/socketfactory/index.html	551
ftp://ftp.java.sun.com/docs/j2se1.4/rmi-spec-1.4.ps	552
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/dgc/package-summary.html	553
http://java.sun.com/j2se/1.4.1/docs/relnotes/license.html	589
http://java.sun.com/j2se/1.4.1/docs/relnotes/prop_rights.html	590
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/DynamicAny/DynAnyPackage/package-summary.html	663
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/stub/java/rmi/package-summary.html	665
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CosNaming/package-summary.html	669
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/reflect/package-summary.html	670
http://java.sun.com/j2se/1.4.1/docs/api/java/nio/charset/package-summary.html	671
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/ORBPackage/package-summary.html	673
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/directory/package-summary.html	676
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/im/package-summary.html	677
http://java.sun.com/j2se/1.4.1/docs/api/java/util/jar/package-summary.html	679
http://java.sun.com/j2se/1.4.1/docs/api/javax/print/attribute/standard/package-summary.html	680
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/print/package-summary.html	685
http://java.sun.com/j2se/1.4.1/docs/api/javax/imageio/event/package-summary.html	686
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/dnd/package-summary.html	687
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/DynamicAny/DynAnyFactoryPackage/package-summary.html	689
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/portable/package-summary.html	690
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/DynamicAny/package-summary.html	691
http://java.sun.com/j2se/1.4.1/docs/relnotes/devdocs-vs-specs.html	692
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableInterceptor/ORBInitInfoPackage/package-summary.html	693
http://java.sun.com/j2se/1.4.1/docs/api/javax/transaction/xa/package-summary.html	694
http://java.sun.com/j2se/1.4.1/docs/api/java/util/zip/package-summary.html	695
http://java.sun.com/j2se/1.4.1/docs/api/org/xml/sax/helpers/package-summary.html	696
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/POAManagerPackage/package-summary.html	697
http://java.sun.com/j2se/1.4.1/docs/api/javax/print/package-summary.html	698
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/IOP/package-summary.html	699
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/portable/package-summary.html	700
http://java.sun.com/j2se/1.4.1/docs/api/java/nio/package-summary.html	701
http://java.sun.com/j2se/1.4.1/docs/api/javax/accessibility/package-summary.html	702
http://java.sun.com/j2se/1.4.1/docs/api/org/xml/sax/ext/package-summary.html	703
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/ldap/package-summary.html	704
http://java.sun.com/j2se/1.4.1/docs/api/javax/xml/transform/stream/package-summary.html	705
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/event/package-summary.html	706
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/ServantLocatorPackage/package-summary.html	707
http://java.sun.com/j2se/1.4.1/docs/api/javax/xml/transform/dom/package-summary.html	708
http://java.sun.com/j2se/1.4.1/docs/api/java/util/prefs/package-summary.html	713
http://java.sun.com/j2se/1.4.1/docs/api/java/text/package-summary.html	714
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/package-summary.html	716
http://java.sun.com/j2se/1.4.1/docs/api/javax/print/event/package-summary.html	717
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CosNaming/NamingContextPackage/package-summary.html	718
http://java.sun.com/j2se/1.4.1/docs/api/javax/imageio/metadata/package-summary.html	719
http://developer.java.sun.com/developer/bugParade/bugs/4627627.html	576
http://developer.java.sun.com/developer/bugParade/bugs/4379138.html	577
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/extensions.html	578
http://developer.java.sun.com/developer/bugParade/bugs/4628933.html	579
http://jcp.org/aboutJava/communityprocess/maintenance/jsr059/index2.html	580
http://java.sun.com/j2se/1.4.1/docs/guide/jndi	581
http://developer.java.sun.com/developer/bugParade/bugs/4513638.html	582
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/special_tags.html	583
http://developer.java.sun.com/developer/bugParade/bugs/4030374.html	584
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/using_tags.html	585
http://java.sun.com/products/plugin/versions.html	586
http://java.sun.com/j2se/1.4.1/sample-output.html	587
http://developer.java.sun.com/developer/bugParade/bugs/4690831.html	588
http://developer.java.sun.com/developer/bugParade/bugs/4218431.html	593
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/java_js.html	594
http://developer.java.sun.com/developer/bugParade/bugs/4636548.html	595
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/server/RemoteServer.html	597
http://developer.java.sun.com/developer/bugParade/bugs/4627542.html	598
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/Naming.html	599
http://developer.java.sun.com/developer/bugParade/bugs/4668511.html	600
http://java.sun.com/j2se/1.4.1/docs/api/java/rmi/server/RMIFailureHandler.html	602
http://developer.java.sun.com/developer/bugParade/bugs/4669873.html	603
http://java.sun.com/docs/books/effective/chapters.html	857
http://java.sun.com/docs/books/effective/awards.html	858
http://vig.pearsoned.com/store/home/1,4158,store-5401_id-2,00.html	859
http://www.amazon.com/exec/obidos/ASIN/0201310058/ref=ase_javasoftsunmicroA/002-3146347-8288839	860
http://java.sun.com/docs/books/effective/reviews.html	861
http://java.sun.com/docs/books/effective/effective.zip	862
http://java.sun.com/docs/books/effective/errata.html	863
http://java.sun.com/docs/books/effective/translations.html	864
http://12.31.179.2/DigitalGuru/product_detail.asp?catalog_name=Books&category_name=&product_id=0201310058&partner_id=87	865
http://java.sun.com/docs/books/effective/bio.html	867
http://java.sun.com/docs/books/effective/excursions.html	868
http://java.sun.com/docs/books/effective/praise.html	869
http://java.sun.com/docs/books/effective/toc.html	870
http://java.sun.com/docs/books/effective/interviews.html	871
http://java.sun.com/j2se/1.4.1/docs/guide/io/io-min.html	880
http://java.sun.com/j2se/1.4.1/docs/guide/io/troubleshooting.html	881
http://java.sun.com/j2se/1.4.1/docs/guide/io/io-maj.html	882
http://java.sun.com/j2se/1.4.1/docs/guide/io/io.html	885
http://developer.java.sun.com/developer/onlineTraining/new2java/divelog/part3	906
http://developer.java.sun.com/developer/onlineTraining/Beans/JBShortCourse	913
http://developer.java.sun.com/developer/onlineTraining/Beans/bean01	914
http://developer.java.sun.com/developer/onlineTraining/javaai	917
http://developer.java.sun.com/developer/onlineTraining/J2EE/Intro	918
http://developer.java.sun.com/developer/onlineTraining/J2EE	923
http://developer.java.sun.com/developer/onlineTraining/Beans/beans3	924
http://java.sun.com/j2ee/1.3/docs/tutorial/doc	925
http://developer.java.sun.com/developer/onlineTraining/Beans	927
http://developer.java.sun.com/developer/onlineTraining/GUI/AWTLayoutMgr	929
http://developer.java.sun.com/developer/onlineTraining/new2java/divelog	930
http://java.sun.com/products/jndi/tutorial	931
http://developer.java.sun.com/developer/onlineTraining/Security/Fundamentals/abstract.html	932
http://developer.java.sun.com/developer/onlineTraining/Media/2DText	933
http://java.sun.com/j2ee/tutorial/1_3-fcs	934
http://developer.java.sun.com/developer/onlineTraining/Programming/BasicJava2	935
http://developer.java.sun.com/developer/onlineTraining/Programming/BasicJava1	936
http://developer.java.sun.com/developer/onlineTraining/GUI	937
http://developer.java.sun.com/developer/onlineTraining/Beans/EJBTutorial	938
http://developer.java.sun.com/developer/onlineTraining/distributed	939
http://www.amazon.com/exec/obidos/ASIN/0201707209/o/qid%3D957218666/sr%3D8-1/ref%3Daps%5Fsr%5Fb%5F1%5F1/102-8347053-6316853	940
http://developer.java.sun.com/developer/onlineTraining/Beans/beans02	941
http://developer.java.sun.com/developer/onlineTraining/collections	942
http://developer.java.sun.com/developer/onlineTraining/Database/JDBC20Intro	943
http://developer.java.sun.com/developer/onlineTraining/forte4j3	951
http://developer.java.sun.com/developer/onlineTraining/java3d	956
http://developer.java.sun.com/developer/onlineTraining/Security	958
http://developer.java.sun.com/developer/onlineTraining/Database/JDBCShortCourse	959
http://java.sun.com/webservices/tutorial.html	962
http://developer.java.sun.com/developer/onlineTraining/new2java/divelog/part4/index.jsp	964
http://developer.java.sun.com/developer/onlineTraining/Downloads	968
http://developer.java.sun.com/developer/onlineTraining/corba	974
http://www.amazon.com/exec/obidos/ASIN/0201715015/o/qid=963590813/sr=8-2/ref=aps_sr_b_1_2/002-0968593-5090437	975
http://java.sun.com/j2se/1.4.1/docs/api/javax/xml/transform/sax/package-summary.html	720
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/ref/package-summary.html	721
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/IOP/CodecFactoryPackage/package-summary.html	722
http://java.sun.com/j2se/1.4.1/docs/api/javax/transaction/package-summary.html	723
http://java.sun.com/j2se/1.4.1/docs/api/javax/rmi/package-summary.html	724
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/spi/package-summary.html	725
http://java.sun.com/j2se/1.4.1/docs/api/javax/imageio/package-summary.html	726
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/IOP/CodecPackage/package-summary.html	727
http://java.sun.com/j2se/1.4.1/docs/api/javax/imageio/stream/package-summary.html	728
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/geom/package-summary.html	729
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/package-summary.html	730
http://java.sun.com/j2se/1.4.1/docs/api/overview-tree.html	731
http://java.sun.com/j2se/1.4.1/docs/api/java/nio/channels/package-summary.html	732
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/package-summary.html	733
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/color/package-summary.html	736
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/Dynamic/package-summary.html	743
http://java.sun.com/j2se/1.4.1/docs/api/help-doc.html	746
http://java.sun.com/j2se/1.4.1/docs/api/javax/imageio/spi/package-summary.html	747
http://java.sun.com/j2se/1.4.1/docs/api/java/applet/package-summary.html	749
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/SendingContext/package-summary.html	751
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableInterceptor/package-summary.html	753
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA_2_3/package-summary.html	755
http://java.sun.com/j2se/1.4.1/docs/api/java/math/package-summary.html	758
http://java.sun.com/j2se/1.4.1/docs/api/javax/rmi/CORBA/package-summary.html	760
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/CurrentPackage/package-summary.html	761
http://java.sun.com/j2se/1.4.1/docs/api	762
http://cgi.omg.org/cgi-bin/doc?ptc/2000-08-06	763
http://java.sun.com/j2se/1.4.1/docs/api/java/security/acl/package-summary.html	765
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/package-summary.html	767
http://java.sun.com/j2se/1.4.1/docs/api/javax/xml/parsers/package-summary.html	768
http://java.sun.com/j2se/1.4.1/docs/api/javax/xml/transform/package-summary.html	770
http://java.sun.com/j2se/1.4.1/docs/api/java/nio/charset/spi/package-summary.html	771
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CosNaming/NamingContextExtPackage/package-summary.html	772
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/image/package-summary.html	773
http://java.sun.com/j2se/1.4.1/docs/api/java/util/package-summary.html	774
http://java.sun.com/j2se/1.4.1/docs/api/javax/imageio/plugins/jpeg/package-summary.html	775
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/DynAnyPackage/package-summary.html	776
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/image/renderable/package-summary.html	777
http://cgi.omg.org/cgi-bin/doc?formal/99-10-07	778
http://java.sun.com/j2se/1.4.1/docs/api/index-files/index-1.html	779
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/POAPackage/package-summary.html	780
http://java.sun.com/j2se/1.4.1/docs/api/allclasses-noframe.html	781
http://java.sun.com/j2se/1.4.1/docs/api/org/xml/sax/package-summary.html	782
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/im/spi/package-summary.html	783
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA_2_3/portable/package-summary.html	784
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/Messaging/package-summary.html	785
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/font/package-summary.html	786
http://java.sun.com/j2se/1.4.1/docs/api/java/nio/channels/spi/package-summary.html	787
http://java.sun.com/j2se/1.4.1/docs/api/org/w3c/dom/package-summary.html	788
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/TypeCodePackage/package-summary.html	789
http://java.sun.com/j2se/1.4.1/docs/guide/intl/font.html	826
http://java.sun.com/j2se/1.4.1/docs/guide/intl/demos/MessageFormat/example1.html	827
http://java.sun.com/j2se/1.4.1/docs/guide/intl/intlTOC.doc.html	828
http://java.sun.com/j2se/1.4.1/docs/guide/intl/demos/NumberFormat/example1.html	829
http://java.sun.com/j2se/1.4.1/docs/guide/intl/demos/TextBound/example1.html	830
http://java.sun.com/docs/books/tutorial/i18n/index.html	831
http://java.sun.com/j2se/1.4.1/docs/guide/intl/demos/Collate/example1.html	832
http://developer.java.sun.com/developer/technicalArticles/Intl	833
http://java.sun.com/j2se/1.4.1/docs/guide/2d/spec/j2d-fonts.fm.html	834
http://java.sun.com/j2se/1.4.1/docs/guide/intl/faq.html	835
http://java.sun.com/j2se/1.4.1/docs/guide/intl/demos/DateTimeFormat/example1.html	836
http://java.sun.com/j2se/1.4.1/docs/guide/intl/intl.doc.html	838
http://java.sun.com/j2se/1.4.1/docs/guide/intl/fontprop.html	839
http://java.sun.com/docs/books/chanlee/first_edition/examples.html	843
http://java.sun.com/docs/books/chanlee/first_edition	844
http://java.sun.com/docs/books/chanlee/second_edition	845
http://java.sun.com/docs/books/chanlee/second_edition/vol1/index.html	846
http://java.sun.com/docs/books/chanlee/second_edition/vol1/readme.txt	847
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Threads.doc.html	837
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Instructions.doc.html	840
http://java.sun.com/docs/books/vmspec/2nd-edition/html/ChangesAppendix.doc.html	841
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Concepts.doc.html	842
http://java.sun.com/docs/books/vmspec/2nd-edition/html/VMSpecIX.fm.html	849
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Mnemonics.doc.html	850
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Introduction.doc.html	851
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Overview.doc.html	852
http://servlet.java.sun.com/feedback.jsp?qid=258	853
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Compiling.doc.html	854
http://java.sun.com/docs/books/vmspec/2nd-edition/html/ClassFile.doc.html	855
http://java.sun.com/docs/books/vmspec/2nd-edition/html/ConstantPool.doc.html	856
http://java.sun.com/docs/books/vmspec/2nd-edition/html/Preface.doc.html	866
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/contents.html	969
http://java.sun.com/docs/books/chanlee/supplement	1088
http://suned.sun.com/USA/catalog/options/index.html	1157
http://suned.sun.com/USA/consulting	1158
http://suned.sun.com/	1159
http://suned.sun.com/USA/certification	1160
http://suned.sun.com/USA/catalog/java.html	1161
http://suned.sun.com/usa	1162
http://www.sun.com/access/index.html	1191
http://java.sun.com/j2se/1.4.1/docs/guide/access/properties.html	1192
http://java.sun.com/j2se/1.4.1/docs/api/javax/swing/doc-files/Key-Index.html	1193
http://java.sun.com/j2se/1.4.1/docs/guide/access/new-features.html	1194
http://java.sun.com/products/accessbridge	1195
http://java.sun.com/products/jfc/jaccess-1.3/doc/index.html	1196
http://java.sun.com/products/jfc/accessibility.html	1197
ftp://ftp.javasoft.com/docs/books/chanlee/JavaClassLibVol1Examples.zip	848
http://java.sun.com/docs/books/tutorial/overview/index.html	872
http://www.amazon.com/exec/obidos/ASIN/0201433214/javasoftsunmicroA	873
http://java.sun.com/docs/books/tutorial/java/index.html	874
http://java.sun.com/docs/books/tutorial/post1.0/index.html	875
http://java.sun.com/docs/books/tutorial/networking/index.html	876
http://java.sun.com/docs/books/tutorial/reflect/index.html	877
http://java.sun.com/docs/books/tutorial/extra/regex/index.html	878
http://www.amazon.com/exec/obidos/ISBN%3D0201703939/javasoftsunmicroA	879
http://java.sun.com/docs/books/tutorial	883
http://java.sun.com/docs/books/tutorial/book.html	884
http://java.sun.com/docs/books/tutorial/sound/index.html	886
http://java.sun.com/docs/books/tutorial/information/copyright.html	887
http://java.sun.com/docs/books/tutorial/information/download.html	888
http://java.sun.com/docs/books/tutorial/extra/fullscreen/index.html	889
http://www.informit.com/promo/java_sun_books	890
http://java.sun.com/docs/books/tutorial/uiswing/mini/index.html	891
http://java.sun.com/docs/books/tutorial/getStarted/cupojava/unix.html	892
http://java.sun.com/docs/books/tutorial/jdbc/index.html	893
http://java.sun.com/docs/books/tutorial/information/FAQ.html	894
http://java.sun.com/docs/books/tutorial/information/announcelist.html	895
http://java.sun.com/docs/books/tutorial/security1.1/index.html	896
http://java.sun.com/docs/books/tutorial/information/resources.html	897
http://java.sun.com/docs/books/tutorial/ext/index.html	898
http://java.sun.com/docs/books/tutorial/getStarted/cupojava/win32.html	899
http://java.sun.com/docs/books/tutorial/applet/index.html	900
http://www.amazon.com/exec/obidos/ISBN%3D0201485583/javasoftsunmicroA	905
http://www.digitalguru.com/DigitalGuru/product_detail.asp?catalog_name=Books&product_id=0201485583&partner_id=87	911
http://java.sun.com/docs/books/tutorial/reallybigindex.html	912
http://www.digitalguru.com/DigitalGuru/product_detail.asp?catalog_name=Books&product_id=0201703939&partner_id=87	915
http://java.sun.com/docs/books/tutorial/jar/index.html	916
http://java.sun.com/docs/books/tutorial/information/history.html	919
http://java.sun.com/docs/books/tutorial/getStarted/cupojava/mac.html	920
http://java.sun.com/docs/books/tutorial/essential/index.html	921
http://java.sun.com/docs/books/tutorial/idl/index.html	922
http://java.sun.com/docs/books/tutorial/dnd/index.html	926
http://www.digitalguru.com/DigitalGuru/product_detail.asp?catalog_name=Books&product_id=0201433214&partner_id=87	928
ftp://ftp.java.sun.com/docs/j2se1.4/jndi.ps	944
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/spec/jndi/index.html	945
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/jndi-cos.html	946
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/jndi-dns.html	947
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/reference.html	948
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/spec/spi/spicover.frame.html	949
http://java.sun.com/products/jndi/serviceproviders.html	950
http://www.ietf.org/rfc/rfc2829.txt	952
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/ldap/StartTlsResponse.html	953
http://www.ietf.org/rfc/rfc2222.txt	954
http://java.sun.com/products/jndi	955
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/jndi-rmi.html	957
ftp://ftp.java.sun.com/docs/j2se1.4/jndi.pdf	960
http://java.sun.com/products/jndi/tutorial/index.html	961
ftp://ftp.java.sun.com/docs/j2se1.4/jndispi.pdf	963
http://www.ietf.org/rfc/rfc2831.txt	965
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/jndi-ldap-gl.html	966
http://java.sun.com/products/jndi/tutorial/ldap/security	967
ftp://ftp.java.sun.com/docs/j2se1.4/jndiexecsumm.pdf	970
http://java.sun.com/j2se/1.4.1/docs/guide/jndi/spec/execsumm/jndiexecsumm.html	971
ftp://ftp.java.sun.com/docs/j2se1.4/jndiexecsumm.ps	972
http://java.sun.com/j2se/1.4.1/docs/api/javax/naming/ldap/StartTlsRequest.html	973
http://java.sun.com/products/jndi/docs.html	979
http://www.ietf.org/rfc/rfc2830.txt	980
ftp://ftp.java.sun.com/docs/j2se1.4/jndispi.ps	981
http://java.sun.com/products/jndi/staytouch.html	982
http://sunonedev.sun.com/building/tech_articles/j2ee_soap_part2.html	1075
http://developer.java.sun.com/developer/Books/effectivejava	1076
http://cseng.aw.com/book/0,3828,0201310058,00.html	1077
http://java.sun.com/features/authors.html	1078
http://java.sun.com/docs/books/effective	1079
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop	1203
http://java.sun.com/j2se/1.4.1/docs/guide/rmi	1204
http://cgi.omg.org/cgi-bin/doc?ptc/00-01-08	1205
http://cgi.omg.org/cgi-bin/doc?ptc/00-01-06	1206
http://www.corba.org/	1207
http://java.sun.com/j2se/1.4.1/docs/guide/corba	1208
http://java.sun.com/j2se/1.4.1/docs/guide/extensions/extensions.html	903
http://java.sun.com/j2se/1.4.1/docs/guide/extensions/versioning.html	904
http://java.sun.com/j2se/1.4.1/docs/api/java/security/SecureClassLoader.html	907
http://java.sun.com/docs/books/tutorial/ext	908
http://java.sun.com/j2se/1.4.1/docs/api/java/net/URLClassLoader.html	909
http://java.sun.com/j2se/1.4.1/docs/api/java/net/JarURLConnection.html	910
http://java.sun.com/j2se/1.4.1/docs/guide/collections	1002
http://java.sun.com/j2se/1.4.1/docs/guide/lang/enhancements-1.3.html	1003
http://java.sun.com/j2se/1.4.1/docs/guide/jar	1004
ftp://ftp.java.sun.com/docs/j2se1.4.1/developer_guide.pdf	1008
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/dom/index.html	1009
http://java.sun.com/docs/forms/plugin-sendusmail.html	1010
ftp://ftp.javasoft.com/docs/books/chanlee/sup1-egs.zip	1011
http://java.sun.com/docs/books/chanlee/second_edition/vol1	1012
http://java.sun.com/docs/books/chanlee/supplement/readme.txt	1013
http://java.sun.com/docs/books/chanlee/supplement/index.html	1014
http://www.sun.com/share/text/SMICopyright.html	1015
http://java.sun.com/products/jdk/1.1/docs/index.html	1016
http://developer.java.sun.com/developer/bugParade/bugs/4693219.html	1020
http://developer.java.sun.com/developer/bugParade/bugs/4615751.html	1021
http://developer.java.sun.com/developer/bugParade/bugs/4697804.html	1022
http://www.nvidia.com/	1023
http://developer.java.sun.com/developer/bugParade/bugs/4648702.html	1024
http://www.ietf.org/rfc/rfc2246.txt	1025
http://developer.java.sun.com/developer/bugParade/bugs/4628281.html	1026
http://developer.java.sun.com/developer/bugParade/bugs/4682626.html	1027
http://developer.java.sun.com/developer/bugParade/bugs/4505899.html	1028
http://www.research.avayalabs.com/project/libsafe	1029
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/TextArea.html	1030
http://java.sun.com/j2se/1.4.1/ReleaseNotes.html	1031
http://developer.java.sun.com/developer/bugParade/bugs/4704500.html	1032
http://developer.java.sun.com/developer/bugParade/bugs/4634165.html	1033
http://developer.java.sun.com/developer/bugParade/bugs/4736093.html	1034
http://developer.java.sun.com/developer/bugParade/bugs/4654636.html	1035
http://developer.java.sun.com/developer/bugParade/bugs/4644270.html	1036
http://java.sun.com/products/java-media/2D/perf_graphics.pdf	1037
http://developer.java.sun.com/developer/bugParade/bugs/4460583.html	1038
http://developer.java.sun.com/developer/bugParade/bugs/4387291.html	1039
http://developer.java.sun.com/developer/bugParade/bugs/4503092.html	1040
http://developer.java.sun.com/developer/bugParade/bugs/4656697.html	1041
http://www.ietf.org/internet-drafts/draft-ietf-ldapext-locate-07.txt	1042
http://developer.java.sun.com/developer/bugParade/bugs/4456393.html	1043
http://developer.java.sun.com/developer/bugParade/bugs/4740901.html	1044
http://developer.java.sun.com/developer/bugParade/bugs/4672707.html	1045
http://java.sun.com/j2se/javadoc/faq.html	1046
http://developer.java.sun.com/developer/bugParade/bugs/4521661.html	1047
http://developer.java.sun.com/developer/bugParade/bugs/4460065.html	1048
http://www.atitech.com/	1053
http://java.sun.com/products/java-media/jmf/index.html	1055
http://developer.java.sun.com/developer/bugParade/bugs/4650839.html	1056
http://java.sun.com/j2se/1.4.1/nio/index.html	1057
http://developer.java.sun.com/developer/bugParade/bugs/4682743.html	1058
http://java.sun.com/j2se/1.4.1/docs/guide/idl/limitations.html	1059
http://developer.java.sun.com/developer/bugParade/bugs/4701394.html	1062
http://java.sun.com/j2se/1.4.1/docs/api/java/applet/Applet.html	1063
http://developer.java.sun.com/developer/bugParade/bugs/4652655.html	1064
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/Component.html	1065
http://java.sun.com/j2se/1.4.1/docs/api/java/awt/datatransfer/DataFlavor.html	1069
ftp://ftp.java.sun.com/docs/j2se1.4/dnd1.ps	1070
ftp://ftp.java.sun.com/docs/j2se1.4/dnd1.pdf	1071
http://java.sun.com/j2se/1.4.1/docs/guide/dragndrop/spec/dnd1TOC.doc.html	1072
http://java.sun.com/j2se/1.4.1/docs/guide/math/enhancements.html	1073
http://java.sun.com/j2se/1.4.1/docs/guide/math/enhancements14.html	1074
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/PortableServer/Servant.html	1125
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/rmiiiopexample.html	1126
http://java.sun.com/j2se/1.4.1/docs/guide/idl/PI.html	1127
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/interop.html	1128
http://java.sun.com/products/ejb/index.html	1138
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/doc-files/compliance.html	1140
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/rmi_iiop_pg.html	1142
http://java.sun.com/products/rmi-iiop	1147
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA_2_3/portable/ObjectImpl.html	1149
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/interop.pdf	1151
http://java.sun.com/j2se/1.4.1/docs/guide/rmi-iiop/tutorial.html	1152
http://www.omg.org/	1155
http://java.sun.com/docs/books	1176
http://www.jguru.com/	976
http://developer.java.sun.com/developer/onlineTraining/awt	977
http://developer.java.sun.com/developer/onlineTraining/Servlets/Fundamentals	978
http://developer.java.sun.com/developer/onlineTraining/new2java/divelog/part2/index.jsp	983
http://java.sun.com/docs/books/tutorial/uiswing	984
http://developer.java.sun.com/developer/onlineTraining/protocolhandlers	985
http://developer.java.sun.com/developer/onlineTraining/JavaIntro	986
http://java.sun.com/j2ee/1.4/docs/tutorial	987
http://developer.java.sun.com/developer/onlineTraining/JSPIntro	988
http://developer.java.sun.com/developer/onlineTraining/JavaMail	989
http://developer.java.sun.com/developer/onlineTraining/Beans/JBeansAPI	990
http://developer.java.sun.com/developer/onlineTraining/GUI/Swing2	991
http://developer.java.sun.com/developer/onlineTraining/GUI/Swing1	992
http://developer.java.sun.com/developer/onlineTraining/webcasts	993
http://developer.java.sun.com/developer/onlineTraining/rmi	994
http://developer.java.sun.com/developer/onlineTraining/Media	995
http://java.sun.com/products/jms/tutorial	996
http://developer.java.sun.com/developer/onlineTraining/EJBIntro	997
http://www.amazon.com/exec/obidos/ASIN/0201703939/o/qid=963596417/sr=8-3/ref=aps_sr_b_2_2/002-0968593-5090437	998
http://developer.java.sun.com/developer/onlineTraining/Programming/JDCBook	999
http://developer.java.sun.com/developer/onlineTraining/collections/index2.html	1000
http://developer.java.sun.com/developer/onlineTraining/J2EE/Intro2/j2ee.html	1001
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/SecurityManager.html	1005
http://java.sun.com/j2se/1.4.1/docs/guide/resources/resources.html	1006
http://java.sun.com/j2se/1.4.1/docs/api/java/util/ResourceBundle.html	1007
http://java.sun.com/j2se/1.4/performance.guide.html	1066
http://java.sun.com/j2se/1.4.1/docs/guide/performance/startup.html	1067
http://java.sun.com/docs/performance/index.html	1068
http://java.sun.com/j2se/1.4.1/install-solaris-64.html	1080
http://java.sun.com/j2se/1.4.1/font-requirements.html	1081
http://sunsolve.sun.com/pub-cgi/show.pl?target=patches/J2SE	1082
http://java.sun.com/j2se/1.4/docs/guide/plugin/index.html	1083
http://java.sun.com/j2se/1.4.1/docs/guide/jvmpi/jvmpi.html	1090
http://java.sun.com/j2se/1.4.1/docs/api/java/net/InetSocketAddress.html	1129
http://java.sun.com/j2se/1.4.1/docs/api/java/net/ServerSocket.html	1130
http://java.sun.com/j2se/1.4.1/docs/guide/nio/example/index.html	1131
http://java.sun.com/j2se/1.4.1/docs/api/java/net/DatagramSocket.html	1132
http://java.sun.com/j2se/1.4.1/docs/api/java/io/FileOutputStream.html	1133
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/StringBuffer.html	1134
http://java.sun.com/j2se/1.4.1/docs/guide/io/index.html	1135
http://java.sun.com/j2se/1.4.1/docs/api/java/io/RandomAccessFile.html	1136
http://java.sun.com/aboutJava/communityprocess/jsr/jsr_051_ioapis.html	1137
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/CharSequence.html	1139
http://java.sun.com/j2se/1.4.1/docs/api/java/io/FileInputStream.html	1141
http://java.sun.com/j2se/1.4.1/docs/api/java/net/SocketAddress.html	1143
http://java.sun.com/j2se/1.4.1/docs/api/java/net/Socket.html	1144
http://java.sun.com/j2se/1.4.1/docs/api/java/io/OutputStreamWriter.html	1145
http://java.sun.com/j2se/1.4/nio/index.html	1146
http://java.sun.com/j2se/1.4.1/docs/api/java/lang/String.html	1148
http://java.sun.com/j2se/1.4.1/docs/api/java/io/InputStreamReader.html	1150
http://java.sun.com/j2se/1.4.1/docs/guide/idl/servantlocators.html	1166
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlExample3.html	1167
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlDSI.html	1168
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlImplBaseServer.html	1169
http://java.sun.com/j2se/1.4.1/docs/guide/idl/servantactivator.html	1171
http://java.sun.com/j2se/1.4.1/docs/guide/idl/INStutorial.html	1172
http://java.sun.com/j2se/1.4.1/docs/api/org/omg/CORBA/ORB.html	1173
http://developer.java.sun.com/developer/technicalArticles/releases/corba	1175
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlUsingCORBA.html	1177
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlExceptions.html	1178
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlFAQ.html	1179
http://java.sun.com/j2se/1.4.1/docs/guide/idl/GShome.html	1180
http://java.sun.com/j2se/1.4.1/docs/guide/idl/mapping/jidlMapping.html	1181
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlExample2.html	1182
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlTieServer.html	1183
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlDistApp.html	1184
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlSampleCode.html	1185
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlInitialization.html	1186
http://java.sun.com/j2se/1.4.1/docs/guide/idl/tnameserv.html	1187
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlGlossary.html	1188
http://java.sun.com/j2se/1.4.1/docs/guide/idl/jidlExample.html	1189
http://java.sun.com/j2se/1.4.1/docs/guide/idl/adapteractivator.html	1190
http://java.sun.com/aboutJava/communityprocess/jsr/jsr_015_iio.html	1085
ftp://ftp.java.sun.com/docs/j2se1.4/imageio_guide.pdf	1086
http://java.sun.com/products/java-media/jai/index.html	1087
ftp://ftp.java.sun.com/docs/j2se1.4/imageio_guide.ps	1089
ftp://ftp.java.sun.com/docs/j2se1.4/j2d-book.ps	1091
http://java.sun.com/feedback/index.html	1092
ftp://ftp.java.sun.com/docs/j2se1.4/j2d-book.pdf	1093
ftp://ftp.java.sun.com/docs/j2se1.4/rmi-spec-1.3.pdf	1094
http://www.adobe.com/acrobat/readstep.html	1095
ftp://ftp.java.sun.com/docs/j2se/1.4/JPS_PDF.pdf	1096
ftp://ftp.java.sun.com/docs/j2se1.4/VolatileImage.pdf	1097
ftp://ftp.java.sun.com/docs/j2se1.4/rmi-spec-1.3.ps	1098
ftp://ftp.java.sun.com/docs/j2se1.4/beancontext.pdf	1099
ftp://ftp.java.sun.com/docs/j2se1.4/beancontext.ps	1100
http://java.sun.com/j2se/1.4/docs/relnotes/demos.html	1101
http://java.sun.com/download	1102
http://java.sun.com/j2se/1.4/ja/docs/ja/index.html	1103
http://www.sun.com/policies/trademarks	1104
http://www.awl.com/cseng/javaseries	1105
http://java.sun.com/j2se/1.4/docs/index.html	1106
http://java.sun.com/nav/whatis/index.html	1107
http://java.sun.com/j2se/tools.html	1108
http://java.sun.com/jdc	1109
http://java.sun.com/infodocs	1110
http://java.sun.com/support	1111
http://java.sun.com/community	1112
http://java.sun.com/products/jdk/1.2	1113
http://www.sun.com/software/communitysource/java2/index.html	1114
http://java.sun.com/products/jdk/1.1	1115
http://java.sun.com/products/archive/index.html	1116
http://java.sun.com/docs/glossary.html	1117
http://java.sun.com/j2se/1.4	1118
http://java.sun.com/casestudies	1119
http://java.sun.com/j2se/1.3	1120
http://java.sun.com/j2se/technologies.html	1121
http://java.sun.com/j2se/index.html	1122
http://search.java.sun.com/Search/java?help=tips	1123
http://java.sun.com/j2se/faq.html	1124
http://java.sun.com/docs/books/chanlee/second_edition/readme.txt	1153
http://java.sun.com/docs/books/chanlee/second_edition/index.html	1154
ftp://ftp.javasoft.com/docs/books/chanlee/JavaClassLibVol2Examples.zip	1156
http://support.installshield.com/kb/view.asp?pcode=ALL&articleid=Q104985	1163
http://www.microsoft.com/Com/DCOM/Dcom98/relnotes.asp	1164
http://support.microsoft.com/support/kb/articles/Q142/2/71.asp	1165
http://java.sun.com/j2se/1.4.1/docs/guide/plugin/developer_guide/silent.html	1170
http://java.sun.com/j2se/1.4.1/index.html	1174
http://java.sun.com/j2se/1.4.1/docs/api/java/util/jar/JarFile.html	1198
http://java.sun.com/j2se/1.4.1/docs/guide/jar/jarGuide.html	1199
http://java.sun.com/j2se/1.4.1/docs/api/java/util/zip/ZipFile.html	1200
http://java.sun.com/j2se/1.4.1/docs/guide/jar/jar.html	1201
http://java.sun.com/docs/books/tutorial/jar	1202
\.
--
-- Data for TOC Entry ID 54 (OID 230334)
--
-- Name: mothttp Type: TABLE DATA Owner: tistou
--


COPY "mothttp" FROM stdin;
xml	1
serialization	2
object	3
toolkit	4
window	5
abstract	6
releases	7
version	8
compatibility	9
previous	10
with	11
demos	12
features	13
general	14
guide	15
info	16
tutorials	17
language	18
api	19
location	20
to	21
search	22
logging	23
tm	24
component	25
javabeans	26
platform	27
new	28
summary	29
since	30
3	31
j2se	32
1	33
of	34
documentation	35
tool	36
docs	37
java	38
connectivity	39
jdbc	40
database	41
specification	42
the	43
graphics	44
imaging	45
and	46
2d	47
security	48
demonstration	49
applets	50
applications	51
microsystems	52
sun	53
inc	54
interface	55
native	56
jni	57
components	58
swing	59
project	60
in	61
winhelp	62
format	63
fixed	64
bugs	65
web	66
start	67
4	68
changes	69
enhancements	70
framework	71
input	72
method	73
collections	74
software	75
page	76
home	77
conventions	78
code	79
programming	80
for	81
this	82
download	83
2	84
sdk	85
standards	86
override	87
mechanism	88
endorsed	89
sound	90
faq	91
debugger	92
architecture	93
jpda	94
at	95
us	96
send	97
suggestions	98
comments	99
contact	100
contacting	101
glance	102
networking	103
remote	104
rmi	105
invocation	106
copyright	107
	108
terms	109
license	110
report	111
bug	112
submitting	113
frames	114
no	115
effective	116
center	117
new-to-java	118
service	119
print	120
package	121
identification	122
internationalization	123
machine	124
virtual	125
extension	126
reflection	127
util	128
math	129
packages	130
net	131
text	132
lang	133
tutorial	134
courses	135
on-line	136
utility	137
directory	138
jndi	139
naming	140
libraries	141
class	142
review	143
gosling	144
james	145
by	146
resources	147
plug-in	148
performance	149
supplement	150
about	151
note	152
release	153
notes	154
reference	155
objects	156
miscellaneous	157
image	158
transfer	159
data	160
drag-and-drop	161
environment	162
solaris	163
operating	164
installation	165
arbitrary-precision	166
rmi-iiop	167
corba	168
profiler	169
jvmpi	170
pdf	171
ps	172
policy	173
redistribution	174
linux	175
online	176
beans	177
applet	178
awt	179
idl	180
readme	181
microsoft	182
windows	183
training	184
accessibility	185
archive	186
files	187
jar	188
event	189
overview	190
focus	191
model	192
contents	193
v1	194
datatransfer	195
io	196
examples	197
serialver	198
-	199
advanced	200
jfc	201
user	202
creating	203
com	204
j2se-comments	205
beancontext	206
development	207
more	208
kit	209
information	210
connection	211
klist	212
processing	213
w3c	214
technology	215
javadoctoolpage	216
servertool	217
printable	218
licensing	219
binary	220
source	221
programs	222
not	223
why	224
that	225
basic	226
tools	227
should	228
developers	229
write	230
call	231
trademarks	232
or	233
registered	234
on	235
javaone	236
driver	237
bridge	238
jdbc-odbc	239
employment	240
downloads	241
main	242
technologies	243
javax	244
sql	245
blob	246
blueprints	247
large	248
solarisandlinux	249
orbd	250
vb	251
using	252
drivers	253
under	254
press	255
currently	256
standard	257
incompatibilities	258
edition	259
available	260
vendors	261
0	262
between	263
news	264
industry	265
privacy	266
enterprise	267
second	268
book	269
apis	270
use	271
scripting	272
series	273
kadmin	274
idlj	275
services	276
developer	277
rowset	278
started	279
company	280
kinit	281
wear	282
getting	283
frequently-asked	284
questions	285
answers	286
character	287
books	288
tnameserv	289
methods	290
deprecated	291
classes	292
clarifications	293
amendments	294
clob	295
community	296
process	297
rmiclassloader	298
gss-api	299
networkinterface	300
newinstance	301
persistence	302
long-term	303
reflect	304
field	305
regular	306
regex	307
expressions	308
next	309
index	310
native2ascii	311
product	312
rmiclassloaderspi	313
constructor	314
ins	315
interoperable	316
99-12-03	317
locales	318
supported	319
ipv6	323
including	324
support	325
2002	336
inetaddress	339
socket	341
secure	343
jsse	344
invoke	345
machines	349
path	351
certification	352
rmic	353
uri	354
authentication	357
authorization	363
numberformat	378
preferences	383
portable	384
poa	387
inheritance	388
servant	389
drag	398
exception	406
drop	411
assertion	430
facility	431
chained	432
hotspot[tm]	434
currency	435
javadoc	437
what	438
parade	458
engine	462
access	465
early	466
j2me	467
samples	468
view	469
wireless	470
forums	471
other	472
j2ee	473
help	516
chaining	870
signal	871
solarisoperatingenvironment	872
	873
microsoftwindows	874
reliable	875
solution	876
error-reporting	877
dyanmic	1209
suppressing	1210
reflective	1211
softreference	1256
weakreference	1257
referencequeue	1258
phantomreference	1260
tag	1268
jsr-015	1307
reader	1308
acrobat	1309
legal	1310
our	1311
demo	1312
usage	1313
logo	1314
ides	1315
glossary	1316
fcs	1317
case	1318
studies	1319
privacypolicy	1320
started?	1321
1321577	1346
javaclasslibvol2examples	1348
asp?pcode=all	1378
articleid=q104985	1379
installshield	1380
kb	1381
dcom98	1382
problem	1383
asp	1384
71	1385
q142	1386
silent	1390
int	1407
jarfile	1408
verify	1409
extensions	1410
open_read	1411
open_delete	1412
zipfile	1413
white	320
high	321
paper	322
postscript	333
enhanced	375
tips	392
tree	433
plaf	439
table	440
undo	444
metal	445
colorchooser	446
filechooser	447
rtf	452
border	454
gui	455
html	456
parser	459
multi	461
design	463
j2sdk	464
pack	773
wsdp	775
join	778
example	779
step-by-step	780
introducing	782
learning	784
sessions	785
register?	786
register	790
groups	791
live	795
college-age	797
premier	799
competition	800
coders	801
newsletters	805
engineers	808
apple	809
meet	810
jsr-006	829
unified	830
printing	831
amazon	842
preface	843
maintenance	844
errata	845
digitalguru	846
classloader	878
out-of-order	890
store	891
wait	892
threads	893
rules	894
consistency	895
discussion	896
variables	897
interaction	898
possible	899
9	900
locks	901
7	902
6	903
operations	904
notification	905
prescient	906
5	907
sets	908
14	909
13	910
12	911
11	912
long	913
10	914
swap	915
double	916
order	917
writes	918
synchronization	919
nonatomic	920
treatment	921
execution	922
volatile	923
terminology	924
descriptions	925
assumptions	926
reserved	927
meaning	928
errors	929
opcodes	930
set	931
must	932
instruction	933
appendix	934
finalization	935
floating-point	936
members	937
fp-strict	938
initial	939
conversion	941
casting	942
promotion	943
initializers	945
boolean	946
primitive	947
procedure	948
integral	949
exit	952
formal	953
operators	954
promotions	955
parameters	956
fully	957
values	958
conversions	959
arrays	960
constructors	961
runtimeexception	962
string	963
names	964
value	965
resolution	966
static	967
initialization	968
linking	969
simple	970
preparation	971
overloading	972
creation	973
numeric	974
fields	975
widening	976
literals	977
instances	978
nested	979
causes	980
handling	981
concepts	982
modifiers	983
hierarchy	984
loading	985
start-up	986
overriding	987
assignment	988
signature	989
superinterfaces	990
array	991
subclasses	992
19	993
18	994
verification	995
17	996
qualified	997
jaas	326
kerberos	327
managers	340
jgss	358
ietf	359
org	360
implement	361
cryptography	365
provider	369
how	370
implementation	371
syntax	372
default	376
file	379
permissions	381
crypto	382
spec	385
interfaces	386
auth	390
login	391
jce	393
sign-on	394
single	395
callback	399
cert	418
programmer	419
module	423
ssl	428
x500	436
privileged	441
blocks	442
loginmodule	443
lists	448
revocation	449
certificate	450
509	451
certificates	453
spi	457
cacerts	460
4532517	593
4639735	594
compiler	595
4513715	596
full-speed	597
debugging	598
4668963	609
behavior	612
changed	613
jeditorpane	614
export	615
has	616
import	617
4395157	623
4659800	624
eagerhttpfallback	626
proxy	627
transport	628
4615396	629
rmisocketfactory	632
setfailurehandler	637
clarification	642
jtabbedpane	647
txt	648
www	649
draft-ietf-ldapext-locate-08	650
internet-drafts	651
panel	653
4632782	663
shift-jis	671
encoding	672
encodings	673
change	674
4556882	675
vm	676
hotspot	678
ldap	681
4627627	686
4379138	687
optional	692
deploying	693
4628933	695
candidate	696
4513638	701
attributes	702
4030374	703
embed	713
tags	715
different	718
encountering	719
browsers	721
output	722
	724
v8	725
sparcstation	726
processors	727
sample	729
sparc	733
4690831	735
4218431	746
lookup	747
communication	748
dns	749
java-to-javascript	750
4636548	751
remoteserver	752
setlog	753
4627542	754
4668511	755
rmifailurehandler	756
4669873	757
itanium	759
64-bit	760
introduction	761
lookups	762
intel	763
chapters	1088
awards	1089
30	1090
discount	1091
reviews	1093
used	1097
translations	1098
author	1099
in-depth	1100
topics	1101
discussions	1102
--	1103
covered	1104
excursions	1105
praise	1106
interviews	1107
streams	1115
part	1131
building	1134
course	1135
short	1136
101	1137
iii	1142
styled	1143
essentials	1144
hands-on	1145
graphical	1146
distributed	1147
computing	1148
ii	1149
formerly	1161
forte	1165
modules	1166
ide	1167
developing	1173
3d	1174
jguru	1182
servlets	1186
era	1189
cardtest	328
client	329
bingo!	330
application	331
server	332
hello	334
world	335
sortdemo	337
cup	338
first	342
drawtest	346
fractal	347
simplegraph	348
imagemap	350
clock	355
tictactoe	356
graphicstest	362
arctest	364
barchart	366
blink	367
nervoustext	368
dithertest	373
jumpingbox	374
spreadsheet	377
utilities	380
products	396
chat	397
admins	400
system	401
n1	402
relations	403
investor	404
>	405
my	407
worldwide	408
sites	409
buy	410
learn	412
optimize	413
see	414
events	415
all	416
	417
research	420
executives	421
partners	422
identity	424
network	425
technical	426
solutions	427
business	429
instructions	474
english	475
french	476
pathseparatorchar	486
platform?	524
it?	525
when	526
jdk	527
can	528
favorite	529
get	530
a4	531
production	532
program	533
try	534
helloworld	535
found	536
do	537
virus	538
going	539
virus-checker	540
from	541
stop	542
claims	543
javac	544
run	545
e5	546
notice	547
e4	548
e3	549
e2	550
on?	551
appearing	552
every	553
app?	554
some	555
time	556
95	557
noclassdeffounderror	558
superclass	559
nt	560
have	561
appletviewer?	562
stock	563
available?	564
technology?	565
addresses	566
b4	567
b3	568
are	569
market?	570
carry	571
invest	572
d5	573
newsgroups	574
language?	575
hotjava	576
a7	577
b8	578
b7	579
be	580
alpha	581
tester?	582
price?	583
an	584
http	585
beta	586
where?	587
know	588
comment	589
please	590
you	591
zzz	592
let	599
plans	600
d4	601
software?	602
install	603
platforms	604
supporting	605
a5	606
a8	607
a6	608
logo?	610
netscape?	611
a3	618
a2	619
a1	620
netscape	621
java?	622
where	625
haven	630
stand	631
suggestions?	633
versions	634
free?	635
ve	636
it	638
for?	639
reports	640
is	641
formats?	643
keep	644
will	645
did	646
name	652
any	654
your	477
empower	478
section	479
jnlp	480
packaging	481
localized	482
documents	483
feedback	484
form	485
midi	487
sampled	488
porting	489
walk-through	490
modularity	491
debug	492
wire	493
protocol	494
details	495
team	496
address	497
email	498
list	499
site	500
properties	501
options	502
exceptions	503
extendable	504
serversocket	505
useful	506
dynamic	507
downloading	508
codebase	509
property	510
registry	511
trail	512
continued	513
rmi-users	514
archives	515
subscribe	517
factory	518
pattern	519
applying	520
activation	521
custom	522
dgc	523
proprietary	740
rights	741
dynanypackage	792
omg	793
dynamicany	794
stub	796
cosnaming	798
charset	802
nio	803
orbpackage	804
im	806
attribute	807
imageio	811
dnd	812
dynanyfactorypackage	813
se	814
portableinterceptor	815
orbinitinfopackage	816
transaction	817
xa	818
zip	819
helpers	820
sax	821
poamanagerpackage	822
portableserver	823
iop	824
ext	825
transform	826
stream	827
servantlocatorpackage	828
dom	832
prefs	833
namingcontextpackage	834
metadata	835
ref	836
codecfactorypackage	837
codecpackage	838
geom	839
channels	840
color	841
sendingcontext	847
corba_2_3	848
currentpackage	849
description	850
cgi	851
2000-08-06	852
cgi-bin	853
doc?ptc	854
acl	855
parsers	856
namingcontextextpackage	857
plugins	858
jpeg	859
renderable	860
99-10-07	861
doc?formal	862
poapackage	863
messaging	864
submit	865
font	866
typecodepackage	867
fonts	879
formatting	880
message	881
number	882
boundaries	883
collation	884
articles	885
layout	886
frequently	887
asked	888
date	889
volume	940
bytes	944
javaclasslibvol1examples	950
1165634	951
beyond	1108
basics	1109
onlineonly	1110
specialized	1111
guis	1112
putting	1113
together	1114
statement	1116
mode	1117
exclusive	1118
full-screen	1119
aquick	1120
unix	1121
ed	1122
announcements	1123
writing	1124
big	1132
really	1133
2003	1138
february3	1139
mac	1140
essential	1141
cos	1150
timeouts	1151
domain	1152
automatic	1153
discovery	1154
internet	1155
controlling	1156
providers	1157
rfc	1162
2829	1163
applets?	655
contain?	656
from?	657
mail	658
feature	659
planning	660
find	661
touch	662
staying	664
a14	665
a13	666
a12	667
a11	668
troubleshooting	669
a10	670
latest	677
licensing?	679
jre?	680
limitations	682
special	683
developments?	684
yyy?	685
does	688
heard	689
e1	690
they	691
who	694
out	697
functionality?	698
marketing	699
hotjava?	700
work	704
d3	705
d2	706
d1	707
dos	708
technology-enabled	709
informed	710
?	711
8	712
come	714
c2	716
c1	717
xxx	720
code?	723
scripts?	728
me	730
b9	731
b6	732
b5	734
b2	736
b1	737
email?	738
problems	739
need	742
done	743
javascript	744
a9	745
e-mail	758
java-technology	764
jre	765
educational	766
request	767
navigator	768
guidelines	769
trademark	770
februrary	771
fundamentals	772
newsletter	774
workbook	776
one	777
studio	781
references	783
paths	787
learned	788
micro	789
ftp	868
addison-wesley	869
thread	1125
versioning	1126
optional-package	1127
secureclassloader	1128
urlclassloader	1129
jarurlconnection	1130
factility	1199
common	1204
forms	1205
plugin-sendusmail	1206
sup1-egs	1207
745698	1208
4693219	1212
4615751	1213
4697804	1214
nvidia	1215
4648702	1216
2246-tlsv1	1217
4628281	1218
4682626	1219
4505899	1220
zone	1221
detection	1222
japanese	1223
avaya	1224
libsafe	1225
locale	1226
labs	1227
avayalabs	1228
fixes	1229
textarea	1230
update	1231
subsequent	1232
4704500	1233
4634165	1234
4736093	1235
4654636	1236
4644270	1237
4460583	1238
4387291	1239
4503092	1240
4656697	1241
affecting	1242
draft-ietf-ldapext-locate-07	1243
4456393	1244
4740901	1245
drives	1246
samba	1247
xp	1248
mounted	1249
4672707	1250
javadoc?	1251
4521661	1252
4460065	1253
flags	1254
quality	1255
atitech	1259
openwindows	1261
conformance	1262
4650839	1263
supplemental	1264
4682743	1265
netbeans	1266
known	1267
4701394	1269
getdocumentbase	1270
getcodebase	1271
4652655	1272
requestfocus	1273
comformance	1274
transferable	1281
selectbesttextflavor	1282
availableflavors	1283
dataflavor[]	1284
getreaderfortext	1285
iiop	1322
over	1323
16	998
15	999
control	1000
types	1001
superclasses	1002
narrowing	1003
unicode	1004
detailed	1005
unloading	1006
identifiers	1007
mnemonics	1008
opcode	1009
1999	1010
public	1011
implementing	1012
return	1013
area	1014
load	1015
local	1016
abrupt	1017
operand	1018
arithmetic	1019
areas	1020
representation	1021
heap	1022
modes	1023
completion	1024
pc	1025
management	1026
754	1027
constant	1028
finally	1029
named	1030
normal	1031
additional	1032
type	1033
stacks	1034
structure	1035
ieee	1036
stack	1037
runtime	1038
private	1039
specially	1040
pool	1041
manipulation	1042
throwing	1043
accessing	1044
switches	1045
working	1046
compiling	1047
receiving	1048
arguments	1049
constants	1050
invoking	1051
constructs	1052
newly	1053
handlers	1054
created	1055
constant_nameandtype_info	1056
classfile	1057
grammar	1058
constant_double_info	1059
structural	1060
constant_float_info	1061
constantvalue	1062
constant_long_info	1063
descriptors	1064
constant_fieldref_info	1065
constant_methodref_info	1066
verifier	1067
bytecode	1068
innerclasses	1069
notation	1070
structures	1071
constant_string_info	1072
internal	1073
constant_interfacemethodref_info	1074
linenumbertable	1075
constraints	1076
synthetic	1077
constant_class_info	1078
sourcefile	1079
localvariabletable	1080
instance	1081
constant_utf8_info	1082
defining	1083
constant_integer_info	1084
user-defined	1085
binding	1086
initializing	1087
loader	1092
deriving	1094
implementations	1095
bootstrap	1096
document	1158
2sdk	1159
front	1160
launcher	1172
annotated	1305
vol	1306
getbyname	1344
inetaddresss	1345
host	1347
recommended	1349
rpm	1350
16-bit	1351
displays	1352
bin	1353
ary	1354
required	1355
pentium	1356
48	1357
gnome	1358
conjunction	1359
minimum	1360
kernel	1361
running	1362
later	1363
hosts	1364
2-11	1365
32	1366
kde	1367
megabytes	1368
glibc	1369
v2	1370
desktop	1371
ram	1372
consulting	1373
education	1374
curriculum	1375
keyboard	1403
bindings	1404
assistive	1405
defined	1406
starttlsresponse	1164
2222	1168
browser	1169
separately	1170
namespace	1171
2831	1175
listed	1176
below	1177
multiple	1178
urls	1179
executive	1180
starttlsrequest	1181
via	1183
pooling	1184
related	1185
2830	1187
jndi-interest	1188
connector	1286
soap	1287
web-service-ready	1288
build	1289
jxta	1290
thomas	1291
ulrich	1292
crown	1293
college	1294
topcoders	1295
vie	1296
broker	1414
addendum	1190
pages	1191
javaserver	1192
javamailapi	1193
audiocasts	1194
media	1195
jms	1196
ejb	1197
platform--jdc	1198
securitymanager	1200
manner	1201
location-independent	1202
resourcebundle	1203
scalability	1275
improvements	1276
speed	1277
footprint	1278
memory	1279
startup	1280
requirements	1297
selecting	1298
self-extracting	1299
website	1300
sunsolve	1301
libjvm	1302
plugin	1303
so	1304
inetsocketaddress	1329
datagramsocket	1330
fileoutputstream	1331
stringbuffer	1332
randomaccessfile	1333
jsr-51	1334
charsequence	1335
fileinputstream	1337
socketaddress	1338
outputstreamwriter	1339
inputstreamreader	1340
locators	1387
inter-orb	1388
skeleton	1389
activators	1391
official	1392
specifications	1393
orb	1394
persistent	1395
transient	1396
servers	1397
adapter	1399
introductory	1400
mapping	1402
server-side	1324
interceptors	1325
clients	1326
manpage	1327
man	1328
compliance	1336
objectimpl	1341
chapter	1342
forum	1343
engineering	1376
java2	1377
bugreport	1398
jdc	1401
\.
--
-- Data for TOC Entry ID 55 (OID 230341)
--
-- Name: apphttp Type: TABLE DATA Owner: tistou
--


COPY "apphttp" FROM stdin;
1	1	1	1
1	2	2	1
1	2	3	1
1	3	4	1
1	3	5	1
1	3	6	1
1	4	7	1
1	4	8	1
1	4	9	1
1	4	10	1
1	4	11	1
1	5	12	1
1	5	13	1
1	5	14	1
1	5	15	1
1	5	16	1
1	5	17	1
1	5	18	1
1	5	19	1
1	5	20	1
1	5	21	1
1	5	22	1
1	6	23	1
1	7	24	1
1	7	25	1
1	7	19	1
1	7	26	1
1	8	13	2
1	8	27	1
1	8	28	2
1	8	29	1
1	8	30	1
1	8	31	1
1	8	32	1
1	8	33	1
1	8	34	1
1	9	35	1
1	9	36	2
1	9	37	1
1	10	24	1
1	10	38	1
1	10	39	1
1	10	40	1
1	10	41	1
1	11	38	1
1	11	42	1
1	11	43	1
1	11	18	1
1	12	44	1
1	12	45	1
1	12	46	1
1	12	47	1
1	13	48	1
1	14	49	1
1	14	50	1
1	14	46	1
1	14	51	1
1	15	52	1
1	15	53	1
1	15	54	1
1	16	55	1
1	16	38	1
1	16	56	1
1	16	57	1
1	17	58	1
1	17	59	1
1	17	60	1
1	18	61	1
1	18	35	1
1	18	38	1
1	18	62	1
1	18	63	1
1	19	64	1
1	19	65	1
1	20	66	1
1	20	24	1
1	20	38	1
1	20	67	1
1	21	27	1
1	21	46	1
1	21	61	1
1	21	68	1
1	21	69	1
1	21	32	1
1	21	33	2
1	21	24	1
1	21	70	1
1	22	71	1
1	22	72	1
1	22	73	1
1	23	71	1
1	23	74	1
1	24	38	1
1	24	75	1
1	24	76	1
1	24	77	1
1	25	78	1
1	25	38	1
1	25	43	1
1	25	79	1
1	25	80	1
1	25	81	1
1	25	18	1
1	26	82	2
1	26	83	3
1	26	35	2
1	26	84	1
1	26	38	1
1	26	85	2
1	26	76	1
1	27	86	1
1	27	87	1
1	27	88	1
1	27	89	1
1	28	90	1
1	29	91	1
1	29	84	1
1	29	38	2
1	29	43	1
1	29	85	1
1	29	46	1
1	30	92	1
1	30	27	1
1	30	93	1
1	30	38	1
1	30	94	1
1	31	27	1
1	31	84	1
1	31	38	1
1	31	42	1
1	31	19	1
1	32	38	2
1	32	27	1
1	32	95	1
1	32	96	1
1	32	97	1
1	32	46	1
1	32	98	1
1	32	99	1
1	32	100	1
1	32	75	2
1	32	32	1
1	32	24	2
1	32	101	1
1	32	102	1
1	33	103	1
1	34	104	1
1	34	105	1
1	34	106	1
1	34	73	1
1	35	35	1
1	35	107	2
1	35	108	1
1	35	109	1
1	35	110	1
1	35	46	1
1	35	81	1
1	36	111	1
1	36	112	1
1	36	113	1
1	37	114	1
1	37	115	1
1	38	38	1
1	38	116	1
1	39	117	1
1	39	24	1
1	39	80	1
1	39	118	1
1	40	83	1
1	41	119	1
1	41	120	1
1	42	83	1
1	43	8	1
1	43	121	1
1	43	122	1
1	44	123	1
1	45	124	1
1	45	125	1
1	46	88	1
1	46	126	1
1	47	127	1
1	48	38	1
1	48	42	1
1	48	43	1
1	48	124	1
1	48	125	1
1	49	128	1
1	49	38	5
1	49	33	2
1	49	129	1
1	49	130	1
1	49	131	1
1	49	132	1
1	49	133	1
1	50	38	1
1	50	43	1
1	50	134	1
1	51	35	1
1	51	69	1
1	52	135	1
1	52	38	1
1	52	136	1
1	52	43	1
1	52	80	1
1	52	81	1
1	52	18	1
1	53	137	1
1	53	130	1
1	53	46	1
1	53	18	1
1	54	24	1
1	54	138	1
1	54	55	1
1	54	38	1
1	54	46	1
1	54	139	1
1	54	140	1
1	55	141	1
1	55	38	1
1	55	43	1
1	55	142	1
1	56	143	1
1	56	144	1
1	56	145	1
1	56	146	1
1	57	147	1
1	58	24	1
1	58	38	1
1	58	148	1
1	59	70	1
1	59	149	1
1	60	84	1
1	60	33	1
1	60	150	1
1	61	53	1
1	61	151	1
1	61	152	1
1	61	130	1
1	62	153	1
1	62	154	1
1	63	155	1
1	63	156	1
1	64	157	1
1	64	13	1
1	65	158	1
1	66	159	1
1	66	160	1
1	66	161	1
1	67	162	1
1	67	24	1
1	67	163	1
1	67	154	1
1	67	164	1
1	67	81	1
1	67	165	1
1	68	129	1
1	68	166	1
1	69	167	1
1	70	168	1
1	71	169	1
1	71	55	1
1	71	38	1
1	71	124	1
1	71	170	1
1	71	125	1
1	72	171	1
1	72	83	1
1	72	46	1
1	72	172	1
1	73	28	1
1	74	35	1
1	74	173	1
1	74	174	1
1	75	154	1
1	75	175	1
1	75	81	1
1	75	165	1
1	76	35	1
1	76	176	1
1	76	22	1
1	76	43	1
1	77	177	1
1	77	178	1
1	77	38	3
1	77	33	2
1	77	130	1
1	77	179	1
1	78	180	1
1	78	38	1
1	79	181	1
1	80	154	1
1	80	182	1
1	80	183	1
1	80	81	1
1	80	165	1
1	81	184	1
1	81	38	1
1	81	43	1
1	81	80	1
1	81	81	1
1	81	18	1
1	82	185	1
1	83	186	1
1	83	38	1
1	83	187	1
1	83	188	1
3	35	107	1
3	35	108	1
3	82	19	1
3	82	185	1
3	84	121	1
3	84	38	1
3	84	189	1
3	84	179	1
3	85	10	1
3	85	34	1
3	85	190	1
3	85	70	1
3	15	52	1
3	15	53	1
3	15	54	1
3	86	191	1
3	86	192	1
3	86	42	1
3	87	35	1
3	87	193	1
3	88	38	1
3	88	85	1
3	88	179	1
3	88	43	1
3	88	61	1
3	88	68	1
3	88	194	1
3	88	84	1
3	88	70	1
3	89	121	1
3	89	38	1
3	89	195	1
4	90	10	1
4	90	70	1
4	91	121	1
4	91	38	1
4	91	196	1
4	35	107	1
4	35	108	1
4	92	91	1
3	89	179	1
4	93	42	1
4	94	197	1
4	95	198	1
4	96	61	1
4	96	24	1
4	96	68	1
4	96	33	1
4	96	32	1
4	96	70	1
4	87	35	1
4	87	193	1
4	97	171	1
4	15	52	1
4	15	53	1
4	15	54	1
4	98	172	1
3	12	44	1
3	12	45	1
3	12	46	1
3	12	199	1
3	12	200	1
3	12	47	1
3	99	43	1
3	99	76	1
3	99	77	1
3	99	201	1
3	100	43	1
3	100	76	1
3	100	179	1
3	100	77	1
3	101	202	1
3	101	55	1
3	101	203	1
3	102	197	1
3	102	80	1
3	103	121	1
3	103	38	1
3	103	179	1
3	17	58	1
3	17	59	1
3	66	159	1
3	66	160	1
3	66	161	1
3	104	38	1
3	104	85	1
3	104	179	1
3	104	43	1
3	104	61	1
3	104	31	1
3	104	194	1
3	104	84	1
3	104	70	1
7	87	35	1
7	87	193	1
7	105	204	1
7	105	53	1
7	105	38	1
7	105	205	1
7	106	128	1
7	106	23	1
7	106	38	1
7	107	23	1
7	107	190	1
7	35	107	1
7	35	108	1
7	15	52	1
7	15	53	1
7	15	54	1
8	108	177	1
8	108	38	1
8	108	206	1
8	109	172	1
8	110	26	1
8	110	207	1
8	110	46	1
8	110	208	1
8	110	76	1
8	110	43	1
8	110	77	1
8	110	209	1
8	110	210	1
8	110	177	1
8	35	107	1
8	35	108	1
8	111	61	1
8	111	68	1
8	111	19	1
8	111	194	1
8	111	70	1
8	112	134	1
8	112	26	1
8	113	211	1
8	113	43	1
8	113	59	1
8	87	35	1
8	87	193	1
8	114	171	1
8	115	24	1
8	115	42	1
8	115	26	1
8	116	177	1
8	116	38	1
8	15	52	1
8	15	53	1
8	15	54	1
8	117	42	1
8	117	206	1
10	118	155	1
10	118	212	1
11	87	35	1
10	118	76	1
11	87	193	1
10	119	175	1
10	120	163	1
10	120	175	1
10	120	46	1
10	121	183	1
10	122	163	1
10	122	46	1
10	122	175	1
10	122	183	1
10	123	163	1
10	123	175	1
11	124	1	1
10	123	46	1
10	126	163	1
10	126	175	1
10	126	46	1
10	127	183	1
10	95	163	1
10	95	175	1
10	95	46	1
10	131	163	1
10	15	52	1
10	15	53	1
10	15	54	1
10	132	163	1
10	132	175	1
10	132	46	1
10	133	163	1
10	133	175	1
10	133	46	1
10	134	163	1
10	134	175	1
10	134	46	1
10	135	163	1
10	135	175	1
10	135	46	1
10	136	183	1
10	137	163	1
10	138	163	1
10	138	46	1
10	138	175	1
10	138	183	1
10	139	216	1
10	140	183	1
10	141	163	1
10	141	175	1
10	141	46	1
10	142	183	1
10	143	183	1
10	144	217	1
10	145	183	1
10	146	73	1
10	146	104	1
10	146	38	2
10	146	123	1
10	146	148	1
10	146	105	1
10	146	180	1
10	146	226	1
10	146	46	1
10	146	227	6
10	146	167	1
10	146	106	1
10	146	48	1
10	146	24	1
10	153	183	1
10	158	163	1
10	158	175	1
10	158	46	1
10	164	175	1
10	166	183	1
10	167	183	1
10	87	35	1
10	87	193	1
10	35	107	1
10	176	175	1
10	178	183	1
10	179	183	1
10	180	249	1
10	181	250	1
10	182	175	1
10	186	183	1
10	191	175	1
10	194	183	1
10	197	183	1
10	198	183	1
10	202	163	1
10	202	175	1
10	202	46	1
10	204	163	1
10	204	175	1
10	204	46	1
10	206	163	1
10	206	175	1
10	206	46	1
10	208	183	1
10	214	272	1
10	214	38	1
10	214	148	1
10	217	183	1
10	218	155	1
10	218	274	1
10	218	76	1
10	224	275	1
10	225	163	1
10	225	175	1
10	225	46	1
10	226	183	1
10	227	183	1
10	228	183	1
10	230	163	1
10	230	175	1
10	230	46	1
10	235	155	1
10	235	281	1
10	235	76	1
10	239	163	1
10	239	175	1
10	239	46	1
10	242	183	1
10	246	289	1
13	262	107	1
13	264	309	2
13	264	193	2
13	265	310	2
14	276	44	1
14	276	47	1
14	277	181	1
14	35	107	1
14	35	108	1
14	278	320	1
14	278	44	1
14	278	321	1
14	278	322	1
14	278	149	1
14	87	35	1
14	87	193	1
14	279	171	1
14	280	38	1
14	280	13	1
14	280	28	1
14	280	47	1
14	282	38	1
14	282	43	1
14	282	76	1
14	282	77	1
14	282	47	1
14	286	333	1
14	291	38	1
14	291	42	1
14	291	19	1
14	291	47	1
14	305	45	1
14	305	38	2
14	305	15	1
14	305	47	1
14	305	375	1
14	305	46	1
14	305	19	1
14	305	81	1
14	305	44	1
14	15	52	1
14	15	53	1
14	15	54	1
14	339	43	1
14	339	76	1
14	339	77	1
14	339	201	1
18	353	392	1
11	124	134	1
11	125	24	1
11	125	1	1
11	125	38	1
11	125	19	1
11	125	43	1
11	125	213	1
11	125	81	1
11	128	214	1
11	129	24	1
11	129	1	1
11	129	215	1
11	129	38	1
11	129	76	1
11	129	77	1
11	130	95	1
11	130	1	1
11	130	53	1
11	35	107	1
11	15	52	1
11	15	53	1
11	15	54	1
5	147	38	1
5	147	28	1
5	147	199	1
5	147	21	1
5	148	218	1
5	148	76	1
5	149	219	1
5	40	9	1
5	40	38	1
5	40	42	1
5	40	220	1
5	40	18	1
5	150	219	1
5	150	221	1
5	150	199	1
5	61	222	1
5	61	223	1
5	61	224	1
5	61	53	1
5	61	130	1
5	61	225	1
5	61	228	1
5	61	229	1
5	61	230	1
5	61	231	1
5	15	52	1
5	15	53	1
5	15	54	1
5	152	232	3
5	152	233	1
5	152	234	1
12	155	204	1
5	154	199	1
12	155	38	1
12	155	53	1
12	155	19	1
12	155	81	1
12	155	235	1
12	155	76	1
12	155	77	1
12	155	40	1
12	35	107	1
12	35	108	1
12	163	83	1
12	163	76	1
12	165	237	1
5	161	236	1
12	165	238	1
12	165	239	1
12	15	52	1
12	15	53	1
12	15	54	1
5	169	227	1
12	87	35	1
5	169	199	1
12	87	193	1
5	171	240	1
5	172	241	1
5	173	242	1
5	173	243	1
5	173	32	2
12	174	121	1
5	175	38	1
12	174	244	1
12	174	245	1
12	177	246	1
5	175	247	1
12	177	248	1
12	177	156	2
5	183	251	1
12	177	252	1
5	183	207	1
12	177	220	1
12	185	253	1
12	185	254	1
5	183	199	1
5	189	255	1
5	190	221	2
12	185	256	1
5	190	38	1
5	190	27	1
5	190	257	1
5	190	220	1
5	190	46	1
5	190	258	3
5	190	9	3
5	190	259	1
12	185	260	1
12	185	207	1
12	185	233	1
12	185	11	1
12	185	261	1
5	190	68	2
5	190	194	2
5	190	84	1
12	193	121	1
5	190	33	1
5	190	262	1
5	190	263	1
5	87	35	1
5	87	85	1
5	195	22	1
5	195	200	1
5	196	264	1
5	196	265	1
12	193	38	1
12	193	245	1
12	200	226	1
12	200	134	1
12	203	66	1
12	203	35	1
5	199	266	1
12	203	84	1
12	203	38	1
12	203	85	1
12	203	76	1
12	203	259	1
12	203	267	1
5	199	173	1
12	205	134	1
12	205	200	1
12	207	268	1
12	207	38	1
12	207	155	1
12	207	269	1
5	209	243	1
5	210	35	1
5	210	9	1
5	211	270	1
5	211	199	1
5	212	35	1
5	212	9	1
5	213	271	1
5	213	109	1
5	213	34	1
6	151	71	1
6	151	74	1
6	4	7	1
6	4	8	1
6	4	9	1
6	4	10	1
6	4	11	1
6	156	2	1
6	156	3	1
6	157	167	1
6	159	55	1
6	159	38	1
6	159	56	1
6	159	57	1
6	160	157	1
6	160	13	1
6	162	4	1
6	162	5	1
6	162	6	1
6	168	23	1
6	11	38	1
6	11	42	1
6	11	43	1
6	11	18	1
6	170	169	1
6	170	55	1
6	170	38	1
6	170	124	1
6	170	170	1
6	170	125	1
6	184	129	1
6	184	166	1
6	187	168	1
6	15	52	1
6	15	53	1
6	15	54	1
6	188	71	1
6	188	72	1
6	188	73	1
6	18	61	1
6	18	35	1
6	18	38	1
6	18	62	1
6	18	63	1
6	192	185	1
6	19	64	1
6	19	65	1
6	21	27	1
6	21	46	1
6	21	61	1
6	21	68	1
6	21	69	1
6	21	32	1
6	21	33	2
6	21	24	1
6	21	70	1
6	24	38	1
6	24	75	1
6	24	76	1
6	24	77	1
6	201	88	1
6	201	126	1
6	25	78	1
6	25	38	1
6	25	43	1
6	25	79	1
6	25	80	1
6	25	81	1
6	25	18	1
6	215	127	1
6	219	66	1
6	219	24	1
6	219	38	1
6	219	67	1
6	26	82	2
6	26	83	3
6	26	35	2
6	26	84	1
6	26	38	1
6	26	85	2
6	26	76	1
6	29	91	1
6	29	84	1
6	29	38	2
6	29	43	1
6	29	85	1
6	29	46	1
6	233	104	1
6	233	105	1
6	233	106	1
6	233	73	1
6	236	158	1
6	237	8	1
6	237	121	1
6	237	122	1
6	243	24	1
6	243	38	1
6	243	39	1
6	243	40	1
6	243	41	1
6	244	119	1
6	244	120	1
6	36	111	1
6	36	112	1
6	36	113	1
6	38	38	1
6	38	116	1
6	245	103	1
6	39	117	1
6	39	24	1
6	39	80	1
6	39	118	1
6	40	83	1
6	42	83	1
6	252	24	1
6	252	25	1
6	252	19	1
6	252	26	1
6	253	48	1
6	254	13	2
6	254	27	1
6	254	28	2
6	254	29	1
6	254	30	1
6	254	31	1
6	254	32	1
6	254	33	1
6	254	34	1
6	260	86	1
6	260	87	1
6	260	88	1
6	260	89	1
6	48	38	1
6	48	42	1
6	48	43	1
6	48	124	1
6	48	125	1
6	49	128	1
6	49	38	5
6	49	33	2
6	49	129	1
6	49	130	1
6	49	131	1
6	49	132	1
6	49	133	1
6	263	35	1
6	263	36	2
6	263	37	1
6	50	38	1
6	50	43	1
6	50	134	1
6	266	58	1
6	266	59	1
6	266	60	1
6	51	35	1
6	51	69	1
6	268	35	1
12	207	134	1
12	207	273	1
12	207	46	1
12	207	19	1
12	207	259	1
12	207	40	1
12	207	24	1
12	229	134	1
12	229	278	1
12	231	15	1
12	231	279	1
12	231	24	1
12	231	215	1
12	231	283	1
12	231	40	1
12	240	284	1
12	240	285	1
12	240	286	1
12	240	21	1
12	241	248	1
12	241	287	1
12	241	156	2
12	241	252	1
12	241	295	1
15	256	271	2
15	256	299	2
15	256	38	2
15	256	17	2
15	256	46	2
15	256	81	2
15	256	326	2
15	256	11	2
15	256	327	2
15	283	24	1
15	283	84	1
15	283	38	1
15	283	43	1
15	283	85	1
15	283	46	1
15	283	340	1
15	283	48	1
15	299	27	1
15	299	24	1
15	299	84	1
15	299	38	1
15	299	48	1
15	120	163	1
15	120	81	1
15	315	358	1
15	315	121	1
15	315	359	1
15	315	360	1
15	316	361	1
15	316	38	1
15	316	93	1
15	316	365	1
15	316	81	1
15	316	43	1
15	316	369	1
15	316	21	1
15	316	370	1
15	333	371	1
15	333	372	1
15	333	376	1
15	333	379	1
15	333	46	1
15	333	173	2
15	340	381	1
15	340	173	1
15	341	121	1
15	341	244	1
15	341	382	1
15	15	52	1
15	15	53	1
15	15	54	1
15	345	121	1
15	345	244	1
15	345	385	1
15	345	382	1
15	346	121	1
15	346	244	1
15	346	382	1
15	346	386	1
15	347	121	1
15	347	244	1
15	347	327	1
15	347	390	1
15	347	48	1
15	136	183	1
15	136	81	1
15	352	121	1
15	352	391	1
15	352	204	1
15	352	53	1
15	352	390	1
15	352	48	1
15	355	121	1
15	355	244	1
15	355	391	1
15	355	390	1
15	355	48	1
15	357	15	1
15	357	155	1
15	357	393	1
15	359	61	1
15	359	394	1
15	359	327	1
15	359	38	1
15	359	252	1
15	359	395	1
15	362	121	1
15	362	38	1
15	362	48	1
15	363	93	1
15	363	48	1
15	364	121	1
15	364	204	1
15	364	53	1
15	364	390	1
15	364	48	1
15	364	399	1
15	166	183	1
15	166	81	1
15	87	35	1
15	87	193	1
15	372	17	2
15	372	326	2
15	373	121	1
15	373	244	1
15	373	390	1
15	373	48	1
15	373	399	1
15	35	107	1
15	35	108	1
15	382	121	1
15	382	244	1
15	382	418	1
15	382	48	1
15	310	15	1
15	310	419	1
15	310	38	1
15	310	19	1
15	310	351	1
15	310	352	1
15	395	121	1
15	395	204	1
15	395	423	1
15	395	53	1
15	395	390	1
15	395	48	1
15	401	121	2
15	401	418	2
15	401	38	2
15	401	48	2
15	403	121	1
15	403	244	1
15	403	428	1
5	216	110	1
5	220	35	1
5	220	9	1
5	221	35	1
5	221	9	1
5	222	100	1
5	223	276	1
5	223	277	1
5	232	35	1
5	234	280	1
5	234	16	1
5	238	282	1
5	238	38	1
5	238	46	1
5	238	288	1
5	247	32	1
5	247	241	1
5	248	35	1
5	248	32	1
5	249	290	1
5	249	291	1
5	249	292	1
5	249	46	1
5	250	293	1
5	250	46	1
5	250	294	1
5	251	296	1
5	251	38	1
5	251	297	1
16	284	328	1
16	285	329	1
16	285	330	1
16	285	331	1
16	285	332	1
16	287	331	1
16	287	178	1
16	287	334	1
16	287	46	1
16	287	335	1
16	290	84	1
16	50	38	1
16	50	43	1
16	50	134	1
16	292	68	1
16	293	33	1
16	294	337	1
16	15	52	1
16	15	53	1
16	15	54	1
16	295	31	1
16	296	338	1
16	296	38	1
16	296	34	1
16	296	342	1
16	300	84	1
16	301	68	1
16	302	84	1
16	306	346	1
16	307	347	1
16	308	348	1
16	87	15	1
16	87	35	1
16	87	13	1
16	87	193	1
16	87	21	1
16	309	350	1
16	313	355	1
16	35	107	1
16	35	108	1
16	314	356	1
16	317	362	1
16	320	33	1
16	321	364	1
16	322	366	1
16	323	50	1
16	323	76	1
16	324	31	1
16	325	84	1
16	326	33	1
16	327	68	1
16	328	367	1
16	329	31	1
16	330	368	1
16	331	33	1
16	334	373	1
16	335	31	1
16	336	374	1
16	337	377	1
16	9	380	1
16	9	84	1
16	9	38	1
16	9	46	1
16	9	85	1
16	9	227	1
17	360	276	1
17	360	396	1
17	365	397	1
17	365	176	1
17	365	32	1
17	366	229	1
17	367	400	1
17	367	401	1
17	368	402	1
17	369	403	1
17	369	404	1
17	370	405	1
17	371	53	1
17	371	407	1
17	15	204	1
17	15	405	2
17	15	53	1
17	152	232	1
17	171	240	1
17	374	408	1
17	374	409	1
17	375	370	1
17	375	410	1
17	375	21	1
17	376	46	1
17	376	412	1
17	376	413	1
17	379	38	1
17	380	66	1
17	380	276	1
17	381	414	1
17	381	415	1
17	381	264	1
17	381	416	1
17	381	46	1
17	381	417	1
17	384	405	1
17	385	184	1
17	385	325	1
17	386	241	1
17	199	266	1
17	387	405	1
17	388	420	1
17	389	421	1
17	391	422	1
17	392	405	1
17	213	271	1
17	213	109	1
17	213	34	1
17	393	35	1
17	394	414	1
17	394	13	1
17	394	416	1
17	394	417	1
17	396	163	1
17	234	280	1
17	234	16	1
17	397	100	1
17	398	424	1
17	398	425	1
17	399	255	1
17	400	111	1
17	400	28	1
9	255	298	1
9	256	24	1
9	256	299	1
9	256	38	1
9	257	300	1
9	2	2	1
9	3	179	1
9	258	301	1
9	258	142	1
9	6	23	1
9	6	19	1
9	7	58	1
9	7	302	1
9	7	303	1
9	7	26	1
9	7	34	1
9	259	304	1
9	259	38	1
9	259	305	1
9	259	133	1
9	10	31	1
9	10	19	1
9	10	40	1
9	10	262	1
9	125	1	1
9	125	213	1
9	12	24	1
9	12	215	1
9	12	38	1
9	12	47	1
9	13	48	1
9	261	128	1
9	261	38	1
9	261	306	1
9	261	307	1
9	261	308	1
9	134	311	1
9	16	55	1
9	16	38	1
9	16	56	1
9	17	59	1
9	267	159	1
9	267	160	1
9	267	59	1
9	20	66	1
9	20	24	1
9	20	38	1
9	20	312	1
9	20	67	1
9	269	71	1
9	269	74	1
9	269	70	1
9	21	61	1
9	21	68	1
9	21	33	2
9	21	69	1
9	21	32	1
9	21	46	1
9	21	70	1
9	270	313	1
9	23	71	1
9	23	74	1
9	271	70	1
9	271	149	1
9	27	86	2
9	27	87	2
9	27	88	2
9	27	89	2
9	272	304	1
9	272	301	1
9	272	38	1
9	272	314	1
9	272	133	1
9	30	92	1
9	30	27	1
9	30	24	1
9	30	93	1
9	30	38	1
9	273	119	1
9	273	315	1
9	273	316	1
9	273	317	1
9	273	42	1
9	273	140	1
9	275	318	1
9	275	319	1
9	33	323	1
9	33	324	1
9	33	325	1
9	33	103	1
9	281	13	1
9	281	46	1
9	281	61	1
9	281	68	1
9	281	69	1
9	281	31	1
9	281	32	1
9	281	33	2
9	281	168	1
9	281	263	1
9	34	105	1
9	35	336	1
9	35	107	1
9	35	108	1
9	87	15	1
9	87	13	1
9	87	193	1
9	87	21	1
9	297	339	1
9	298	15	1
9	298	155	1
9	298	341	1
9	298	24	1
9	298	38	1
9	298	343	1
9	298	344	2
9	298	126	1
9	303	57	1
9	303	70	1
9	41	119	1
9	41	120	1
9	41	38	1
9	41	19	1
9	44	123	1
9	304	304	1
9	304	345	1
9	304	38	1
9	304	133	1
9	304	73	1
9	45	349	1
9	45	38	1
9	45	125	1
9	138	36	1
9	138	69	1
9	47	127	1
9	310	24	1
9	310	38	1
9	310	19	1
9	310	351	1
9	310	352	1
9	204	353	1
9	311	354	1
9	312	119	1
9	312	24	1
9	312	357	1
9	312	38	1
9	312	363	1
9	312	46	1
9	312	326	1
9	332	13	1
9	332	28	1
9	338	378	1
9	338	38	1
9	338	132	1
9	137	38	1
9	54	24	1
9	54	138	1
6	268	107	2
6	268	108	1
6	268	109	1
6	268	110	1
6	268	46	1
6	268	81	1
6	274	70	1
6	274	149	1
6	52	135	1
6	52	38	1
6	52	136	1
6	52	43	1
6	52	80	1
6	52	81	1
6	52	18	1
6	55	141	1
6	55	38	1
6	55	43	1
6	55	142	1
6	56	143	1
6	56	144	1
6	56	145	1
6	56	146	1
6	288	90	1
6	289	44	1
6	289	45	1
6	289	46	1
6	289	47	1
6	318	49	1
6	318	50	1
6	318	46	1
6	318	51	1
6	319	38	2
6	319	27	1
6	319	95	1
6	319	96	1
6	319	97	1
6	319	46	1
6	319	98	1
6	319	99	1
6	319	100	1
6	319	75	2
6	319	32	1
6	319	24	2
6	319	101	1
6	319	102	1
6	343	92	1
6	343	27	1
6	343	93	1
6	343	38	1
6	343	94	1
6	348	123	1
6	60	84	1
6	60	33	1
6	60	150	1
6	349	114	1
6	349	115	1
6	61	53	1
6	61	151	1
6	61	152	1
6	61	130	1
6	62	153	1
6	62	154	1
6	350	27	1
6	350	84	1
6	350	38	1
6	350	42	1
6	350	19	1
6	67	162	1
6	67	24	1
6	67	163	1
6	67	154	1
6	67	164	1
6	67	81	1
6	67	165	1
6	354	28	1
6	358	24	1
6	358	38	1
6	358	148	1
6	72	171	1
6	72	83	1
6	72	46	1
6	72	172	1
6	74	35	1
6	74	173	1
6	74	174	1
6	75	154	1
6	75	175	1
6	75	81	1
6	75	165	1
6	76	35	1
6	76	176	1
6	76	22	1
6	76	43	1
6	77	177	1
6	77	178	1
6	77	38	3
6	77	33	2
6	77	130	1
6	77	179	1
6	79	181	1
6	383	137	1
6	383	130	1
6	383	46	1
6	383	18	1
6	80	154	1
6	80	182	1
6	80	183	1
6	80	81	1
6	80	165	1
6	390	186	1
6	390	38	1
6	390	187	1
6	390	188	1
6	81	184	1
6	81	38	1
6	81	43	1
6	81	80	1
6	81	81	1
6	81	18	1
6	405	147	1
6	406	1	1
6	407	24	1
6	407	138	1
6	407	55	1
6	407	38	1
6	407	46	1
6	407	139	1
6	407	140	1
6	408	159	1
6	408	160	1
6	408	161	1
6	414	124	1
6	414	125	1
6	416	155	1
6	416	156	1
6	417	180	1
6	417	38	1
6	190	12	1
6	190	13	1
6	190	14	1
6	190	15	1
6	190	16	1
6	190	17	1
6	190	18	1
6	190	19	1
6	190	20	1
6	190	21	1
6	190	22	1
28	486	91	1
28	487	93	1
28	488	66	1
28	488	24	1
28	488	38	1
28	488	477	1
28	488	51	1
28	488	478	1
9	54	55	1
9	54	38	1
9	54	46	1
9	54	139	2
9	54	140	1
9	54	70	1
9	342	383	1
9	342	19	1
9	344	384	1
9	344	192	1
9	344	387	1
9	344	388	1
9	344	389	1
9	58	24	1
9	58	38	1
9	58	148	1
9	58	312	1
9	59	149	1
9	251	296	1
9	251	38	1
9	251	297	1
9	351	27	1
9	351	139	1
9	351	88	1
9	351	28	1
9	351	323	1
9	351	127	1
9	351	180	1
9	351	158	1
9	351	56	1
9	351	103	1
9	351	119	1
9	351	398	1
9	351	19	3
9	351	105	1
9	351	215	1
9	351	2	1
9	351	406	1
9	351	324	1
9	351	66	1
9	351	59	1
9	351	93	1
9	351	168	1
9	351	270	1
9	351	1	1
9	351	26	1
9	351	303	1
9	351	138	1
9	351	149	1
9	351	411	1
9	351	31	1
9	351	380	1
9	351	74	1
9	351	86	1
9	351	262	1
9	351	58	1
9	351	213	1
9	351	67	1
9	351	227	1
9	351	23	1
9	351	123	1
9	351	383	1
9	351	129	1
9	351	125	1
9	351	349	1
9	351	167	1
9	351	430	1
9	351	47	1
9	351	148	1
9	351	431	2
9	351	185	1
9	351	302	1
9	351	34	1
9	351	312	2
9	351	179	1
9	351	325	1
9	351	432	1
9	351	38	9
9	351	46	4
9	351	140	1
9	351	92	1
9	351	55	2
9	351	48	1
9	351	87	1
9	351	89	1
9	351	120	1
9	351	306	1
9	351	71	2
9	351	40	1
9	351	308	1
9	351	24	7
9	65	71	1
9	65	158	1
9	68	129	1
9	411	434	1
9	411	38	1
9	411	124	1
9	411	125	1
9	69	167	1
9	412	431	1
9	412	406	1
9	412	432	1
9	415	435	1
9	415	128	1
9	415	38	1
9	181	250	1
9	224	275	1
9	73	270	1
9	73	28	1
9	96	69	1
9	96	46	1
9	96	70	1
9	420	61	1
9	420	68	1
9	420	437	1
9	420	33	2
9	420	28	1
9	420	438	1
9	144	217	1
9	357	24	1
9	357	393	1
9	357	38	1
9	357	365	1
9	357	126	1
9	78	180	1
9	78	38	1
9	422	430	1
9	422	431	1
9	423	411	1
9	423	398	1
9	423	46	1
9	82	185	1
9	158	437	1
21	449	211	1
21	449	277	1
21	449	38	1
21	451	107	1
21	452	64	1
21	452	65	1
21	453	112	1
21	453	458	1
21	15	52	1
21	15	53	1
21	15	54	1
21	21	68	1
21	21	33	1
21	21	69	1
21	21	262	1
21	21	30	1
22	459	72	1
22	459	462	1
22	459	134	1
22	459	457	1
22	459	73	1
22	460	190	1
22	35	107	1
22	35	108	1
18	353	55	1
18	353	38	1
18	353	56	1
18	356	42	1
18	356	33	2
18	356	57	1
18	361	55	1
18	361	38	1
18	361	56	1
18	361	134	1
18	303	61	1
18	303	68	1
18	303	33	1
18	303	57	1
18	303	70	1
18	377	55	1
18	377	56	1
18	377	179	1
18	35	107	1
18	378	61	1
18	378	84	1
18	378	33	1
18	378	57	1
18	378	70	1
18	87	35	1
18	87	193	1
18	15	52	1
18	15	53	1
18	15	54	1
19	409	433	1
19	409	244	1
19	409	59	1
19	35	107	1
19	35	108	1
19	15	52	1
19	15	53	1
19	15	54	1
19	86	191	1
19	86	192	1
19	86	42	1
19	87	35	1
19	87	193	1
19	425	244	1
19	425	189	1
19	425	59	1
19	426	244	1
19	426	226	1
19	426	439	1
19	426	59	1
19	427	244	1
19	427	440	1
19	427	59	1
19	428	59	1
19	428	38	1
19	428	85	1
19	428	43	1
19	428	61	1
19	428	68	1
19	428	194	1
19	428	84	1
19	428	70	1
19	430	59	1
19	430	38	1
19	430	85	1
19	430	43	1
19	430	61	1
19	430	31	1
19	430	194	1
19	430	84	1
19	430	70	1
19	433	244	1
19	433	439	1
19	433	59	1
19	434	444	1
19	434	244	1
19	434	59	1
19	435	211	1
19	435	43	1
19	435	59	1
19	436	244	1
19	436	445	1
19	436	439	1
19	436	59	1
19	438	244	1
19	438	446	1
19	438	59	1
19	439	447	1
19	439	244	1
19	439	59	1
19	441	244	1
19	441	59	1
19	443	244	1
19	443	452	1
19	443	59	1
19	443	132	1
19	444	244	1
19	444	454	1
19	444	59	1
19	445	455	1
19	445	38	1
19	445	203	1
19	445	43	1
19	445	59	1
19	445	134	1
19	445	201	1
19	445	11	1
19	447	244	1
19	447	456	1
19	447	59	1
19	447	132	1
19	447	459	1
19	339	43	1
19	339	76	1
19	339	77	1
19	339	201	1
19	454	59	1
19	454	38	1
19	454	85	1
19	454	43	1
19	454	61	1
19	454	68	1
19	454	194	1
19	454	84	1
19	454	33	1
19	454	70	1
19	456	244	1
19	456	59	1
19	456	132	1
19	457	244	1
19	457	456	1
19	457	59	1
19	457	132	1
19	458	244	1
19	458	439	1
19	458	59	1
19	458	461	1
23	461	190	1
23	35	107	1
23	35	108	1
23	463	134	1
23	464	91	1
23	464	463	1
23	465	153	1
23	465	61	1
23	465	43	1
23	465	19	1
23	465	10	1
23	465	70	1
23	87	35	1
23	87	193	1
23	467	155	1
23	467	19	1
23	269	61	1
23	269	68	1
23	269	33	1
23	269	19	1
23	269	464	1
17	400	426	1
17	402	427	1
17	402	429	1
17	402	265	1
20	470	112	1
20	470	41	1
20	470	199	1
20	148	218	1
20	148	76	1
20	149	219	1
20	15	52	1
20	15	53	1
20	15	54	1
20	152	232	3
20	152	233	1
20	152	234	1
20	161	236	1
20	129	1	1
20	129	199	1
20	471	465	1
20	471	466	1
20	471	199	1
20	171	240	1
20	472	467	1
20	472	199	1
20	172	241	1
20	173	32	1
20	173	199	1
20	175	38	1
20	175	247	1
20	189	255	1
20	473	66	1
20	473	276	1
20	473	199	1
20	195	22	1
20	195	200	1
20	196	264	1
20	196	265	1
20	199	266	1
20	199	173	1
20	209	243	1
20	484	474	1
20	484	83	1
20	484	475	1
20	475	468	1
20	475	79	1
20	475	199	1
20	211	270	1
20	211	199	1
20	213	271	1
20	213	109	1
20	213	34	1
20	485	474	1
20	485	476	1
20	485	83	1
20	216	110	1
20	477	470	1
20	477	199	1
20	222	100	1
20	223	414	1
20	223	276	1
20	223	277	1
20	223	416	1
20	223	199	1
20	478	471	1
20	478	199	1
20	232	35	1
20	232	414	1
20	232	416	1
20	232	199	1
20	479	472	1
20	479	199	1
20	234	280	1
20	234	16	1
20	238	282	1
20	238	38	1
20	238	46	1
20	238	288	1
20	52	17	1
20	52	199	1
20	481	325	1
20	481	199	1
20	482	473	1
20	482	199	1
20	251	296	1
20	251	38	1
20	251	297	1
29	87	35	1
29	87	193	1
29	497	486	1
29	497	379	1
29	35	107	1
29	35	108	1
29	15	52	1
29	15	53	1
29	15	54	1
29	251	296	1
29	251	38	1
29	251	297	1
31	554	91	1
31	554	524	1
31	554	8	1
31	554	151	1
31	554	525	1
31	554	526	1
31	554	527	1
31	554	43	1
31	554	528	1
31	554	407	1
31	554	529	1
31	554	163	1
31	554	81	2
31	554	438	1
31	554	153	1
31	554	530	1
31	554	531	1
31	554	532	1
31	147	38	1
31	147	28	1
31	147	199	1
31	147	21	1
31	148	218	1
31	148	76	1
31	149	219	1
31	555	224	1
31	555	533	1
31	555	534	1
31	555	500	1
31	555	535	2
31	555	407	2
31	555	536	2
31	555	537	2
31	555	538	1
31	555	66	1
31	555	539	1
31	555	540	1
31	555	142	1
31	555	541	1
31	555	542	1
31	555	107	1
31	555	543	1
31	555	544	1
31	555	545	1
31	555	546	1
31	555	547	1
31	555	370	1
31	555	548	1
31	555	67	1
31	555	549	1
31	555	187	1
31	555	550	1
31	555	75	1
31	555	183	1
31	555	43	3
31	555	61	1
31	555	551	1
31	555	552	1
15	403	131	1
15	404	121	1
15	404	385	1
15	404	38	1
15	404	48	1
15	410	76	1
15	410	48	1
15	410	77	1
15	202	163	1
15	202	81	1
15	413	121	1
15	413	244	1
15	413	436	1
15	413	390	1
15	413	48	1
15	418	121	1
15	418	244	1
15	418	390	1
15	418	48	1
15	419	38	1
15	419	134	1
15	421	121	1
15	421	244	1
15	421	131	1
15	424	19	1
15	424	81	1
15	424	441	1
15	424	442	1
15	429	358	1
15	429	121	1
15	429	204	1
15	429	53	1
15	429	48	1
15	431	15	1
15	431	277	1
15	431	443	1
15	431	326	1
15	432	361	1
15	432	38	1
15	432	365	1
15	432	81	1
15	432	43	1
15	432	369	1
15	432	21	1
15	432	370	1
15	432	126	1
15	437	320	1
15	437	322	1
15	437	326	1
15	440	29	1
15	440	227	1
15	440	48	1
15	442	448	1
15	442	449	1
15	442	450	1
15	442	451	1
15	442	453	1
15	442	46	1
15	446	121	1
15	446	244	1
15	446	390	1
15	446	48	1
15	446	457	1
15	448	121	1
15	448	38	1
15	448	48	1
15	448	386	1
15	450	121	1
15	450	204	1
15	450	53	1
15	450	390	1
15	450	48	1
15	298	15	2
15	298	155	2
15	298	344	2
15	455	93	1
15	455	365	1
15	239	163	1
15	239	379	1
15	239	453	1
15	239	460	1
15	239	43	1
15	239	81	1
15	242	183	1
15	242	81	1
15	9	227	1
15	9	48	1
15	312	15	1
15	312	155	1
15	312	326	1
24	559	593	1
24	560	594	1
24	492	595	1
24	492	67	1
24	492	38	1
24	492	379	1
24	492	142	1
24	492	46	1
24	492	66	1
24	492	154	1
24	492	69	1
24	492	153	1
24	492	63	1
24	561	596	1
24	223	276	1
24	223	277	1
24	510	597	1
24	510	598	1
24	562	297	1
24	562	38	1
24	562	42	1
24	562	19	1
24	562	81	1
24	562	68	1
24	562	586	1
24	562	33	2
24	562	296	1
24	562	143	1
24	247	32	1
24	247	241	1
24	9	227	1
24	9	48	1
24	565	609	1
24	15	52	1
24	15	53	1
24	15	54	1
24	222	100	1
24	267	612	1
24	267	613	1
24	267	614	1
24	267	81	1
24	267	43	1
24	267	25	1
24	267	615	1
24	267	616	1
24	267	617	1
24	20	66	1
24	20	35	1
24	20	38	1
24	20	67	1
24	566	623	1
24	567	624	1
24	149	219	1
24	189	255	1
24	183	251	1
24	183	207	1
24	183	199	1
24	537	626	1
24	537	627	1
24	537	53	1
24	537	105	1
24	537	628	1
24	26	83	1
24	26	76	1
24	152	232	3
24	152	233	1
24	152	234	1
22	462	155	1
22	462	329	1
22	462	72	1
22	462	19	1
22	462	73	1
22	87	35	1
22	87	193	1
22	466	329	1
22	466	72	1
22	466	19	1
22	466	134	1
22	466	73	1
22	15	52	1
22	15	53	1
22	15	54	1
22	468	155	1
22	468	72	1
22	468	462	1
22	468	457	1
22	468	73	1
22	469	42	1
26	470	112	1
26	470	41	1
26	470	199	1
26	148	218	1
26	148	76	1
26	149	219	1
26	15	52	1
26	15	53	1
26	15	54	1
26	152	232	3
26	152	233	1
26	152	234	1
26	161	236	1
26	129	1	1
26	129	199	1
26	471	465	1
26	471	466	1
26	471	199	1
26	171	240	1
26	472	467	1
26	472	199	1
26	172	241	1
26	173	32	1
26	173	199	1
26	175	38	1
26	175	247	1
26	189	255	1
26	473	66	1
26	473	276	1
26	473	199	1
26	195	22	1
26	195	200	1
26	196	264	1
26	196	265	1
26	199	266	1
26	199	173	1
26	209	243	1
26	474	83	1
26	474	456	1
26	475	468	1
26	475	79	1
26	475	199	1
26	476	469	1
26	476	456	1
26	211	270	1
26	211	199	1
26	213	271	1
26	213	109	1
26	213	34	1
26	216	110	1
26	477	470	1
26	477	199	1
26	222	100	1
26	223	414	1
26	223	276	1
26	223	277	1
26	223	416	1
26	223	199	1
26	478	471	1
26	478	199	1
26	232	35	1
26	232	414	1
26	232	416	1
26	232	199	1
26	479	472	1
26	479	199	1
26	480	171	1
26	480	83	1
26	234	280	1
26	234	16	1
26	238	282	1
26	238	38	1
26	238	46	1
26	238	288	1
26	52	17	1
26	52	199	1
26	481	325	1
26	481	199	1
26	482	473	1
26	482	199	1
26	251	296	1
26	251	38	1
26	251	297	1
26	483	83	1
26	483	333	1
27	173	242	1
27	173	243	1
27	173	32	2
27	238	282	1
27	238	38	1
27	238	46	1
27	238	288	1
27	189	255	1
27	248	35	1
27	248	32	1
27	223	276	1
27	223	277	1
27	171	240	1
27	169	227	1
27	169	199	1
27	172	241	1
27	234	280	1
27	234	16	1
27	195	22	1
27	195	200	1
27	15	52	1
27	15	53	1
27	15	54	1
27	152	232	3
27	152	233	1
27	152	234	1
27	232	35	1
27	175	38	1
27	175	247	1
27	150	219	1
27	150	221	1
27	150	199	1
27	149	219	1
27	209	243	1
27	148	218	1
27	148	76	1
27	251	296	1
27	251	38	1
27	251	297	1
27	222	100	1
27	196	264	1
27	196	265	1
27	539	35	1
27	539	68	1
27	539	33	2
27	539	32	1
27	540	83	1
27	540	516	1
27	183	251	1
27	183	207	1
27	183	199	1
23	269	70	1
23	15	52	1
23	15	53	1
23	15	54	1
25	622	270	1
25	622	199	1
25	365	38	2
25	365	27	1
25	365	257	1
25	365	66	1
25	365	259	1
25	365	208	1
25	365	68	1
25	365	773	1
25	365	276	1
25	365	586	1
25	365	32	1
25	365	84	2
25	365	33	3
25	365	277	1
25	148	218	1
25	148	76	1
25	149	219	1
25	623	38	1
25	623	134	1
25	624	38	1
25	624	33	1
25	624	775	1
25	624	194	1
25	625	473	1
25	625	199	1
25	626	468	1
25	626	79	1
25	626	199	1
25	627	68	1
25	627	84	1
25	627	33	1
25	627	85	1
25	627	32	1
25	627	586	1
25	629	38	1
25	629	676	1
25	630	296	1
25	630	38	1
25	630	43	1
25	630	778	1
25	633	779	1
25	633	79	1
25	633	780	1
25	15	52	1
25	15	53	1
25	15	54	1
25	634	38	1
25	634	227	1
25	635	473	1
25	635	68	1
25	635	33	1
25	635	586	1
25	628	776	1
25	628	215	1
25	628	38	1
25	628	782	1
25	636	66	1
25	636	276	1
25	636	199	1
25	152	232	3
25	152	233	1
25	152	234	1
25	637	325	1
25	637	199	1
25	161	236	1
25	638	208	1
25	641	331	1
25	641	777	1
25	641	53	1
25	641	332	1
25	643	784	1
25	643	38	1
25	171	240	1
25	644	391	1
25	645	785	1
25	189	255	1
25	646	224	1
25	646	786	1
25	647	471	1
25	647	199	1
25	650	35	1
25	650	414	1
25	650	416	1
25	650	199	1
25	651	17	1
25	651	199	1
25	654	467	1
25	654	199	1
25	655	790	1
25	195	22	1
25	195	200	1
25	656	472	1
25	656	199	1
25	657	264	2
25	657	265	2
25	658	68	1
25	658	33	2
25	658	85	1
25	658	32	1
25	659	32	1
25	659	199	1
25	660	791	1
25	660	202	1
25	660	38	1
25	199	266	1
25	199	173	1
25	662	777	1
25	662	53	1
25	662	781	1
25	666	38	1
25	666	795	1
25	667	243	1
25	668	797	1
25	668	43	1
25	668	81	1
25	668	799	1
25	668	800	1
25	668	801	1
25	672	517	1
25	672	805	1
25	672	21	1
25	674	241	1
25	675	1	1
25	675	199	1
25	213	271	1
25	213	109	1
25	213	34	1
25	678	465	1
25	678	466	1
25	678	199	1
25	681	112	1
25	681	41	1
25	681	199	1
25	216	110	1
25	682	470	1
25	682	199	1
25	222	100	1
25	683	808	1
25	683	809	1
25	683	810	1
25	683	11	1
25	26	68	2
25	26	270	1
25	26	33	4
25	26	32	2
25	238	282	1
25	238	38	1
25	238	46	1
25	238	288	1
25	234	280	1
25	234	16	1
28	488	67	1
28	488	11	1
28	489	181	1
28	490	277	1
28	490	479	1
28	491	61	1
28	491	66	1
28	491	186	1
28	491	480	1
28	491	51	1
28	491	481	1
28	35	107	1
28	35	108	1
28	492	153	1
28	492	154	1
28	493	482	1
28	493	483	1
28	87	35	1
28	87	193	1
28	494	15	1
28	494	277	1
28	495	484	1
28	495	485	1
28	15	52	1
28	15	53	1
28	15	54	1
28	496	42	1
28	496	19	1
28	496	480	1
30	498	38	1
30	498	43	1
30	498	76	1
30	498	90	1
30	498	77	1
30	499	121	1
30	499	244	1
30	499	487	1
30	499	90	1
30	500	15	1
30	500	419	1
30	500	19	1
30	35	107	1
30	501	38	1
30	501	76	1
30	501	90	1
30	501	77	1
30	87	35	1
30	87	193	1
30	502	121	1
30	502	244	1
30	502	487	1
30	502	90	1
30	502	457	1
30	503	121	1
30	503	244	1
30	503	488	1
30	503	90	1
30	503	457	1
30	504	171	1
30	505	121	1
30	505	244	1
30	505	488	1
30	505	90	1
30	15	52	1
30	15	53	1
30	15	54	1
32	506	94	1
32	506	489	1
32	506	490	1
32	506	491	1
32	506	190	1
32	507	42	1
32	508	492	2
32	508	125	1
32	508	38	3
32	508	92	2
32	508	93	2
32	508	124	1
32	508	55	2
32	508	493	1
32	508	24	3
32	508	494	1
32	508	190	1
32	508	386	1
32	509	42	1
32	87	35	1
32	87	193	1
32	510	61	1
32	510	68	1
32	510	84	1
32	510	38	1
32	510	43	1
32	510	85	1
32	510	194	1
32	510	70	1
32	511	211	1
32	511	495	1
32	511	46	1
32	511	106	1
32	512	42	1
32	15	52	1
32	15	53	1
32	15	54	1
32	513	76	1
32	513	94	1
32	513	77	1
34	514	35	1
34	514	496	1
34	5	15	1
34	5	13	1
34	5	21	1
34	515	497	1
34	515	498	1
34	515	38	1
34	515	75	1
34	515	499	1
34	35	107	1
34	35	108	1
34	36	111	1
34	36	112	1
34	36	485	1
34	516	208	1
34	516	426	1
34	516	147	1
34	87	35	1
34	87	193	1
34	517	484	1
34	517	66	1
34	517	500	1
34	517	485	1
34	15	52	1
34	15	53	1
34	15	54	1
35	332	13	1
35	332	28	1
35	332	46	1
35	332	70	1
35	403	121	1
35	403	244	1
35	403	428	1
35	403	131	1
35	421	121	1
35	421	244	1
35	421	131	1
35	35	107	1
35	35	108	1
35	518	190	1
35	518	103	1
35	519	501	1
35	519	103	1
35	520	341	1
35	520	502	1
35	521	153	1
35	521	154	1
35	521	103	1
35	15	52	1
35	15	53	1
35	15	54	1
35	522	121	1
35	522	38	1
35	522	131	1
35	87	35	1
35	87	193	1
35	523	323	1
35	523	325	1
35	524	171	1
35	525	69	1
35	525	46	1
35	525	70	1
35	526	171	1
35	527	341	1
35	527	503	1
35	528	341	1
35	528	504	1
35	528	46	1
35	528	505	1
35	529	157	1
36	530	171	1
36	204	162	1
36	204	24	1
36	204	163	1
36	204	43	1
36	204	164	1
36	204	81	1
36	531	506	1
36	531	501	1
36	531	38	1
36	531	105	1
36	226	182	1
36	226	183	1
36	226	81	1
36	35	107	1
36	35	108	1
36	532	79	1
36	532	38	1
36	532	507	1
36	532	105	2
36	532	332	1
36	532	508	1
36	532	509	1
36	532	43	1
36	532	510	1
36	532	252	2
36	126	162	1
36	126	163	1
36	126	43	1
36	126	164	1
36	126	81	1
36	533	121	1
36	533	511	1
36	533	38	1
36	533	105	1
36	140	182	1
36	140	183	1
36	140	81	1
36	534	153	1
36	534	154	1
36	534	105	1
36	145	182	1
36	145	183	1
36	145	81	1
36	535	428	1
36	535	105	1
36	535	252	1
36	535	11	1
36	133	162	1
36	133	163	1
36	133	43	1
36	133	164	1
36	133	81	1
36	15	52	1
36	15	53	1
36	15	54	1
36	87	35	1
36	87	193	1
36	536	24	1
36	536	512	1
36	536	38	1
36	536	43	2
36	536	105	1
36	536	513	1
36	536	134	1
36	536	34	1
36	537	506	1
36	537	501	1
36	537	53	1
36	537	105	1
36	538	514	1
36	538	515	1
36	538	22	1
36	538	43	2
36	538	499	1
36	538	34	1
36	541	2	1
36	541	91	1
36	541	3	1
36	541	43	1
36	541	46	1
36	541	105	1
36	542	514	1
36	542	517	1
36	542	43	1
36	542	499	1
36	542	21	1
36	543	518	1
36	543	43	1
36	543	519	1
36	543	105	1
36	543	520	1
36	543	21	1
36	544	121	1
36	544	38	1
36	544	521	1
36	544	105	1
36	545	121	1
36	545	38	1
36	545	105	1
36	546	38	1
36	546	43	1
36	546	76	1
36	546	104	1
36	546	105	1
36	546	106	1
36	546	77	1
36	546	73	1
36	547	121	1
36	547	38	1
36	547	332	1
36	547	105	1
36	548	279	1
36	548	283	1
36	549	42	1
36	549	105	1
36	550	17	1
36	550	43	1
36	550	521	1
36	551	341	1
36	551	518	1
36	551	43	1
36	551	522	1
36	551	134	1
36	552	333	1
36	553	121	1
36	553	523	1
36	553	38	1
36	553	105	1
37	87	35	1
37	87	193	1
37	589	42	1
37	589	110	1
37	74	35	1
37	74	173	1
37	74	174	1
37	35	107	1
27	211	270	1
27	211	199	1
27	161	236	1
27	213	271	1
27	213	109	1
27	213	34	1
27	247	32	1
27	247	241	1
27	154	199	1
27	199	266	1
27	199	173	1
27	147	38	1
27	147	28	1
27	147	199	1
27	147	21	1
27	216	110	1
43	808	91	1
43	808	215	1
43	808	38	1
43	808	678	1
43	808	81	1
43	16	55	1
43	16	38	1
43	16	56	1
43	809	722	1
43	809	729	1
43	810	870	1
43	810	871	1
43	119	175	1
43	137	872	1
43	137	873	1
43	35	107	1
43	35	108	1
43	186	874	1
43	812	502	2
43	812	38	2
43	812	676	2
43	812	678	2
43	813	320	1
43	813	38	1
43	813	426	1
43	813	124	1
43	813	678	1
43	813	125	1
43	813	322	1
43	26	83	1
43	26	76	1
43	817	35	1
43	817	149	1
43	87	35	1
43	87	193	1
43	818	343	1
43	818	678	1
43	818	38	1
43	818	676	1
43	818	875	1
43	818	332	1
43	818	81	2
43	818	43	3
43	818	876	1
43	818	149	1
43	818	267	1
43	819	877	1
43	819	88	1
43	15	52	1
43	15	53	1
43	15	54	1
62	670	121	1
62	670	304	1
62	670	38	1
62	670	133	1
62	259	304	1
62	259	38	1
62	259	305	1
62	259	133	1
62	35	107	1
62	87	35	1
62	87	193	1
62	1017	1209	1
62	1017	292	1
62	1017	627	1
62	258	301	1
62	258	142	1
62	272	304	1
62	272	301	1
62	272	38	1
62	272	314	1
62	272	133	1
62	15	52	1
62	15	53	1
62	15	54	1
62	304	304	1
62	304	345	1
62	304	38	1
62	304	133	1
62	304	73	1
62	1018	465	1
62	1018	1000	1
62	1018	1210	1
62	1018	1211	1
62	1019	33	2
62	1019	127	1
62	1019	190	1
64	1049	155	1
64	1049	38	1
64	1049	836	1
64	1049	133	1
64	35	107	1
64	35	108	1
64	721	38	1
64	721	836	1
64	721	133	1
64	1050	1256	1
64	1050	38	1
64	1050	836	1
64	1050	133	1
64	87	35	1
64	87	193	1
64	1051	38	1
64	1051	836	1
64	1051	133	1
64	1051	1257	1
64	15	52	1
64	15	53	1
64	15	54	1
64	1052	38	1
64	1052	1258	1
64	1052	836	1
64	1052	133	1
64	1054	1260	1
64	1054	38	1
64	1054	836	1
64	1054	133	1
65	87	35	1
65	87	193	1
65	1060	1268	1
65	1060	291	1
65	1060	43	1
65	35	107	1
65	1061	1268	1
65	1061	178	1
65	15	52	1
65	15	53	1
65	15	54	1
66	1084	456	1
66	1085	71	1
66	1085	42	1
66	1085	1307	2
66	1085	158	1
66	726	244	1
66	726	811	1
66	1086	171	1
66	1087	45	1
66	1087	38	1
66	1087	200	1
66	35	107	1
66	35	108	1
31	555	553	1
31	555	554	1
31	555	526	1
31	555	34	3
31	555	178	2
31	555	555	1
31	555	38	1
31	555	223	1
31	555	556	1
31	555	557	1
31	555	558	1
31	555	559	1
31	555	560	1
31	555	530	1
31	555	561	1
31	555	8	1
31	555	562	1
31	555	438	1
31	555	527	1
31	555	21	2
31	556	563	1
31	556	564	1
31	556	565	1
31	556	566	1
31	556	151	1
31	556	567	1
31	556	568	1
31	556	569	1
31	556	75	2
31	556	61	1
31	556	43	1
31	556	235	1
31	556	528	1
31	556	95	2
31	556	38	4
31	556	570	1
31	556	498	1
31	556	215	1
31	556	28	2
31	556	370	1
31	556	438	4
31	556	571	1
31	556	572	1
31	556	210	1
31	556	573	1
31	556	574	1
31	150	219	1
31	150	221	1
31	150	199	1
31	557	38	1
31	557	530	1
31	557	575	1
31	557	576	1
31	557	43	1
31	557	279	1
31	557	61	1
31	557	80	2
31	557	370	1
31	557	577	1
31	557	528	1
31	61	222	1
31	61	223	1
31	61	224	1
31	61	53	1
31	61	130	1
31	61	225	1
31	61	228	1
31	61	229	1
31	61	230	1
31	61	231	1
31	15	52	1
31	15	53	1
31	15	54	1
31	152	232	3
31	152	233	1
31	152	234	1
31	154	199	1
31	161	236	1
31	24	564	1
31	24	53	2
31	24	578	1
31	24	579	1
31	24	580	1
31	24	581	1
31	24	204	2
31	24	569	1
31	24	233	1
31	24	582	1
31	24	528	1
31	24	135	1
31	24	583	1
31	24	95	1
31	24	38	3
31	24	584	1
31	24	18	1
31	24	80	1
31	24	585	2
31	24	438	1
31	24	586	1
31	24	587	1
31	169	227	1
31	169	199	1
31	171	240	1
31	558	588	1
31	558	589	1
31	558	590	1
31	558	565	1
31	558	280	1
31	558	591	1
31	558	75	1
31	558	96	1
31	558	592	1
31	558	528	1
31	558	235	1
31	558	38	2
31	558	252	1
31	558	599	1
31	558	219	1
31	558	81	1
31	558	101	1
31	558	600	1
31	558	601	1
31	558	46	1
31	563	215	2
31	563	83	1
31	563	602	1
31	563	603	1
31	563	38	3
31	563	537	2
31	563	233	1
31	563	604	1
31	563	605	1
31	563	46	1
31	563	85	1
31	563	525	1
31	563	84	1
31	563	370	2
31	563	606	1
31	564	607	1
31	564	577	1
31	564	608	1
31	564	562	1
31	564	610	1
31	564	606	1
31	564	611	1
31	564	531	1
31	564	618	1
31	564	83	1
31	564	619	1
31	564	620	2
31	564	621	4
31	564	225	1
31	564	230	1
31	564	622	1
31	564	231	1
31	564	135	1
31	564	532	1
31	564	625	6
31	564	516	1
31	564	530	7
31	564	591	4
31	564	215	10
31	564	279	3
31	564	569	6
31	564	553	1
31	564	35	2
31	564	292	1
31	564	630	1
31	564	631	2
31	564	633	1
31	564	634	2
31	564	586	1
31	564	558	1
31	564	635	2
31	564	636	1
31	564	529	1
31	564	638	2
31	564	639	2
31	564	545	3
31	564	640	1
31	564	641	6
31	564	178	2
31	564	566	1
31	564	61	8
31	564	600	2
31	564	557	1
31	564	43	15
31	564	564	6
31	564	210	7
31	564	19	1
31	564	643	1
31	564	280	1
31	564	582	1
31	564	252	2
31	564	644	2
31	564	645	2
31	564	603	1
31	564	332	1
31	564	555	1
31	564	535	2
31	564	21	3
31	564	646	2
31	564	97	1
31	564	561	1
31	564	581	1
31	564	112	1
31	564	652	4
31	564	221	1
31	564	526	2
31	564	48	1
31	564	539	1
31	564	7	2
31	564	8	2
31	564	654	1
31	564	534	1
31	564	551	2
31	564	655	3
31	564	656	2
31	564	657	2
31	564	547	1
31	564	46	7
31	564	658	1
31	564	528	18
31	564	659	1
31	564	660	2
31	564	256	2
31	564	661	3
31	564	543	1
31	564	662	2
31	564	602	1
31	564	142	1
31	564	664	2
31	564	665	2
31	564	666	1
31	564	667	1
31	564	668	1
31	564	571	1
31	564	669	2
31	564	670	1
31	564	187	1
31	564	371	1
31	564	283	4
31	564	574	1
31	564	552	1
31	564	536	2
31	564	540	1
31	564	572	1
31	564	496	2
31	564	677	2
31	564	542	1
31	564	679	2
31	564	416	2
31	564	75	6
31	564	680	1
31	564	183	1
31	564	556	1
31	564	570	1
31	564	151	5
31	564	682	2
31	564	683	1
31	564	684	2
31	564	208	1
31	564	537	9
31	564	589	1
31	564	306	1
31	564	379	3
31	564	260	1
31	564	685	1
31	564	527	4
31	564	538	1
31	564	11	6
31	564	224	3
31	564	688	2
31	564	438	16
31	564	546	1
31	564	689	1
31	564	548	1
31	564	549	1
31	564	592	1
31	564	53	3
31	564	550	1
31	564	690	2
31	564	691	2
31	564	163	1
31	564	694	1
31	564	223	2
31	564	697	1
31	564	698	1
31	564	233	5
31	564	155	1
31	564	533	1
31	564	699	2
31	564	583	1
31	564	235	5
31	564	700	1
31	564	34	8
31	564	146	2
31	564	370	8
31	564	107	1
31	564	554	1
31	564	704	2
31	564	573	1
31	564	601	1
31	564	604	1
31	564	705	1
31	564	706	1
31	564	707	2
31	564	38	26
31	564	81	3
31	564	559	1
31	564	560	1
31	564	67	1
31	564	541	1
31	564	228	2
24	568	629	1
24	521	153	1
24	521	154	1
24	521	105	1
24	521	103	1
24	569	632	1
24	569	38	1
24	569	332	1
24	569	105	1
24	569	637	1
24	232	35	1
24	248	35	1
24	248	32	1
24	213	271	1
24	213	109	1
24	213	34	1
24	428	642	1
24	428	191	1
24	428	46	1
24	428	647	1
24	161	236	1
24	570	648	1
24	570	585	1
24	570	359	1
24	570	649	1
24	570	650	1
24	570	103	1
24	570	651	1
24	570	360	1
24	571	15	1
24	571	653	1
24	571	277	1
24	571	38	1
24	571	148	1
24	571	200	1
24	209	243	1
24	216	110	1
24	534	153	1
24	534	154	1
24	534	69	1
24	534	179	1
24	534	105	1
24	572	663	1
24	88	153	1
24	88	154	1
24	88	69	1
24	88	59	1
24	88	179	1
24	573	319	1
24	573	671	1
24	573	672	1
24	573	673	1
24	573	287	1
24	573	674	1
24	574	675	1
24	574	48	1
24	45	92	1
24	45	27	1
24	45	93	1
24	45	35	1
24	45	38	2
24	45	676	1
24	45	678	1
24	150	219	1
24	150	221	1
24	150	199	1
24	575	119	1
24	575	35	1
24	575	43	1
24	575	681	1
24	575	369	1
24	576	686	1
24	577	687	1
24	196	264	1
24	196	265	1
24	154	199	1
24	578	692	1
24	578	693	1
24	578	130	1
24	169	227	1
24	169	199	1
24	199	266	1
24	199	173	1
24	579	695	1
24	195	22	1
24	195	200	1
24	580	297	1
24	580	38	1
24	580	42	1
24	580	19	1
24	580	81	1
24	580	68	1
24	580	153	1
24	580	33	2
24	580	296	1
24	580	143	1
24	580	696	1
24	175	38	1
24	175	247	1
24	581	35	1
24	581	139	1
24	582	701	1
24	583	702	1
24	583	683	1
24	583	178	1
24	148	218	1
24	148	76	1
24	62	153	1
24	62	154	1
24	584	437	1
24	584	69	1
24	584	703	1
24	234	280	1
24	234	16	1
24	585	178	1
24	585	38	1
24	585	148	1
24	585	3	1
24	585	46	1
24	585	713	1
24	585	61	1
24	585	252	1
24	585	715	1
24	251	296	1
24	251	38	1
24	251	297	1
24	586	718	1
24	586	719	1
24	586	178	1
24	586	634	1
24	586	148	1
24	586	721	1
24	586	3	1
24	586	46	2
24	586	713	1
24	586	11	1
24	586	715	1
24	147	38	1
24	147	28	1
24	147	199	1
24	147	21	1
24	587	722	1
24	587	724	2
24	587	725	1
24	587	726	1
24	587	81	1
24	587	727	1
24	587	729	1
24	587	325	1
24	587	733	1
24	239	215	1
24	239	453	1
24	239	38	1
24	239	148	1
24	239	379	1
24	239	43	1
24	239	21	1
31	564	708	2
31	564	580	1
31	564	80	3
31	564	709	2
31	564	710	2
31	564	711	2
31	564	95	1
31	564	219	4
31	564	712	2
31	564	587	1
31	564	714	2
31	564	716	1
31	564	717	2
31	564	271	3
31	564	584	1
31	564	407	3
31	564	31	4
31	564	720	1
31	564	222	1
31	564	565	3
31	564	723	1
31	564	728	1
31	564	563	1
31	564	524	1
31	564	730	4
31	564	731	1
31	564	578	1
31	564	579	1
31	564	732	1
31	564	734	1
31	564	229	1
31	564	567	1
31	564	568	1
31	564	153	1
31	564	736	2
31	564	477	1
31	564	737	2
31	564	738	1
31	564	130	2
31	564	544	1
31	564	18	2
31	564	739	1
31	564	498	1
31	564	742	1
31	564	525	4
31	564	743	1
31	564	744	2
31	564	745	1
31	591	35	1
31	591	84	1
31	591	38	1
31	591	227	1
31	172	241	1
31	592	111	1
31	592	112	1
31	592	621	1
31	596	215	1
31	596	219	1
31	596	564	1
31	596	151	1
31	596	697	1
31	596	537	1
31	596	641	1
31	596	661	1
31	596	208	1
31	596	622	1
31	596	525	1
31	596	370	1
31	596	744	1
31	596	694	1
31	596	670	1
31	601	38	2
31	601	530	1
31	601	564	1
31	601	566	2
31	601	641	1
31	601	758	2
31	601	734	1
31	601	643	1
31	601	35	1
31	601	61	1
31	601	525	1
31	601	75	2
31	601	438	2
31	601	370	1
31	601	528	1
31	604	38	1
31	604	75	1
31	604	76	1
31	604	77	1
31	173	66	1
31	173	228	1
31	173	243	1
31	173	76	1
31	173	641	1
31	173	242	1
31	173	155	1
31	173	233	1
31	173	75	3
31	173	527	1
31	173	43	4
31	173	32	2
31	173	551	1
31	173	500	1
31	173	38	2
31	173	260	1
31	173	163	1
31	173	34	1
31	173	271	1
31	173	438	1
31	173	153	1
31	173	77	1
31	173	680	1
31	173	532	1
31	173	618	1
31	173	84	2
31	173	604	1
31	173	619	1
31	173	46	1
31	173	764	1
31	173	27	2
31	173	371	1
31	605	155	1
31	605	371	1
31	605	84	1
31	605	33	1
31	605	765	1
31	175	38	1
31	175	247	1
31	183	251	1
31	183	207	1
31	183	199	1
31	189	255	1
31	606	155	1
31	606	371	1
31	606	84	1
31	606	33	1
31	606	527	1
31	607	153	1
31	607	527	1
31	607	532	1
31	608	155	1
31	608	371	1
31	608	33	2
31	608	765	1
31	609	112	1
31	609	379	1
31	609	537	1
31	609	233	1
31	609	731	1
31	609	53	1
31	609	640	1
31	609	370	1
31	609	276	1
31	609	633	1
31	609	659	1
31	609	766	1
24	239	70	1
24	239	460	1
24	171	240	1
24	588	735	1
24	211	270	1
24	211	199	1
24	454	68	1
24	454	33	1
24	454	69	1
24	454	262	1
24	454	32	1
24	454	59	1
24	454	123	1
24	454	30	1
24	238	282	1
24	238	38	1
24	238	46	1
24	238	288	1
24	420	38	1
24	420	55	1
24	420	46	1
24	420	19	1
24	420	138	1
24	420	28	1
24	420	437	1
24	420	61	1
24	420	68	1
24	420	438	1
24	420	33	2
24	420	140	1
24	173	242	1
24	173	243	1
24	173	32	2
24	593	746	1
24	594	652	1
24	594	125	1
24	594	747	1
24	594	748	1
24	594	124	1
24	594	46	1
24	594	749	1
24	594	119	1
24	594	750	1
24	594	327	1
24	595	751	1
24	597	752	1
24	597	38	1
24	597	753	1
24	597	332	1
24	597	105	1
24	598	754	1
24	172	241	1
24	599	38	1
24	599	499	1
24	599	140	1
24	599	105	1
24	600	755	1
24	602	38	1
24	602	756	1
24	602	332	1
24	602	105	1
24	603	757	1
24	190	27	1
24	190	726	1
24	190	437	1
24	190	671	1
24	190	733	1
24	190	674	1
24	190	595	1
24	190	119	1
24	190	103	1
24	190	19	1
24	190	215	1
24	190	105	1
24	190	724	2
24	190	70	1
24	190	66	1
24	190	759	1
24	190	59	1
24	190	93	1
24	190	760	1
24	190	142	1
24	190	749	1
24	190	727	2
24	190	379	1
24	190	138	1
24	190	69	4
24	190	84	1
24	190	327	1
24	190	33	1
24	190	67	1
24	190	123	1
24	190	63	1
24	190	761	1
24	190	125	1
24	190	7	1
24	190	148	1
24	190	179	1
24	190	325	1
24	190	38	4
24	190	81	2
24	190	277	1
24	190	672	1
24	190	762	1
24	190	124	1
24	190	46	3
24	190	140	1
24	190	92	1
24	190	48	1
24	190	55	1
24	190	763	1
24	190	287	1
24	190	725	1
24	190	21	1
49	857	1088	1
49	857	729	1
49	470	112	1
49	470	41	1
49	470	199	1
49	148	218	1
49	148	76	1
49	149	219	1
49	858	1089	1
49	859	891	1
49	859	273	1
49	859	38	1
49	859	1090	1
49	859	1091	1
49	15	52	1
49	15	53	1
49	15	54	1
49	860	842	1
49	860	204	1
49	152	232	3
49	152	233	1
49	152	234	1
49	161	236	1
49	129	1	1
49	129	199	1
49	171	240	1
49	471	465	1
49	471	466	1
49	471	199	1
49	472	467	1
49	472	199	1
49	172	241	1
49	861	1093	1
49	173	32	1
49	173	199	1
49	175	38	1
49	175	247	1
49	862	61	1
49	862	82	1
49	862	83	1
49	862	269	1
49	862	468	1
49	862	1097	1
37	35	108	1
37	15	52	1
37	15	53	1
37	15	54	1
37	590	740	1
37	590	547	1
37	590	741	1
39	355	244	1
39	355	391	1
39	355	390	1
39	355	48	1
39	413	244	1
39	413	436	1
39	413	390	1
39	413	48	1
39	434	444	1
39	434	244	1
39	434	59	1
39	545	38	1
39	545	105	1
39	663	792	1
39	663	793	1
39	663	794	1
39	663	360	1
39	347	244	1
39	347	327	1
39	347	390	1
39	347	48	1
39	665	793	1
39	665	38	1
39	665	105	1
39	665	796	1
39	665	360	1
39	669	793	1
39	669	798	1
39	669	360	1
39	91	38	1
39	91	196	1
39	670	304	1
39	670	38	1
39	670	133	1
39	671	38	2
39	671	802	2
39	671	803	2
39	673	804	1
39	673	793	1
39	673	168	1
39	673	360	1
39	676	138	1
39	676	244	1
39	676	140	1
39	677	806	1
39	677	38	1
39	677	179	1
39	679	128	1
39	679	38	1
39	679	188	1
39	522	38	1
39	522	131	1
39	174	244	1
39	174	245	1
39	433	244	1
39	433	439	1
39	433	59	1
39	680	244	1
39	680	257	1
39	680	120	1
39	680	807	1
39	129	1	4
39	129	38	4
39	129	19	4
39	129	213	4
39	129	81	4
39	685	120	1
39	685	38	1
39	685	179	1
39	418	244	1
39	418	390	1
39	418	48	1
39	686	244	1
39	686	811	1
39	686	189	1
39	547	38	1
39	547	332	1
39	547	105	1
39	687	38	1
39	687	812	1
39	687	179	1
39	689	793	1
39	689	794	1
39	689	813	1
39	689	360	1
39	690	793	1
39	690	384	1
39	690	168	1
39	690	360	1
39	691	793	1
39	691	794	1
39	691	360	1
39	249	291	2
39	499	244	1
39	499	487	1
39	499	90	1
39	692	35	1
39	692	277	1
39	692	84	1
39	692	38	1
39	692	85	1
39	692	814	1
39	448	38	1
39	448	48	1
39	448	386	1
39	345	244	1
39	345	385	1
39	345	382	1
39	693	793	1
39	693	815	1
39	693	816	1
39	693	360	1
39	694	244	1
39	694	817	1
39	694	818	1
39	695	128	1
39	695	38	1
39	695	819	1
39	696	1	1
39	696	820	1
39	696	821	1
39	696	360	1
39	697	793	1
39	697	822	1
39	697	823	1
39	697	360	1
39	426	244	1
39	426	226	1
39	426	439	1
39	426	59	1
39	698	244	1
39	698	120	1
39	699	793	1
39	699	824	1
39	699	360	1
39	700	793	1
39	700	384	1
39	700	823	1
39	700	360	1
39	701	38	1
39	701	803	1
39	702	244	1
39	702	185	1
39	116	177	1
39	116	38	1
39	703	1	1
39	703	825	1
39	703	821	1
39	703	360	1
39	403	244	1
31	195	22	1
31	195	200	1
31	196	264	1
31	196	265	1
31	199	266	1
31	199	173	1
31	209	243	1
31	610	153	1
31	610	532	1
31	610	765	1
31	611	306	1
31	611	97	1
31	611	233	1
31	611	658	1
31	611	732	1
31	611	310	1
31	611	591	1
31	611	146	2
31	611	35	1
31	611	730	1
31	611	738	1
31	611	210	1
31	611	528	1
31	612	155	1
31	612	371	1
31	612	33	2
31	612	527	1
31	211	270	1
31	211	199	1
31	613	215	1
31	613	569	1
31	613	728	1
31	613	739	1
31	613	151	1
31	613	621	1
31	613	636	1
31	613	43	1
31	613	689	1
31	613	438	1
31	613	48	1
31	613	744	2
31	613	668	1
31	213	271	1
31	213	109	1
31	213	34	1
31	216	110	1
31	36	112	1
31	36	659	1
31	36	767	1
31	36	113	1
31	36	233	1
31	222	100	1
31	223	276	1
31	223	277	1
31	614	215	1
31	614	611	1
31	614	38	1
31	614	716	1
31	614	516	1
31	614	621	1
31	614	591	1
31	614	61	1
31	614	730	1
31	614	768	1
31	614	252	1
31	614	11	1
31	614	528	1
31	232	35	1
31	615	569	1
31	615	720	1
31	615	38	1
31	615	743	1
31	615	630	1
31	615	224	1
31	615	769	1
31	615	591	1
31	615	81	1
31	615	770	1
31	615	438	1
31	615	685	1
31	615	600	1
31	615	477	1
31	615	698	1
31	615	705	1
31	238	282	1
31	238	38	1
31	238	46	1
31	238	288	1
31	234	280	1
31	234	16	1
31	247	32	1
31	247	241	1
31	616	296	1
31	616	219	1
31	616	79	1
31	616	221	1
31	248	35	1
31	248	32	1
31	617	279	1
31	617	11	1
31	617	565	1
31	617	21	1
31	617	683	1
31	617	641	1
31	617	75	1
31	617	742	1
31	617	38	2
31	617	655	1
31	617	332	1
31	617	219	1
31	617	537	1
31	617	215	1
31	617	271	1
31	617	745	1
31	617	607	1
31	617	694	1
31	617	283	1
31	618	706	1
31	618	215	1
31	618	219	1
31	618	271	1
31	618	38	1
31	618	53	1
31	618	610	1
31	618	210	1
31	618	528	1
31	619	163	1
31	619	33	2
31	619	81	1
31	619	396	1
31	619	190	1
31	619	199	1
31	619	527	1
31	619	220	1
31	251	296	1
31	251	38	1
31	251	297	1
38	470	112	1
38	470	41	1
38	470	199	1
38	148	218	1
38	148	76	1
38	149	219	1
38	620	27	1
38	620	38	1
38	620	190	1
38	621	215	1
38	621	38	1
38	621	771	1
38	621	772	1
38	621	774	1
38	15	52	1
38	15	53	1
38	15	54	1
38	628	776	1
38	628	215	1
38	628	38	1
38	152	232	3
38	152	233	1
38	152	234	1
38	161	236	1
38	129	1	1
38	129	199	1
38	631	414	1
38	631	276	1
38	631	277	1
38	631	416	1
38	631	199	1
38	171	240	1
38	632	777	1
38	632	53	1
38	632	259	1
38	632	781	1
38	632	267	1
38	471	465	1
38	471	466	1
38	471	199	1
38	472	467	1
38	472	199	1
38	172	241	1
38	639	783	1
38	639	147	1
38	173	32	1
38	173	199	1
38	640	331	1
38	640	777	1
38	640	53	1
38	640	332	1
38	175	38	1
38	175	247	1
38	189	255	1
38	473	66	1
38	473	276	1
38	473	199	1
38	195	22	1
38	195	200	1
38	642	135	1
38	642	46	1
38	642	352	1
38	196	264	1
38	196	265	1
38	648	784	1
38	648	787	1
38	649	143	1
38	649	636	1
38	649	591	1
38	649	438	1
38	649	788	1
38	199	266	1
38	199	173	1
38	209	243	1
38	387	38	1
38	387	676	1
38	652	279	1
38	652	283	1
38	653	473	1
38	653	257	1
38	653	789	1
38	653	467	1
38	653	32	1
38	653	259	3
38	653	267	1
38	475	468	1
38	475	79	1
38	475	199	1
38	211	270	1
38	211	199	1
38	213	271	1
38	213	109	1
38	213	34	1
38	216	110	1
38	477	470	1
38	477	199	1
38	222	100	1
38	661	66	1
38	661	773	1
38	661	277	1
38	661	276	1
38	661	38	1
38	478	471	1
38	478	199	1
38	664	780	1
38	664	80	1
38	26	68	1
38	26	33	2
38	26	85	1
38	26	32	1
38	232	35	1
38	232	414	1
38	232	416	1
38	232	199	1
38	479	472	1
38	479	199	1
38	238	282	1
38	238	38	1
38	238	46	1
38	238	288	1
38	234	280	1
38	234	16	1
38	52	17	1
38	52	199	1
38	481	325	1
38	481	199	1
38	482	473	1
38	482	199	1
38	251	296	1
38	251	38	1
38	251	297	1
40	790	842	1
40	790	204	1
40	791	868	1
40	470	112	1
40	470	41	1
40	470	199	1
40	148	218	1
40	148	76	1
40	149	219	1
40	792	469	1
40	792	456	1
40	15	52	1
40	15	53	1
40	15	54	1
40	152	232	3
40	152	233	1
40	152	234	1
40	793	269	1
40	793	850	1
40	161	236	1
40	129	1	1
40	129	199	1
40	794	83	1
40	794	456	1
40	171	240	1
40	471	465	1
40	471	466	1
40	471	199	1
40	795	83	1
40	795	456	1
40	472	467	1
40	472	199	1
40	172	241	1
40	173	32	1
40	173	199	1
40	175	38	1
40	175	247	1
40	189	255	1
40	796	869	1
40	797	83	1
40	797	333	1
40	798	171	1
40	798	83	1
40	473	66	1
40	473	276	1
40	473	199	1
25	684	414	1
25	684	276	1
25	684	277	1
25	684	416	1
25	684	199	1
25	688	38	1
25	688	247	1
25	251	296	1
25	251	38	1
25	251	297	1
41	709	829	1
41	709	19	1
41	709	830	1
41	709	831	1
41	710	171	1
41	35	107	1
41	35	108	1
41	711	244	1
41	711	120	1
41	711	807	1
41	712	27	1
41	712	235	1
41	712	38	1
41	712	43	1
41	712	831	1
41	698	244	1
41	698	120	1
41	87	35	1
41	87	193	1
41	282	38	1
41	282	43	1
41	282	76	1
41	282	77	1
41	282	47	1
41	715	456	1
41	680	244	1
41	680	257	1
41	680	120	1
41	680	807	1
41	15	52	1
41	15	53	1
41	15	54	1
41	339	43	1
41	339	76	1
41	339	77	1
41	339	201	1
41	717	244	1
41	717	120	1
41	717	189	1
42	470	112	1
42	470	41	1
42	470	199	1
42	148	218	1
42	148	76	1
42	149	219	1
42	734	83	1
42	734	456	1
42	15	52	1
42	15	53	1
42	15	54	1
42	735	469	1
42	735	456	1
42	152	232	3
42	152	233	1
42	152	234	1
42	737	83	1
42	737	456	1
42	161	236	1
42	738	83	1
42	738	456	1
42	129	1	1
42	129	199	1
42	739	842	1
42	739	204	1
42	171	240	1
42	471	465	1
42	471	466	1
42	471	199	1
42	740	842	1
42	740	204	1
42	741	107	1
42	742	843	1
42	472	467	1
42	472	199	1
42	172	241	1
42	744	844	1
42	744	210	1
42	173	32	1
42	173	199	1
42	745	845	1
42	175	38	1
42	175	247	1
42	189	255	1
42	48	469	1
42	48	456	1
42	473	66	1
42	473	276	1
42	473	199	1
42	748	846	1
42	195	22	1
42	195	200	1
42	196	264	1
42	196	265	1
42	199	266	1
42	199	173	1
42	750	107	1
42	209	243	1
42	752	845	1
42	754	843	1
42	475	468	1
42	475	79	1
42	475	199	1
42	211	270	1
42	211	199	1
42	756	846	1
42	213	271	1
42	213	109	1
42	213	34	1
42	216	110	1
42	757	83	1
42	757	456	1
42	477	470	1
42	477	199	1
42	759	83	1
42	759	456	1
42	222	100	1
42	223	414	1
42	223	276	1
42	223	277	1
42	223	416	1
42	223	199	1
42	478	471	1
42	478	199	1
42	232	35	1
42	232	414	1
42	232	416	1
42	232	199	1
42	479	472	1
42	479	199	1
42	238	282	1
42	238	38	1
42	238	46	1
42	238	288	1
42	234	280	1
42	234	16	1
42	764	83	1
42	764	456	1
42	52	17	1
42	52	199	1
42	481	325	1
42	481	199	1
42	766	269	1
42	766	850	1
42	482	473	1
42	482	199	1
42	251	296	1
42	251	38	1
39	403	428	1
39	403	131	1
39	106	128	1
39	106	23	1
39	106	38	1
39	704	244	1
39	704	681	1
39	704	140	1
39	427	244	1
39	427	440	1
39	427	59	1
39	705	244	1
39	705	826	1
39	705	1	1
39	705	827	1
39	341	244	1
39	341	382	1
39	108	177	1
39	108	38	1
39	108	206	1
39	315	358	1
39	315	359	1
39	315	360	1
39	706	244	1
39	706	189	1
39	706	140	1
39	707	793	1
39	707	828	1
39	707	823	1
39	707	360	1
39	708	244	1
39	708	826	1
39	708	1	1
39	708	832	1
39	362	38	1
39	362	48	1
39	89	38	1
39	89	195	1
39	89	179	1
39	713	128	1
39	713	833	1
39	713	38	1
39	503	244	1
39	503	488	1
39	503	90	1
39	503	457	1
39	714	38	1
39	714	132	1
39	716	793	1
39	716	168	1
39	716	360	1
39	717	244	1
39	717	120	1
39	717	189	1
39	425	244	1
39	425	189	1
39	425	59	1
39	718	793	1
39	718	798	1
39	718	834	1
39	718	360	1
39	719	244	1
39	719	811	1
39	719	835	1
39	720	244	1
39	720	826	1
39	720	1	1
39	720	821	1
39	721	38	1
39	721	836	1
39	721	133	1
39	722	793	1
39	722	837	1
39	722	824	1
39	722	360	1
39	37	114	2
39	37	115	2
39	723	244	1
39	723	817	1
39	724	244	1
39	724	105	1
39	725	244	1
39	725	140	1
39	725	457	1
39	726	244	1
39	726	811	1
39	502	244	1
39	502	487	1
39	502	90	1
39	502	457	1
39	727	793	1
39	727	838	1
39	727	824	1
39	727	360	1
39	404	385	1
39	404	38	1
39	404	48	1
39	401	418	1
39	401	38	1
39	401	48	1
39	421	244	1
39	421	131	1
39	438	244	1
39	438	446	1
39	438	59	1
39	728	244	1
39	728	811	1
39	728	827	1
39	729	839	1
39	729	38	1
39	729	179	1
39	730	793	1
39	730	823	1
39	730	360	1
39	731	433	2
39	193	38	1
39	193	245	1
39	84	38	1
39	84	189	1
39	84	179	1
39	732	840	2
39	732	38	2
39	732	803	2
39	447	244	1
39	447	456	1
39	447	59	1
39	447	132	1
39	447	459	1
39	733	244	1
39	733	140	1
39	458	244	1
39	458	439	1
39	458	59	1
39	458	461	1
39	736	841	1
39	736	38	1
39	736	179	1
39	743	793	1
39	743	507	1
39	743	360	1
39	746	516	2
39	747	244	1
39	747	811	1
39	747	457	1
39	409	433	1
39	409	244	1
39	409	59	1
39	443	244	1
39	443	452	1
39	443	59	1
39	443	132	1
39	749	178	1
39	749	38	1
39	446	244	1
39	446	390	1
39	446	48	1
39	446	457	1
39	751	847	1
39	751	793	1
39	751	360	1
39	753	793	1
39	753	815	1
39	753	360	1
39	755	848	1
39	755	793	1
39	755	360	1
39	711	244	1
39	711	120	1
39	711	807	1
39	758	38	1
39	758	129	1
39	760	244	1
39	760	168	1
39	760	105	1
39	553	523	1
39	553	38	1
39	553	105	1
39	761	793	1
39	761	849	1
39	761	823	1
39	761	360	1
39	346	244	1
39	346	382	1
39	346	386	1
39	762	850	1
39	763	793	2
39	763	851	2
39	763	585	2
39	763	852	2
39	763	853	2
39	763	854	2
39	763	360	2
39	436	244	1
39	436	445	1
39	436	439	1
39	436	59	1
39	765	38	1
39	765	48	1
39	765	855	1
39	767	38	1
39	767	133	1
39	441	244	1
39	441	59	1
39	31	114	2
39	768	244	1
39	768	1	1
39	768	856	1
39	456	244	1
39	456	59	1
39	456	132	1
39	770	244	1
39	770	826	1
39	770	1	1
39	771	38	1
39	771	457	1
39	771	802	1
39	771	803	1
39	261	128	1
39	261	38	1
39	261	307	1
39	772	793	1
39	772	857	1
39	772	798	1
39	772	360	1
39	773	38	1
39	773	158	1
39	773	179	1
39	774	128	1
39	774	38	1
39	775	858	1
39	775	244	1
39	775	811	1
39	775	859	1
39	457	244	1
39	457	456	1
39	457	59	1
39	457	132	1
39	776	792	1
39	776	793	1
39	776	168	1
39	776	360	1
39	544	38	1
39	544	521	1
39	544	105	1
39	777	38	1
39	777	860	1
39	777	158	1
39	777	179	1
39	778	793	4
39	778	851	4
39	778	585	4
39	778	861	4
39	778	853	4
39	778	862	4
39	778	360	4
39	779	310	2
39	780	793	1
39	780	863	1
39	780	823	1
39	780	360	1
39	533	511	1
39	533	38	1
39	533	105	1
39	781	292	2
39	781	416	2
39	439	447	1
39	439	244	1
39	439	59	1
39	782	1	1
39	782	821	1
39	782	360	1
39	505	244	1
39	505	488	1
39	505	90	1
39	783	806	1
39	783	38	1
39	783	179	1
39	783	457	1
39	103	38	1
39	103	179	1
39	784	848	1
39	784	793	1
39	784	384	1
39	784	360	1
39	373	244	1
39	373	390	1
39	373	48	1
39	373	399	1
39	785	793	1
39	785	864	1
39	785	360	1
39	444	244	1
39	444	454	1
39	444	59	1
39	382	244	1
39	382	418	1
39	382	48	1
39	36	112	1
39	36	659	1
39	36	865	1
39	36	233	1
39	786	866	1
39	786	38	1
39	786	179	1
39	787	840	1
39	787	38	1
39	787	457	1
39	787	803	1
39	788	832	1
39	788	214	1
39	788	360	1
39	589	109	1
39	589	110	1
39	789	793	1
42	251	297	1
42	769	269	1
42	769	850	1
44	820	171	1
44	821	38	1
44	821	401	1
44	821	133	1
44	35	107	1
44	35	108	1
44	822	121	1
44	822	38	1
44	822	133	1
44	87	35	1
44	87	193	1
44	823	172	1
44	824	456	1
44	258	38	1
44	258	142	1
44	258	133	1
44	825	38	1
44	825	878	1
44	825	133	1
44	15	52	1
44	15	53	1
44	15	54	1
46	837	890	1
46	837	891	1
46	837	779	2
46	837	892	1
46	837	893	2
46	837	894	4
46	837	895	1
46	837	896	1
46	837	897	4
46	837	898	1
46	837	899	1
46	837	900	1
46	837	712	16
46	837	901	4
46	837	902	1
46	837	903	1
46	837	904	1
46	837	151	3
46	837	905	1
46	837	906	1
46	837	907	1
46	837	908	1
46	837	68	1
46	837	909	1
46	837	31	1
46	837	910	1
46	837	84	1
46	837	911	1
46	837	33	1
46	837	912	1
46	837	913	1
46	837	914	1
46	837	43	1
46	837	915	1
46	837	916	1
46	837	917	1
46	837	34	2
46	837	918	1
46	837	81	1
46	837	919	1
46	837	920	1
46	837	46	7
46	837	921	1
46	837	922	1
46	837	923	1
46	837	71	1
46	837	924	1
46	840	124	2
46	840	925	1
46	840	926	1
46	840	927	1
46	840	928	1
46	840	929	1
46	840	43	2
46	840	930	1
46	840	931	1
46	840	38	1
46	840	34	2
46	840	932	1
46	840	63	1
46	840	125	2
46	840	933	2
46	840	903	5
46	840	68	1
46	840	31	1
46	840	84	1
46	840	33	1
46	841	293	1
46	841	29	1
46	841	934	1
46	841	46	1
46	841	294	1
46	841	34	1
46	842	80	1
46	842	935	1
46	842	936	2
46	842	308	1
46	842	937	3
46	842	124	2
46	842	38	1
46	842	938	1
46	842	939	1
46	842	941	4
46	842	942	1
46	842	55	2
46	842	388	1
46	842	943	1
46	842	945	1
46	842	386	4
46	842	946	1
46	842	947	3
46	842	73	3
46	842	948	1
46	842	949	1
46	842	952	1
46	842	503	2
46	842	953	1
46	842	155	4
46	842	954	4
46	842	955	1
46	842	956	1
46	842	957	1
46	842	292	5
46	842	958	8
46	842	305	1
46	842	959	6
46	842	960	1
46	842	314	1
46	842	961	1
46	842	962	1
46	842	963	1
46	842	61	1
46	842	964	6
46	842	965	2
46	842	931	1
46	842	966	1
46	842	235	4
46	842	908	1
46	842	967	1
46	842	968	3
46	842	969	1
46	842	970	1
46	842	971	1
46	842	34	6
46	842	406	3
46	842	972	1
46	842	424	1
46	842	973	2
46	842	974	1
46	842	28	1
46	842	130	2
46	842	975	2
39	789	168	1
39	789	867	1
39	789	360	1
45	826	319	1
45	826	879	1
45	827	880	1
45	827	881	1
45	22	71	1
45	22	72	1
45	22	73	1
45	35	107	1
45	35	108	1
45	828	190	1
45	828	123	1
45	829	880	1
45	829	882	1
45	15	52	1
45	15	53	1
45	15	54	1
45	830	883	1
45	830	132	1
45	87	35	1
45	87	193	1
45	831	512	1
45	831	123	1
45	134	8	1
45	134	163	1
45	832	884	1
45	419	38	1
45	419	134	1
45	833	885	1
45	833	123	1
45	573	319	1
45	573	673	1
45	208	8	1
45	208	183	1
45	834	886	1
45	834	46	1
45	834	132	1
45	834	879	1
45	305	15	1
45	305	38	1
45	305	19	1
45	305	47	1
45	835	887	1
45	835	285	1
45	835	888	1
45	836	880	1
45	836	889	1
45	836	46	1
45	836	556	1
45	838	290	1
45	838	72	1
45	275	318	1
45	275	319	1
45	839	866	1
45	839	501	1
45	839	43	1
45	839	187	1
47	77	197	1
47	77	33	2
47	77	527	1
47	843	197	1
47	843	84	1
47	843	33	1
47	843	262	1
47	843	527	1
47	844	259	1
47	844	342	1
47	845	268	1
47	845	84	1
47	845	940	1
47	845	259	1
47	846	269	1
47	847	648	1
47	847	181	1
47	848	944	1
47	848	819	1
47	848	950	1
47	848	951	1
48	299	61	1
48	299	84	1
48	299	33	1
48	299	48	1
48	872	190	1
48	873	842	1
48	873	204	1
48	223	276	1
48	223	277	1
48	445	455	1
48	445	203	1
48	445	59	1
48	445	201	1
48	445	11	1
48	874	784	1
48	874	38	1
48	874	43	1
48	874	18	1
48	875	1103	1
48	875	24	1
48	875	33	2
48	875	46	1
48	875	1108	1
48	875	527	1
48	876	522	1
48	876	103	1
48	877	127	1
48	878	306	1
48	878	308	1
48	15	52	1
48	15	53	1
48	15	54	1
48	222	100	1
48	879	842	1
48	879	204	1
48	149	219	1
48	189	255	1
48	387	38	1
48	387	676	1
48	26	68	1
48	26	33	2
48	26	85	1
48	26	32	1
48	536	105	1
48	152	232	3
48	152	233	1
48	152	234	1
48	232	35	1
48	213	271	1
48	213	109	1
48	213	34	1
48	161	236	1
48	209	243	1
48	883	1109	1
48	883	1110	1
48	883	38	1
48	883	1111	1
48	883	134	1
48	883	1112	1
48	216	110	1
48	285	1113	1
48	285	416	1
48	285	638	1
48	285	1114	1
48	884	288	1
48	884	199	1
48	112	24	1
48	112	26	1
48	661	66	1
48	661	773	1
48	661	277	1
48	661	276	1
48	661	38	1
48	886	90	1
48	887	107	1
48	887	1116	1
48	831	123	1
40	799	171	1
40	799	83	1
40	195	22	1
40	195	200	1
40	196	264	1
40	196	265	1
40	800	585	1
40	801	484	1
40	801	485	1
40	199	266	1
40	199	173	1
40	209	243	1
40	802	38	1
40	802	33	2
40	802	69	1
40	802	81	1
40	803	107	1
40	475	468	1
40	475	79	1
40	475	199	1
40	804	585	1
40	805	844	1
40	805	210	1
40	211	270	1
40	211	199	1
40	213	271	1
40	213	109	1
40	213	34	1
40	806	846	1
40	216	110	1
40	477	470	1
40	477	199	1
40	807	868	1
40	222	100	1
40	223	414	1
40	223	276	1
40	223	277	1
40	223	416	1
40	223	199	1
40	478	471	1
40	478	199	1
40	232	35	1
40	232	414	1
40	232	416	1
40	232	199	1
40	479	472	1
40	479	199	1
40	238	282	1
40	238	38	1
40	238	46	1
40	238	288	1
40	234	280	1
40	234	16	1
40	11	469	1
40	11	456	1
40	811	846	1
40	52	17	1
40	52	199	1
40	814	842	1
40	814	204	1
40	815	193	1
40	815	440	1
40	815	34	1
40	481	325	1
40	481	199	1
40	482	473	1
40	482	199	1
40	250	293	1
40	250	46	1
40	250	294	1
40	816	83	1
40	816	333	1
40	251	296	1
40	251	38	1
40	251	297	1
52	901	93	1
52	901	495	1
52	901	19	1
52	901	88	1
52	901	126	1
52	902	1125	1
52	902	38	1
52	902	133	1
52	903	190	1
52	35	107	1
52	35	108	1
52	904	1126	1
52	904	1127	1
52	822	121	1
52	822	38	1
52	822	133	1
52	87	35	1
52	87	193	1
52	825	38	1
52	825	878	1
52	825	133	1
52	907	38	1
52	907	48	1
52	907	1128	1
52	908	38	1
52	908	43	1
52	908	88	1
52	908	126	1
52	15	52	1
52	15	53	1
52	15	54	1
52	909	38	1
52	909	1129	1
52	909	131	1
52	910	1130	1
52	910	38	1
52	910	131	1
56	35	107	1
56	1002	71	1
56	1002	43	1
56	1002	74	1
56	15	52	1
56	15	53	1
56	15	54	1
56	87	35	1
56	87	193	1
56	1003	61	1
56	1003	31	1
56	1003	33	1
56	1003	70	1
56	721	38	1
56	721	836	1
56	721	133	1
56	670	304	1
56	670	38	1
56	670	133	1
56	767	38	1
56	767	133	1
56	573	319	1
56	573	673	1
56	679	128	1
56	679	38	1
56	679	188	1
56	106	128	1
56	106	23	1
56	106	38	1
56	422	430	1
56	422	1199	1
56	774	128	1
56	774	38	1
56	412	431	1
56	412	406	1
56	412	432	1
56	6	23	1
56	6	19	1
56	342	383	1
56	342	19	1
56	261	128	2
56	261	38	2
56	261	307	2
56	695	128	1
56	695	38	1
46	842	976	2
46	842	977	1
46	842	978	2
46	842	897	4
46	842	979	1
46	842	46	14
46	842	156	3
46	842	18	1
46	842	980	1
46	842	465	2
46	842	981	1
46	842	982	1
46	842	983	5
46	842	984	1
46	842	985	1
46	842	986	1
46	842	584	1
46	842	987	1
46	842	988	1
46	842	106	1
46	842	900	6
46	842	712	8
46	842	902	9
46	842	903	14
46	842	907	7
46	842	989	1
46	842	68	18
46	842	31	10
46	842	990	1
46	842	84	89
46	842	991	4
46	842	992	1
46	842	33	13
46	842	993	1
46	842	994	1
46	842	995	1
46	842	996	10
46	842	997	3
46	842	998	5
46	842	999	5
46	842	909	1
46	842	3	1
46	842	910	5
46	842	1000	1
46	842	893	1
46	842	911	2
46	842	1001	6
46	842	912	1
46	842	1002	1
46	842	914	5
46	842	1003	2
46	842	290	1
46	842	125	2
46	842	142	7
46	842	922	1
46	842	1004	1
46	842	1005	1
46	842	1006	1
46	842	43	6
46	842	1007	1
46	842	561	2
46	849	310	3
46	850	1008	1
46	850	146	1
46	850	1009	2
46	850	900	1
46	741	1010	1
46	741	52	1
46	741	53	1
46	741	107	1
46	741	108	1
46	741	54	1
46	851	33	1
46	851	761	1
46	852	933	1
46	852	159	1
46	852	936	3
46	852	1011	1
46	852	1012	1
46	852	1013	1
46	852	124	4
46	852	1014	1
46	852	38	4
46	852	1015	1
46	852	941	2
46	852	1016	1
46	852	1017	1
46	852	1018	2
46	852	1019	3
46	852	1020	1
46	852	1021	1
46	852	73	5
46	852	1022	1
46	852	1023	1
46	852	160	1
46	852	503	2
46	852	155	1
46	852	1024	2
46	852	958	1
46	852	1025	1
46	852	141	1
46	852	1026	1
46	852	919	1
46	852	965	1
46	852	931	2
46	852	1027	1
46	852	968	1
46	852	474	6
46	852	1028	1
46	852	969	1
46	852	1029	1
46	852	34	2
46	852	1030	1
46	852	1031	1
46	852	1032	1
46	852	973	1
46	852	1033	1
46	852	114	1
46	852	1034	3
46	852	1035	1
46	852	897	1
46	852	46	6
46	852	156	1
46	852	1036	1
46	852	1037	1
46	852	106	3
46	852	900	2
46	852	712	5
46	852	902	2
46	852	1038	2
46	852	903	10
46	852	907	10
46	852	1039	1
46	852	68	4
46	852	31	41
46	852	84	4
46	852	33	4
46	852	1040	1
46	852	3	1
46	852	910	1
46	852	1000	1
46	852	911	1
46	852	1001	2
46	852	912	13
46	852	914	2
46	852	29	1
46	852	210	1
46	852	290	1
46	852	891	1
46	852	142	1
46	852	125	4
46	852	790	1
46	852	1041	1
46	852	1042	1
46	852	1043	1
46	852	507	1
46	852	371	1
46	852	56	1
46	852	43	4
46	852	463	1
46	853	484	1
46	853	485	1
46	854	1018	1
46	854	1044	1
46	854	386	1
46	854	1029	1
46	854	1045	1
46	854	292	1
46	854	1046	1
46	854	142	1
46	854	503	1
46	854	897	1
46	854	1038	1
46	854	900	1
46	854	1047	4
46	854	712	1
46	854	1048	1
46	854	902	17
46	854	904	1
46	854	903	1
46	854	907	1
46	854	999	1
46	854	68	1
46	854	909	1
46	854	31	1
46	854	910	1
46	854	84	1
46	854	911	1
46	854	1037	1
46	854	33	1
46	854	912	1
46	854	978	1
46	854	1000	2
46	854	1043	1
46	854	914	1
46	854	63	1
46	854	43	3
46	854	125	1
46	854	1028	1
46	854	235	1
46	854	208	1
46	854	290	1
46	854	34	2
46	854	197	2
46	854	960	1
46	854	1049	1
46	854	11	1
46	854	1050	1
46	854	1016	1
46	854	38	1
46	854	81	1
46	854	1041	1
46	854	1019	1
46	854	919	1
46	854	1051	1
46	854	46	3
46	854	124	1
46	854	271	1
46	854	979	1
46	854	1052	1
46	854	981	1
46	855	1053	1
46	855	1054	1
46	855	140	1
46	855	1055	1
46	855	1056	1
46	855	124	2
46	855	297	1
46	855	38	2
46	855	485	1
46	855	55	1
46	855	1057	1
46	855	187	1
46	855	1058	1
46	855	63	1
46	855	73	1
46	855	291	1
46	855	1059	1
46	855	1060	1
46	855	503	2
46	855	1061	1
46	855	1062	1
46	855	957	1
46	855	958	1
46	855	305	1
46	855	379	1
46	855	1063	1
46	855	1064	3
46	855	79	2
46	855	1065	1
46	855	807	9
46	855	1066	1
46	855	1067	1
46	855	964	1
46	855	235	1
46	855	968	1
46	855	967	1
46	855	1028	1
46	855	1029	1
46	855	34	4
46	855	406	1
46	855	1068	1
46	855	1069	1
46	855	1070	1
46	855	28	1
46	855	1071	3
46	855	975	1
46	855	1035	5
46	855	156	1
46	855	46	8
46	855	916	1
46	855	1072	1
46	855	1073	1
46	855	1074	1
46	855	1075	1
46	855	1076	3
46	855	1077	1
46	855	682	1
46	855	900	8
46	855	712	4
46	855	902	13
46	855	903	4
46	855	907	4
46	855	68	50
46	855	31	8
46	855	84	6
46	855	33	6
46	855	995	2
46	855	702	2
46	855	997	1
46	855	1001	1
46	855	914	2
46	855	1078	1
46	855	1079	1
46	855	290	2
46	855	125	2
46	855	142	3
46	855	1041	1
46	855	1080	1
46	855	1081	1
46	855	1082	1
46	855	1083	1
46	855	913	1
46	855	43	23
46	855	1084	1
46	856	1076	1
46	856	252	2
46	856	203	1
46	856	56	1
46	856	991	1
46	856	1085	1
46	856	969	2
46	856	292	1
46	856	465	1
46	856	986	1
46	856	1086	1
46	856	1087	1
46	856	968	1
46	856	142	4
46	856	541	1
46	856	1038	1
46	856	379	1
46	856	903	1
46	856	907	18
46	856	1092	2
46	856	68	7
46	856	31	8
46	856	84	3
46	856	33	3
46	856	1094	1
46	856	1000	1
46	856	1095	1
46	856	43	2
46	856	125	1
46	856	1028	1
46	856	1021	1
46	856	973	1
46	856	1096	1
46	856	1041	1
46	856	966	1
46	856	46	2
46	856	124	1
46	856	73	1
46	856	985	5
46	856	995	1
46	856	971	1
46	866	843	1
46	866	309	2
53	147	38	1
53	147	28	1
53	147	199	1
53	147	21	1
53	148	218	1
53	148	76	1
53	149	219	1
53	150	219	1
53	150	221	1
53	150	199	1
53	15	52	1
53	15	53	1
53	15	54	1
53	154	199	1
53	152	232	3
53	152	233	1
53	152	234	1
53	21	1158	1
53	21	69	1
53	161	236	1
53	169	227	1
53	169	199	1
53	171	240	1
53	172	241	1
53	173	242	1
53	173	243	1
53	173	32	2
53	175	38	1
53	175	247	1
53	183	251	1
53	183	207	1
53	183	199	1
53	189	255	1
53	87	1159	1
53	87	35	3
53	87	38	1
53	87	193	1
53	87	440	1
53	87	1160	1
53	87	76	1
53	87	34	1
53	195	22	1
53	195	200	1
53	196	264	1
53	196	265	1
53	186	35	1
53	186	331	1
53	186	38	1
53	186	1172	1
53	199	266	1
53	199	173	1
53	209	243	1
53	211	270	1
53	211	199	1
53	213	271	1
53	213	109	1
53	213	34	1
53	216	110	1
53	494	15	1
53	494	66	1
53	494	277	1
53	494	38	1
53	494	67	1
53	222	100	1
53	223	276	1
53	223	277	1
53	232	35	1
53	234	280	1
53	234	16	1
53	238	282	1
53	238	38	1
53	238	46	1
53	238	288	1
53	247	32	1
53	247	241	1
53	62	153	1
53	62	154	1
53	248	35	1
53	248	32	1
53	969	15	1
53	969	277	1
53	969	38	1
53	969	148	1
53	251	296	1
53	251	38	1
53	251	297	1
55	844	155	1
55	844	141	1
55	844	1305	1
55	844	38	1
55	844	43	1
55	844	584	1
55	844	142	1
55	1012	141	1
55	1012	268	1
55	1012	1306	1
55	1012	38	1
55	1012	33	1
55	1012	43	1
55	1012	259	1
55	1012	142	1
55	470	112	1
55	470	41	1
55	470	199	1
55	148	218	1
55	148	76	1
55	149	219	1
55	15	52	1
55	15	53	1
55	15	54	1
55	152	232	3
55	152	233	1
55	152	234	1
55	161	236	1
55	129	1	1
55	129	199	1
55	471	465	1
55	471	466	1
55	471	199	1
55	171	240	1
55	472	467	1
55	472	199	1
55	172	241	1
49	862	43	1
49	862	79	1
49	189	255	1
49	863	845	1
49	864	1098	1
49	473	66	1
49	473	276	1
49	473	199	1
49	865	846	1
49	195	22	1
49	195	200	1
49	196	264	1
49	196	265	1
49	867	1099	1
49	867	43	1
49	867	151	1
49	199	266	1
49	199	173	1
49	209	243	1
49	868	1100	1
49	868	1101	1
49	868	1032	1
49	868	1102	1
49	868	269	1
49	868	1103	1
49	868	1104	1
49	868	61	1
49	868	1105	1
49	868	82	1
49	868	555	1
49	868	34	1
49	475	468	1
49	475	79	1
49	475	199	1
49	869	1106	1
49	211	270	1
49	211	199	1
49	213	271	1
49	213	109	1
49	213	34	1
49	216	110	1
49	477	470	1
49	477	199	1
49	222	100	1
49	870	269	1
49	870	193	1
49	870	34	1
49	223	414	1
49	223	276	1
49	223	277	1
49	223	416	1
49	223	199	1
49	478	471	1
49	478	199	1
49	232	35	1
49	232	414	1
49	232	416	1
49	232	199	1
49	479	472	1
49	479	199	1
49	238	282	1
49	238	38	1
49	238	46	1
49	238	288	1
49	234	280	1
49	234	16	1
49	52	17	1
49	52	199	1
49	481	325	1
49	481	199	1
49	482	473	1
49	482	199	1
49	871	1099	1
49	871	43	1
49	871	11	1
49	871	1107	1
49	251	296	1
49	251	38	1
49	251	297	1
50	73	19	2
50	73	28	2
50	73	803	2
50	880	472	1
50	880	69	1
50	881	392	1
50	881	669	1
50	91	38	1
50	91	196	1
50	35	107	1
50	497	379	1
50	497	38	1
50	497	196	1
50	87	35	1
50	87	193	1
50	882	379	1
50	882	38	1
50	882	13	1
50	882	34	1
50	882	196	1
50	701	38	1
50	701	803	1
50	885	287	1
50	885	1115	1
50	15	52	1
50	15	53	1
50	15	54	1
51	906	31	1
51	906	1131	1
51	906	331	1
51	906	1134	1
51	906	584	1
51	913	1135	1
51	913	1136	1
51	913	26	1
51	914	1131	1
51	914	1137	1
51	914	134	1
51	914	26	1
51	917	45	1
51	917	38	1
51	917	134	1
51	917	200	1
51	918	1124	1
51	918	38	1
51	918	371	1
51	918	155	1
51	918	51	1
51	918	81	1
51	918	259	1
51	918	43	1
51	918	84	1
51	918	267	2
51	923	84	1
51	923	38	1
51	923	259	1
51	923	267	1
51	924	1142	1
51	924	1131	1
51	924	1137	1
51	924	134	1
51	924	26	1
51	925	27	1
51	925	473	1
51	925	777	1
51	925	53	1
51	925	43	2
51	925	81	1
51	925	134	1
51	927	177	1
51	482	473	1
51	482	199	1
51	631	414	1
51	631	276	1
51	631	277	1
51	631	416	1
51	631	199	1
51	929	1026	1
48	888	83	1
48	888	199	1
48	196	264	1
48	196	265	1
48	889	19	1
48	889	1117	1
48	889	1118	1
48	889	1119	1
48	890	891	1
48	890	273	1
48	890	38	1
48	890	43	1
48	891	15	1
48	891	202	1
48	891	1120	1
48	891	225	1
48	891	59	1
48	891	386	1
48	891	67	1
48	892	1121	1
48	199	266	1
48	199	173	1
48	195	22	1
48	195	200	1
48	632	1122	1
48	632	777	1
48	632	53	1
48	632	781	1
48	632	267	1
48	893	465	1
48	893	24	1
48	893	40	1
48	893	41	1
48	175	38	1
48	175	247	1
48	361	55	1
48	361	38	1
48	361	56	1
48	148	218	1
48	148	76	1
48	894	91	1
48	894	199	1
48	234	280	1
48	234	16	1
48	251	296	1
48	251	38	1
48	251	297	1
48	895	758	1
48	895	1123	1
48	896	61	1
48	896	33	2
48	896	48	1
48	171	240	1
48	897	176	1
48	897	147	1
48	898	43	1
48	898	88	1
48	898	126	1
48	640	331	1
48	640	777	1
48	640	53	1
48	640	332	1
48	899	874	1
48	900	50	1
48	900	1124	1
48	905	842	1
48	905	204	1
48	911	846	1
48	912	1132	1
48	912	310	1
48	912	1133	1
48	238	282	1
48	238	38	1
48	238	46	1
48	238	288	1
48	915	846	1
48	916	187	1
48	916	188	1
48	919	1138	1
48	919	1139	1
48	920	1140	1
48	921	1141	1
48	921	292	1
48	921	38	1
48	922	180	1
48	463	74	1
48	172	241	1
48	287	279	1
48	287	283	1
48	926	411	1
48	926	398	1
48	926	46	1
48	276	44	1
48	276	47	1
48	296	338	1
48	296	38	1
48	296	477	1
48	296	34	1
48	296	342	1
48	928	846	1
54	944	333	1
54	945	19	1
54	945	139	1
54	946	119	2
54	946	43	1
54	946	1150	2
54	946	140	2
54	946	369	2
54	35	107	1
54	35	108	1
54	947	1151	1
54	947	401	1
54	947	1152	1
54	947	1153	1
54	947	584	1
54	947	749	3
54	947	119	3
54	947	43	1
54	947	1154	1
54	947	1155	1
54	947	369	2
54	947	140	1
54	947	34	1
54	947	1156	1
54	948	119	1
54	948	42	1
54	948	19	1
54	948	1157	1
54	948	46	1
54	948	139	2
54	948	457	1
54	949	139	1
54	949	457	1
54	950	119	1
54	950	1157	1
54	15	52	1
54	15	53	1
54	15	54	1
54	87	35	1
54	87	193	1
54	952	1162	1
54	952	1163	1
54	953	244	1
54	953	681	1
54	953	140	1
54	953	1164	1
54	954	1162	1
54	954	1168	1
54	955	1169	1
54	955	49	1
54	955	1170	1
54	955	1171	1
54	955	76	1
54	955	139	1
54	955	260	1
54	955	77	1
54	957	119	1
51	929	886	1
51	929	116	1
51	15	52	1
51	15	53	1
51	15	54	1
51	930	1131	1
51	930	331	1
51	930	1134	1
51	930	33	1
51	930	584	1
51	931	43	1
51	931	139	1
51	931	134	1
51	222	100	1
51	932	38	1
51	932	772	1
51	932	48	1
51	932	34	1
51	933	38	1
51	933	132	1
51	933	1143	1
51	933	47	1
51	149	219	1
51	189	255	1
51	934	473	1
51	934	43	1
51	934	134	1
51	935	1131	2
51	935	38	2
51	935	1144	2
51	935	15	2
51	935	18	2
51	935	1145	2
51	935	43	2
51	935	84	2
51	935	80	2
51	935	34	2
51	936	1131	2
51	936	38	2
51	936	1144	2
51	936	15	2
51	936	18	2
51	936	1145	2
51	936	43	2
51	936	80	2
51	936	33	2
51	936	34	2
51	937	202	1
51	937	1146	1
51	937	386	1
51	937	1112	1
51	152	232	3
51	152	233	1
51	152	234	1
51	938	134	1
51	938	26	1
51	938	267	1
51	475	468	1
51	475	79	1
51	475	199	1
51	939	1147	1
51	939	1148	1
51	232	35	1
51	232	414	1
51	232	416	1
51	232	199	1
51	213	271	1
51	213	109	1
51	213	34	1
51	940	1144	1
51	940	38	1
51	940	43	1
51	940	80	1
51	940	34	1
51	940	18	1
51	161	236	1
51	941	1131	1
51	941	1137	1
51	941	1149	1
51	941	134	1
51	941	26	1
51	209	243	1
51	883	38	1
51	883	43	1
51	883	134	1
51	216	110	1
51	942	71	1
51	942	43	1
51	942	74	1
51	942	761	1
51	942	21	1
51	473	66	1
51	473	276	1
51	473	199	1
51	943	1135	1
51	943	1136	1
51	943	84	1
51	943	772	1
51	943	40	1
51	943	262	1
51	479	472	1
51	479	199	1
51	951	781	1
51	951	1161	1
51	951	38	1
51	951	1165	1
51	951	1166	1
51	951	777	1
51	951	53	1
51	951	81	2
51	951	1167	1
51	951	1173	1
51	951	43	1
51	951	68	1
51	951	31	1
51	951	262	1
51	956	1174	1
51	956	38	1
51	956	19	1
51	956	134	1
51	50	273	1
51	50	38	2
51	50	43	1
51	50	134	1
51	958	48	1
51	478	471	1
51	478	199	1
51	959	1135	1
51	959	1136	1
51	959	40	1
51	196	264	1
51	196	265	1
51	129	1	1
51	129	199	1
51	52	17	1
51	52	199	1
51	962	66	2
51	962	276	2
51	962	38	1
51	962	43	1
51	962	134	2
51	964	68	1
51	964	1131	1
51	964	331	1
51	964	1134	1
51	964	584	1
51	199	266	1
51	199	173	1
51	968	241	1
51	481	325	1
51	481	199	1
51	195	22	1
51	195	200	1
51	175	38	1
51	175	247	1
51	974	168	1
51	974	761	1
54	957	511	1
54	957	43	1
54	957	105	1
54	957	369	1
54	960	171	1
54	961	139	1
54	961	134	1
54	963	171	1
54	965	1162	1
54	965	1175	1
54	581	1176	1
54	581	1177	1
54	966	1178	1
54	966	271	1
54	966	1179	1
54	966	34	1
54	967	139	1
54	967	134	1
54	970	171	1
54	971	29	1
54	971	1180	1
54	972	333	1
54	973	1181	1
54	973	244	1
54	973	681	1
54	973	140	1
54	273	119	1
54	273	315	1
54	273	316	1
54	273	317	1
54	273	42	1
54	273	140	1
54	575	211	1
54	575	749	1
54	575	1153	1
54	575	119	3
54	575	43	1
54	575	35	1
54	575	1154	1
54	575	369	2
54	575	1183	1
54	575	34	1
54	575	681	3
54	575	1184	1
54	979	483	1
54	979	1185	1
54	980	1162	1
54	980	1187	1
54	981	333	1
54	982	1188	1
54	982	499	1
70	470	112	1
70	470	41	1
70	470	199	1
70	1075	1131	1
70	1075	51	1
70	1075	93	1
70	1075	1286	1
70	1075	46	1
70	1075	1287	1
70	1075	1288	1
70	1075	43	1
70	1075	473	1
70	1075	84	1
70	1075	21	1
70	1075	1289	1
70	1075	252	1
70	1075	267	1
70	148	218	1
70	148	76	1
70	149	219	1
70	633	61	1
70	633	341	1
70	633	84	1
70	633	19	1
70	633	43	1
70	633	262	1
70	633	1290	1
70	1076	211	1
70	1076	277	1
70	1076	38	1
70	15	52	1
70	15	53	1
70	15	54	1
70	628	776	1
70	628	215	1
70	628	38	1
70	152	232	3
70	152	233	1
70	152	234	1
70	161	236	1
70	129	1	1
70	129	199	1
70	638	208	1
70	638	13	1
70	471	465	1
70	471	466	1
70	471	199	1
70	171	240	1
70	472	467	1
70	472	199	1
70	172	241	1
70	173	32	1
70	173	199	1
70	175	38	1
70	175	247	1
70	189	255	1
70	1077	869	1
70	473	66	1
70	473	276	1
70	473	199	1
70	195	22	1
70	195	200	1
70	196	264	1
70	196	265	1
70	1078	1291	1
70	1078	1292	1
70	199	266	1
70	199	173	1
70	209	243	1
70	668	1293	1
70	668	81	1
70	668	1294	1
70	668	1295	1
70	668	1296	1
70	475	468	1
70	475	79	1
70	475	199	1
70	211	270	1
70	211	199	1
70	213	271	1
70	213	109	1
70	213	34	1
70	216	110	1
70	477	470	1
70	477	199	1
70	1079	204	1
70	1079	53	1
70	1079	38	1
70	222	100	1
70	222	1191	1
70	222	516	1
70	223	414	1
70	223	276	1
70	223	277	1
70	223	416	1
70	223	199	1
70	478	471	1
70	478	199	1
70	232	35	1
70	232	414	1
70	232	416	1
70	232	199	1
70	479	472	1
70	479	199	1
70	238	282	1
70	238	38	1
51	974	21	1
51	148	218	1
51	148	76	1
51	975	27	1
51	975	84	1
51	975	38	1
51	975	43	1
51	975	81	1
51	975	80	1
51	975	200	1
51	976	204	1
51	976	1182	1
51	234	280	1
51	234	16	1
51	977	772	1
51	977	179	1
51	978	38	1
51	978	772	1
51	978	1186	1
51	978	34	1
51	251	296	1
51	251	38	1
51	251	297	1
51	983	1131	1
51	983	331	1
51	983	84	1
51	983	1134	1
51	983	584	1
51	984	43	1
51	984	59	1
51	984	134	1
51	985	1189	1
51	985	1054	1
51	985	38	1
51	985	28	1
51	985	81	1
51	985	494	1
51	986	1135	1
51	986	1144	1
51	986	1136	1
51	986	18	1
51	171	240	1
51	987	473	1
51	987	1190	1
51	987	43	1
51	987	134	1
51	988	1191	1
51	988	772	1
51	988	1192	1
51	989	1193	1
51	989	43	1
51	989	772	1
51	989	34	1
51	211	270	1
51	211	199	1
51	990	19	1
51	990	43	1
51	990	26	1
51	990	761	1
51	990	21	1
51	991	1131	1
51	991	1149	1
51	991	772	1
51	991	59	1
51	991	34	1
51	991	201	1
51	992	1131	1
51	992	772	1
51	992	59	1
51	992	34	1
51	992	201	1
51	238	282	1
51	238	38	1
51	238	46	1
51	238	288	1
51	472	467	1
51	472	199	1
51	470	112	1
51	470	41	1
51	470	199	1
51	993	215	1
51	993	53	1
51	993	1194	1
51	994	772	1
51	994	105	1
51	994	34	1
51	995	44	1
51	995	46	1
51	995	1195	1
51	996	43	1
51	996	1196	1
51	996	134	1
51	173	32	1
51	173	199	1
51	471	465	1
51	471	466	1
51	471	199	1
51	997	215	1
51	997	772	1
51	997	1197	1
51	997	26	1
51	997	267	1
51	477	470	1
51	477	199	1
51	172	241	1
51	998	38	1
51	998	43	1
51	998	134	1
51	999	27	1
51	999	1198	1
51	999	84	2
51	999	38	2
51	999	43	2
51	999	81	2
51	999	80	2
51	999	200	2
51	1000	74	1
51	1001	27	1
51	1001	473	1
51	1001	43	1
51	1001	51	1
51	1001	1173	1
51	1001	252	1
51	1001	267	1
57	1005	38	1
57	1005	142	1
57	1005	1200	1
57	1005	133	1
57	35	107	1
57	35	108	1
57	362	121	1
57	362	38	1
57	362	48	1
57	87	35	1
57	87	193	1
57	1006	61	1
57	1006	1201	1
57	1006	1202	1
57	1006	147	1
57	1006	1044	1
57	1007	128	1
57	1007	38	1
57	1007	142	1
57	1007	1203	1
57	258	38	1
57	258	142	2
57	258	133	1
57	825	38	1
57	825	878	1
57	825	142	1
57	825	133	1
57	15	52	1
57	15	53	1
57	15	54	1
57	909	38	1
57	909	142	1
57	909	1129	1
56	695	819	1
56	1004	186	1
56	1004	38	1
56	1004	13	1
56	1004	188	1
56	713	128	2
56	713	833	2
56	713	38	2
58	87	35	1
58	87	193	1
58	1008	171	1
58	1009	19	1
58	1009	1204	1
58	1009	832	1
58	969	15	1
58	969	277	1
58	969	38	1
58	969	148	1
58	1010	1205	1
58	1010	204	1
58	1010	585	1
58	1010	456	1
58	1010	53	1
58	1010	38	1
58	1010	37	1
58	1010	1206	1
58	35	107	1
58	35	108	1
58	15	52	1
58	15	53	1
58	15	54	1
59	843	197	1
59	843	84	1
59	843	33	1
59	843	262	1
59	843	527	1
59	844	259	1
59	844	342	1
59	49	197	1
59	49	33	2
59	49	527	1
59	1011	944	1
59	1011	1207	1
59	1011	1208	1
59	1011	819	1
59	1012	268	1
59	1012	33	1
59	1012	940	1
59	1012	259	1
59	1013	648	1
59	1013	181	1
59	1014	269	1
60	1015	107	1
60	1015	108	1
60	1016	193	1
60	1016	527	1
61	1020	1212	1
61	1020	154	1
61	1020	175	1
61	223	276	1
61	223	277	1
61	1021	112	1
61	1021	1213	1
61	1022	1214	1
61	1022	270	1
61	1022	28	1
61	1022	803	1
61	4	215	1
61	4	38	1
61	4	7	1
61	4	148	1
61	4	464	1
61	4	46	1
61	4	10	1
61	4	9	1
61	4	68	1
61	4	33	2
61	4	263	1
61	1023	204	1
61	1023	585	1
61	1023	649	1
61	1023	1215	1
61	247	32	1
61	247	241	1
61	1024	215	1
61	1024	38	1
61	1024	1216	1
61	1024	47	1
61	1025	1162	1
61	1025	180	1
61	1025	168	1
61	1025	167	1
61	1025	38	2
61	1025	46	1
61	1025	1217	1
61	1026	1218	1
61	1026	112	1
61	1027	48	1
61	1027	1219	1
61	1028	178	1
61	1028	27	1
61	1028	556	1
61	1028	1220	1
61	1028	154	1
61	1028	235	1
61	1028	1221	1
61	1028	1222	1
61	1028	183	1
61	1028	182	1
61	15	52	1
61	15	53	1
61	15	54	1
61	1029	204	1
61	1029	420	2
61	1029	649	1
61	1029	2	1
61	1029	1223	1
61	1029	154	1
61	1029	1224	1
61	1029	235	1
61	1029	1225	1
61	1029	1226	1
61	1029	60	1
61	1029	1227	1
61	1029	1228	1
61	1029	585	1
61	222	100	1
61	19	153	1
61	19	61	1
61	19	68	1
61	19	1229	1
61	19	112	1
61	19	939	1
61	19	33	2
61	19	43	1
61	1030	1230	1
61	21	38	1
61	21	46	1
61	21	85	1
61	21	61	1
61	21	68	1
61	21	69	2
61	21	84	1
61	21	33	2
61	21	70	1
61	149	219	1
61	189	255	1
61	1031	112	1
61	1031	634	1
61	1031	1231	1
61	1031	1229	1
61	1031	61	1
61	1031	68	1
61	1031	153	1
61	1031	33	2
61	1031	1232	1
61	183	251	1
57	909	131	1
63	808	91	1
63	808	149	1
63	35	107	1
63	35	108	1
63	1066	15	1
63	1066	1275	1
63	1066	46	1
63	1066	149	1
63	812	502	1
63	812	38	1
63	812	676	1
63	812	678	1
63	271	533	1
63	271	1276	1
63	271	1277	1
63	271	922	1
63	271	21	1
63	1067	1278	1
63	1067	46	1
63	1067	1276	1
63	1067	556	1
63	1067	1279	1
63	1067	1280	1
63	1067	21	1
63	87	35	1
63	87	193	1
63	1068	27	1
63	1068	35	1
63	1068	38	1
63	1068	43	1
63	1068	81	1
63	1068	149	1
63	15	52	1
63	15	53	1
63	15	54	1
68	147	38	1
68	147	28	1
68	147	199	1
68	147	21	1
68	148	218	1
68	148	76	1
68	149	219	1
68	1080	474	1
68	1080	760	1
68	1080	165	1
68	150	219	1
68	150	221	1
68	150	199	1
68	15	52	1
68	15	53	1
68	15	54	1
68	154	199	1
68	152	232	3
68	152	233	1
68	152	234	1
68	161	236	1
68	169	227	1
68	169	199	1
68	171	240	1
68	1081	163	1
68	1081	38	1
68	1081	866	1
68	1081	1297	1
68	1081	474	1
68	1081	165	1
68	1081	85	1
68	1081	84	1
68	1081	121	1
68	172	241	1
68	173	242	1
68	173	243	1
68	173	32	2
68	175	38	1
68	175	247	1
68	183	251	1
68	183	207	1
68	183	199	1
68	189	255	1
68	190	220	4
68	190	474	3
68	190	1297	2
68	190	66	1
68	190	401	2
68	190	67	1
68	190	85	1
68	190	43	1
68	190	38	4
68	190	34	5
68	190	130	3
68	190	376	1
68	190	1298	1
68	190	148	1
68	190	165	8
68	190	84	1
68	190	1299	4
68	190	27	1
68	4	38	1
68	4	204	1
68	4	456	1
68	4	53	1
68	4	9	1
68	4	68	1
68	4	32	1
68	4	33	2
68	4	585	1
68	195	22	1
68	195	200	1
68	1082	1300	1
68	1082	1301	1
68	342	383	1
68	342	19	1
68	196	264	1
68	196	265	1
68	199	266	1
68	199	173	1
68	209	243	1
68	211	270	1
68	211	199	1
68	213	271	1
68	213	109	1
68	213	34	1
68	216	110	1
68	1083	20	1
68	1083	1302	1
68	1083	53	1
68	1083	1303	1
68	1083	204	1
68	1083	187	1
68	1083	310	1
68	1083	43	1
68	1083	32	1
68	1083	456	1
68	1083	37	1
68	1083	38	2
68	1083	34	1
68	1083	585	1
68	1083	1304	1
68	1083	376	1
68	1083	1298	1
68	1083	68	1
68	1083	33	1
68	1083	15	1
68	1083	27	1
68	222	100	1
68	223	276	1
68	223	277	1
68	232	35	1
68	234	280	1
68	234	16	1
68	238	282	1
68	238	38	1
68	238	46	1
68	238	288	1
68	247	32	1
68	247	241	1
68	62	153	1
61	183	207	1
61	183	199	1
61	152	232	3
61	152	233	1
61	152	234	1
61	1032	1233	1
61	1033	936	1
61	1033	319	1
61	1033	163	1
61	1033	503	1
61	1033	223	1
61	1033	1234	1
61	1033	162	1
61	1033	903	1
61	1033	84	1
61	1033	164	1
61	1034	1235	1
61	521	153	1
61	521	154	1
61	521	179	1
61	521	103	1
61	232	35	1
61	248	35	1
61	248	32	1
61	213	271	1
61	213	109	1
61	213	34	1
61	1035	112	1
61	1035	1236	1
61	1036	1237	1
61	161	236	1
61	209	243	1
61	216	110	1
61	1037	171	1
61	1037	59	1
61	1038	1238	1
61	1039	1239	1
61	1040	1240	1
61	45	35	1
61	45	38	1
61	45	676	1
61	45	678	1
61	1041	1241	1
61	150	219	1
61	150	221	1
61	150	199	1
61	1042	1242	1
61	1042	112	1
61	1042	1195	1
61	1042	1243	1
61	1042	38	2
61	1042	649	1
61	1042	651	1
61	1042	648	1
61	1042	71	1
61	1042	359	1
61	1042	90	1
61	1042	585	1
61	1042	360	1
61	1043	1244	1
61	196	264	1
61	196	265	1
61	154	199	1
61	1044	1245	1
61	1044	1246	1
61	1044	1247	1
61	1044	1248	1
61	1044	183	1
61	1044	1249	1
61	1044	11	1
61	169	227	1
61	169	199	1
61	199	266	1
61	199	173	1
61	195	22	1
61	195	200	1
61	1045	1250	1
61	175	38	1
61	175	247	1
61	148	218	1
61	148	76	1
61	234	280	1
61	234	16	1
61	1046	61	1
61	1046	1251	1
61	1046	569	1
61	1046	438	1
61	1046	65	1
61	251	296	1
61	251	38	1
61	251	297	1
61	147	38	1
61	147	28	1
61	147	199	1
61	147	21	1
61	1047	1252	1
61	1047	112	1
61	1048	1253	1
61	171	240	1
61	278	1254	1
61	278	44	1
61	278	46	1
61	278	321	1
61	278	1156	1
61	278	81	1
61	278	1255	1
61	278	149	2
61	1053	204	1
61	1053	585	1
61	1053	649	1
61	1053	1259	1
61	211	270	1
61	211	199	1
61	1055	235	1
61	1055	71	1
61	1055	163	1
61	1055	38	1
61	1055	1261	1
61	1055	1195	1
61	1055	11	1
61	1055	1262	1
61	238	282	1
61	238	38	1
61	238	46	1
61	238	288	1
61	73	242	1
61	1056	1263	1
61	420	61	1
61	420	68	1
61	420	437	1
61	420	33	2
61	420	28	1
61	420	438	1
61	1057	1264	1
61	1057	138	1
61	1057	55	1
61	1057	38	1
61	1057	19	1
61	1057	46	1
61	1057	140	1
61	173	242	1
61	173	243	1
61	173	32	2
61	1058	1265	1
61	75	781	1
61	75	1161	1
61	75	739	1
61	75	38	1
61	75	1165	1
61	75	46	1
61	75	777	1
61	75	53	1
61	75	1266	1
61	75	81	1
61	75	1267	1
61	1059	180	1
61	1059	349	1
61	1059	167	1
61	1059	38	2
61	1059	46	1
61	1059	81	1
61	1059	125	1
61	1059	682	1
61	1062	1269	1
61	1063	1270	1
61	1063	1271	1
61	1063	178	2
61	1063	38	2
61	172	241	1
61	1064	112	1
61	1064	1272	1
61	1065	1273	1
61	1065	25	1
61	190	27	1
61	190	1161	1
61	190	1266	1
61	190	28	1
61	190	164	1
61	190	180	1
61	190	1242	1
61	190	103	2
61	190	19	1
61	190	215	2
61	190	2	1
61	190	163	2
61	190	777	1
61	190	319	1
61	190	182	1
61	190	59	1
61	190	1249	1
61	190	168	1
61	190	1221	1
61	190	503	1
61	190	53	1
61	190	175	1
61	190	270	1
61	190	112	1
61	190	903	1
61	190	138	1
61	190	1226	1
61	190	84	1
61	190	380	1
61	190	227	1
61	190	1165	1
61	190	183	2
61	190	125	1
61	190	349	1
61	190	90	1
61	190	167	1
61	190	781	1
61	190	235	3
61	190	47	1
61	190	148	1
61	190	1223	1
61	190	1248	1
61	190	1246	1
61	190	178	2
61	190	1274	1
61	190	179	1
61	190	1247	1
61	190	11	2
61	190	38	8
61	190	81	1
61	190	1195	1
61	190	936	1
61	190	223	1
61	190	46	4
61	190	162	1
61	190	140	1
61	190	556	1
61	190	803	1
61	190	48	1
61	190	55	1
61	190	154	4
61	190	1261	1
61	190	71	1
61	190	1222	1
61	190	190	2
67	1069	1281	2
67	1069	1282	1
67	1069	1283	1
67	1069	1284	1
67	1069	1285	1
67	35	107	1
67	35	108	1
67	267	159	1
67	267	160	1
67	267	59	1
67	87	35	1
67	87	193	1
67	687	38	1
67	687	812	1
67	687	179	1
67	1070	333	1
67	1071	171	1
67	15	52	1
67	15	53	1
67	15	54	1
67	339	43	1
67	339	76	1
67	339	77	1
67	339	201	1
67	1072	411	1
67	1072	42	1
67	1072	398	1
67	1072	46	1
69	87	35	1
69	87	193	1
69	758	121	1
69	758	38	1
69	758	129	1
69	1073	38	1
69	1073	129	1
69	1073	21	1
69	1073	70	1
69	35	107	1
69	35	108	1
69	15	52	1
69	15	53	1
69	15	54	1
69	1074	38	1
69	1074	129	1
69	1074	21	1
69	1074	70	1
71	1125	793	1
71	1125	389	1
71	1125	823	1
71	1125	360	1
71	1126	1322	1
71	1126	192	1
71	1126	387	1
71	1126	1323	1
71	1126	105	1
71	1126	1324	1
71	1126	134	1
71	1126	11	1
71	204	163	1
71	204	353	1
71	204	38	1
71	204	595	1
71	204	43	1
71	204	105	1
71	204	199	1
71	226	183	1
71	34	215	1
71	34	38	1
71	34	105	1
71	760	244	1
71	760	168	1
71	760	105	1
71	1127	384	1
71	1127	1325	1
71	1127	252	1
71	1128	1326	2
70	238	46	1
70	238	288	1
70	234	280	1
70	234	16	1
70	52	17	1
70	52	199	1
70	481	325	1
70	481	199	1
70	482	473	1
70	482	199	1
70	251	296	1
70	251	38	1
70	251	297	1
76	204	353	1
76	204	38	1
76	204	595	1
76	204	43	1
76	204	796	1
76	204	105	1
76	204	199	1
76	34	35	1
76	34	105	1
76	35	107	1
76	35	108	1
76	15	52	1
76	15	53	1
76	15	54	1
76	1138	26	1
76	1138	267	1
76	1203	1322	1
76	1140	1336	1
76	762	793	1
76	762	360	1
76	1180	180	1
76	1180	279	1
76	1180	38	1
76	1180	283	1
76	1180	134	1
76	1180	11	1
76	1142	15	1
76	1142	1322	1
76	1142	419	1
76	1142	1323	1
76	1142	105	1
76	224	180	1
76	224	24	1
76	224	38	1
76	224	595	1
76	281	13	1
76	281	46	1
76	281	61	1
76	281	68	1
76	281	69	1
76	281	31	1
76	281	32	1
76	281	33	2
76	281	168	1
76	281	263	1
76	78	180	2
76	78	35	1
76	78	38	1
76	1173	1394	1
76	1152	1322	1
76	1152	279	1
76	1152	283	1
76	1152	1323	1
76	1152	105	1
76	1152	134	1
76	1152	11	1
76	1204	38	1
76	1204	105	1
76	1205	793	1
76	1205	180	1
76	1205	1402	1
76	1205	38	1
76	1205	42	1
76	1205	18	1
76	1205	21	1
76	69	1322	1
76	69	35	1
76	69	1323	1
76	69	105	1
76	1206	793	1
76	1206	180	1
76	1206	1402	1
76	1206	38	1
76	1206	42	1
76	1206	21	1
76	1206	18	1
76	1207	168	1
76	1207	93	1
76	1207	1414	1
76	1207	3	1
76	1207	1204	1
76	1207	767	1
76	1208	180	1
76	1208	1414	1
76	1208	192	2
76	1208	3	1
76	1208	1394	1
76	1208	767	1
76	1208	80	2
76	1208	105	1
68	62	154	1
68	248	35	1
68	248	32	1
68	251	296	1
68	251	38	1
68	251	297	1
72	87	35	1
72	87	193	1
72	35	107	1
72	1090	155	1
72	1090	170	1
72	15	52	1
72	15	53	1
72	15	54	1
78	1129	1329	1
78	35	107	1
78	1130	505	1
78	1131	197	1
78	1131	803	1
78	1132	1330	1
78	15	52	1
78	15	53	1
78	15	54	1
78	87	35	1
78	87	193	1
78	1133	1331	1
78	1134	1332	1
78	1135	121	1
78	1135	38	1
78	1135	196	1
78	303	61	1
78	303	68	1
78	303	33	1
78	303	57	1
78	303	70	1
78	573	319	1
78	573	673	1
78	771	38	1
78	771	457	1
78	771	802	1
78	771	803	1
78	1136	1333	1
78	1137	27	1
78	1137	38	1
78	1137	270	1
78	1137	43	1
78	1137	28	1
78	1137	81	1
78	1137	1334	1
78	1139	38	1
78	1139	1335	1
78	1139	133	1
78	1141	1337	1
78	1143	1338	1
78	1144	341	1
78	902	1125	1
78	1145	1339	1
78	1146	1032	1
78	1146	35	1
78	1146	28	1
78	787	840	1
78	787	38	1
78	787	457	1
78	787	803	1
78	732	840	1
78	732	38	1
78	732	803	1
78	261	128	1
78	261	38	1
78	261	307	1
78	1148	963	1
78	701	38	1
78	701	803	1
78	1150	1340	1
78	671	38	1
78	671	802	1
78	671	803	1
80	1059	180	1
80	1059	38	1
80	1059	312	1
80	1059	682	1
80	1166	1387	1
80	1166	389	1
80	1166	252	1
80	69	73	1
80	69	104	1
80	69	38	1
80	69	1388	1
80	69	1323	1
80	69	1155	1
80	69	167	1
80	69	106	1
80	69	494	1
80	1167	779	1
80	1167	156	1
80	1167	399	1
80	669	793	1
80	669	798	1
80	669	360	1
80	1168	55	1
80	1168	1389	1
80	1168	507	1
80	1169	779	1
80	1169	334	1
80	1169	335	1
80	1171	1391	1
80	1171	389	1
80	1171	252	1
80	1172	119	3
80	1172	779	1
80	1172	316	3
80	1172	315	1
80	1172	43	1
80	1172	140	3
80	1172	252	1
80	1172	199	1
80	1140	1392	1
80	1140	1393	1
80	1140	1336	1
80	1140	81	1
80	1140	61	1
80	1140	68	1
80	1140	32	1
80	1140	325	1
80	1140	33	2
80	1140	168	1
80	1173	793	1
80	1173	168	1
80	1173	1394	1
80	1173	360	1
80	1175	1395	1
80	1175	1396	1
80	1175	46	1
80	1175	68	1
80	1175	80	2
80	1175	32	1
80	1175	1397	1
80	1175	33	1
80	1175	11	1
80	1175	168	1
80	1177	180	1
80	1177	168	1
80	1177	38	1
80	1177	46	1
80	1177	252	1
80	753	793	1
80	753	815	1
80	753	360	1
80	1128	1326	1
80	1128	168	1
80	1128	46	1
80	1128	58	1
80	1128	26	1
80	1128	267	1
80	15	52	1
80	15	53	1
80	15	54	1
66	686	244	1
66	686	811	1
66	686	189	1
66	747	244	1
66	747	811	1
66	747	457	1
66	775	858	1
66	775	244	1
66	775	811	1
66	775	859	1
66	87	35	1
66	87	193	1
66	282	38	1
66	282	43	1
66	282	76	1
66	282	77	1
66	282	47	1
66	728	244	1
66	728	811	1
66	728	827	1
66	15	52	1
66	15	53	1
66	15	54	1
66	339	43	1
66	339	76	1
66	339	77	1
66	339	201	1
66	719	244	1
66	719	811	1
66	719	835	1
66	1089	172	1
73	944	172	1
73	1070	172	1
73	1091	172	1
73	1092	484	1
73	504	171	1
73	1086	171	1
73	1089	172	1
73	1093	171	1
73	87	35	1
73	87	85	1
73	1094	171	1
73	1071	171	1
73	1008	171	1
73	97	171	1
73	960	171	1
73	1095	1308	1
73	1095	83	1
73	1095	1309	1
73	1095	76	1
73	1096	171	1
73	963	171	1
73	970	171	1
73	1097	171	1
73	1098	172	1
73	972	172	1
73	1099	171	1
73	820	171	1
73	526	171	1
73	98	172	1
73	981	172	1
73	1100	172	1
73	823	172	1
74	470	112	1
74	470	41	1
74	470	199	1
74	148	218	1
74	148	76	1
74	149	219	2
74	149	91	1
74	149	46	1
74	149	1310	1
74	1101	50	1
74	1101	1311	1
74	1101	46	1
74	1101	1312	1
74	1101	51	1
74	15	52	1
74	15	53	1
74	15	54	1
74	152	232	3
74	152	233	1
74	152	234	1
74	161	236	1
74	129	1	1
74	129	199	1
74	471	465	1
74	471	466	1
74	471	199	1
74	171	240	1
74	472	467	1
74	472	199	1
74	172	241	1
74	1102	83	1
74	1102	204	1
74	1102	585	1
74	1102	53	1
74	1102	38	1
74	173	32	1
74	173	199	1
74	175	38	1
74	175	247	1
74	189	255	1
74	473	66	1
74	473	276	1
74	473	199	1
74	195	22	1
74	195	200	1
74	196	264	1
74	196	265	1
74	1103	1223	1
74	199	266	1
74	199	173	1
74	323	50	1
74	323	38	1
74	323	1311	1
74	209	243	1
74	475	468	1
74	475	79	1
74	475	199	1
74	211	270	1
74	211	199	1
74	213	271	1
74	213	109	1
74	213	34	1
74	216	110	1
74	1104	53	1
74	1104	1297	1
74	1104	46	1
74	1104	1313	1
74	1104	1314	1
74	1104	770	1
74	477	470	1
74	477	199	1
74	222	100	1
74	223	414	1
74	223	276	1
74	223	277	1
74	223	416	1
74	223	199	1
74	478	471	1
74	478	199	1
74	232	35	1
74	232	414	1
74	232	416	1
74	232	199	1
74	479	472	1
74	479	199	1
74	238	282	1
74	238	38	1
74	238	46	1
74	238	288	1
74	234	280	1
74	234	16	1
74	52	17	1
74	52	199	1
74	1105	66	1
55	173	32	1
55	173	199	1
55	175	38	1
55	175	247	1
55	189	255	1
55	473	66	1
55	473	276	1
55	473	199	1
55	1088	150	1
55	1088	27	1
55	1088	38	2
55	1088	268	1
55	1088	142	1
55	1088	1306	1
55	1088	257	1
55	1088	141	1
55	1088	81	1
55	1088	259	2
55	1088	43	2
55	1088	194	1
55	1088	84	2
55	1088	33	1
55	195	22	1
55	195	200	1
55	196	264	1
55	196	265	1
55	199	266	1
55	199	173	1
55	209	243	1
55	845	141	1
55	845	268	1
55	845	84	1
55	845	38	1
55	845	43	1
55	845	940	1
55	845	259	1
55	845	142	1
55	475	468	1
55	475	79	1
55	475	199	1
55	211	270	1
55	211	199	1
55	213	271	1
55	213	109	1
55	213	34	1
55	216	110	1
55	477	470	1
55	477	199	1
55	222	100	1
55	223	414	1
55	223	276	1
55	223	277	1
55	223	416	1
55	223	199	1
55	478	471	1
55	478	199	1
55	232	35	1
55	232	414	1
55	232	416	1
55	232	199	1
55	479	472	1
55	479	199	1
55	234	280	1
55	234	16	1
55	238	282	1
55	238	38	1
55	238	46	1
55	238	288	1
55	52	17	1
55	52	199	1
55	481	325	1
55	481	199	1
55	482	473	1
55	482	199	1
55	251	296	1
55	251	38	1
55	251	297	1
75	173	242	1
75	173	243	1
75	173	32	2
75	238	282	1
75	238	38	1
75	238	46	1
75	238	288	1
75	189	255	1
75	1083	15	1
75	1083	38	1
75	1083	204	1
75	1083	456	1
75	1083	1303	1
75	1083	53	1
75	1083	310	1
75	1083	37	1
75	1083	68	1
75	1083	32	1
75	1083	33	1
75	1083	585	1
75	248	35	1
75	248	32	1
75	223	276	1
75	223	277	1
75	171	240	1
75	169	227	1
75	169	199	1
75	172	241	1
75	234	280	1
75	234	16	1
75	195	22	1
75	195	200	1
75	15	52	1
75	15	53	1
75	15	54	1
75	152	232	3
75	152	233	1
75	152	234	1
75	62	474	1
75	62	154	1
75	62	175	1
75	62	165	1
75	232	35	1
75	175	38	1
75	175	247	1
75	150	219	1
75	150	221	1
75	150	199	1
75	149	219	1
75	297	963	1
75	297	38	1
75	297	1344	1
75	297	1345	1
75	297	1347	1
75	297	131	1
75	209	243	1
75	148	218	1
75	148	76	1
75	251	296	1
75	251	38	1
75	251	297	1
75	190	1267	1
75	190	165	10
75	190	1349	1
75	190	1350	3
75	190	82	1
75	190	1351	1
75	190	1117	1
75	190	319	1
75	190	1352	1
75	190	1353	1
75	190	66	2
75	190	1299	4
75	190	220	3
75	190	1354	1
75	190	1297	2
75	190	1355	1
75	190	175	1
75	190	739	1
75	190	379	3
74	1105	500	1
74	1105	273	1
74	1105	38	1
74	1105	869	1
74	1015	52	1
74	1015	53	1
74	1015	109	1
74	1015	1310	1
74	1015	54	1
74	481	325	1
74	481	199	1
74	482	473	1
74	482	199	1
74	1106	475	1
74	251	296	1
74	251	38	1
74	251	297	1
74	514	27	1
74	514	35	2
74	514	496	2
74	514	84	1
74	514	38	1
77	1107	622	1
77	1107	641	1
77	1107	438	1
77	248	35	1
77	35	107	1
77	1108	46	1
77	1108	227	1
77	1108	1315	1
77	1109	211	1
77	1109	277	1
77	1110	184	1
77	1110	37	1
77	15	52	1
77	15	53	1
77	15	54	1
77	1111	325	1
77	1112	296	1
77	1112	896	1
77	1113	84	2
77	1113	33	1
77	1114	79	1
77	1114	221	1
77	1115	33	2
77	209	270	1
77	209	396	1
77	1116	7	1
77	1116	186	1
77	1117	1316	1
77	190	68	1
77	190	1317	1
77	190	33	2
77	222	1191	2
77	222	516	2
77	196	264	1
77	196	265	1
77	1118	68	1
77	1118	33	1
77	1118	262	1
77	1119	1318	1
77	1119	1319	1
77	183	117	1
77	183	251	1
77	183	207	1
77	1120	31	1
77	1120	33	2
77	1121	1032	1
77	1121	243	1
77	1122	27	1
77	1122	24	1
77	1122	257	1
77	1122	84	1
77	1122	38	1
77	1122	259	1
77	1123	392	1
77	1123	197	1
77	1123	22	1
77	1123	46	1
77	213	271	1
77	213	109	1
77	213	34	1
77	199	1320	1
77	147	537	1
77	147	530	1
77	147	1321	1
77	147	370	1
77	1124	91	1
79	843	197	1
79	843	84	1
79	843	33	1
79	843	262	1
79	843	527	1
79	844	259	1
79	844	342	1
79	1153	648	1
79	1153	181	1
79	1154	269	1
79	49	197	1
79	49	33	2
79	49	527	1
79	1156	944	1
79	1156	1346	1
79	1156	819	1
79	1156	1348	1
79	1012	268	1
79	1012	33	1
79	1012	940	1
79	1012	259	1
82	147	38	1
82	147	28	1
82	147	199	1
82	147	21	1
82	148	218	1
82	148	76	1
82	149	219	1
82	150	219	1
82	150	221	1
82	150	199	1
82	1163	1378	1
82	1163	469	1
82	1163	1379	1
82	1163	204	1
82	1163	585	1
82	1163	1380	1
82	1163	1381	1
82	1163	325	1
82	15	52	1
82	15	53	1
82	15	54	1
82	154	199	1
82	1164	1382	1
82	1164	312	1
82	152	232	3
82	152	233	1
82	152	234	1
82	161	236	1
82	169	227	1
82	169	199	1
82	558	111	1
82	558	1383	1
82	558	584	1
82	558	165	1
82	1165	204	1
82	1165	1384	1
82	1165	885	1
82	1165	1381	1
82	1165	1385	1
82	1165	182	1
82	1165	84	1
82	1165	325	2
82	1165	585	1
82	1165	1386	1
82	171	240	1
82	172	241	1
82	173	242	1
82	173	243	1
71	1128	168	2
71	1128	46	2
71	1128	58	2
71	1128	26	2
71	1128	267	2
71	35	107	1
71	181	1327	1
71	181	76	1
71	181	1328	1
71	181	250	1
71	144	76	1
71	144	1328	1
71	15	52	1
71	15	53	1
71	15	54	1
71	1138	24	1
71	1138	26	1
71	1138	267	1
71	1140	1336	1
71	87	35	1
71	87	193	1
71	224	76	1
71	224	1328	1
71	1142	15	1
71	1142	419	1
71	1142	167	1
71	1142	38	1
71	281	13	2
71	281	38	1
71	281	180	1
71	281	46	2
71	281	61	2
71	281	68	2
71	281	31	2
71	281	69	2
71	281	167	1
71	281	32	2
71	281	33	4
71	281	24	1
71	281	168	2
71	281	263	2
71	669	793	1
71	669	798	1
71	669	360	1
71	1147	1322	1
71	1147	38	1
71	1147	76	1
71	1147	1323	1
71	1147	105	1
71	1147	77	1
71	78	1191	1
71	78	180	2
71	78	215	2
71	78	38	2
71	724	244	1
71	724	105	1
71	1149	848	1
71	1149	793	1
71	1149	1341	1
71	1149	384	1
71	1149	360	1
71	778	1342	1
71	778	953	2
71	778	861	2
71	778	42	1
71	778	31	1
71	778	84	1
71	778	912	1
71	778	33	1
71	778	168	1
71	778	1322	1
71	1151	171	1
71	1152	1322	1
71	1152	279	1
71	1152	38	1
71	1152	283	1
71	1152	1323	1
71	1152	105	1
71	1152	252	1
71	478	204	1
71	478	1343	1
71	478	585	1
71	478	53	1
71	478	38	1
71	1155	793	1
71	730	793	1
71	730	360	1
71	730	823	2
71	716	793	1
71	716	168	1
71	716	360	1
71	246	119	1
71	246	140	1
81	470	66	1
81	470	112	1
81	470	458	1
81	470	76	1
81	147	38	1
81	147	28	1
81	147	199	1
81	147	21	1
81	148	218	1
81	148	76	1
81	149	219	1
81	150	219	1
81	150	221	1
81	150	199	1
81	15	52	1
81	15	53	1
81	15	54	1
81	71	125	1
81	71	38	2
81	71	124	1
81	71	162	1
81	71	1038	1
81	71	55	1
81	71	43	1
81	71	84	1
81	71	169	1
81	152	232	3
81	152	233	1
81	152	234	1
81	154	199	1
81	161	236	1
81	24	204	1
81	24	585	1
81	24	53	1
81	24	38	1
81	16	55	1
81	16	38	1
81	16	56	1
81	169	227	1
81	169	199	1
81	507	92	1
81	507	55	1
81	507	38	1
81	507	124	1
81	507	125	1
81	171	240	1
81	172	241	1
81	515	498	1
81	515	496	1
81	515	1376	1
81	515	38	1
81	515	75	1
81	515	566	1
81	173	242	1
81	173	243	1
81	173	32	2
81	175	38	1
81	175	247	1
81	183	251	1
81	183	207	1
81	183	199	1
81	189	255	1
81	31	27	1
81	31	42	1
75	190	1356	1
75	190	1357	1
75	190	84	4
75	190	1358	1
75	190	33	1
75	190	911	1
75	190	67	2
75	190	931	1
75	190	1359	1
75	190	569	1
75	190	1360	1
75	190	641	1
75	190	841	1
75	190	1361	1
75	190	43	3
75	190	61	1
75	190	233	2
75	190	1362	1
75	190	235	1
75	190	474	5
75	190	148	2
75	190	1363	1
75	190	34	9
75	190	1364	1
75	190	11	2
75	190	1016	1
75	190	38	6
75	190	1365	1
75	190	46	2
75	190	1366	1
75	190	763	1
75	190	8	1
75	190	401	2
75	190	1367	1
75	190	1368	2
75	190	85	2
75	190	1369	1
75	190	604	1
75	190	1370	1
75	190	21	1
75	190	1371	1
75	190	1372	2
75	222	100	1
75	196	264	1
75	196	265	1
75	183	251	1
75	183	207	1
75	183	199	1
75	211	270	1
75	211	199	1
75	161	236	1
75	342	383	1
75	342	19	1
75	213	271	1
75	213	109	1
75	213	34	1
75	247	32	1
75	247	241	1
75	154	199	1
75	199	266	1
75	199	173	1
75	147	38	1
75	147	28	1
75	147	199	1
75	147	21	1
75	216	110	1
83	1157	502	1
83	1157	184	1
83	1158	276	1
83	1158	1373	1
83	1158	1374	1
83	1109	211	1
83	1109	277	1
83	1110	184	1
83	1110	37	1
83	15	52	1
83	15	53	1
83	15	54	1
83	1159	135	1
83	1159	408	1
83	1159	53	1
83	1159	541	1
83	1111	325	1
83	1112	296	1
83	1112	896	1
83	1160	352	1
83	209	270	1
83	209	396	1
83	1117	1316	1
83	196	264	1
83	196	265	1
83	1161	784	1
83	1161	1375	1
83	1161	215	1
83	1161	38	1
83	222	1191	2
83	222	516	2
83	1119	1318	1
83	1119	1319	1
83	1162	66	1
83	1162	500	1
83	1162	276	1
83	1162	53	1
83	1162	766	1
83	213	271	1
83	213	109	1
83	213	34	1
83	199	1320	1
84	1191	533	1
84	1191	52	1
84	1191	53	1
84	1191	185	1
84	35	107	1
84	35	108	1
84	1192	501	1
84	1192	185	1
84	1193	1403	1
84	1193	1404	1
84	1194	185	1
84	1194	38	1
84	1194	27	1
84	1194	43	1
84	1194	61	1
84	1194	68	1
84	1194	194	1
84	1194	84	1
84	1194	70	1
84	113	211	1
84	113	43	1
84	113	59	1
84	87	84	1
84	87	38	1
84	87	193	1
84	87	85	1
84	1195	465	1
84	1195	38	1
84	1195	182	1
84	1195	183	1
84	1195	81	1
84	1195	238	1
84	1196	380	2
84	1196	38	2
84	1196	185	2
84	15	52	1
84	15	53	1
84	15	54	1
84	339	43	1
84	339	76	2
84	339	77	2
84	339	201	2
84	702	38	1
84	702	42	1
84	702	19	1
84	702	185	1
84	1197	215	1
84	1197	1405	1
84	1197	1406	1
81	31	19	1
81	31	1377	1
81	31	43	1
81	190	9	1
81	190	66	1
81	190	484	1
81	190	761	2
81	190	640	1
81	190	85	3
81	190	43	1
81	190	1191	1
81	190	154	1
81	190	38	4
81	190	34	1
81	190	1038	1
81	190	193	1
81	190	153	1
81	190	112	1
81	190	162	1
81	190	84	4
81	190	35	2
81	190	46	1
81	190	174	1
81	87	27	1
81	87	35	1
81	87	1377	1
81	4	7	1
81	4	484	1
81	4	640	1
81	4	112	1
81	4	9	1
81	4	46	1
81	4	10	1
81	4	11	1
81	195	22	1
81	195	200	1
81	196	264	1
81	196	265	1
81	199	266	1
81	199	173	1
81	209	243	1
81	209	204	1
81	209	585	1
81	209	53	1
81	209	38	1
81	209	396	1
81	211	270	1
81	211	199	1
81	27	86	1
81	27	15	1
81	27	38	1
81	27	204	1
81	27	1191	1
81	27	66	1
81	27	53	1
81	27	37	1
81	27	68	1
81	27	32	1
81	27	33	2
81	27	585	1
81	213	271	1
81	213	109	1
81	213	34	1
81	216	110	1
81	36	851	1
81	36	204	1
81	36	585	1
81	36	53	1
81	36	38	1
81	36	1398	1
81	36	853	1
81	1176	153	1
81	1176	154	1
81	1176	273	1
81	1176	38	1
81	1176	43	1
81	222	100	1
81	223	276	1
81	223	277	1
81	26	66	1
81	26	83	2
81	26	500	1
81	26	76	1
81	26	174	1
81	232	35	1
81	238	282	1
81	238	38	1
81	238	46	1
81	238	288	1
81	234	280	1
81	234	16	1
81	247	32	1
81	247	241	1
81	62	153	1
81	62	9	1
81	62	154	1
81	1109	204	1
81	1109	585	1
81	1109	53	1
81	1109	38	1
81	1109	1401	1
81	1111	38	1
81	1111	193	1
81	1111	46	1
81	1111	85	1
81	1111	43	1
81	1111	276	1
81	1111	84	1
81	1111	325	1
81	1111	34	1
81	248	204	1
81	248	35	1
81	248	585	1
81	248	53	1
81	248	38	1
81	248	32	1
81	248	37	1
81	55	141	1
81	55	38	1
81	55	43	1
81	55	142	1
81	9	1035	1
81	9	35	1
81	9	36	1
81	9	379	1
81	9	85	1
81	251	296	1
81	251	38	1
81	251	297	1
82	173	32	2
82	175	38	1
82	175	247	1
82	183	251	1
82	183	207	1
82	183	199	1
82	189	255	1
82	190	474	1
82	190	669	2
82	190	1297	2
82	190	401	2
82	190	165	1
82	195	22	1
82	195	200	1
82	196	264	1
82	196	265	1
82	1170	1390	1
82	1170	165	1
82	199	266	1
82	199	173	1
82	209	243	1
82	883	38	1
82	883	43	1
82	883	134	1
82	211	270	1
82	211	199	1
82	213	271	1
82	213	109	1
82	213	34	1
82	216	110	1
82	222	100	1
82	223	276	1
82	223	277	1
82	232	35	1
82	1174	83	2
82	1174	35	1
82	1174	84	2
82	1174	38	2
82	1174	43	2
82	1174	85	2
82	1174	76	1
82	1174	541	1
82	234	280	1
82	234	16	1
82	238	282	1
82	238	38	1
82	238	46	1
82	238	288	1
82	247	32	1
82	247	241	1
82	248	35	1
82	248	32	1
82	29	91	1
82	29	38	1
82	251	296	1
82	251	38	1
82	251	297	1
92	1198	38	1
92	1198	379	2
92	1198	188	1
92	1198	128	1
92	1198	1117	1
92	1198	1407	1
92	1198	1408	1
92	1198	1409	1
92	1198	946	1
92	901	42	1
92	901	1410	1
92	35	107	1
92	35	108	1
92	132	155	1
92	132	163	1
92	132	36	1
92	132	81	1
92	132	76	1
92	132	188	1
92	1199	379	1
92	1199	188	1
92	1199	190	1
92	87	35	1
92	87	193	1
92	1200	819	3
92	1200	38	3
92	1200	1411	1
92	1200	379	2
92	1200	1412	1
92	1200	128	3
92	1200	1117	1
92	1200	1407	1
92	1200	1413	1
92	15	52	1
92	15	53	1
92	15	54	1
92	1201	379	1
92	1201	42	1
92	1201	188	1
92	679	128	1
92	679	38	1
92	679	188	1
92	910	1130	1
92	910	38	1
92	910	131	1
92	1202	379	1
92	1202	186	1
92	1202	38	1
92	1202	43	1
92	1202	188	1
92	1202	63	1
92	153	155	1
92	153	36	1
92	153	183	1
92	153	81	1
92	153	76	1
92	153	188	1
80	778	953	1
80	778	861	1
80	716	793	1
80	716	168	1
80	716	360	1
80	344	1399	1
80	344	384	1
80	344	3	1
80	344	387	1
80	344	199	1
80	1151	171	1
80	1178	503	1
80	1179	180	2
80	1179	91	2
80	1179	38	2
80	144	217	1
80	1180	779	1
80	1180	1400	1
80	1180	334	1
80	1180	335	1
80	1127	384	2
80	1127	1325	2
80	87	24	1
80	87	35	1
80	87	68	1
80	87	33	2
80	87	193	1
80	87	32	1
80	35	107	1
80	1181	180	1
80	1181	1402	1
80	1181	38	1
80	1181	43	1
80	1181	80	1
80	1181	18	1
80	1181	21	1
80	1182	779	1
80	1182	334	1
80	1182	335	1
80	181	250	1
80	974	168	1
80	974	211	1
80	974	277	1
80	974	38	1
80	974	761	1
80	974	21	1
80	1183	779	1
80	1183	334	1
80	1183	335	1
80	1184	331	1
80	1184	1147	1
80	1184	982	1
80	70	168	1
80	70	38	1
80	70	43	1
80	70	46	1
80	70	80	1
80	70	18	1
80	1185	334	1
80	1185	79	1
80	1185	729	1
80	1185	335	1
80	1185	81	1
80	1155	793	1
80	1186	968	1
80	281	13	1
80	281	38	2
80	281	180	1
80	281	46	1
80	281	61	1
80	281	68	1
80	281	31	1
80	281	69	1
80	281	167	1
80	281	32	1
80	281	33	3
80	281	168	1
80	281	24	1
80	281	263	1
80	478	204	1
80	478	1343	1
80	478	585	1
80	478	53	1
80	478	38	1
80	730	793	1
80	730	823	1
80	730	360	1
80	224	275	1
80	1187	289	1
80	1188	1316	1
80	691	793	1
80	691	794	1
80	691	360	1
80	1189	779	1
80	1189	192	1
80	1189	334	1
80	1189	387	1
80	1189	335	1
80	1189	134	1
80	1189	1324	1
80	1190	1399	1
80	1190	1391	1
80	1190	252	1
80	246	119	1
80	246	140	1
\.
--
-- Data for TOC Entry ID 56 (OID 230364)
--
-- Name: mail Type: TABLE DATA Owner: tistou
--


COPY "mail" FROM stdin;
mailto:java-io@java.sun.com	1
mailto:java-awt@java.sun.com	2
mailto:java-beans@java.sun.com	3
mailto:jdbc-odbc@sun.com	4
mailto:jdbc@sun.com	5
mailto:jls@java.sun.com	6
mailto:jdk-comments@java.sun.com	7
mailto:java2d-comments@sun.com	8
mailto:jni@java.sun.com	9
mailto:java-security@sun.com	10
mailto:swing-feedback@java.sun.com	11
mailto:collections-comments@java.sun.com	12
mailto:java-intl@java.sun.com	13
mailto:f.allimant@confluent.fr	14
mailto:j2se-comments@sun.com	15
mailto:javasound-comments@sun.com	16
mailto:java-debugger@sun.com	17
mailto:rmi-comments@java.sun.com	18
mailto:java-print@sun.com	19
mailto:j2se-comments@eng.sun.com	20
mailto:jre-comments@java.sun.com	21
mailto:jndi@java.sun.com	22
mailto:pelegri@eng.sun.com	23
mailto:reflection-comments@sun.com	24
mailto:java-gc-comments@eng.sun.com	25
mailto:java-dnd@java.sun.com	26
mailto:jsr015-comments@sun.com	27
mailto:jvmpi@eng.sun.com	28
mailto:rosanna.lee@sun.com	29
mailto:copyrights@sun.com	30
mailto:rmi-iiop@sun.com	31
mailto:sdk-docl10nbugs@java.sun.com	32
mailto:javaidl@sun.com	33
mailto:access@sun.com	34
\.
--
-- Data for TOC Entry ID 57 (OID 230373)
--
-- Name: motmail Type: TABLE DATA Owner: tistou
--


COPY "motmail" FROM stdin;
java-io	1
com	2
sun	3
java	4
java-awt	5
java-beans	6
jdbc-odbc	7
jdbc	8
jls	9
jdk-comments	10
java2d-comments	11
jni	12
java-security	13
swing-feedback	14
collections-comments	15
java-intl	16
fr	17
allimant	18
confluent	19
j2se-comments	20
javasound-comments	21
java-debugger	22
rmi-comments	23
java-print	24
eng	25
jre-comments	26
jndi	27
pelegri	28
reflection-comments	29
java-gc-comments	30
java-dnd	31
jsr015-comments	32
jvmpi	33
rosanna	34
lee	35
copyrights	36
rmi-iiop	37
sdk-docl10nbugs	38
javaidl	39
access	40
\.
--
-- Data for TOC Entry ID 58 (OID 230380)
--
-- Name: appmail Type: TABLE DATA Owner: tistou
--


COPY "appmail" FROM stdin;
4	1	1	1
4	1	2	1
4	1	3	1
4	1	4	1
3	2	5	1
3	2	2	1
3	2	3	1
3	2	4	1
8	3	2	1
8	3	3	1
8	3	4	1
8	3	6	1
12	4	2	1
12	4	3	1
12	4	7	1
12	5	2	1
12	5	3	1
12	5	8	1
13	6	2	1
13	6	3	1
13	6	4	1
13	6	9	1
16	7	2	1
16	7	3	1
16	7	4	1
16	7	10	1
14	8	2	1
14	8	3	1
14	8	11	1
18	9	2	1
18	9	3	1
18	9	4	1
18	9	12	1
15	10	13	1
15	10	2	1
15	10	3	1
19	11	2	1
19	11	3	1
19	11	4	1
19	11	14	1
23	12	15	1
23	12	2	1
23	12	3	1
22	13	2	1
22	13	3	1
23	12	4	1
22	13	4	1
22	13	16	1
20	14	17	1
20	14	18	1
20	14	19	1
29	15	2	1
29	15	3	1
29	15	20	1
30	16	21	1
30	16	2	1
30	16	3	1
32	17	2	1
32	17	22	1
32	17	3	1
36	18	2	1
36	18	3	1
36	18	4	1
36	18	23	1
41	19	2	1
41	19	3	1
41	19	24	1
43	20	2	1
43	20	3	1
43	20	25	1
43	20	20	1
44	21	2	1
44	21	3	1
44	21	4	1
44	21	26	1
45	13	2	1
45	13	3	1
45	13	4	1
45	13	16	1
54	22	2	1
54	22	3	1
54	22	4	1
54	22	27	1
57	23	2	1
57	23	3	1
57	23	28	1
57	23	25	1
62	24	2	1
62	24	29	1
62	24	3	1
62	24	25	1
64	25	2	1
64	25	3	1
64	25	25	1
64	25	30	1
65	7	2	1
65	7	3	1
65	7	4	1
65	7	10	1
63	20	2	1
63	20	3	1
63	20	25	1
63	20	20	1
67	26	2	1
67	26	3	1
67	26	4	1
67	26	31	1
69	15	2	1
69	15	3	1
69	15	20	1
66	27	2	1
66	27	3	1
66	27	32	1
72	28	2	1
72	28	3	1
72	28	33	1
72	28	25	1
55	29	2	1
55	29	3	1
55	29	34	1
55	29	35	1
74	30	2	1
74	30	3	1
74	30	36	1
78	1	1	1
78	1	2	1
78	1	3	1
78	1	4	1
71	31	2	2
71	31	37	2
71	31	3	2
81	32	2	1
81	32	38	1
81	32	3	1
81	32	4	1
80	33	2	1
80	33	3	1
80	33	39	1
80	31	2	1
80	31	37	1
80	31	3	1
84	34	40	1
84	34	2	1
84	34	3	1
\.
--
-- Data for TOC Entry ID 59 (OID 230403)
--
-- Name: pict Type: TABLE DATA Owner: tistou
--


COPY "pict" FROM stdin;
download.arrow.gif	/j2se/1.4.1/docs/images/	1	pict17495.gif	1
javalogo52x88.gif	/j2se/1.4.1/docs/images/	1	pict17496.gif	2
sunlogo64x30.gif	/j2se/1.4.1/docs/images/	1	pict17497.gif	3
v4_java_sun_com.gif	/images/	1	pict17512.gif	4
v3_sun_logo.gif	/images/	1	pict17514.gif	5
Japanese12B.gif	/j2se/1.4.1/ja/images/	1	pict17515.gif	6
v3_print.gif	/images/	1	pict17516.gif	7
v4_java_logo.gif	/images/	1	pict17517.gif	8
masthead_slogan.gif	/im/home/	2	pict17524.gif	9
sun_logo.gif	/im/	2	pict17525.gif	10
b5_nc_03_q2.gif	/pics/promos/	2	pict17526.gif	11
b3_nascar-java.jpg	/2003-0422/images/	2	pict17527.jpg	12
b5_sun_fire_blade_platform.gif	/pics/promos/	2	pict17528.gif	13
b5_get_java.gif	/pics/promos/	2	pict17529.gif	14
b5_why_not.gif	/pics/promos/	2	pict17530.gif	15
a.gif	/im/	2	pict17531.gif	16
view.option.gif	/j2se/1.4.1/images/	1	pict17572.gif	17
javalogo52x88.gif	/j2se/1.4.1/docs/guide/rmi/images/	1	pict17573.gif	18
download.option.gif	/j2se/1.4.1/images/	1	pict17575.gif	19
j2se_sm.gif	/j2se/images/	1	pict17579.gif	20
Japanese12B.gif	/images/	1	pict17580.gif	21
arrow.gif	/images/misc/	1	pict17597.gif	22
professionals.gif	/developer/onlineTraining/new2java/	3	pict17598.gif	23
new.gif	/developer/onlineTraining/new2java/	3	pict17600.gif	24
step3.gif	/developer/onlineTraining/new2java/	3	pict17601.gif	25
step2.gif	/developer/onlineTraining/new2java/	3	pict17602.gif	26
step1.gif	/developer/onlineTraining/new2java/	3	pict17603.gif	27
v4_java_sun_com.gif	/images/	3	pict17604.gif	28
v4_java_logo.gif	/images/	3	pict17605.gif	29
j1sf.register.gif	/images/	1	pict17606.gif	30
customed.gif	/developer/onlineTraining/new2java/	3	pict17608.gif	31
library.gif	/developer/onlineTraining/new2java/	3	pict17609.gif	32
v3_print.gif	/images/	3	pict17610.gif	33
v3_sun_logo.gif	/images/	3	pict17611.gif	34
j2se_homepage_button.jpg	/images/	1	pict17612.jpg	35
T7.gif	/images/	3	pict17613.gif	36
step4.gif	/developer/onlineTraining/new2java/	3	pict17615.gif	37
hostthebutton.gif	/images/	1	pict17618.gif	38
j2ee_homepage_button.jpg	/images/	1	pict17619.jpg	39
bnr.socketjxta.gif	/images/rollover/	1	pict17622.gif	40
j2me_homepage_button.jpg	/images/	1	pict17623.jpg	41
bullet.gif	/images/misc/	1	pict17644.gif	42
dukesign.GIF	/docs/books/tutorial/images/	1	pict17655.GIF	43
3ebook_sm.gif	/docs/books/tutorial/images/bookcovers/	1	pict17658.gif	44
continued_sm.gif	/docs/books/tutorial/images/bookcovers/	1	pict17659.gif	45
javatut.gif	/docs/books/tutorial/images/	1	pict17660.gif	46
download.gif	/docs/books/tutorial/images/	1	pict17663.gif	47
swing_sm.gif	/docs/books/tutorial/images/bookcovers/	1	pict17664.gif	48
smi.logo.gif	/images/	1	pict17687.gif	49
JAVA.85.GIF	/images/	1	pict17688.GIF	50
endicon.duke.gif	/images/	1	pict17713.gif	51
getacro.gif	/images/	1	pict17729.gif	52
side.tab.docs.gif	/images/navbar/	1	pict17737.gif	53
side.tab.developer.gif	/images/navbar/	1	pict17738.gif	54
side.tab.products.gif	/images/navbar/	1	pict17739.gif	55
azindex.gif	/images/banners/	1	pict17740.gif	56
side.tab.support.gif	/images/navbar/	1	pict17742.gif	57
help.gif	/images/banners/	1	pict17743.gif	58
side.tab.community.gif	/images/navbar/	1	pict17744.gif	59
thesourceforjava.gif	/images/banners/	1	pict17746.gif	60
javalogo52x88.gif	/images/logos/	1	pict17748.gif	61
side.tab.case.gif	/images/navbar/	1	pict17749.gif	62
side.tab.news.gif	/images/navbar/	1	pict17750.gif	63
lgsun.gif	/images/buttons/	1	pict17751.gif	64
omg_memb.gif	/j2se/1.4.1/docs/guide/corba/images/	1	pict17756.gif	65
\.
--
-- Data for TOC Entry ID 60 (OID 230418)
--
-- Name: motpict Type: TABLE DATA Owner: tistou
--


COPY "motpict" FROM stdin;
download	1
documentation	2
4	3
1	4
j2se	5
java	6
sun	7
microsystems	8
inc	9
technology	10
page	11
home	12
japanese	13
printable	14
work	15
make	16
we	17
the	18
net	19
logo	20
nc03-q2	21
mega	22
-	23
launch	24
start	25
nascar	26
helps	27
seat	28
com	29
fans	30
put	31
in	32
engines!	33
racing	34
your	35
driver	36
platform	37
cutting	38
fire	39
new	40
edge	41
blade	42
get	43
why	44
not?	45
links	46
search	47
content	48
skip	49
submit	50
masthead	51
to	52
readme	53
instructions	54
all	55
64-bit	56
jre	57
license	58
sdk	59
linux	60
view	61
notes	62
for	63
instruction	64
release	65
developer	66
installation	67
windows	68
platforms	69
solaris	70
patches	71
intel	72
sparc	73
standard	74
edition	75
version	76
section	77
2	78
1_02	79
return	80
top	81
professionals	82
3	83
step	84
april	85
learning	86
register	87
paths	88
library	89
save!	90
before	91
30	92
2003	93
[duke]	94
--	95
button	96
host	97
j2ee	98
socket	99
api	100
0	101
jxta	102
j2me	103
bullet	104
decorative	105
sign	106
duke	107
third	108
tutorial	109
continued	110
tm	111
swing	112
jfc	113
end	114
reader	115
acrobat	116
tutorials	117
tech	118
training	119
articles	120
docs	121
connection	122
apis	123
downloads	124
index	125
a-z	126
online	127
support	128
pages	129
help	130
community	131
discussion	132
source	133
worldwide	134
used	135
how	136
is	137
events	138
news	139
everywhere	140
from	141
omg	142
\.
--
-- Data for TOC Entry ID 61 (OID 230425)
--
-- Name: apppict Type: TABLE DATA Owner: tistou
--


COPY "apppict" FROM stdin;
1	1	1	1
1	1	2	1
1	1	3	1
1	1	4	2
1	1	5	1
1	2	6	1
1	3	7	1
4	2	6	1
4	3	7	1
3	2	6	1
3	3	8	1
3	3	7	1
3	3	9	1
7	2	6	1
7	3	7	1
8	2	6	1
8	3	7	1
11	2	6	1
11	3	7	1
10	2	6	1
10	3	7	1
5	4	10	1
5	4	6	1
5	4	11	1
12	3	7	1
5	4	12	1
5	5	8	1
5	5	7	1
5	5	9	1
5	6	13	1
5	7	11	1
5	7	14	1
5	8	10	1
5	8	6	1
5	8	11	1
5	8	12	1
16	2	6	1
16	3	7	1
14	2	6	1
14	3	8	1
14	3	7	1
14	3	9	1
18	2	6	1
18	3	7	1
17	9	15	1
17	9	16	1
17	9	17	1
17	9	18	1
17	9	19	1
17	10	8	1
17	10	7	1
17	10	20	1
17	11	21	1
17	11	22	1
17	11	7	1
17	11	23	1
17	11	24	1
17	12	23	1
17	12	10	1
17	12	25	1
17	12	26	1
17	12	27	1
17	12	28	1
17	12	29	1
17	12	6	1
17	12	30	1
17	12	31	1
17	12	18	1
17	12	32	1
17	12	33	1
17	12	34	1
17	12	35	1
17	12	36	1
17	13	37	1
17	13	38	1
17	13	7	1
17	13	39	1
17	13	40	1
17	13	41	1
17	13	42	1
17	13	23	1
17	14	43	1
17	14	6	1
17	15	44	1
17	15	45	1
17	16	46	1
17	16	47	2
17	16	48	1
17	16	49	2
17	16	50	1
17	16	51	1
17	16	52	1
9	2	6	1
9	3	8	1
9	3	7	1
9	3	9	1
15	2	6	1
15	3	7	1
19	2	6	1
19	3	8	1
19	3	7	1
19	3	9	1
23	2	6	1
23	3	7	1
22	2	6	1
22	3	7	1
26	4	10	1
26	4	6	1
26	4	11	1
26	4	12	1
26	5	8	1
26	5	7	1
26	5	9	1
26	7	11	1
26	7	14	1
26	8	10	1
26	8	6	1
26	8	11	1
26	8	12	1
20	4	10	1
20	4	6	1
20	4	11	1
20	4	12	1
20	5	8	1
20	5	7	1
20	5	9	1
20	7	11	1
20	7	14	1
20	8	10	1
20	8	6	1
20	8	11	1
20	8	12	1
28	2	6	1
28	3	7	1
29	2	6	1
29	3	8	1
29	3	7	1
29	3	9	1
30	2	6	1
30	3	7	1
32	2	6	1
32	3	7	1
34	2	6	1
34	3	7	1
35	2	6	1
35	3	8	1
35	3	7	1
35	3	9	1
27	4	10	1
27	4	6	1
27	4	11	1
27	4	12	1
27	8	10	1
27	8	6	1
27	8	11	1
27	8	12	1
27	17	53	2
27	17	54	3
27	17	55	2
27	17	56	1
27	17	57	4
27	17	58	4
27	17	59	5
27	17	60	1
27	17	5	2
27	17	61	14
27	17	62	3
27	17	63	3
27	17	64	1
27	17	65	4
27	17	66	1
27	17	67	4
27	17	3	2
27	17	68	1
27	17	4	4
27	17	69	2
27	19	1	2
27	19	70	2
27	19	71	2
27	19	72	1
27	19	73	1
27	7	11	1
27	7	14	1
27	5	8	1
27	5	7	1
27	5	9	1
27	20	6	1
27	20	74	1
27	20	75	1
27	20	76	1
27	20	3	1
27	20	77	1
27	20	78	1
27	20	4	1
27	20	79	1
27	21	13	1
43	2	6	1
43	3	7	1
62	2	6	1
62	3	7	1
64	2	6	1
64	3	7	1
65	2	6	1
65	3	7	1
66	2	6	1
66	3	8	1
66	3	7	1
66	3	9	1
73	52	115	1
73	52	43	1
73	52	116	1
74	4	10	1
74	4	6	1
74	4	11	1
74	4	12	1
74	5	8	1
74	5	7	1
74	5	9	1
74	7	11	1
74	7	14	1
74	8	10	1
74	8	6	1
74	8	11	1
74	8	12	1
77	53	117	1
77	53	118	1
77	53	119	1
77	53	120	1
77	53	121	1
77	54	122	1
77	54	66	1
77	54	6	1
77	55	2	1
77	55	123	1
77	55	124	1
77	56	125	1
77	56	126	1
77	57	127	1
77	57	128	1
77	58	129	1
77	58	130	1
77	59	131	1
77	59	132	1
77	60	10	1
77	60	6	1
77	60	18	1
77	60	63	1
77	60	133	1
77	61	10	1
77	61	6	1
77	61	11	1
77	61	12	1
77	62	134	1
77	62	10	1
77	62	6	1
77	62	135	1
77	62	136	1
77	62	137	1
77	63	138	1
77	63	139	1
77	63	140	1
77	63	141	1
77	64	8	1
77	64	7	1
77	64	9	1
82	4	10	1
82	4	6	1
82	4	11	1
82	4	12	1
82	5	8	1
82	5	7	1
82	5	9	1
82	6	13	1
82	7	11	1
82	7	14	1
82	8	10	1
82	8	6	1
82	8	11	1
82	8	12	1
92	2	6	1
92	3	7	1
36	18	6	1
36	3	7	1
37	2	6	1
37	3	7	1
45	2	6	1
45	3	7	1
48	4	10	1
48	4	6	1
48	4	11	1
48	4	12	1
48	43	106	1
48	43	107	1
48	8	10	1
48	8	6	1
48	8	11	1
48	8	12	1
48	44	108	1
48	44	6	1
48	44	18	1
48	44	75	1
48	44	109	1
48	45	6	1
48	45	18	1
48	45	110	1
48	45	109	1
48	46	111	1
48	46	6	1
48	46	18	1
48	46	109	1
48	7	11	1
48	7	14	1
48	5	8	1
48	5	7	1
48	5	9	1
48	47	1	1
48	48	18	1
48	48	112	1
48	48	109	1
48	48	113	1
54	2	6	1
54	3	8	1
54	3	7	1
54	3	9	1
70	4	10	1
70	4	6	1
70	4	11	1
70	4	12	1
70	5	8	1
70	5	7	1
70	5	9	1
70	7	11	1
70	7	14	1
70	51	114	1
70	8	10	1
70	8	6	1
70	8	11	1
70	8	12	1
76	2	6	1
76	3	7	2
76	65	142	1
24	4	10	1
24	4	6	1
24	4	11	1
24	4	12	1
24	5	8	1
24	5	7	1
24	5	9	1
24	6	13	1
24	7	11	1
24	7	14	1
24	8	10	1
24	8	6	1
24	8	11	1
24	8	12	1
49	42	104	10
49	42	105	10
49	4	10	1
49	4	6	1
49	4	11	1
49	4	12	1
49	5	8	1
49	5	7	1
49	5	9	1
49	7	11	1
49	7	14	1
49	8	10	1
49	8	6	1
49	8	11	1
49	8	12	1
50	2	6	1
50	3	7	1
51	28	10	1
51	28	6	1
51	28	11	1
51	28	12	1
51	34	8	1
51	34	7	1
51	34	9	1
51	33	11	1
51	33	14	1
51	29	10	1
51	29	6	1
51	29	11	1
51	29	12	1
57	2	6	1
57	3	8	1
57	3	7	1
57	3	9	1
63	2	6	1
63	3	7	1
68	4	10	1
68	4	6	1
68	4	11	1
68	4	12	1
68	5	8	1
68	5	7	1
68	5	9	1
68	6	13	1
68	7	11	1
68	7	14	1
68	8	10	1
68	8	6	1
68	8	11	1
68	8	12	1
72	2	111	1
72	2	6	1
72	3	7	1
78	2	6	1
78	3	7	1
80	53	117	1
80	53	118	1
80	53	119	1
80	53	120	1
80	53	121	1
80	54	122	1
80	54	66	1
80	54	6	1
80	3	7	2
80	2	6	1
80	55	2	1
80	55	123	1
80	55	124	1
80	65	142	1
80	57	127	1
80	57	128	1
80	59	131	1
80	59	132	1
80	62	134	1
80	62	10	1
80	62	6	1
80	62	135	1
80	62	136	1
80	62	137	1
80	63	138	1
80	63	139	1
80	63	140	1
80	63	141	1
31	4	10	1
31	4	6	1
31	4	11	1
31	4	12	1
31	5	8	1
31	5	7	1
31	5	9	1
31	7	11	1
31	7	14	1
31	8	10	1
31	8	6	1
31	8	11	1
31	8	12	1
31	22	80	5
31	22	81	5
31	22	52	5
38	23	82	1
38	24	40	1
38	25	83	1
38	25	84	1
38	26	78	1
38	26	84	1
38	27	4	1
38	27	84	1
38	28	10	1
38	28	6	1
38	28	11	1
38	28	12	1
38	29	10	1
38	29	6	1
38	29	11	1
38	29	12	1
38	31	86	1
38	31	88	1
38	32	89	1
38	33	11	1
38	33	14	1
38	34	8	1
38	34	7	1
38	34	9	1
38	36	94	1
38	37	3	1
38	37	84	1
40	4	10	1
40	4	6	1
40	4	11	1
40	4	12	1
40	5	8	1
40	5	7	1
40	5	9	1
40	7	11	1
40	7	14	1
40	8	10	1
40	8	6	1
40	8	11	1
40	8	12	1
52	2	6	1
52	3	7	1
56	2	6	1
56	3	7	1
58	2	6	1
58	3	7	1
60	49	8	1
60	49	7	1
60	49	9	1
60	50	6	1
61	4	10	1
61	4	6	1
61	4	11	1
61	4	12	1
61	5	8	1
61	5	7	1
61	5	9	1
61	6	13	1
61	7	11	1
61	7	14	1
61	8	10	1
61	8	6	1
61	8	11	1
61	8	12	1
67	2	6	1
67	3	8	1
67	3	7	1
67	3	9	1
69	2	6	1
69	3	8	1
69	3	7	1
69	3	9	1
71	2	6	1
71	3	7	2
71	65	142	1
81	4	10	1
81	4	6	1
81	4	11	1
81	4	12	1
81	5	8	1
81	5	7	1
81	5	9	1
81	7	11	1
81	7	14	1
81	8	10	1
81	8	6	1
81	8	11	1
81	8	12	1
25	30	85	1
25	30	87	1
25	30	90	1
25	30	91	1
25	30	92	1
25	30	52	1
25	30	93	1
25	35	5	1
25	4	10	1
25	4	6	1
25	4	11	1
25	4	12	1
25	8	10	1
25	8	6	1
25	8	11	1
25	8	12	1
25	38	95	1
25	38	96	1
25	38	6	1
25	38	18	1
25	38	97	1
25	39	98	1
25	7	11	1
25	7	14	1
25	5	8	1
25	5	7	1
25	5	9	1
25	40	32	1
25	40	99	1
25	40	78	1
25	40	100	1
25	40	18	1
25	40	101	1
25	40	102	1
25	41	103	1
41	2	6	1
41	3	8	1
41	3	7	1
41	3	9	1
42	4	10	1
42	4	6	1
42	4	11	1
42	4	12	1
42	5	8	1
42	5	7	1
42	5	9	1
42	7	11	1
42	7	14	1
42	8	10	1
42	8	6	1
42	8	11	1
42	8	12	1
44	2	6	1
44	3	7	1
53	4	10	1
53	4	6	1
53	4	11	1
53	4	12	1
53	5	8	1
53	5	7	1
53	5	9	1
53	6	13	1
53	7	11	1
53	7	14	1
53	8	10	1
53	8	6	1
53	8	11	1
53	8	12	1
55	4	10	1
55	4	6	1
55	4	11	1
55	4	12	1
55	5	8	1
55	5	7	1
55	5	9	1
55	7	11	1
55	7	14	1
55	8	10	1
55	8	6	1
55	8	11	1
55	8	12	1
75	4	10	1
75	4	6	1
75	4	11	1
75	4	12	1
75	5	8	1
75	5	7	1
75	5	9	1
75	6	13	1
75	7	11	1
75	7	14	1
75	8	10	1
75	8	6	1
75	8	11	1
75	8	12	1
83	53	117	1
83	53	118	1
83	53	119	1
83	53	120	1
83	53	121	1
83	54	122	1
83	54	66	1
83	54	6	1
83	55	2	1
83	55	123	1
83	55	124	1
83	56	125	1
83	56	126	1
83	57	127	1
83	57	128	1
83	58	129	1
83	58	130	1
83	59	131	1
83	59	132	1
83	60	10	1
83	60	6	1
83	60	18	1
83	60	63	1
83	60	133	1
83	61	10	1
83	61	6	1
83	61	11	1
83	61	12	1
83	62	134	1
83	62	10	1
83	62	6	1
83	62	135	1
83	62	136	1
83	62	137	1
83	63	138	1
83	63	139	1
83	63	140	1
83	63	141	1
83	64	8	1
83	64	7	1
83	64	9	1
84	2	6	1
84	3	7	1
\.
--
-- Data for TOC Entry ID 62 (OID 230447)
--
-- Name: suppfic Type: TABLE DATA Owner: tistou
--


COPY "suppfic" FROM stdin;
\.
--
-- TOC Entry ID 36 (OID 230307)
--
-- Name: "site_url_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX site_url_key ON site USING btree (url);

--
-- TOC Entry ID 37 (OID 230316)
--
-- Name: "page_fin_url_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX page_fin_url_key ON page USING btree (fin_url, id_site);

--
-- TOC Entry ID 32 (OID 230331)
--
-- Name: "http_lien_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX http_lien_key ON http USING btree (lien);

--
-- TOC Entry ID 30 (OID 230340)
--
-- Name: "mothttp_mot_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX mothttp_mot_key ON mothttp USING btree (mot);

--
-- TOC Entry ID 31 (OID 230343)
--
-- Name: "apphttp_id_page_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX apphttp_id_page_key ON apphttp USING btree (id_page, id_http, id_mot);

--
-- TOC Entry ID 35 (OID 230370)
--
-- Name: "mail_mail_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX mail_mail_key ON mail USING btree (mail);

--
-- TOC Entry ID 33 (OID 230379)
--
-- Name: "motmail_mot_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX motmail_mot_key ON motmail USING btree (mot);

--
-- TOC Entry ID 34 (OID 230382)
--
-- Name: "appmail_id_page_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX appmail_id_page_key ON appmail USING btree (id_page, id_mail, id_mot);

--
-- TOC Entry ID 40 (OID 230409)
--
-- Name: "pict_nom_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX pict_nom_key ON pict USING btree (nom, chemin, id_site);

--
-- TOC Entry ID 38 (OID 230424)
--
-- Name: "motpict_mot_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX motpict_mot_key ON motpict USING btree (mot);

--
-- TOC Entry ID 39 (OID 230427)
--
-- Name: "apppict_id_page_key" Type: INDEX Owner: tistou
--

CREATE UNIQUE INDEX apppict_id_page_key ON apppict USING btree (id_page, id_pict, id_mot);

--
-- TOC Entry ID 73 (OID 230318)
--
-- Name: "RI_ConstraintTrigger_230317" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "page"  FROM "site" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'page', 'site', 'UNSPECIFIED', 'id_site', 'id_site');

--
-- TOC Entry ID 66 (OID 230320)
--
-- Name: "RI_ConstraintTrigger_230319" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "site"  FROM "page" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'page', 'site', 'UNSPECIFIED', 'id_site', 'id_site');

--
-- TOC Entry ID 65 (OID 230322)
--
-- Name: "RI_ConstraintTrigger_230321" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "site"  FROM "page" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'page', 'site', 'UNSPECIFIED', 'id_site', 'id_site');

--
-- TOC Entry ID 80 (OID 230345)
--
-- Name: "RI_ConstraintTrigger_230344" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "apphttp"  FROM "page" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'apphttp', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 72 (OID 230347)
--
-- Name: "RI_ConstraintTrigger_230346" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "page"  FROM "apphttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'apphttp', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 71 (OID 230349)
--
-- Name: "RI_ConstraintTrigger_230348" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "page"  FROM "apphttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'apphttp', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 79 (OID 230351)
--
-- Name: "RI_ConstraintTrigger_230350" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "apphttp"  FROM "mothttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'apphttp', 'mothttp', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 77 (OID 230353)
--
-- Name: "RI_ConstraintTrigger_230352" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "mothttp"  FROM "apphttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'apphttp', 'mothttp', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 76 (OID 230355)
--
-- Name: "RI_ConstraintTrigger_230354" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "mothttp"  FROM "apphttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'apphttp', 'mothttp', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 78 (OID 230357)
--
-- Name: "RI_ConstraintTrigger_230356" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "apphttp"  FROM "http" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'apphttp', 'http', 'UNSPECIFIED', 'id_http', 'id_http');

--
-- TOC Entry ID 75 (OID 230359)
--
-- Name: "RI_ConstraintTrigger_230358" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "http"  FROM "apphttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'apphttp', 'http', 'UNSPECIFIED', 'id_http', 'id_http');

--
-- TOC Entry ID 74 (OID 230361)
--
-- Name: "RI_ConstraintTrigger_230360" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "http"  FROM "apphttp" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'apphttp', 'http', 'UNSPECIFIED', 'id_http', 'id_http');

--
-- TOC Entry ID 87 (OID 230384)
--
-- Name: "RI_ConstraintTrigger_230383" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "appmail"  FROM "page" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'appmail', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 70 (OID 230386)
--
-- Name: "RI_ConstraintTrigger_230385" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "page"  FROM "appmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'appmail', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 69 (OID 230388)
--
-- Name: "RI_ConstraintTrigger_230387" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "page"  FROM "appmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'appmail', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 86 (OID 230390)
--
-- Name: "RI_ConstraintTrigger_230389" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "appmail"  FROM "motmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'appmail', 'motmail', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 84 (OID 230392)
--
-- Name: "RI_ConstraintTrigger_230391" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "motmail"  FROM "appmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'appmail', 'motmail', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 83 (OID 230394)
--
-- Name: "RI_ConstraintTrigger_230393" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "motmail"  FROM "appmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'appmail', 'motmail', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 85 (OID 230396)
--
-- Name: "RI_ConstraintTrigger_230395" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "appmail"  FROM "mail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'appmail', 'mail', 'UNSPECIFIED', 'id_mail', 'id_mail');

--
-- TOC Entry ID 82 (OID 230398)
--
-- Name: "RI_ConstraintTrigger_230397" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "mail"  FROM "appmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'appmail', 'mail', 'UNSPECIFIED', 'id_mail', 'id_mail');

--
-- TOC Entry ID 81 (OID 230400)
--
-- Name: "RI_ConstraintTrigger_230399" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "mail"  FROM "appmail" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'appmail', 'mail', 'UNSPECIFIED', 'id_mail', 'id_mail');

--
-- TOC Entry ID 90 (OID 230411)
--
-- Name: "RI_ConstraintTrigger_230410" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "pict"  FROM "site" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'pict', 'site', 'UNSPECIFIED', 'id_site', 'id_site');

--
-- TOC Entry ID 64 (OID 230413)
--
-- Name: "RI_ConstraintTrigger_230412" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "site"  FROM "pict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'pict', 'site', 'UNSPECIFIED', 'id_site', 'id_site');

--
-- TOC Entry ID 63 (OID 230415)
--
-- Name: "RI_ConstraintTrigger_230414" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "site"  FROM "pict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'pict', 'site', 'UNSPECIFIED', 'id_site', 'id_site');

--
-- TOC Entry ID 95 (OID 230429)
--
-- Name: "RI_ConstraintTrigger_230428" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "apppict"  FROM "page" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'apppict', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 68 (OID 230431)
--
-- Name: "RI_ConstraintTrigger_230430" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "page"  FROM "apppict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'apppict', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 67 (OID 230433)
--
-- Name: "RI_ConstraintTrigger_230432" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "page"  FROM "apppict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'apppict', 'page', 'UNSPECIFIED', 'id_page', 'id_page');

--
-- TOC Entry ID 94 (OID 230435)
--
-- Name: "RI_ConstraintTrigger_230434" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "apppict"  FROM "motpict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'apppict', 'motpict', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 92 (OID 230437)
--
-- Name: "RI_ConstraintTrigger_230436" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "motpict"  FROM "apppict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'apppict', 'motpict', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 91 (OID 230439)
--
-- Name: "RI_ConstraintTrigger_230438" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "motpict"  FROM "apppict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'apppict', 'motpict', 'UNSPECIFIED', 'id_mot', 'id_mot');

--
-- TOC Entry ID 93 (OID 230441)
--
-- Name: "RI_ConstraintTrigger_230440" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER INSERT OR UPDATE ON "apppict"  FROM "pict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('<unnamed>', 'apppict', 'pict', 'UNSPECIFIED', 'id_pict', 'id_pict');

--
-- TOC Entry ID 89 (OID 230443)
--
-- Name: "RI_ConstraintTrigger_230442" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER DELETE ON "pict"  FROM "apppict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_del" ('<unnamed>', 'apppict', 'pict', 'UNSPECIFIED', 'id_pict', 'id_pict');

--
-- TOC Entry ID 88 (OID 230445)
--
-- Name: "RI_ConstraintTrigger_230444" Type: TRIGGER Owner: tistou
--

CREATE CONSTRAINT TRIGGER "<unnamed>" AFTER UPDATE ON "pict"  FROM "apppict" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_cascade_upd" ('<unnamed>', 'apppict', 'pict', 'UNSPECIFIED', 'id_pict', 'id_pict');

--
-- TOC Entry ID 3 (OID 230299)
--
-- Name: site_id_site_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"site_id_site_seq"', 9, true);

--
-- TOC Entry ID 5 (OID 230308)
--
-- Name: page_id_page_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"page_id_page_seq"', 277, true);

--
-- TOC Entry ID 7 (OID 230323)
--
-- Name: http_id_http_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"http_id_http_seq"', 1208, true);

--
-- TOC Entry ID 9 (OID 230332)
--
-- Name: mothttp_id_mot_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"mothttp_id_mot_seq"', 1414, true);

--
-- TOC Entry ID 11 (OID 230362)
--
-- Name: mail_id_mail_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"mail_id_mail_seq"', 34, true);

--
-- TOC Entry ID 13 (OID 230371)
--
-- Name: motmail_id_mot_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"motmail_id_mot_seq"', 40, true);

--
-- TOC Entry ID 15 (OID 230401)
--
-- Name: pict_id_pict_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"pict_id_pict_seq"', 65, true);

--
-- TOC Entry ID 17 (OID 230416)
--
-- Name: motpict_id_mot_seq Type: SEQUENCE SET Owner: tistou
--

SELECT setval ('"motpict_id_mot_seq"', 142, true);

